set autocommit = 0;

--
-- ALTER TABLE `view_column`
-- ADD COLUMN `eng_fieldname`  varchar(255) NOT NULL DEFAULT '' COMMENT '英文名';
--
-- ALTER TABLE `channel`
-- ADD COLUMN `eng_name`  varchar(255) NOT NULL DEFAULT '' COMMENT '英文的渠道名' AFTER `modify_time`;
--
--
-- ALTER TABLE `tip`
-- ADD COLUMN `eng_key`  varchar(255) NOT NULL DEFAULT '' COMMENT '英文key' AFTER `id`,
-- ADD COLUMN `eng_tip`  varchar(600) NOT NULL DEFAULT '' COMMENT '英文tip' AFTER `menu`;
--
--
-- ALTER TABLE `export_report_info`
-- ADD COLUMN `language_type`  varchar(255) NULL DEFAULT 'zh' COMMENT '语种类型（zh为中文  en为英文）' AFTER `status`;
--
-- ALTER TABLE `download_info`
-- ADD COLUMN `language_type`  varchar(255) NULL DEFAULT 'zh' COMMENT '语种类型（zh为中文  en为英文）' AFTER `businame`;
--
-- ALTER TABLE `sub_campaign_export`
-- ADD COLUMN `language_type`  varchar(255) NULL DEFAULT 'zh' COMMENT '语种类型' AFTER `status`;
--
-- ALTER TABLE `sy_dic_item`
-- ADD COLUMN `eng_item_value`  varchar(255) NOT NULL DEFAULT '' AFTER `dic_code`;
--
--
-- ALTER TABLE `account`
-- ADD COLUMN `language_type`  varchar(255) NOT NULL DEFAULT 'zh' COMMENT '语种类型：zh为中文  en为英文' AFTER `start_by_contract`;
--
-- ALTER TABLE `recycle_channel`
-- ADD COLUMN `eng_name`  varchar(255) NOT NULL DEFAULT '' COMMENT '英文名' AFTER `unique_name`;
--
--
-- ALTER TABLE `role_auth_detail`
-- ADD COLUMN `eng_auth_name`  varchar(255) NOT NULL DEFAULT '' AFTER `auth`;
--
--
-- ALTER TABLE channel MODIFY eng_name varchar(255) character set utf8 NOT NULL DEFAULT ''  COMMENT '英文的渠道名';




alter table `view_column`
modify column `eng_fieldname`  varchar(255)   default '' comment '英文名';

alter table `channel`
modify column `eng_name`  varchar(255) character set utf8 default '' comment '英文的渠道名' after `modify_time`;

alter table `tip`
modify column `eng_key`  varchar(255) character set utf8 default '' comment '英文key' after `id`,
modify column `eng_tip`  varchar(600) character set utf8 default '' comment '英文tip' after `menu`;

alter table `export_report_info`
modify column `language_type`  varchar(64) null default 'zh' comment '语种类型（zh为中文  en为英文）' after `status`;

alter table `download_info`
modify column `language_type`  varchar(64) null default 'zh' comment '语种类型（zh为中文  en为英文）' after `businame`;

alter table `sub_campaign_export`
modify column `language_type`  varchar(64) null default 'zh' comment '语种类型' after `status`;

alter table `sy_dic_item`
modify column `eng_item_value`  varchar(255)  default '' after `dic_code`;

alter table `account`
modify column `language_type`  varchar(64)  default 'zh' comment '语种类型：zh为中文  en为英文' after `start_by_contract`;

alter table `recycle_channel`
modify column `eng_name`  varchar(255) default '' comment '英文名' after `unique_name`;

alter table `role_auth_detail`
modify column `eng_auth_name`  varchar(255)  default '' after `auth`;

alter table channel
modify eng_name varchar(255) character set utf8  default ''  comment '英文的渠道名';



update channel set eng_name = '最右' where id =12103;
update channel set eng_name = '灼见' where id =2777;
update channel set eng_name = '追书神器' where id =497;
update channel set eng_name = 'ADUSING' where id =1874;
update channel set eng_name = 'ZHONGXUMENGXING' where id =9906;
update channel set eng_name = '智投广告' where id =6266;
update channel set eng_name = 'WISELONS' where id =7169;
update channel set eng_name = '智汇推外链' where id =1858;
update channel set eng_name = '智汇推' where id =5311;
update channel set eng_name = 'mobsmar' where id =492;
update channel set eng_name = '指尖互动' where id =728;
update channel set eng_name = '知乎' where id =6417;
update channel set eng_name = 'Sesame Entertainment' where id =5644;
update channel set eng_name = '之行传媒' where id =1143;
update channel set eng_name = 'joysuch' where id =10139;
update channel set eng_name = 'iReader' where id =5309;
update channel set eng_name = 'WOQU GAME' where id =1384;
update channel set eng_name = 'hdtMobile' where id =1944;
update channel set eng_name = '掌通' where id =666;
update channel set eng_name = 'adzshd' where id =865;
update channel set eng_name = 'palmhappy' where id =8482;
update channel set eng_name = '云数' where id =3169;
update channel set eng_name = 'asovip' where id =2237;
update channel set eng_name = 'yumimobi' where id =5766;
update channel set eng_name = 'YOUMI' where id =399;
update channel set eng_name = '游戏多' where id =5588;
update channel set eng_name = '优友' where id =435;
update channel set eng_name = 'YOOSHU' where id =542;
update channel set eng_name = '优量' where id =12113;
update channel set eng_name = 'YOUKU GD' where id =11031;
update channel set eng_name = 'YOUKU(subpackage)' where id =1350;
update channel set eng_name = 'YOUKU' where id =773;
update channel set eng_name = '涌玉' where id =5560;
update channel set eng_name = '应用雷达' where id =9703;
update channel set eng_name = 'AppChina' where id =777;
update channel set eng_name = '鹰击' where id =1045;
update channel set eng_name = 'CENTRIXLINK' where id =2601;
update channel set eng_name = 'ycmedia' where id =1877;
update channel set eng_name = '易杨DSP' where id =2514;
update channel set eng_name = 'yilianfeiyu' where id =541;
update channel set eng_name = '易动手盟' where id =1993;
update channel set eng_name = 'emar' where id =1770;
update channel set eng_name = '宜搜' where id =502;
update channel set eng_name = '一下科技' where id =11779;
update channel set eng_name = '一木' where id =5346;
update channel set eng_name = '一个桔子' where id =10970;
update channel set eng_name = '一点资讯' where id =6764;
update channel set eng_name = '讯飞营销云' where id =10953;
update channel set eng_name = 'XINGWUTONG' where id =11631;
update channel set eng_name = 'NEW GAME' where id =439;
update channel set eng_name = 'Xinlao' where id =7420;
update channel set eng_name = 'shuyun' where id =6009;
update channel set eng_name = 'wisemedia dsp' where id =5308;
update channel set eng_name = '新睿视' where id =12442;
update channel set eng_name = 'Sina Ad eXchange' where id =7536;
update channel set eng_name = '笑得合不拢嘴' where id =507;
update channel set eng_name = 'mi' where id =11775;
update channel set eng_name = 'mi(subpackage)' where id =762;
update channel set eng_name = '象威hypers' where id =5350;
update channel set eng_name = '限时免费大全' where id =499;
update channel set eng_name = 'GoalMobi DSP' where id =992;
update channel set eng_name = '喜马拉雅' where id =9212;
update channel set eng_name = '西洋镜' where id =786;
update channel set eng_name = '武汉一起游' where id =11508;
update channel set eng_name = '微云浏览器' where id =10539;
update channel set eng_name = 'Wechat' where id =5306;
update channel set eng_name = '微传播' where id =10773;
update channel set eng_name = '微博-超级粉丝通' where id =9219;
update channel set eng_name = '网易云音乐_分包' where id =11871;
update channel set eng_name = '网易云音乐' where id =10837;
update channel set eng_name = '网易有道智选_分包' where id =11888;
update channel set eng_name = '网易有道智选' where id =5310;
update channel set eng_name = 'NetEase Ads' where id =12185;
update channel set eng_name = 'WAPS' where id =396;
update channel set eng_name = '玩转互联' where id =1844;
update channel set eng_name = '玩吧' where id =743;
update channel set eng_name = '豌豆荚' where id =764;
update channel set eng_name = 'toomee dsp' where id =7311;
update channel set eng_name = 'TUWAN ESPORTS' where id =599;
update channel set eng_name = '兔兔助手' where id =5824;
update channel set eng_name = 'TUKMOB' where id =402;
update channel set eng_name = 'TDTUYOU DSP' where id =744;
update channel set eng_name = '腾讯应用宝' where id =765;
update channel set eng_name = '塔肯' where id =10093;
update channel set eng_name = 'sohu ADS' where id =11746;
update channel set eng_name = 'sohutv' where id =10391;
update channel set eng_name = '搜狐汇算' where id =950;
update channel set eng_name = 'sougou' where id =10962;
update channel set eng_name = 'sougou SEM' where id =5839;
update channel set eng_name = '搜狗' where id =780;
update channel set eng_name = '手机百度' where id =785;
update channel set eng_name = '试用宝' where id =8549;
update channel set eng_name = '试客' where id =516;
update channel set eng_name = '时趣互动' where id =1431;
update channel set eng_name = '圣纹网络' where id =10558;
update channel set eng_name = '神奇移动' where id =9709;
update channel set eng_name = '神马搜索' where id =5337;
update channel set eng_name = '上榜科技' where id =2518;
update channel set eng_name = '山雀' where id =8594;
update channel set eng_name = 'listen-ad' where id =679;
update channel set eng_name = '锐艺' where id =5688;
update channel set eng_name = '软猎' where id =859;
update channel set eng_name = '融翔' where id =11636;
update channel set eng_name = '仁盈软件' where id =620;
update channel set eng_name = '趣头条' where id =9255;
update channel set eng_name = 'Qumi' where id =408;
update channel set eng_name = 'qianlu' where id =748;
update channel set eng_name = 'qianka' where id =521;
update channel set eng_name = '钱大师' where id =8230;
update channel set eng_name = 'autohome' where id =6228;
update channel set eng_name = 'Keydot' where id =1985;
update channel set eng_name = '盆友' where id =718;
update channel set eng_name = 'NIUYOUGUO' where id =9788;
update channel set eng_name = '拇指玩' where id =782;
update channel set eng_name = 'MoWeather' where id =6047;
update channel set eng_name = 'momo' where id =822;
update channel set eng_name = 'imopan' where id =407;
update channel set eng_name = '米淘赚赚' where id =12708;
update channel set eng_name = '咪兔广告' where id =5754;
update channel set eng_name = 'MEIZU(subpackage)' where id =772;
update channel set eng_name = 'meitu' where id =10966;
update channel set eng_name = '芒果启明' where id =9342;
update channel set eng_name = 'mantoinfo' where id =5389;
update channel set eng_name = '麦田' where id =2337;
update channel set eng_name = '麦萌漫画' where id =1744;
update channel set eng_name = 'LOOME' where id =11262;
update channel set eng_name = '龙珠直播' where id =5579;
update channel set eng_name = '龙涵' where id =5880;
update channel set eng_name = '零花钱' where id =10362;
update channel set eng_name = '灵境' where id =919;
update channel set eng_name = '猎户投放平台' where id =12632;
update channel set eng_name = 'UNIWING' where id =8005;
update channel set eng_name = '联想' where id =769;
update channel set eng_name = '联创云科' where id =12559;
update channel set eng_name = '力美积分墙' where id =409;
update channel set eng_name = 'limeiDSP' where id =450;
update channel set eng_name = '乐樽' where id =5339;
update channel set eng_name = '乐视DSP' where id =2408;
update channel set eng_name = '乐米科技' where id =10864;
update channel set eng_name = '懒鱼' where id =11639;
update channel set eng_name = 'Kuaizi' where id =423;
update channel set eng_name = 'AdView' where id =5567;
update channel set eng_name = 'Kwai(subpackage)' where id =10588;
update channel set eng_name = 'Kwai' where id =2586;
update channel set eng_name = 'Kuaikan World' where id =5695;
update channel set eng_name = '酷派' where id =771;
update channel set eng_name = '酷狗' where id =783;
update channel set eng_name = 'gzjunbo' where id =7716;
update channel set eng_name = 'jpmob' where id =1368;
update channel set eng_name = 'AdinALL' where id =7726;
update channel set eng_name = '聚点DaM' where id =5388;
update channel set eng_name = '巨掌' where id =955;
update channel set eng_name = '巨鲨Wap' where id =2821;
update channel set eng_name = 'Tanv' where id =7678;
update channel set eng_name = '玖玖网络' where id =7743;
update channel set eng_name = 'gomo' where id =509;
update channel set eng_name = 'Ground Nine' where id =6164;
update channel set eng_name = '京盟世纪' where id =8772;
update channel set eng_name = 'KING CLOUD' where id =8986;
update channel set eng_name = '金立' where id =770;
update channel set eng_name = '金龟子' where id =11058;
update channel set eng_name = '今日赚' where id =5961;
update channel set eng_name = 'bytedance(subpackage)' where id =10452;
update channel set eng_name = 'bytedance' where id =514;
update channel set eng_name = 'JIGUANG' where id =2567;
update channel set eng_name = 'htmob' where id =2322;
update channel set eng_name = '惠员助手' where id =5890;
update channel set eng_name = '话语科技' where id =6523;
update channel set eng_name = 'HuaAT' where id =5909;
update channel set eng_name = 'HUAWEI' where id =768;
update channel set eng_name = 'HeTaoLin' where id =8956;
update channel set eng_name = 'HISUN UNION' where id =1676;
update channel set eng_name = '海马玩' where id =11548;
update channel set eng_name = '果盟' where id =391;
update channel set eng_name = '果合视频' where id =1100;
update channel set eng_name = 'Guohe' where id =393;
update channel set eng_name = '广州娱玩' where id =6668;
update channel set eng_name = 'Tencent Social Ads(subpackage)' where id =10457;
update channel set eng_name = 'Tencent Social Ads' where id =5305;
update channel set eng_name = 'CooGuo' where id =8166;
update channel set eng_name = 'gao7' where id =496;
update channel set eng_name = '高能平台' where id =7386;
update channel set eng_name = 'PHOENIX SATELLITE TV' where id =9023;
update channel set eng_name = '蜂巢' where id =737;
update channel set eng_name = 'ADSMAR' where id =2415;

update sy_dic_item set eng_item_value = "game type" where item_value = "游戏类型";
update sy_dic_item set eng_item_value = "cosplay" where item_value = "角色扮演";
update sy_dic_item set eng_item_value = "action" where item_value = "动作";
update sy_dic_item set eng_item_value = "shooting" where item_value = "射击";
update sy_dic_item set eng_item_value = "card" where item_value = "卡牌";
update sy_dic_item set eng_item_value = "Strategy" where item_value = "策略";
update sy_dic_item set eng_item_value = "Simulation operation" where item_value = "模拟经营";
update sy_dic_item set eng_item_value = "Casual puzzle" where item_value = "休闲益智";
update sy_dic_item set eng_item_value = "Racing" where item_value = "竞速";
update sy_dic_item set eng_item_value = "Chess" where item_value = "棋牌";
update sy_dic_item set eng_item_value = "physical education" where item_value = "体育";
update sy_dic_item set eng_item_value = "Musical dance" where item_value = "音乐舞蹈";
update sy_dic_item set eng_item_value = "Word games" where item_value = "文字游戏";
update sy_dic_item set eng_item_value = "MOBA" where item_value = "MOBA";
update sy_dic_item set eng_item_value = "MMO" where item_value = "MMO";
update sy_dic_item set eng_item_value = "Arcade" where item_value = "街机";
update sy_dic_item set eng_item_value = "Tower defensive" where item_value = "塔防守卫";
update sy_dic_item set eng_item_value = "Sandbox" where item_value = "沙盒";
update sy_dic_item set eng_item_value = "board game" where item_value = "桌游";
update sy_dic_item set eng_item_value = "Party game" where item_value = "聚会游戏";
update sy_dic_item set eng_item_value = "Place the game" where item_value = "放置游戏";
update sy_dic_item set eng_item_value = "legend" where item_value = "传奇";
update sy_dic_item set eng_item_value = "Game theme" where item_value = "游戏题材";
update sy_dic_item set eng_item_value = "Martial arts" where item_value = "武侠";
update sy_dic_item set eng_item_value = "modern" where item_value = "现代";
update sy_dic_item set eng_item_value = "Xian Xia" where item_value = "仙侠";
update sy_dic_item set eng_item_value = "Anime" where item_value = "动漫";
update sy_dic_item set eng_item_value = "Chinese myth" where item_value = "中国神话";
update sy_dic_item set eng_item_value = "Western myth" where item_value = "西方神话";
update sy_dic_item set eng_item_value = "Science fiction" where item_value = "科幻";
update sy_dic_item set eng_item_value = "Fantasy" where item_value = "玄幻";
update sy_dic_item set eng_item_value = "Fantasy" where item_value = "奇幻";
update sy_dic_item set eng_item_value = "Magic" where item_value = "魔幻";
update sy_dic_item set eng_item_value = "Warcraft" where item_value = "魔兽";
update sy_dic_item set eng_item_value = "Westward tour" where item_value = "西游";
update sy_dic_item set eng_item_value = "Three countries" where item_value = "三国";
update sy_dic_item set eng_item_value = "World War II" where item_value = "二战";
update sy_dic_item set eng_item_value = "war" where item_value = "战争";
update sy_dic_item set eng_item_value = "Variety" where item_value = "综艺";
update sy_dic_item set eng_item_value = "Movie" where item_value = "影视";
update sy_dic_item set eng_item_value = "navigation" where item_value = "航海";
update sy_dic_item set eng_item_value = "Zombie" where item_value = "僵尸";
update sy_dic_item set eng_item_value = "Chamber" where item_value = "密室";
update sy_dic_item set eng_item_value = "Girl" where item_value = "女生";
update sy_dic_item set eng_item_value = "Mech" where item_value = "机甲";
update sy_dic_item set eng_item_value = "crime" where item_value = "犯罪";
update sy_dic_item set eng_item_value = "Ninja" where item_value = "忍者";
update sy_dic_item set eng_item_value = "knight" where item_value = "骑士";
update sy_dic_item set eng_item_value = "Counter terrorism" where item_value = "反恐";
update sy_dic_item set eng_item_value = "palace" where item_value = "宫廷";
update sy_dic_item set eng_item_value = "Crossing" where item_value = "穿越";
update sy_dic_item set eng_item_value = "Boy" where item_value = "男生";
update sy_dic_item set eng_item_value = "Matchstick Men" where item_value = "火柴人";
update sy_dic_item set eng_item_value = "Art style" where item_value = "美术风格";
update sy_dic_item set eng_item_value = "Realistic" where item_value = "写实";
update sy_dic_item set eng_item_value = "Cartoon" where item_value = "卡通";
update sy_dic_item set eng_item_value = "Ink" where item_value = "水墨";
update sy_dic_item set eng_item_value = "dream" where item_value = "梦幻";
update sy_dic_item set eng_item_value = "Secondary element" where item_value = "二次元";
update sy_dic_item set eng_item_value = "bloody" where item_value = "血腥";
update sy_dic_item set eng_item_value = "Pixel" where item_value = "像素";
update sy_dic_item set eng_item_value = "Retro" where item_value = "复古";
update sy_dic_item set eng_item_value = "antiquity" where item_value = "古风";
update sy_dic_item set eng_item_value = "Black and white" where item_value = "黑白";
update sy_dic_item set eng_item_value = "Simple" where item_value = "简约";
update sy_dic_item set eng_item_value = "Beautiful" where item_value = "唯美";
update sy_dic_item set eng_item_value = "Cool" where item_value = "酷炫";
update sy_dic_item set eng_item_value = "Japanese" where item_value = "日系";
update sy_dic_item set eng_item_value = "Matchstick Men" where item_value = "火柴人";
update sy_dic_item set eng_item_value = "Funny" where item_value = "搞笑";
update sy_dic_item set eng_item_value = "Blood" where item_value = "热血";
update sy_dic_item set eng_item_value = "Online shopping" where item_value = "网购";
update sy_dic_item set eng_item_value = "online store" where item_value = "网上商城";
update sy_dic_item set eng_item_value = "Group buy" where item_value = "团购";
update sy_dic_item set eng_item_value = "Shopping guide" where item_value = "导购";
update sy_dic_item set eng_item_value = "parity" where item_value = "比价";
update sy_dic_item set eng_item_value = "Shopping sharing" where item_value = "购物分享";
update sy_dic_item set eng_item_value = "education" where item_value = "教育";
update sy_dic_item set eng_item_value = "Early education" where item_value = "早教";
update sy_dic_item set eng_item_value = "Tutoring" where item_value = "课外辅导";
update sy_dic_item set eng_item_value = "Study abroad" where item_value = "留学出国";
update sy_dic_item set eng_item_value = "foreign language" where item_value = "外语";
update sy_dic_item set eng_item_value = "professional skill" where item_value = "专业技能";
update sy_dic_item set eng_item_value = "management" where item_value = "管理";
update sy_dic_item set eng_item_value = "culture and art" where item_value = "文化艺术";
update sy_dic_item set eng_item_value = "Book audio" where item_value = "图书音像";
update sy_dic_item set eng_item_value = "examination" where item_value = "考试";
update sy_dic_item set eng_item_value = "dialect" where item_value = "方言";
update sy_dic_item set eng_item_value = "Course management" where item_value = "课程管理";
update sy_dic_item set eng_item_value = "read" where item_value = "阅读";
update sy_dic_item set eng_item_value = "Prenatal reading" where item_value = "胎教读物";
update sy_dic_item set eng_item_value = "Children's books" where item_value = "少儿读物";
update sy_dic_item set eng_item_value = "Fiction" where item_value = "小说";
update sy_dic_item set eng_item_value = "magazine" where item_value = "期刊杂志";
update sy_dic_item set eng_item_value = "Comic" where item_value = "漫画";
update sy_dic_item set eng_item_value = "Dictionary translation" where item_value = "词典翻译";
update sy_dic_item set eng_item_value = "Reading platform" where item_value = "阅读平台";
update sy_dic_item set eng_item_value = "Poetry" where item_value = "诗词名著";
update sy_dic_item set eng_item_value = "joke" where item_value = "笑话";
update sy_dic_item set eng_item_value = "psychological" where item_value = "心理";
update sy_dic_item set eng_item_value = "Popular science" where item_value = "科普";
update sy_dic_item set eng_item_value = "News" where item_value = "资讯";
update sy_dic_item set eng_item_value = "news" where item_value = "新闻资讯";
update sy_dic_item set eng_item_value = "Entertainment news" where item_value = "娱乐资讯";
update sy_dic_item set eng_item_value = "Academic information" where item_value = "学术资讯";
update sy_dic_item set eng_item_value = "Sports information" where item_value = "体育资讯";
update sy_dic_item set eng_item_value = "Financial information" where item_value = "财经资讯";
update sy_dic_item set eng_item_value = "Technology information" where item_value = "科技资讯";
update sy_dic_item set eng_item_value = "gaming strategy" where item_value = "游戏攻略";
update sy_dic_item set eng_item_value = "Social" where item_value = "社交";
update sy_dic_item set eng_item_value = "Weibo" where item_value = "微博";
update sy_dic_item set eng_item_value = "Marriage" where item_value = "婚恋";
update sy_dic_item set eng_item_value = "Dating community" where item_value = "交友社区";
update sy_dic_item set eng_item_value = "Picture sharing" where item_value = "图片分享";
update sy_dic_item set eng_item_value = "Blog forum" where item_value = "博客论坛";
update sy_dic_item set eng_item_value = "communication" where item_value = "通讯";
update sy_dic_item set eng_item_value = "Instant messaging" where item_value = "即时通讯";
update sy_dic_item set eng_item_value = "SMS" where item_value = "短信";
update sy_dic_item set eng_item_value = "mail" where item_value = "邮件";
update sy_dic_item set eng_item_value = "phone" where item_value = "电话";
update sy_dic_item set eng_item_value = "Video and audio" where item_value = "影音";
update sy_dic_item set eng_item_value = "Radio" where item_value = "电台";
update sy_dic_item set eng_item_value = "music" where item_value = "音乐";
update sy_dic_item set eng_item_value = "video" where item_value = "视频";
update sy_dic_item set eng_item_value = "Live broadcast" where item_value = "直播";
update sy_dic_item set eng_item_value = "Audiobooks" where item_value = "有声读物";
update sy_dic_item set eng_item_value = "Business travel" where item_value = "商旅出行";
update sy_dic_item set eng_item_value = "map navigation" where item_value = "地图导航";
update sy_dic_item set eng_item_value = "Driving" where item_value = "代驾";
update sy_dic_item set eng_item_value = "Take a taxi" where item_value = "打车";
update sy_dic_item set eng_item_value = "Car rental" where item_value = "租车";
update sy_dic_item set eng_item_value = "flight" where item_value = "航班";
update sy_dic_item set eng_item_value = "Bus" where item_value = "公交";
update sy_dic_item set eng_item_value = "train" where item_value = "火车";
update sy_dic_item set eng_item_value = "Hotel application" where item_value = "酒店应用";
update sy_dic_item set eng_item_value = "travel information" where item_value = "旅游资讯";
update sy_dic_item set eng_item_value = "Travel sharing" where item_value = "游记分享";
update sy_dic_item set eng_item_value = "coach" where item_value = "长途客车";
update sy_dic_item set eng_item_value = "Home" where item_value = "家居";
update sy_dic_item set eng_item_value = "Decoration" where item_value = "装潢";
update sy_dic_item set eng_item_value = "Home appliance" where item_value = "家电";
update sy_dic_item set eng_item_value = "Furniture" where item_value = "家具";
update sy_dic_item set eng_item_value = "household products" where item_value = "家居用品";
update sy_dic_item set eng_item_value = "Smart home" where item_value = "智能家居";
update sy_dic_item set eng_item_value = "health" where item_value = "健康";
update sy_dic_item set eng_item_value = "lose weight" where item_value = "减肥";
update sy_dic_item set eng_item_value = "work out" where item_value = "运动健身";
update sy_dic_item set eng_item_value = "Health" where item_value = "养生";
update sy_dic_item set eng_item_value = "Medical" where item_value = "医疗";
update sy_dic_item set eng_item_value = "Health management" where item_value = "健康管理";
update sy_dic_item set eng_item_value = "life" where item_value = "生活";
update sy_dic_item set eng_item_value = "Photo photography" where item_value = "拍照摄影";
update sy_dic_item set eng_item_value = "Wenwan collection" where item_value = "文玩收藏";
update sy_dic_item set eng_item_value = "Takeaway order" where item_value = "外卖订餐";
update sy_dic_item set eng_item_value = "Astrology" where item_value = "占星运程";
update sy_dic_item set eng_item_value = "coupon" where item_value = "优惠券";
update sy_dic_item set eng_item_value = "Review" where item_value = "点评";
update sy_dic_item set eng_item_value = "recipe" where item_value = "食谱";
update sy_dic_item set eng_item_value = "business Hall" where item_value = "营业厅";
update sy_dic_item set eng_item_value = "the weather" where item_value = "天气";
update sy_dic_item set eng_item_value = "clock" where item_value = "时钟";
update sy_dic_item set eng_item_value = "express delivery" where item_value = "快递";
update sy_dic_item set eng_item_value = "calendar" where item_value = "日历";
update sy_dic_item set eng_item_value = "Convenience services" where item_value = "便民服务";
update sy_dic_item set eng_item_value = "Fashion wear" where item_value = "时尚穿搭";
update sy_dic_item set eng_item_value = "Point activity" where item_value = "积分活动";
update sy_dic_item set eng_item_value = "Housekeeping" where item_value = "家政";
update sy_dic_item set eng_item_value = "Life synthesis" where item_value = "生活综合";
update sy_dic_item set eng_item_value = "jobs" where item_value = "工作";
update sy_dic_item set eng_item_value = "Recruitment job search" where item_value = "招聘求职";
update sy_dic_item set eng_item_value = "Schedule management" where item_value = "日程管理";
update sy_dic_item set eng_item_value = "notes" where item_value = "笔记";
update sy_dic_item set eng_item_value = "Memo" where item_value = "备忘";
update sy_dic_item set eng_item_value = "Document editing" where item_value = "文件编辑";
update sy_dic_item set eng_item_value = "business card" where item_value = "名片";
update sy_dic_item set eng_item_value = "Address book" where item_value = "通讯录";
update sy_dic_item set eng_item_value = "netdisc" where item_value = "网盘";
update sy_dic_item set eng_item_value = "Store management" where item_value = "店铺管理";
update sy_dic_item set eng_item_value = "Engineering drawing" where item_value = "工程制图";
update sy_dic_item set eng_item_value = "Mobile phone tool" where item_value = "手机工具";
update sy_dic_item set eng_item_value = "System Tool" where item_value = "系统工具";
update sy_dic_item set eng_item_value = "app Store" where item_value = "应用商店";
update sy_dic_item set eng_item_value = "search for" where item_value = "搜索";
update sy_dic_item set eng_item_value = "Input" where item_value = "输入法";
update sy_dic_item set eng_item_value = "Browser" where item_value = "浏览器";
update sy_dic_item set eng_item_value = "Desktop beautification" where item_value = "桌面美化";
update sy_dic_item set eng_item_value = "Reader" where item_value = "阅读器";
update sy_dic_item set eng_item_value = "Utilities" where item_value = "实用工具";
update sy_dic_item set eng_item_value = "editor" where item_value = "编辑器";
update sy_dic_item set eng_item_value = "WIFI" where item_value = "WIFI";
update sy_dic_item set eng_item_value = "Financial management" where item_value = "金融理财";
update sy_dic_item set eng_item_value = "Wealth management" where item_value = "财富管理";
update sy_dic_item set eng_item_value = "Monetary Fund" where item_value = "货币基金";
update sy_dic_item set eng_item_value = "Direct bank" where item_value = "直销银行";
update sy_dic_item set eng_item_value = "Direct insurance" where item_value = "直销保险";
update sy_dic_item set eng_item_value = "Securities" where item_value = "证券";
update sy_dic_item set eng_item_value = "futures" where item_value = "期货";
update sy_dic_item set eng_item_value = "Foreign exchange" where item_value = "外汇";
update sy_dic_item set eng_item_value = "Precious metal" where item_value = "贵金属";
update sy_dic_item set eng_item_value = "Crowdfunding" where item_value = "众筹融资";
update sy_dic_item set eng_item_value = "lottery ticket" where item_value = "彩票";
update sy_dic_item set eng_item_value = "Pay" where item_value = "支付";
update sy_dic_item set eng_item_value = "Borrowing" where item_value = "借贷";
update sy_dic_item set eng_item_value = "Property" where item_value = "房产";
update sy_dic_item set eng_item_value = "Housing consultation" where item_value = "房屋咨询";
update sy_dic_item set eng_item_value = "Buy a house" where item_value = "买房";
update sy_dic_item set eng_item_value = "Selling a house" where item_value = "卖房";
update sy_dic_item set eng_item_value = "Renting a house" where item_value = "租房";
update sy_dic_item set eng_item_value = "Mother and baby" where item_value = "母婴";
update sy_dic_item set eng_item_value = "Pregnancy pregnancy" where item_value = "怀孕备孕";
update sy_dic_item set eng_item_value = "Parenting" where item_value = "育儿";
update sy_dic_item set eng_item_value = "Maternal and child supplies" where item_value = "母婴用品类";
update sy_dic_item set eng_item_value = "entertainment" where item_value = "娱乐";
update sy_dic_item set eng_item_value = "KTV" where item_value = "KTV";
update sy_dic_item set eng_item_value = "show" where item_value = "演出";
update sy_dic_item set eng_item_value = "the film" where item_value = "电影";
update sy_dic_item set eng_item_value = "car" where item_value = "汽车";
update sy_dic_item set eng_item_value = "Car information" where item_value = "汽车资讯";
update sy_dic_item set eng_item_value = "Trading car" where item_value = "买卖车";
update sy_dic_item set eng_item_value = "Driving test" where item_value = "驾考";
update sy_dic_item set eng_item_value = "Owner service" where item_value = "车主服务";
update sy_dic_item set eng_item_value = "Beauty care" where item_value = "个护美容";
update sy_dic_item set eng_item_value = "Skin care application" where item_value = "护肤类应用";
update sy_dic_item set eng_item_value = "Beauty salon manicure" where item_value = "美容美发美甲";
update sy_dic_item set eng_item_value = "Makeup application" where item_value = "彩妆类应用";
update sy_dic_item set eng_item_value = "fantasy" where item_value = "幻想";


update view_column set eng_fieldname = 'Impressions' where fieldname = '展示总数';
update view_column set eng_fieldname = 'Click' where fieldname = '点击';
update view_column set eng_fieldname = 'Valid Clicks' where fieldname = '有效点击总数';
update view_column set eng_fieldname = 'Unique Clicks' where fieldname = '排重点击数';
update view_column set eng_fieldname = 'Daily Unique Clicks' where fieldname = '按天排重点击数';
update view_column set eng_fieldname = 'Unique Installs' where fieldname = '排重激活设备数';
update view_column set eng_fieldname = 'Clicks to Installs' where fieldname = '激活率';
update view_column set eng_fieldname = 'Daily Unique Registers' where fieldname = '按天排重注册设备数';
update view_column set eng_fieldname = 'Unique Registers' where fieldname = '排重注册设备数';
update view_column set eng_fieldname = 'Registration Rate' where fieldname = '注册率';
update view_column set eng_fieldname = '1st Day Retention' where fieldname = 'D1留存';
update view_column set eng_fieldname = '2nd Day Retention' where fieldname = 'D2留存';
update view_column set eng_fieldname = '3rd Day Retention' where fieldname = 'D3留存';
update view_column set eng_fieldname = '4th Day Retention' where fieldname = 'D4留存';
update view_column set eng_fieldname = '5th Day Retention' where fieldname = 'D5留存';
update view_column set eng_fieldname = '6th Day Retention' where fieldname = 'D6留存';
update view_column set eng_fieldname = '7th Day Retention' where fieldname = 'D7留存';
update view_column set eng_fieldname = '14th Day Retention' where fieldname = 'D14留存';
update view_column set eng_fieldname = '30th Day Retention' where fieldname = 'D30留存';
update view_column set eng_fieldname = '45th Day Retention' where fieldname = 'D45留存';
update view_column set eng_fieldname = '60th Day Retention' where fieldname = 'D60留存';
update view_column set eng_fieldname = '90th Day Retention' where fieldname = 'D90留存';
update view_column set eng_fieldname = 'Interval Payments' where fieldname = '区间付费';
update view_column set eng_fieldname = 'New Payments' where fieldname = '新增付费';
update view_column set eng_fieldname = 'New Paid Devices' where fieldname = '新增付费设备数';
update view_column set eng_fieldname = 'Total Payments' where fieldname = '总付费';
update view_column set eng_fieldname = 'Total Paid Devices' where fieldname = '总付费设备数';
update view_column set eng_fieldname = 'Fraud Clicks' where fieldname = '异常点击总数';
update view_column set eng_fieldname = 'Fraud CTR' where fieldname = '异常点击率';
update view_column set eng_fieldname = 'Fraud Installs' where fieldname = '异常激活设备数';
update view_column set eng_fieldname = 'Fraud Convension Rate' where fieldname = '异常激活率';
update view_column set eng_fieldname = 'Fraud Devices' where fieldname = '设备作弊激活数';
update view_column set eng_fieldname = 'Orders' where fieldname = '订单数';
update view_column set eng_fieldname = 'Paid Devices' where fieldname = '下单设备数';
update view_column set eng_fieldname = 'Total Order Value' where fieldname = '订单总额';
update view_column set eng_fieldname = 'Units per Transaction' where fieldname = '客单价';
update view_column set eng_fieldname = 'Paid Orders' where fieldname = '支付订单数';
update view_column set eng_fieldname = 'Paid Devices' where fieldname = '支付设备数';
update view_column set eng_fieldname = 'Total Payments' where fieldname = '支付总额';
update view_column set eng_fieldname = 'Units per Transaction (Paid)' where fieldname = '支付客单价';
update view_column set eng_fieldname = 'Order Payment Rate' where fieldname = '订单付费率';
update view_column set eng_fieldname = 'Convention in 1 Day' where fieldname = '当天激活且注册设备数';
update view_column set eng_fieldname = 'Spend' where fieldname = '总消费';
update view_column set eng_fieldname = 'Clicks' where fieldname = '点击总数';
update view_column set eng_fieldname = 'CTR' where fieldname = '点击率';
update view_column set eng_fieldname = 'CPM' where fieldname = '千次展现消费';
update view_column set eng_fieldname = 'ACP' where fieldname = '平均点击价格';
update view_column set eng_fieldname = 'Valid Click' where fieldname = '有效点击数';
update view_column set eng_fieldname = 'eCPA' where fieldname = '激活eCPA';
update view_column set eng_fieldname = 'eCPA for Registers' where fieldname = '注册eCPA';
update view_column set eng_fieldname = '1 Day ROI' where fieldname = '当日回收率';
update view_column set eng_fieldname = '3 Days ROI' where fieldname = '3日回收率';
update view_column set eng_fieldname = '7 Days ROI' where fieldname = '7日回收率';
update view_column set eng_fieldname = '15 Days ROI' where fieldname = '15日回收率';
update view_column set eng_fieldname = '30 Days ROI' where fieldname = '30日回收率';
update view_column set eng_fieldname = '60 Days ROI' where fieldname = '60日回收率';
update view_column set eng_fieldname = '90 Days ROI' where fieldname = '90日回收率';
update view_column set eng_fieldname = 'New Paid Users' where fieldname = '新增付费用户数';
update view_column set eng_fieldname = 'Total Paid Users' where fieldname = '总付费用户数';
update view_column set eng_fieldname = 'Number of Visits' where fieldname = '访问次数';
update view_column set eng_fieldname = 'New Installs' where fieldname = '新增用户';
update view_column set eng_fieldname = 'Registers' where fieldname = '注册数';
update view_column set eng_fieldname = 'Login' where fieldname = '登录';
update view_column set eng_fieldname = 'Average Time on Site' where fieldname = '次均访问时长';
update view_column set eng_fieldname = 'Bounce Rate' where fieldname = '跳出率';
update view_column set eng_fieldname = 'Daily Unique Logins' where fieldname = '按天排重登陆设备数';
update view_column set eng_fieldname = 'Total Registers' where fieldname = '总注册数';


update role_auth_detail set eng_auth_name = 'Reports' where auth_name = '报表';
update role_auth_detail set eng_auth_name = 'Overview' where auth_name = '总览';
update role_auth_detail set eng_auth_name = 'Real time' where auth_name = '实时';
update role_auth_detail set eng_auth_name = 'Campaign' where auth_name = '推广活动详情';
update role_auth_detail set eng_auth_name = 'SEM Campaign' where auth_name = 'SEM推广详情';
update role_auth_detail set eng_auth_name = 'Performance' where auth_name = '渠道效果对比';
update role_auth_detail set eng_auth_name = 'Attribution Inquiry' where auth_name = '归因查询';
update role_auth_detail set eng_auth_name = 'Latent Attribution Analysis' where auth_name = '激活延迟分析';
update role_auth_detail set eng_auth_name = 'Ranged Payment' where auth_name = '注收比';
update role_auth_detail set eng_auth_name = 'Integration Management' where auth_name = '推广管理';
update role_auth_detail set eng_auth_name = 'Campaign Management' where auth_name = '推广活动管理';
update role_auth_detail set eng_auth_name = 'Postback Management' where auth_name = '推广回调管理';
update role_auth_detail set eng_auth_name = 'User Behavior Analysis' where auth_name = '行为分析';
update role_auth_detail set eng_auth_name = 'Custom Dashboard' where auth_name = '行业看单';
update role_auth_detail set eng_auth_name = 'Event Analysis' where auth_name = '事件分析';
update role_auth_detail set eng_auth_name = 'Funnel' where auth_name = '漏斗转化';
update role_auth_detail set eng_auth_name = 'Retention' where auth_name = '留存分析';
update role_auth_detail set eng_auth_name = 'User Tracking' where auth_name = '智能路径';
update role_auth_detail set eng_auth_name = 'Cohort' where auth_name = '用户分群';
update role_auth_detail set eng_auth_name = 'Events Tracking Management' where auth_name = '埋点管理';
update role_auth_detail set eng_auth_name = 'APP Events Tracking Management' where auth_name = 'APP事件管理';
update role_auth_detail set eng_auth_name = 'User Profile Management' where auth_name = '用户属性管理';
update role_auth_detail set eng_auth_name = 'Export Data' where auth_name = '数据导出';
update role_auth_detail set eng_auth_name = 'Export Log' where auth_name = '日志导出';
update role_auth_detail set eng_auth_name = 'Log Address' where auth_name = '日志地址';
update role_auth_detail set eng_auth_name = 'Real Time Log' where auth_name = '日志流';
update role_auth_detail set eng_auth_name = 'Download Reports' where auth_name = '下载报表';
update role_auth_detail set eng_auth_name = 'Export ad group' where auth_name = '子活动导出';
update role_auth_detail set eng_auth_name = 'Campaign (package)' where auth_name = '分包推广详情';
update role_auth_detail set eng_auth_name = 'ASM Latent Attribution' where auth_name = 'ASM延迟归因';
update role_auth_detail set eng_auth_name = 'Dashboard' where auth_name = '仪表盘';
update role_auth_detail set eng_auth_name = 'Configuration' where auth_name = '配置';
update role_auth_detail set eng_auth_name = 'Advance' where auth_name = '高级服务';
update role_auth_detail set eng_auth_name = 'Fraud Protection' where auth_name = '防作弊卫士';
update role_auth_detail set eng_auth_name = 'Tools' where auth_name = '工具';
update role_auth_detail set eng_auth_name = 'Cost Data Integration' where auth_name = '回本分析';

commit;
set autocommit = 1;