package com.reyun.controller;

import com.reyun.service.TipService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

/**
 * LOGO 信息后台接口化
 */
@Controller
@RequestMapping("logo")
public class LogoDicController {

    @Autowired
    private TipService tipService;


    @RequestMapping(value = "dic", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findByMenu(String domain, HttpServletRequest request){
        //通过域名获取相关 替换数据
        return ResultModel.OK (tipService.findLogoDicData(domain));

    }
}
