package com.reyun.controller.manage;

import com.reyun.task.ExportReportTask;
import com.reyun.util.ResultModel;
import com.reyun.util.SendCommonPostMail;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;


@RestController
public class MailTestController {

    @Autowired
    ExportReportTask exportReportTask;

    @RequestMapping(value = "testmail", method = RequestMethod.GET)
    public ResultModel list( ) {

        String sub = "测试邮件";
        String content="测试邮件,请忽略";

        try {
            /*MailUtils.sendSimpleEmail(sub,"(sendSimpleEmail) "+content,new ArrayList<>());
            MailUtils.sendHtmlEmail(sub,"(sendHtmlEmail) "+content,new ArrayList<>());
            MailUtils.sendHtmlEmailWithCC(sub,"(sendHtmlEmailWithCC) "+content,new ArrayList<>(),new ArrayList<>(),new ArrayList<>(),null);
            MailUtils.sendMultiPartEmail(sub,"(sendMultiPartEmail) "+content,new ArrayList<>(),new String[]{});*/
            SendCommonPostMail.sendMailReuse(new ArrayList<>(), sub, content,new ArrayList<>(),new ArrayList<>());

        }catch (Exception e){
            e.printStackTrace();
        }

        return ResultModel.OK();
    }


    @RequestMapping(value = "testexport", method = RequestMethod.GET)
    public ResultModel listExport(String id ) {

        exportReportTask.exportReport(Long.parseLong(id));

        return ResultModel.OK();
    }
}
