package com.reyun.dic;


/**
 * 回本分析渠道(备注：此处的key与recycle_channel的unique_name一致)
 */
public enum RecycleChannelEnum {

    UCTT("uctoutiao","Uc头条"),
    BAIDUYS("baiduyuansheng","百度原生");


    private String key;
    private String value;

    RecycleChannelEnum(String key, String value) {
        this.key = key;
        this.value = value;
    }

    public String getKey() {
        return key;
    }

    public String getValue() {
        return value;
    }

    public  static RecycleChannelEnum getRecycleChannelEnumByKey(String key){
         for(RecycleChannelEnum recycleChannelEnum : RecycleChannelEnum.values()){
             if(key.equals(recycleChannelEnum.getKey())){
                 return  recycleChannelEnum;
             }
         }
         return  null;
    }

}
