package com.reyun.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;

@Entity
public class PackageSubCampaign
{

    private Long id;
    private Long account;
    private Long app;
    private Long channel;
    private Long parent;
    private String parentCampaignid;  //父推广活动id
    private String campaignid;        //子推广活动
    private String packChannelid;

    private String name;
    private String url;
    private String urlName;
    private String surl;

    private Boolean awssuccess = false;

    private Date createTime;
    private Long createAccount;
    private Date modifyTime;
    private Long modifyAccount;
    private Boolean delFlag = false;

    private String trackUrl;

    private String impUrl;

    private String specialKeys;

    private String advertiserid;

    private String bundleid;
    
    private int batchNumber = -1;

    private int startNumber = -1;
    
    private int endNumber = -1;

    private boolean vivo2DDb;
    private boolean deeplink = false;
    private AppDeepLink appDeepLink;
    
    public PackageSubCampaign clone() {
    	PackageSubCampaign instance = new PackageSubCampaign();
    	instance.id = this.id;
    	instance.account = this.account;
    	instance.app = this.app;
    	instance.channel = this.channel;
    	instance.parent = this.parent;
    	instance.parentCampaignid = this.parentCampaignid;
    	instance.campaignid = this.campaignid;
    	instance.packChannelid = this.packChannelid;
    	instance.name = this.name;
    	instance.url = this.url;
    	instance.surl = this.surl;
    	instance.awssuccess = this.awssuccess;
    	instance.createTime = this.createTime;
    	instance.createAccount = this.createAccount;
    	instance.modifyTime = this.modifyTime;
    	instance.modifyAccount = this.modifyAccount;
    	instance.delFlag = this.delFlag;
    	instance.specialKeys = this.specialKeys;
    	instance.advertiserid = this.advertiserid;
    	instance.bundleid = this.bundleid;
    	return instance;
    }
    
    @Transient
    public int getBatchNumber() {
		return batchNumber;
	}

	public void setBatchNumber(int batchNumber) {
		this.batchNumber = batchNumber;
	}
	
	@Transient
	public int getStartNumber() {
		return startNumber;
	}

	public void setStartNumber(int startNumber) {
		this.startNumber = startNumber;
	}
	
	@Transient
	public int getEndNumber() {
		return endNumber;
	}

	public void setEndNumber(int endNumber) {
		this.endNumber = endNumber;
	}

	@Transient
    public String getImpUrl() {
        return impUrl;
    }

    public void setImpUrl(String impUrl) {
        this.impUrl = impUrl;
    }

    @Transient
    public String getTrackUrl() {
        return trackUrl;
    }

    public void setTrackUrl(String trackUrl) {
        this.trackUrl = trackUrl;
    }

    @Transient
    public boolean isVivo2DDb() {
        return vivo2DDb;
    }

    public void setVivo2DDb(boolean vivo2DDb) {
        this.vivo2DDb = vivo2DDb;
    }

    @Id
    @GeneratedValue
    public Long getId()
    {
        return id;
    }

    public void setId(Long id)
    {
        this.id = id;
    }

    public Long getAccount() {
        return account;
    }

    public void setAccount(Long account) {
        this.account = account;
    }

    public Long getApp() {
        return app;
    }

    public void setApp(Long app) {
        this.app = app;
    }

    public Long getChannel() {
        return channel;
    }

    public void setChannel(Long channel) {
        this.channel = channel;
    }

    public String getCampaignid() {
        return campaignid;
    }

    public void setCampaignid(String campaignid) {
        this.campaignid = campaignid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getSurl() {
        return surl;
    }

    public void setSurl(String surl) {
        this.surl = surl;
    }

    public Boolean getAwssuccess() {
        return awssuccess;
    }

    public void setAwssuccess(Boolean awssuccess) {
        this.awssuccess = awssuccess;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Long getCreateAccount() {
        return createAccount;
    }

    public void setCreateAccount(Long createAccount) {
        this.createAccount = createAccount;
    }

    public Date getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
    }

    public Long getModifyAccount() {
        return modifyAccount;
    }

    public void setModifyAccount(Long modifyAccount) {
        this.modifyAccount = modifyAccount;
    }

    public Boolean getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Boolean delFlag) {
        this.delFlag = delFlag;
    }

    public String getParentCampaignid() {
        return parentCampaignid;
    }

    public void setParentCampaignid(String parentCampaignid) {
        this.parentCampaignid = parentCampaignid;
    }

    public Long getParent() {
        return parent;
    }

    public void setParent(Long parent) {
        this.parent = parent;
    }

    public String getPackChannelid() {
        return packChannelid;
    }

    public void setPackChannelid(String packChannelid) {
        this.packChannelid = packChannelid;
    }

    public String getSpecialKeys() {
        return specialKeys;
    }

    public void setSpecialKeys(String specialKeys) {
        this.specialKeys = specialKeys;
    }

    public String getBundleid() {
        return bundleid;
    }

    public void setBundleid(String bundleid) {
        this.bundleid = bundleid;
    }

    public String getAdvertiserid() {
        return advertiserid;
    }

    public void setAdvertiserid(String advertiserid) {
        this.advertiserid = advertiserid;
    }

    public String getUrlName() {
        return urlName;
    }

    public void setUrlName(String urlName) {
        this.urlName = urlName;
    }

    @Transient
    public AppDeepLink getAppDeepLink() {
        return appDeepLink;
    }

    public void setAppDeepLink(AppDeepLink appDeepLink) {
        this.appDeepLink = appDeepLink;
    }
    @Transient
    public boolean isDeeplink() {
        return deeplink;
    }

    public void setDeeplink(boolean deeplink) {
        this.deeplink = deeplink;
    }
}
