package com.reyun.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

/**
 * Created by sunhao on 17/3/14.
 * Description: DynamoDB TrackInstall 中的点击MAP模型
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class TrackInstallClickModel {

    private String campaignid;

    private String campaignName;

    private String cid;

    private String channelName;

    private String ip;

    private String isNormClick;

    private String isLastClick;

    private String timestamp;

    private Boolean impressionMatch;

    private Boolean campaignSubscribes;

    public Boolean getImpressionMatch() {
        return impressionMatch;
    }

    public void setImpressionMatch(Boolean impressionMatch) {
        this.impressionMatch = impressionMatch;
    }

    public String getCampaignid() {
        return campaignid;
    }

    public void setCampaignid(String campaignid) {
        this.campaignid = campaignid;
    }

    public String getCampaignName() {
        return campaignName;
    }

    public void setCampaignName(String campaignName) {
        this.campaignName = campaignName;
    }

    public String getCid() {
        return cid;
    }

    public void setCid(String cid) {
        this.cid = cid;
    }

    public String getChannelName() {
        return channelName;
    }

    public void setChannelName(String channelName) {
        this.channelName = channelName;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getIsNormClick() {
        return isNormClick;
    }

    public void setIsNormClick(String isNormClick) {
        this.isNormClick = isNormClick;
    }

    public String getIsLastClick() {
        return isLastClick;
    }

    public void setIsLastClick(String isLastClick) {
        this.isLastClick = isLastClick;
    }

    public String getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(String timestamp) {
        this.timestamp = timestamp;
    }

    public Boolean getCampaignSubscribes() {
        return campaignSubscribes;
    }

    public void setCampaignSubscribes(Boolean campaignSubscribes) {
        this.campaignSubscribes = campaignSubscribes;
    }
}
