package com.reyun.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import java.util.List;

/**
 * Created by sunhao on 17/3/13.
 * description:DynamoDB TrackInstall 激活模型
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class TrackInstallModel {

    private String appid;

    private String campaignid;

    private String campaignName;

    private String channelname;

    private String clicktime;

    private String deviceid;

    private String installid;

    private String ip;

    private String isNormInstall;

    private String joinType;

    private String timestamp;

    private String ttl;

    private String when;

    private String cid;

    private String click_ip;

    private Boolean impressionMatch;

    private String sonCampaignid;

    private String sonCampaignName;

    private Boolean campaignSubscribes;

    public Boolean getImpressionMatch() {
        return impressionMatch;
    }

    public void setImpressionMatch(Boolean impressionMatch) {
        this.impressionMatch = impressionMatch;
    }

    public String getClick_ip() {
        return click_ip;
    }

    public void setClick_ip(String click_ip) {
        this.click_ip = click_ip;
    }

    public String getCid() {
        return cid;
    }

    public void setCid(String cid) {
        this.cid = cid;
    }

    private List<TrackInstallClickModel> clickHistory;

    public String getAppid() {
        return appid;
    }

    public void setAppid(String appid) {
        this.appid = appid;
    }

    public String getCampaignid() {
        return campaignid;
    }

    public void setCampaignid(String campaignid) {
        this.campaignid = campaignid;
    }

    public String getCampaignName() {
        return campaignName;
    }

    public void setCampaignName(String campaignName) {
        this.campaignName = campaignName;
    }

    public String getChannelname() {
        return channelname;
    }

    public void setChannelname(String channelname) {
        this.channelname = channelname;
    }

    public String getClicktime() {
        return clicktime;
    }

    public void setClicktime(String clicktime) {
        this.clicktime = clicktime;
    }

    public String getDeviceid() {
        return deviceid;
    }

    public void setDeviceid(String deviceid) {
        this.deviceid = deviceid;
    }

    public String getInstallid() {
        return installid;
    }

    public void setInstallid(String installid) {
        this.installid = installid;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getIsNormInstall() {
        return isNormInstall;
    }

    public void setIsNormInstall(String isNormInstall) {
        this.isNormInstall = isNormInstall;
    }

    public String getJoinType() {
        return joinType;
    }

    public void setJoinType(String joinType) {
        this.joinType = joinType;
    }

    public String getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(String timestamp) {
        this.timestamp = timestamp;
    }

    public String getTtl() {
        return ttl;
    }

    public void setTtl(String ttl) {
        this.ttl = ttl;
    }

    public String getWhen() {
        return when;
    }

    public void setWhen(String when) {
        this.when = when;
    }

    public List<TrackInstallClickModel> getClickHistory() {
        return clickHistory;
    }

    public void setClickHistory(List<TrackInstallClickModel> clickHistory) {
        this.clickHistory = clickHistory;
    }

    public String getSonCampaignid() {
        return sonCampaignid;
    }

    public void setSonCampaignid(String sonCampaignid) {
        this.sonCampaignid = sonCampaignid;
    }

    public String getSonCampaignName() {
        return sonCampaignName;
    }

    public void setSonCampaignName(String sonCampaignName) {
        this.sonCampaignName = sonCampaignName;
    }

    public Boolean getCampaignSubscribes() {
        return campaignSubscribes;
    }

    public void setCampaignSubscribes(Boolean campaignSubscribes) {
        this.campaignSubscribes = campaignSubscribes;
    }
}
