package com.reyun.repository;

import com.reyun.model.AbTest;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by sunhao on 17/9/21.
 * 测试查询
 */
public interface AbTestRepository extends JpaRepository<AbTest,Long> {

    @Query(value = "select * from ab_test where menu = ?1 and account_id = ?2 and  status is true", nativeQuery = true)
    AbTest findByAccountAndMenu(String menu, Long accountId);

    @Query(value = "select * from ab_test where account_id = ?1 and  status is true", nativeQuery = true)
    List<AbTest> findByAccount(Long accountId);
}
