package com.reyun.repository;

import com.reyun.model.AccountFlowHourLog;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface AccountFlowHourLogRepository extends JpaRepository<AccountFlowHourLog, Long> {

    @Query(value = "select * from account_flow_hour_log where account_id = ? order by add_time desc limit 1", nativeQuery = true)
    AccountFlowHourLog findLatest(Long id);
}
