package com.reyun.repository;

import org.springframework.data.jpa.repository.JpaRepository;

import com.reyun.model.BussinessMan;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface BussinessManRepository extends JpaRepository<BussinessMan, Long> {

    @Query(value = "select email from bussiness_man where id=(select leader from bussiness_man where id=?1)", nativeQuery = true)
    String findLeaderByBussinessMan(Long bussinessMan);

    @Query(value = "select email from bussiness_man where id=?1", nativeQuery = true)
    String findEmail(Long bussinessMan);

    @Query(value = "select concat(a.email,',',ifnull(b.email,'')) email from bussiness_man a left join bussiness_man b on a.leader = b.id where a.id = ?1", nativeQuery = true)
    String findEmialWithLeader(Long busId);

    @Query(value = "select * from bussiness_man where incumbency is true", nativeQuery = true)
    List<BussinessMan> findAllIncumbency();

    @Query(value = "select email from bussiness_man where id =(select bussinessman from account where id = ?1)", nativeQuery = true)
    String findBussinessManByRootAccount(Long parentAccount);

    @Query(value = "select id from bussiness_man where incumbency =1 and id = (select leader from bussiness_man where id = 1?) union all select id from bussiness_man where incumbency =1 and id = 1?", nativeQuery = true)
    List<Long> findIdsWithLeader(Long bussinessman);
}
