package com.reyun.repository;

import com.reyun.model.CallbackFirstdayPayment;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by zy on 2019/10/17.
 */
@Transactional
public interface CallbackFirstdayPaymentRepository extends JpaRepository<CallbackFirstdayPayment,Long> {

    @Query(value = "select * from callback_firstday_payment where appkey = ?1 nad cid = ?2 limit1", nativeQuery = true)
    CallbackFirstdayPayment getByAppkeyAndCid(String appkey, Long channel);
}
