package com.reyun.repository;

import com.reyun.model.ChannelAdvertising;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author: zhangyao
 * @create: 2019-12-20 15:45
 **/
@Transactional
public interface ChannelAdvertisingRepository extends JpaRepository<ChannelAdvertising,Long> {


    @Query(value = "select * from channel_advertising where status = true order by sort ", nativeQuery = true)
    List<ChannelAdvertising> listAll();

}
