package com.reyun.repository;

import com.reyun.model.ChannelControl;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;


@Transactional
public interface ChannelControlRepository  extends JpaRepository<ChannelControl, Long> {

    @Query(value = "select distinct channel_id from channel_control", nativeQuery = true)
    Long[] findAllDistinctChannelId();

    @Query(value = "select distinct channel_id from channel_control where account_id = ?1", nativeQuery = true)
    Long[] findByAccountId(Long id);
}
