package com.reyun.repository;

import com.reyun.model.Cpcallback;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by Administrator on 2017/3/7 0007.
 */
@Repository
public interface CpcallbackRepository extends JpaRepository<Cpcallback, Long> {
    @Query(value = "SELECT * FROM cpcallback WHERE appid IN (SELECT appkey FROM app WHERE account IN (SELECT id  FROM account WHERE past_date <= ?1)) AND STATUS = 1", nativeQuery = true)
    List<Cpcallback> find15DaysAgo(String date15);

    @Query(value = "UPDATE cpcallback SET STATUS = 0 WHERE id = ?1", nativeQuery = true)
    int updateStatusById(Long id);

    @Query(value = "select event_type from cpcallback where appid = ?1 group by event_type", nativeQuery = true)
    List<String> findEventsByApp(String appkey);


    @Query(value = "SELECT * FROM cpcallback WHERE appid IN ?1", nativeQuery = true)
    List<Cpcallback> findByAppkeys(List<String> appkeys);

}
