package com.reyun.repository;

import com.reyun.model.ExportReportParam;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface ExportReportParamRepository extends JpaRepository<ExportReportParam, Long> {

    List<ExportReportParam> findByApp(Long app);

    @Query(value = "select * from export_report_param where app = ?1 and export_name = ?2",nativeQuery = true)
    ExportReportParam findByAppReportName(Long app, String reportName);
}
