package com.reyun.repository;

import com.reyun.model.FunnelSetting;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface FunnelSettingRepository extends JpaRepository<FunnelSetting, Long> {


    @Query(value = "select * from funnel_setting where app_key = ?1 order by creat_time desc ",nativeQuery = true)
    List<FunnelSetting> findByAppKey(String appid);
}
