package com.reyun.repository;

import com.reyun.model.IncrementFlow;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface IncrementFlowRepository extends JpaRepository<IncrementFlow, Long> {

    @Query(value = "select * from increment_flow where account=?1", nativeQuery = true)
    List<IncrementFlow> findIncrementFlowByAccountId(Long accountId);

}
