package com.reyun.repository;

import com.reyun.model.MenuAuthDetail;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface MenuAuthRepositry extends JpaRepository<MenuAuthDetail, Long> {

    @Query(value = "select * from menu_auth_detail order by sort " ,nativeQuery = true)
    List<MenuAuthDetail> findAllBySort();


    @Query(value = "select * from menu_auth_detail where id in ?1 " ,nativeQuery = true)
    List<MenuAuthDetail> findAccountMenus(List authIds);
}
