package com.reyun.repository;

import com.reyun.model.PreorderParam;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface PreorderParamRepository extends JpaRepository<PreorderParam, Long> {

    @Query(value = "select * from preorder_param where app_id = ?1", nativeQuery = true)
    PreorderParam findByAppId(Long appId);

}
