package com.reyun.repository;

import com.reyun.model.RecycleChannel;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by sunhao on 18/5/17.
 * 回本渠道DAO
 */
public interface RecycleChannelRepository extends JpaRepository<RecycleChannel, Long> {

    @Query(value="select * from recycle_channel where enable is true",nativeQuery=true)
    List<RecycleChannel> findAllEnableChannel();

    @Query(value="select * from recycle_channel where enable is true and cid = ?1",nativeQuery=true)
    RecycleChannel findAllEnableByChannel(Long cid);
}
