package com.reyun.repository;

import com.reyun.model.Restrict4NewContract;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface Restrict4NewContractRepository extends JpaRepository<Restrict4NewContract, Long> {

    @Query(value = "select * from restrict4new_contract where new_price_date = ?2 and account_id = ?1 ",nativeQuery = true)
    Restrict4NewContract findByAccountAndPriceTime(Long id, String modifyPricelevelTime);

    @Query(value = "select * from restrict4new_contract  where account_id=  ?1  order by create_date   ",nativeQuery = true)
    List<Restrict4NewContract> findTop5(Long id);

    @Query(value = "select * from restrict4new_contract  where account_id=  ?1  order by create_date desc limit 1 ",nativeQuery = true)
    Restrict4NewContract findLatest(Long accountId);
}
