package com.reyun.repository;

import com.reyun.model.SyDic;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.List;

/**
 * description:
 *
 * @author nolan
 * @date 25/12/2017
 */
public interface SyDicRepository extends JpaRepository<SyDic, String> {
    /**
     * 查询指定字典信息
     * @param dicCodes
     * @return
     */
    List<SyDic> findByCodeInAndEnableTrue(List<String> dicCodes);


}
