package com.reyun.repository;

import com.reyun.model.TkioAppThirdChannelRel;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * description:
 *
 * @author nolan
 * @date 10/10/2017
 */
public interface TkioAppThirdChannelRelRepository extends JpaRepository<TkioAppThirdChannelRel, String>
{
    @Query(value = "select * from tkio_app_third_channel_rel where update_time >= (select  max(lastupdate_time) from tkio_app_third_channel_rel) or lastupdate_time is null", nativeQuery = true)
    List<TkioAppThirdChannelRel> findNeedSync();
}