package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.AccountRestrict4Web;
import com.reyun.model.App;
import com.reyun.util.ResultModel;

import java.math.BigInteger;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by song on 2017/10/19.
 */
public interface AccountFlowRestrictService {
    AccountRestrict4Web findRestrictByAccount(Long accountId, String lanType);

    BigInteger getTotalNum(String createTime, String pastDate, String appids, String reportName, String sumType);

    BigInteger getTotalNum(Map<String, String> conditions, String reportName, String sumType);

    Boolean isTrackExhaust(Long accountId);

    AccountRestrict4Web RestrictFlowByAccountTask(Account accountId, String lanType);

    HashMap<String, Boolean> getTrackExhaust(List<App> appList);

    Account getRootAccountData(Account account);

    AccountRestrict4Web toEnglish(AccountRestrict4Web byAccountId);

    ResultModel findRestrictByAccountWithoutEmail(String accountId);

    AccountRestrict4Web getAccountUsedFlows(AccountRestrict4Web byAccountId, Account account);
}
