package com.reyun.service;

import com.reyun.dic.ChannelEnumType;
import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.ChannelAccountLinkApp;
import org.json.JSONException;

import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface ChannnelAccountLinkAppService
{

    List<ChannelAccountLinkApp> findByChannelAccount(Account account, long channelAccount);

    ChannelAccountLinkApp save(ChannelAccountLinkApp resource, Long account);

    Map<String, String> valid(ChannelAccountLinkApp resource)
            throws JSONException, IOException;

    void reValid(List<ChannelAccountLinkApp> list)
            throws IOException, JSONException;

    Map<String, String> createUserId(ChannelAccountLinkApp resource)
            throws IOException, JSONException;

    String getUserId(ChannelAccountLinkApp resource);

    void delete(Long id);

    List<App> listApp(Account account, Long linkUserId, String unique_name);

    boolean checkName(ChannelEnumType channelEnumType, String fieldKey, String fieldValue, Long channelAccountId, Long loginAccountId);

    void autoCheckLinkValid();

    List<App> listApp2Manager(Account loginAccount, Long linkuserid, String unique_name, boolean checkManager);
}
