package com.reyun.service;

import com.reyun.dic.DownloadEnumType;
import com.reyun.dic.DownloadStatusEnumType;
import com.reyun.model.Account;
import com.reyun.model.DownloadInfo;

import java.util.List;

/**
 * Created by nolan on 04/01/2017.
 * description:
 */
public interface IDownloadService {
    DownloadInfo save(DownloadInfo downloadInfo);

    DownloadInfo updateStatus(Long id, DownloadStatusEnumType downloadStatusEnumType);

    boolean exist(Long account, String filename, DownloadInfo downloadtype);

    DownloadInfo findById(Long id);

    List<DownloadInfo> find(Long app, Long accountid, DownloadEnumType downloadEnumType);

    List<DownloadInfo> find(Long app, Account loginAccount);

    DownloadInfo delete(Long id);
}
