package com.reyun.service;

import com.reyun.model.App;
import com.reyun.model.AppDeepLink;
import com.reyun.model.SurlModel;

import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 24/12/2016.
 * description:
 */
public interface INoSQLDBService {

    boolean create(SurlModel surlModel);

    boolean update(SurlModel surlModel);

    boolean delete(String surl);

    boolean delete(List<String> surlList);

    SurlModel findBySurl(String surl);

    /**
     * app sdk debug item
     */
    boolean createAppSdkDebugItem(String appKey, App isDebug);

    boolean haveAppDebugItem(String appKey);

    boolean updateAppSdkDebugItem(String appKey, Boolean isDebug);

    boolean deleteAppSdkDebugItem(String appKey);

    boolean updateSettingNewTable(String table, Map valMap);

    boolean deleteFromSettingNewTable(String table, String keyCode, String keyVal);

    void createOrUpdateAndroidAppLinks(AppDeepLink appDeepLink);

    void createOrUpdateIOSUniversalLinks(AppDeepLink appDeepLink);

    boolean sycDDbByBundleId(App appkey, boolean isAdd);

    void updateIOSPaths(AppDeepLink dbAppDeepLink);

    boolean addVivoParamDatas(Map data, String appkey, String campaignid);

    boolean deleteVivoParam(String appkey, String campaignid);
}
