package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.Channel;
import org.springframework.http.ResponseEntity;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface MiniProgramService {
    HashMap<Integer, String> generateAccessToken(App resource);

    Boolean appidValid(Long loginAccount, String mipAppid);

    Map<Integer, String> getQrCode(App app, Long cid, String url, String type, String surl);

    ResponseEntity<byte[]> downloadQrCode(Long id);

    List<Channel> listChannel(Account loginAccount, Long appid, String type);

    HashMap<Integer, String> checkAppValid(Long appid, Account loginAccount);

    ResponseEntity<byte[]> impression(Long campaignId);
}


