package com.reyun.task;

import com.alibaba.fastjson.JSON;
import com.reyun.model.App;
import com.reyun.repository.AppRepository;
import com.reyun.repository.CampaignRepository;
import com.reyun.service.MiniProgramService;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

@SuppressWarnings("SpringAutowiredFieldsWarningInspection")
@Service
public class AutoCheckWeiXinAccessToken {

    private static Logger logger = LoggerFactory.getLogger(AutoCheckWeiXinAccessToken.class);

    @Autowired
    private AppRepository appRepository;

    @Autowired
    private MiniProgramService miniProgramService;

    @Autowired
    private CampaignRepository campaignRepository;

    public void run() {

        /*logger.info("校验微信小程序accessToke是否可用................//Begin, 执行时间: {}", DateTime.now());

        int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE / 1000;
        if (RedisUtilNew.getInstance().tryLock("AutoCheckWeiXinAccessToken", EXPIRE_PERIOD) != null) {
            try {
                List<App> apps = appRepository.findWeiXinApp("wx");
                for (App app : apps) {
                    HashMap<Integer, String> map = null;
                    try {
                        map = miniProgramService.generateAccessToken(app);
                    } catch (Exception e) {
                        logger.error(e.getMessage());
                    }
                    if (map != null) {
                        String tokenMessage = JSON.toJSONString(map);
                        String accessToken = map.get(200);
                        app.setTokenValid(false);
                        app.setTokenMessage(tokenMessage);
                        if (accessToken != null) {
                            app.setAccessToken(accessToken);
                            app.setTokenValid(true);
                        }
                        app.setAppValid(true);

                        HashMap<Integer, String> appValidMap = new HashMap<>();
                        Integer integer = campaignRepository.findbyMipType("miniQrCode", app.getId());
                        if (integer > 100000) {
                            appValidMap.put(211, "创建的小程序二维码数量超过限制(100000条)");
                        }
                        if (!(app.getTokenValid() != null && app.getTokenValid())) {
                            appValidMap.put(212, app.getTokenMessage()==null?"token无效":app.getTokenMessage());
                        }

                        if(appValidMap.size()!=0) {
                            app.setAppValid(false);
                            StringBuilder builder = new StringBuilder();
                            if (appValidMap.get(211) != null) {
                                builder.append("创建的小程序二维码数量超过限制(100000条)\n\n");
                            }
                            if (appValidMap.get(212) != null) {
                                builder.append(map.get(212));
                            }
                            app.setInvalidMessage(builder.toString());
                        }
                        appRepository.save(app);
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
                logger.error(e.getMessage());
            }
        } else {
            logger.info("正在校验微信小程序accessToke......");
        }
        logger.info("校验微信小程序accessToke................//End");*/
    }
}
