package com.reyun.taskexecute;

import com.reyun.context.AppUtils;
import com.reyun.model.Account;
import com.reyun.model.BlacklistApplication;
import com.reyun.model.BussinessMan;
import com.reyun.model.Channel;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.BussinessManRepository;
import com.reyun.repository.ChannelRepository;
import com.reyun.util.*;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by mxq on 2017/10/24.
 */
public class SendEmailByDefenceFakeThread extends Thread{

    private BussinessManRepository bussinessManRepository = AppUtils.getApplicationContext().getBean(BussinessManRepository.class);

    private BlacklistApplication blacklistApplication;

    public SendEmailByDefenceFakeThread(BlacklistApplication blacklistApplication) {
        this.blacklistApplication = blacklistApplication;
    }

    @Override
    public void run() {

        String subject = "TrackingIo申请防作弊";
        StringBuilder content = new StringBuilder();
//        content.append("<!doctype html> <html><head></head><body> ")
//                .append("Larry：</br>")
//                .append("在" + DateUtil.format(blacklistApplication.getPubDate()) + "收到 " + (null == blacklistApplication.getCompany() ? "    " : blacklistApplication.getCompany()) + "   " + blacklistApplication.getParentEmail() + "提交的防作弊功能开通申请，联系手机为 " + blacklistApplication.getTell() + "，请反馈至销售同学进行后续跟进。\n" +
//                        "或至Office快速开通</br>")
//                .append("<a href=\"" + Constant.adminUrl + "\">").append(Constant.adminUrl).append("</a>")
//                .append("</body></html>");

//        Hi
//        在2019-10-22收到‘公司名’邮箱为luka@reyun.com提交的防作弊功能开通申请，
//        联系手机为 18600190031，请销售同学及时关注，如有疑问也可随时联系运营同学。


        content.append("<!doctype html><html><head></head><body> ")
                .append("HI<br>在")
                .append(DateUtil.format(blacklistApplication.getPubDate())).append("收到")
                .append(null == blacklistApplication.getCompany() ? "--" : blacklistApplication.getCompany())
                .append(",邮箱为").append(blacklistApplication.getParentEmail())
                .append("提交的防作弊功能开通申请，联系手机为 ").append(blacklistApplication.getTell())
                .append("，请销售同学及时关注，如有疑问也可随时联系运营同学。")
                .append("</body></html>");
        String contents = content.toString();

//                List<BussinessMan> bussmanList = bussinessManRepository.findAllIncumbency();

        List<BussinessMan> bussmanList = new ArrayList<>();

        Account account = blacklistApplication.getRootAccount();

        if (account != null) {
            bussmanList.add(bussinessManRepository.findOne(account.getBussinessman()));
        }

        if (ValidateUtil.isValid(bussmanList)) {
            List<String> list = new ArrayList<>();
            for (BussinessMan b : bussmanList) {
                if (b != null)
                    list.add(b.getEmail());
            }
            try {
                //MailUtils.sendHtmlEmail(subject,contents,list);
                SendCommonPostMail.sendMailReuse(list, subject, contents, null, null);
            } catch (Exception e) {
                //logger.error(e.getMessage(),e);
            }

        }


    }
}
