package com.reyun.util;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.ResourceBundle;

public class Constant {
    public static final String DEMO_APPLY_CODE = "demo_apply_email_code";
    public static String CURRENT_ACCOUNT = "$CURRENT_ACCOUNT$";

    public static ResourceBundle resourceBundle = ResourceBundle.getBundle("db");
    public static String dburl = resourceBundle.getString("db.url");
    public static String dbusername = resourceBundle.getString("db.username");
    public static String dbpassword = resourceBundle.getString("db.password");
    public static String dbdriver = resourceBundle.getString("db.driver");
    public static String tkiostreamdatasourceurl = resourceBundle.getString("tkiostreamdatasource.url");
    public static String tkiostreamdatasourceusername = resourceBundle.getString("tkiostreamdatasource.username");
    public static String tkiostreamdatasourcepassword = resourceBundle.getString("tkiostreamdatasource.password");
    public static String tkiodatasourceurl = resourceBundle.getString("tkio.datasource.url");
    public static String tkiodatasourceusername = resourceBundle.getString("tkio.datasource.username");
    public static String tkiodatasourcepassword = resourceBundle.getString("tkio.datasource.password");
    public static String MONGO_URI = resourceBundle.getString("mongouri");

    public static ResourceBundle commonBundle = ResourceBundle.getBundle("common");
    public static String reportUrl = commonBundle.getString("report.url");
    public static String adminUrl = commonBundle.getString("admin.url");
    public static String iscache = commonBundle.getString("iscache");
    public static String receiverHost = commonBundle.getString("receiver.host");
    public static String receiverPort = commonBundle.getString("receiver.port");
    public static String reportExportTask = commonBundle.getString("report.export.task");
    public static String appDebugTask = commonBundle.getString("app.debug.task");
    public static String tkioUrl = commonBundle.getString("tkio.url");
    public static String deeplinkHost = commonBundle.getString("deeplink.host");
    public static String qcloudTkioUrl = commonBundle.getString("qcloud.tkio.url");
    public static String backstage = commonBundle.getString("backstage.url");
    public static String ioUrl = commonBundle.getString("io.url");
    public static String demoUtl = commonBundle.getString("demo.url");
    public static String logPath = commonBundle.getString("log.path");
    public static String logBucket = commonBundle.getString("log.bucket");
    public static String mailNeed = commonBundle.getString("mail.need");
    public static String mailProd = commonBundle.getString("mail.prod");
    public static String spiderUrl = commonBundle.getString("spider.url");
    public static String ENV = commonBundle.getString("env");
    public static String kafkaBroker = commonBundle.getString("kafka.broker");

    public static ResourceBundle mailBundle = ResourceBundle.getBundle("mail");
    public static String mailUsername = mailBundle.getString("mail.username");
    public static String mailContentType = mailBundle.getString("mail.content_type");
    public static String mailList = mailBundle.getString("mail.list");
    public static List<String> mlist = Arrays.asList(mailList.split(","));
    public static String mailValidTime = mailBundle.getString("mail.valid_time");

    public static ResourceBundle urlBundle = ResourceBundle.getBundle("trackurl");
    public static String trackurl = urlBundle.getString("track.url");

    public static boolean awsneed = Boolean.parseBoolean(commonBundle.getString("awsneed"));
    public static int FMT_NEWSCALE = 2; //平台小数位数
    public static int FMT_ROUNDINGMODE = BigDecimal.ROUND_HALF_UP;


    public static ResourceBundle cdh = ResourceBundle.getBundle("cdh");
    public static String SHENMA_DOWNLOAD_DIR = cdh.getString("shenma.download.dir");
    public static String bucket = cdh.getString("file.bucket");

    public static ResourceBundle redis = ResourceBundle.getBundle("redis");
    public static String REDIS_KEY_VALID_TIME = redis.getString("redis.key.validtime");
    public static String REDIS_IP_REQUEST_TIMES = redis.getString("redis.ip.requesttimes");
    public static String REDIS_IP_UNKNOWN_REQUEST_TIMES = redis.getString("redis.ip.unknown.requesttimes");

    public static ResourceBundle messagecode = ResourceBundle.getBundle("messagecode");
    public static String messageCodeUrl = messagecode.getString("messagecode.url");

    public static ResourceBundle reportUrlBundle = ResourceBundle.getBundle("report");
    public static String reporturl = reportUrlBundle.getString("report.url");

    public static ResourceBundle lizardBundle = ResourceBundle.getBundle("lizard");
    public static String simulationLoginUrl = lizardBundle.getString("simulation.login.url");

    public static ResourceBundle keyBuddle = ResourceBundle.getBundle("key");
    public static String accessKey = keyBuddle.getString("ddb.accesskey");
    public static String secretKey = keyBuddle.getString("ddb.secretkey");
    public static String ddbregion = keyBuddle.getString("ddb.region");
    public static String cosSecretId = keyBuddle.getString("cos.secretid");
    public static String cosSecretKey = keyBuddle.getString("cos.secretkey");
    public static String cosRegion = keyBuddle.getString("cos.region");
    public static String cosAppid = keyBuddle.getString("cos.appid");

    public static ResourceBundle hive = ResourceBundle.getBundle("hive");
    public static String hiveDriver = hive.getString("hive.driver");
    public static String hiveUrl = hive.getString("hive.url");
    public static String hiveName = hive.getString("hive.username");

    public static String ADVANCED_FUNCTION_MENU_RECYCLE = "recycleanalysis";

    public static String LOCALE_KEY = "lang";
    public static String REGION_KEY = "region";

    public static boolean isQcloudEnv() {
        return "qcloud".equals(ENV);
    }

    public static boolean isAwsEnv() {
        return "aws".equals(ENV);
    }

    public static String getServerDomain() {
        //return Constant.isAwsEnv() ? Constant.qcloudTkioUrl : Constant.tkioUrl;
        return Constant.tkioUrl;
    }

    public static String getDomainStr() {
        /*if (Constant.isQcloudEnv()) {
            return "tweb.trackingio.com";
        } else {
            return "trackingio.com";
        }*/
        return "trackingio.com";
    }
}