package com.reyun.util;

import com.google.common.collect.ArrayListMultimap;
import com.google.common.collect.Multimap;
import com.google.common.collect.Multiset;

import java.util.Collection;

/**
 * Created by nolan on 19/01/2017.
 * description:
 */
public class ViewColumnDependUtil {
    private static Multimap<String, String> multimap = ArrayListMultimap.create();

    static {

        //新增付费设备数/排重激活设备数
        multimap.put("rate_add_daily", "num_payer_new_user");
        multimap.put("rate_add_daily", "num_install");
        //激活率=激活设备数/排重点击
        multimap.put("rate_install", "num_install");
        multimap.put("rate_install", "dupnum_click_all");
        //注册率=注册设备数/激活设备数
        multimap.put("rate_reged", "dupnum_reged_day");
        multimap.put("rate_reged", "num_install");
        //异常点击率=异常点击设备数/点击总数
        multimap.put("rate_click_fake", "num_click_fake");
        multimap.put("rate_click_fake", "num_click_total");
        //异常激活率=异常激活设备数/激活设备数
        multimap.put("rate_install_fake", "num_install_fake");
        multimap.put("rate_install_fake", "num_install");
        //n日留存率=sum(激活设备数n日留存设备数)*100.0/sum(激活设备数)
        multimap.put("rate_retentiond1", "rate_retentiond1");
        multimap.put("rate_retentiond1", "num_install");
        multimap.put("rate_retentiond2", "rate_retentiond2");
        multimap.put("rate_retentiond2", "num_d2_install");
        multimap.put("rate_retentiond3", "rate_retentiond3");
        multimap.put("rate_retentiond3", "num_d3_install");
        multimap.put("rate_retentiond4", "rate_retentiond4");
        multimap.put("rate_retentiond4", "num_d4_install");
        multimap.put("rate_retentiond5", "rate_retentiond5");
        multimap.put("rate_retentiond5", "num_d5_install");
        multimap.put("rate_retentiond6", "rate_retentiond6");
        multimap.put("rate_retentiond6", "num_d6_install");
        multimap.put("rate_retentiond7", "rate_retentiond7");
        multimap.put("rate_retentiond7", "num_d7_install");
        multimap.put("rate_retentiond14", "rate_retentiond14");
        multimap.put("rate_retentiond14", "num_d14_install");
        multimap.put("rate_retentiond30", "rate_retentiond30");
        multimap.put("rate_retentiond30", "num_d30_install");
        multimap.put("rate_retentiond45", "rate_retentiond45");
        multimap.put("rate_retentiond45", "num_d45_install");
        multimap.put("rate_retentiond60", "rate_retentiond60");
        multimap.put("rate_retentiond60", "num_d60_install");
        multimap.put("rate_retentiond90", "rate_retentiond90");
        multimap.put("rate_retentiond90", "num_d90_install");
        //ltvn=sum(n日LTV值)/sum(激活设备数)
        multimap.put("amt_ltv0", "amt_ltv0");
        multimap.put("amt_ltv0", "num_install");
        multimap.put("amt_ltv1", "amt_ltv1");
        multimap.put("amt_ltv1", "num_install");
        multimap.put("amt_ltv2", "amt_ltv2");
        multimap.put("amt_ltv2", "num_install");
        multimap.put("amt_ltv3", "amt_ltv3");
        multimap.put("amt_ltv3", "num_install");
        multimap.put("amt_ltv4", "amt_ltv4");
        multimap.put("amt_ltv4", "num_install");
        multimap.put("amt_ltv5", "amt_ltv5");
        multimap.put("amt_ltv5", "num_install");
        multimap.put("amt_ltv6", "amt_ltv6");
        multimap.put("amt_ltv6", "num_install");
        multimap.put("amt_ltv7", "amt_ltv7");
        multimap.put("amt_ltv7", "num_install");
        multimap.put("amt_ltv14", "amt_ltv14");
        multimap.put("amt_ltv14", "num_install");
        multimap.put("amt_ltv30", "amt_ltv30");
        multimap.put("amt_ltv30", "num_install");
        multimap.put("amt_ltv45", "amt_ltv45");
        multimap.put("amt_ltv45", "num_install");
        multimap.put("amt_ltv60", "amt_ltv60");
        multimap.put("amt_ltv60", "num_install");
        multimap.put("amt_ltv90", "amt_ltv90");
        multimap.put("amt_ltv90", "num_install");
        multimap.put("amt_ltv120", "amt_ltv120");
        multimap.put("amt_ltv120", "num_install");
        multimap.put("amt_ltv150", "amt_ltv150");
        multimap.put("amt_ltv150", "num_install");
        multimap.put("amt_ltv180", "amt_ltv180");
        multimap.put("amt_ltv180", "num_install");
        multimap.put("amt_ltv365", "amt_ltv365");
        multimap.put("amt_ltv365", "num_install");
        //arpu=注收比付费/排重激活设备数
        multimap.put("arpu", "amt_amount");
        multimap.put("arpu", "num_ins");
        //arpu=注收比付费/付费设备数
        multimap.put("arppu", "amt_amount");
        multimap.put("arppu", "num_pay");
        //付费率=付费设备数*100.0/排重激活设备数
        multimap.put("rate_pay", "num_pay");
        multimap.put("rate_pay", "num_ins");
        //H5注册率=注册用户/排重点击
        multimap.put("rate_reged_h5", "num_register");
        multimap.put("rate_reged_h5", "num_click");
        //H5注册率=注册用户/排重点击
        multimap.put("amt_perticket", "amt_order");
        multimap.put("amt_perticket", "num_device");
        //H5注册率=注册用户/排重点击
        multimap.put("amt_pay_perticket", "amt_pay_order");
        multimap.put("amt_pay_perticket", "num_pay_device")
        ;
        multimap.put("rate_pay_order", "num_pay_device");
        multimap.put("rate_pay_order", "num_device");

        multimap.put("rate_bounce", "num_visits_one");
        multimap.put("rate_bounce", "num_click_total");

        multimap.put("amt_time", "amt_time_visits");
        multimap.put("amt_time", "num_click_total");
        //流入流出比：排重激活设备数/新增流失设备数
        multimap.put("rate_backflow_num", "num_install");
        multimap.put("rate_backflow_num", "loss_num");
        //点击率：排重点击数/展示总数
        multimap.put("rate_click", "dupnum_click_all");
        multimap.put("rate_click", "num_impression");
        //调起率：首调总数/排重点击数
        multimap.put("rate_dp", "num_dp");
        multimap.put("rate_dp", "dupnum_click_all");
        //直接调起率：直接调起数/排重点击数
        multimap.put("rate_dp_invoke", "num_dp_invoke");
        multimap.put("rate_dp_invoke", "dupnum_click_all");
        //延迟调起率：延迟调起总数/排重点击数
        multimap.put("rate_dp_install", "num_dp_install_sum");
        multimap.put("rate_dp_install", "dupnum_click_all");

        //回流率
        multimap.put("rate_reflux", "num_install");
        multimap.put("rate_reflux", "dupnum_click_all");
        //游戏付费率
        multimap.put("rate_pay_game", "num_payer_all_user");
        multimap.put("rate_pay_game", "dau");
        //电商付费率
        multimap.put("rate_pay_ec", "num_pay_device");
        multimap.put("rate_pay_ec", "dau");
        //ARPDAU
        multimap.put("amt_arpdau_new", "amt_income_all_user");
        multimap.put("amt_arpdau_new", "dau");
        //ARPPU
        multimap.put("amt_arppu_new", "amt_income_all_user");
        multimap.put("amt_arppu_new", "num_payer_all_user");
        //平均单次使用时长：使用总时长/总会话次数
        multimap.put("avg_time_once_min", "avg_time_once_min");
        multimap.put("avg_time_once_min", "use_freq");
        //平均使用时长：使用总时长/DAU
        multimap.put("avg_time_use_min", "avg_time_use_min");
        multimap.put("avg_time_use_min", "dau");
        //平均使用频率：	总会话次数/DAU
        multimap.put("amt_use_freq", "use_freq");
        multimap.put("amt_use_freq", "dau");
        //变现广告点击率：变现广告点击量/变现广告展示量
        multimap.put("rate_adclick", "adclick_num");
        multimap.put("rate_adclick", "adshow_num");
        //CP0：点击渗透率CP0=选定日期激活设备中第1日点击广告的设备数/选定日期总激活设备数
        multimap.put("rate_cp0", "rate_cp0");
        multimap.put("rate_cp0", "num_install");
        multimap.put("rate_cp1", "rate_cp1");
        multimap.put("rate_cp1", "num_install");
        multimap.put("rate_cp2", "rate_cp2");
        multimap.put("rate_cp2", "num_install");
        multimap.put("rate_cp3", "rate_cp3");
        multimap.put("rate_cp3", "num_install");
        multimap.put("rate_cp4", "rate_cp4");
        multimap.put("rate_cp4", "num_install");
        multimap.put("rate_cp5", "rate_cp5");
        multimap.put("rate_cp5", "num_install");
        multimap.put("rate_cp6", "rate_cp6");
        multimap.put("rate_cp6", "num_install");
        multimap.put("rate_cp7", "rate_cp7");
        multimap.put("rate_cp7", "num_install");
        //ROI=变现收入/消耗*100%
        multimap.put("rate_roi", "cash_income");
        multimap.put("rate_roi", "cost");
        //填充率：填充率=填充成功次数/填充总次数
        multimap.put("rate_fill", "rate_fill");
        multimap.put("rate_fill", "adshow_num");
        multimap.put("activation_cost", "cost");
        multimap.put("activation_cost", "num_install");
        //aaus
        multimap.put("AAUS0", "AAUS0");
        multimap.put("AAUS0", "num_newuser_reten_d0");
        multimap.put("AAUS1", "AAUS1");
        multimap.put("AAUS1", "num_newuser_reten_d1");
        multimap.put("AAUS2", "AAUS2");
        multimap.put("AAUS2", "num_newuser_reten_d2");
        multimap.put("AAUS3", "AAUS3");
        multimap.put("AAUS3", "num_newuser_reten_d3");
        multimap.put("AAUS4", "AAUS4");
        multimap.put("AAUS4", "num_newuser_reten_d4");
        multimap.put("AAUS5", "AAUS5");
        multimap.put("AAUS5", "num_newuser_reten_d5");
        multimap.put("AAUS6", "AAUS6");
        multimap.put("AAUS6", "num_newuser_reten_d6");
        multimap.put("AAUS7", "AAUS7");
        multimap.put("AAUS7", "num_newuser_reten_d7");


    }

    public static Multiset<String> getRateKeyFields() {
        return multimap.keys();
    }

    public static Collection<String> getRateDependFields(String ratefield) {
        return multimap.get(ratefield);
    }
}
