(function() {
    angular.module("app")
        .controller("indexCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$location", "DateService", "$timeout", "$window", "ArrayConstant", "$filter", "$translate", indexCtrl]);


    function indexCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $location, DateService, $timeout, $window, ArrayConstant, $filter, $translate) {
        //灰色上线，仅限两个账号
        $scope.isTrackIo = ToolService.isUser(ArrayConstant.trackIoEmail) || ToolService.isUser(ArrayConstant.zlwEmail);
        //海外版开关 1:是，0：否。
        $scope.isHaiWai = 0;
        $rootScope.unfoldFlag = $rootScope.unfoldFlag == undefined ? false : $rootScope.unfoldFlag;
        //查询开通回本分析状态
        $scope.queryOpenService = function() {
            var servicePM = HttpService.getInfo("mng/recycle/status");
            servicePM.then(function(data) {
                $rootScope.openService = data;
                $rootScope.isShowList = data.isOpen;
                sessionStorage.setItem('isShowList', data.isOpen);
                $rootScope.isPast = diffDate(new Date().Format("yyyy-MM-dd"),
                    new Date(data.pastDate).Format("yyyy-MM-dd")) > 0 ? false : true;
            });
        }

        $scope.goStatus = false
        $scope.goNewPage = function () {
            $scope.goStatus = true
            ToolService.showAlp();
        }
        $scope.closeModal = function(){
            $scope.goStatus = false
            ToolService.hideAlp();
        }
         $scope.goSure = function(){
            $scope.goStatus = false
            ToolService.hideAlp();
            window.open("https://new.trackingio.com/#/home")
         }

        $rootScope.docDomain = 'http://docs.trackingio.com/';//文档地址判断

        $rootScope.redirectNewDoman = true;
        if(document.domain == 'tweb.trackingio.com'){//腾讯云跳转域名
            $rootScope.redirectNewDoman = false;
            $rootScope.docDomain = 'http://doc.trackingio.com/';
        }
        $scope.queryLimit = function(appid) {
            var limitPM, limitBugfixPM;
            if (angular.isDefined(appid)) {
                limitPM = HttpService.getInfo("login/limit/" + appid);
            } else {
                limitPM = HttpService.getInfo("login/limit");

                limitBugfixPM = HttpService.getInfo("login/limit_fake");
                limitBugfixPM.then(function(data) {
                    // $rootScope.limitInfo = data;
                    // sessionStorage.setItem("limitInfo", JSON.stringify($rootScope.limitInfo));
                    if (data && data.defenceFake) {
                        //防作弊节约
                        $rootScope.fakeMoney = data.defenceFake.money;
                        //防作弊状态 :-1未申请 0 已申请 1 试用 2 正式 3 过期
                        $rootScope.fakeType = data.defenceFake.fakeStatusDetail;
                        //防作弊提示
                        $rootScope.fakeAlertType = data.defenceFake.msgStatus;
                        //防作弊报表
                        $rootScope.fakeReport = data.defenceFake.report;
                        //过期时间
                        $rootScope.fakePastDate = data.defenceFake.pastDate;

                        //防作弊剩余天数
                        $rootScope.fakeRemianDays = data.defenceFake.fakeRemianDays;
                        //是否显示到期提醒
                        $rootScope.fakeTips = data.defenceFake.fakeTips;

                        //调起剩余天数
                        if (data.arouseService.arouseRemianDays) {
                            $rootScope.arouseDays = data.arouseService.arouseRemianDays;
                        }
                        //是否显示到期提醒
                        $rootScope.arouseTips = data.arouseService.arouseTips;
                        //-1：未申请；1：审核中；2：已开通；3：已过期；
                        $rootScope.arouseStatus = data.arouseService.arouseStatusDetail;


                    } else {
                        ToolService.showTips($filter('translate')("防作弊相关信息查询为空"));
                    }

                });

            }
            limitPM.then(function(data) {
                $rootScope.limitInfo = data;
                sessionStorage.setItem("limitInfo", JSON.stringify($rootScope.limitInfo));
                /*//防作弊节约
                $rootScope.fakeMoney = $rootScope.limitInfo.defenceFake.money;
                //防作弊状态 :-1未申请 0 已申请 1 试用 2 正式
                $rootScope.fakeType = $rootScope.limitInfo.defenceFake.fakeStatusDetail;
                //防作弊提示
                $rootScope.fakeAlertType = $rootScope.limitInfo.defenceFake.msgStatus;
                //防作弊报表
                $rootScope.fakeReport = $rootScope.limitInfo.defenceFake.report;*/
            });


        }


        $rootScope.demoU = ToolService.isUser(ArrayConstant.demoEmail) || ToolService.isUser(ArrayConstant.hyxdDemoEmail);
        $scope.goLogin = function() {
            window.location.href = "/login.html";
        }
        $scope.closeHint = function(){
			$rootScope.appOnlineTips = false;
        }
        $scope.hideOfflineTip = function(){
            $rootScope.showOfflineTip = false;
        }
        $scope.goAppDetailpage = function () {
            if (angular.isDefined($scope.appid)) {
                $state.go("collect.appDetail", {
                    aid: $scope.appid
                });
            }
        }
        //msgflag=1,新建app刷list
        $scope.queryApp = function(msgflag) {
            ToolService.showLoading();
            var appPM = HttpService.getInfo("app/findall");
            appPM.then(function(data) {

                ToolService.hideLoading();
                $scope.appAlllistInfo = data;
                if ($rootScope.appInstance) {
                    $rootScope.appInstance = data.filter(function(item) {
                        return item.id == $rootScope.appInstance.id;
                    })[0];
                }
                $scope.applistInfo = data ? data.filter(function(item) { //产品过滤后列表
                    return item.isDebug != true;
                }) : [];
                if (msgflag == 1) {
                    return false;
                }

                var lastId = UtilService.getCookie("ryioLastApp");
                var demoapk = UtilService.getCookie("ryioDemoapk");
                UtilService.setCookie("ryioDemoapk", "");
                if ($scope.applistInfo.length > 0) {
                    if (UtilService.isNullStr(lastId)) {
                        lastId = "-1";
                    }
                    lastId = Number(lastId);
                    var apps = $scope.applistInfo.filter(function(item) {
                        if (!UtilService.isNullStr(demoapk)) {
                            return item.appkey == demoapk;
                        } else {
                            return item.id == lastId;
                        }
                    });
                    if (apps.length == 0) { //如果cookie中没有指定最后的产品id或demoapk，则设置第一个产品id为初始id；
                        // lastId = $scope.applistInfo[0].id;//如果第一个产品过期的话会弹出到期提醒，不太适合。
                        var firstValidApp = $scope.applistInfo.find(function(item, index) {
                            return !item.mainAccountExpire && !item.trackAndIoBothExhaust;
                        });
                        lastId = firstValidApp.id || $scope.applistInfo[0].id
                    } else {
                        lastId = apps[0].id;
                    }
                    if ($scope.appidInit == lastId) {
                        $scope.appfresh = ++rmd;
                    } else {
                        $scope.appidInit = lastId;
                    }
                    for (i = 0; i < $scope.applistInfo.length; i++) {
                        if ($scope.applistInfo[i].id == $scope.appidInit) {
                            $scope.appkey = $scope.applistInfo[i].appkey;
                        }
                    }
                } else {
                    if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
                        $state.go("collect.app");
                    } else {
                        $scope.goLogin();
                    }
                }
                $scope.queryOpenService();
            });
        };

        // 地区查询
        $scope.queryArea = function(msgflag) {
            ToolService.showLoading();
            var appArea = HttpService.postInfo("region/find/all");
            appArea.then(function(data) {
                ToolService.hideLoading();
                $scope.appArealistInfo = data;
                var localRegion = $rootScope.getRegion(); //缓存的地区
                var len = data.length;
                if (localRegion) {
                    $scope.appAreaIdInit = localRegion;
                    /*for(var i = 0;i<len; i++){
                        var item = data[i];
                        if(item.regionKey == localRegion){
                            $scope.areaNameInit=item.showValue;
                            break;
                        }
                    }*/
                } else if (len > 0) {
                    $scope.appAreaIdInit = data[0].regionKey;
                }
            });
        };
        $scope.$on('f5Applist', function(e, msg) {
            $scope.queryApp(msg);
        });
        $scope.$on('appAreaId', function(e, msg) {
            if (msg.info.regionKey == $rootScope.getRegion()) return false;
            var regionKey = msg.info.regionKey;
            $rootScope.setRegion(regionKey);
            /*var path = $location.$$path;*/
            $state.reload();
        });
        /**
         * 语言切换监听，刷新页面
         * @type {string[]}
         */
        var langReloadPaths = ["/collect/channeleffect", "/collect/campaigninfo", "/collect/advertisinginfo","/collect/adsenseinfo","/collect/admobinfo","/collect/remarketing","/collect/logexport",
            "/manage/onelinkDetail", "/manage/ckBatchManage", "/collect/packageinfo", "/collect/keyword", "/manage/subpackage",
            "/manage/authpower"
        ];
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                var path = $location.$$path;
                if (langReloadPaths.indexOf(path) > -1) {
                    $state.reload();
                }
            }
        });

        /*
         * 根据域名判断显示logo 
         * doMainType:0 显示trackingio的logo
         * doMainType:1 显示新华频媒的logo
         */
        $rootScope.doMainType = 0;
        $scope.doMain = function() {
            var urltype = $location.host();
            var urlHost = "";
            if (urltype == "hyxd.trackingio.com") {
                urlHost = urltype
                $rootScope.doMainType = 1;
                UtilService.setCookie("sys_domain", urlHost, 7);
                var otherInfoPM = HttpService.getInfo('logo/dic', { domain: urlHost });
                otherInfoPM.then(function(data) {
                        $rootScope.otherCompanyInfo = data;
                    })
            } else {
                urlHost = urltype
                $rootScope.doMainType = 0;
                UtilService.setCookie("sys_domain", urlHost, 7);
            }

        }
        $scope.doMain();


        $scope.getAppFirstMenu = function() {
                //此种情况是，当前子账户登录状态下新增了app权限
                if (!$rootScope.curRoleAuth || !$rootScope.curRoleAuth.roleAuthDetailList) {
                    $scope.goLogin();
                }
                var menus = $rootScope.curRoleAuth.roleAuthDetailList;
                var first = "";
                for (var i = 0; i < menus.length; i++) {
                    var curmenu = UtilService.cloneJSON(menus[i]),
                        mpre = "/collect/";

                    if (['config', 'manage'].indexOf(curmenu.parentAuth) > -1) {
                        mpre = "/manage/";
                    }

                    if ($rootScope.isweb && $rootScope.webHideMenus.indexOf(curmenu.auth) > -1) {
                        continue;
                    }
                    if (curmenu.parentAuth == '') {
                        first = mpre + menus[i + 1].auth;
                    } else {
                        first = mpre + curmenu.auth;
                    }

                    break;
                }
                //判断流量到期或用尽
                var mmenu = first.split("/")[2];
                if ($rootScope.trackLimit != -1 && $rootScope.trackSurplus <= 0 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
                    first = '/collect/expiration'
                }
                return first;
            }

        //H5产品隐藏页面 
        var specialAccount = UtilService.getCookie("specialUname");
        if (specialAccount == "true") {
            $rootScope.webHideMenus = ["datacb", "attribute", "subcampaign", "keyword", "effectevaluate", "roi","advertisinginfo","deeplink","useroverview","channeloverview","refluxanalysis","serveridbackflow","lifesettings","userengagement","terminalattributes"];
            // 如果不是特殊账号，那么就隐藏logexport
            // $rootScope.webHideMenus.push("logexport");
        } else {
            $rootScope.webHideMenus = ["datacb", "attribute", "subcampaign", "logexport", "keyword", "effectevaluate", "roi","advertisinginfo","deeplink","useroverview","channeloverview","refluxanalysis","serveridbackflow","lifesettings","userengagement","terminalattributes"];
        }
        //小程序显示页面
        $rootScope.wxShowMenus = ArrayConstant.wxShowMenus;
        /**
         * 产品ID 监听
         * 切换产品
         */
        $scope.$on("appid", function(e, msg) {
            var newAppId = msg.info.id;
            if (!(newAppId && newAppId !== $scope.appid)) {
                return false;
            }
            if ($rootScope.isChannelU) {
                //渠道账号到期和流量用尽
                $scope.mainAccountExpire = msg.info.mainAccountExpire; //是否过期：true（过期）
                $scope.trackAndIoBothExhaust = msg.info.trackAndIoBothExhaust;
                if ($scope.mainAccountExpire || $scope.trackAndIoBothExhaust) {
                    $scope.channelAlert = true;
                } else {
                    $scope.channelAlert = false;
                }
            }
            if ($scope.channelAlert && $rootScope.appInstance) {
                return false;
            }
            $rootScope.showOnlineDates = false;
            $rootScope.onlineDateInfo = msg.info.onlineDate;//预约上线时间
            var currentTime =new Date().Format('yyyy-MM-dd');
            if($rootScope.onlineDateInfo && currentTime <= $rootScope.onlineDateInfo){// 【预计上线日期】没有值或<当前日期时，不显示该选项
                $rootScope.showOnlineDates = true;
            }else{
                $rootScope.showOnlineDates = false;
            }
            $rootScope.appInstance = msg.info;
            $scope.platform = msg.info.platform;
            $rootScope.isandroid = $scope.platform == 'Android';
            $rootScope.isios = $scope.platform == 'iOS';
            $rootScope.isweb = $scope.platform == 'H5';
            $rootScope.isSelfBuilt = $scope.platform == 'selfBuilt';//媒体自建站
            $rootScope.iswx = $scope.platform == 'wx';
            localStorage.setItem("iswx", $scope.platform == 'wx');
            $rootScope.iswg = $scope.platform == 'wg';
            localStorage.setItem("iswg", $scope.platform == 'wg');
            if (!$rootScope.isSuper && !$rootScope.isManage && !$rootScope.isAppManage) {
                $rootScope.curRoleAuth = $rootScope.roleAuth[msg.info.id + ""];
                if (!$rootScope.curRoleAuth.isdo) {
                    var aList = $rootScope.curRoleAuth.roleAuthDetailList;
                    for (var i = 0; i < aList.length; i++) {
                        if (($rootScope.isios && aList[i].auth == 'packageinfo') || ($rootScope.isandroid && aList[i].auth == 'asmeffectevaluate')) {
                            aList.splice(i, 1);
                            break;
                        }
                    }
                    $rootScope.curRoleAuth.isdo = true;
                }
                $rootScope.firstMeau = $scope.getAppFirstMenu();

            }
            if ($rootScope.trackLimit != -1 && $rootScope.trackSurplus <= 0 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
                // window.location.href = "index.html#/collect/expiration";
                $rootScope.appid = $scope.appid = msg.info.id;
                $scope.isH5platform = msg.info.platform === "H5";
                UtilService.setCookie("ryioLastApp", $scope.appid, 7);
                $location.path("/collect/expiration");
                // $state.go('collect.expiration', {
                //     pageid: null
                // });
                return false;
            }

            // 渠道账号 获取当前app左侧菜单 在office设置的权限
            if($rootScope.isChannelU){
                var authmenusPM = HttpService.getInfo('account/authmenus?app='+msg.info.id);
                authmenusPM.then(function(data) {
                    $rootScope.permissionMenus = data;
                    $rootScope.notice = data.notice.has_auth;
                    $rootScope.document = data.document.has_auth;
                    var menusKey = $rootScope.pagePath
                    if (menusKey == 'fakedec') {
                        //防作弊卫士下的'指标详情'和'数据汇总'都根据'数据汇总'在office系统是否有权限判断
                        menusKey = 'fake'
                    }
                    var hasMenu = $rootScope.permissionMenus.hasOwnProperty(menusKey);
                    var permiss = hasMenu ? $rootScope.permissionMenus[menusKey].has_auth : true;
                    if (!permiss && hasMenu) {
                        $rootScope.hasPermission = true; //没权限
                        //  event.preventDefault();
                    } else {
                        $rootScope.hasPermission = false
                    }
                })
            }
            
            var path = $location.$$path,
                idx = path.indexOf("Detail");
            if (idx > -1) {
                $scope.appid = undefined;
                $location.path(path.substring(0, idx));
            } else if (path.indexOf("authpower") > -1) {
                $location.path("/manage/auth");
            } else if ($rootScope.isweb && $rootScope.webHideMenus.indexOf($rootScope.pagePath) > -1) {
                $scope.appid = undefined;
                $location.path($rootScope.firstMeau);
            } else {
                if ($rootScope.curRoleAuth) {
                    $scope.isHasCampGroup();
                }
                if ($rootScope.pagePath == '' || $rootScope.pagePath == 'collect' ||
                    (!$scope.campaigninfoGroup && $rootScope.pagePath == 'campgroup') ||
                    (!$rootScope.isSuper && $rootScope.curRoleAuth && !$scope.hasTheMenu($rootScope.pagePath)) ||
                    ($rootScope.pagePath == 'asmeffectevaluate' && $scope.platform != 'iOS') ||
                    ($rootScope.pagePath == 'packageinfo' && $scope.platform != 'Android')) {

                    $scope.appid = undefined;
                    $location.path($rootScope.firstMeau);
                }
            }

            $rootScope.appid = $scope.appid = msg.info.id;
            $scope.isH5platform = msg.info.platform === "H5";
            // var specialAccount = UtilService.getCookie("specialUname");
            // $scope.isSpecialAccountShow = (specialAccount == "false" ? false : true) && $scope.isH5platform;


            UtilService.setCookie("ryioLastApp", $scope.appid, 7);
            if ($rootScope.isChannelU) {
                $scope.queryLimit($scope.appid);
            }
            //产品切换后，查询ASM页面是否有数据，从而判断是否显示页面。
            $scope.getShowAsmData();
            //防作弊页面权限判断
            $scope.getFakePower();
            //微信小程序无页面权限时跳转跳到总览
            var paths = path.split('/');
            var lastP = paths[paths.length - 1];
            if ($scope.iswx && (($rootScope.wxShowMenus.indexOf(lastP) == -1 && paths[1] != 'manage') || (paths[1] == 'manage' && ["datacb", "onelink","funnelinfo"].indexOf(lastP) > -1))) {
                $location.path("/collect/dashboard");
            }
            if(($scope.iswg||$rootScope.isSelfBuilt) && (paths[2] == 'deeplink' || paths[2] == 'userengagement'|| paths[2] == 'useroverview'|| paths[2] == 'channeloverview'|| paths[2] == 'refluxanalysis'|| paths[2] == 'lifesettings')){
                $location.path("/collect/dashboard");
            }
        });
        /**
         * 判断'ASM延迟归因'下是否有数据,是否菜单显示
         */
        $scope.getShowAsmData = function() {
            var appid = UtilService.getCookie("ryioLastApp"); //从cookie中取出产品id
            var pm = HttpService.getInfo("report/" + appid + "/asmeffectevaluate_num/number?datatype=list");
            pm.then(function(data) {
                var num = 0;
                if (typeof data == 'number') {
                    num = data;
                } else if (typeof data == 'object') {
                    num = data.content;
                }
                $scope.isShowAsm = num ? true : false;
            });
        }
        var rmd = new Date().getTime();
        $scope.$on("mngappTo", function(e, msg) {
            if ($scope.appid == msg) {
                return false;
            }
            if ($scope.appidInit == msg) {
                $scope.appfresh = ++rmd;
            } else {
                $scope.appidInit = msg;
            }
        });

        $scope.loginuserName = UtilService.getCookie("ryioUname");
        $scope.currentAccountId = UtilService.getCookie("ryioUid");
        $scope.userPastDate = UtilService.getCookie("ryioPastDate");
        $scope.rootParentDl = UtilService.getCookie("rootParent"); //用于deeplink权限控制
        // 灰度上线功能
        $scope.showLang = false;
        if ($scope.loginuserName == "trackingio@reyun.com") {
            $scope.showLang = true;
        }
        //灰度上线deeplink账号
        // $rootScope.isDeepLinkAcount = false;
        // if ($scope.loginuserName == "trackingio@reyun.com" || $scope.loginuserName == "yangfei@reyun.com" || $scope.loginuserName == "3198783882@qq.com" || $scope.rootParentDl == "38" || $scope.rootParentDl == "83" || $scope.rootParentDl == "77") {
        //     $rootScope.isDeepLinkAcount = true;
        // }
        //灰度上线 防作弊
        // $rootScope.showNewFake = false;
        // $scope.newFake = function() {
        //     if ($scope.loginuserName == "3436452648@qq.com" || $scope.loginuserName == "lidanni@bianfeng.com" || $scope.loginuserName == "1817767198@qq.com" || $scope.loginuserName == "huali@bianfeng.com" || $scope.loginuserName == "peter@reyun.com" || $scope.loginuserName == "demo@reyun.com") {
        //         $rootScope.showNewFake = true;
        //     } else {
        //         $rootScope.showNewFake = false;
        //     }
        // }
        // $scope.newFake();
        $scope.errorBack = function(msg) {
            ToolService.showTips(msg);
        };

        var rmdId = UtilService.randRangeId(),
            auid = UtilService.getCookie("ryioUid");

        $scope.goPage = function(ui, type) {
            $rootScope.channeluniqueName = 'normal';
            if (ui == 'home') {
                ui = $rootScope.firstMeau;
                ui = ui.substring(1).replace("/", ".");
            }
            if (ui == 'collect.app') {
                $scope.appid = undefined;
            }
            var mmenu = ui.substring(ui.indexOf('.') + 1);
            //判断流量到期或用尽
            if ($rootScope.trackLimit != -1 && $rootScope.trackSurplus <= 0 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
                ui = 'collect.expiration'
            }

            var logpm = {
                'appid': UtilService.getAppkey(),
                'who': auid,
                'what': mmenu,
                'context': {
                    '_deviceid': rmdId,
                    '_channelid': '_default_',
                    '_idfa': rmdId,
                    '_idfv': rmdId,
                    '_bundleid': 123456
                }
            };
            $.post(UtilService.getLogRoot() + "/receive/tkio/event", JSON.stringify(logpm));
            if (mmenu == 'channel') {
                $rootScope.channeluniqueName = "normal";
            }
            if ($state.current && $state.current.name == ui) {
                $state.reload(ui, {
                    pageid: null
                });
            } else {
                $state.go(ui, {
                    pageid: null
                });
            }
            ToolService.sendBehavior("pv", mmenu)

        }
        $scope.goCreateCrowdTag = function(step, id) {
            $state.go("collect.createCrowdTag", {
                step: step,
                id: id
            });
        }

        $scope.goCrowdAnalysisInfo = function(id) {
            $state.go("collect.crowdAnalysisInfo", {
                id: id
            });
        }

        $rootScope.noLeftMenus = ["userinfo", "nopower", "auth", "app", "authrole", "authpower", "advancedServices","channel","channelAdwords","channelToutiao","channelBaidu","channelKuaishou","channelWeixinmp","customchannel","dataCallback","addDataCallback",
            "crowdAnalysis", "crowdAnalysisGuide", "crowdAnalysisList", "createCrowdTag", "crowdAnalysisInfo", "fakeGuide", "accountauth", "deviceManage", "document", "notice"
        ];
        $rootScope.menus = {
            "dash": ["dashboard", "realtime", "channeleffect"],
            "admonitor": ["campaigninfo","advertisinginfo", "remarketing","keyword", "packageinfo", "effectevaluate","funnelinfo", "roi", "asmeffectevaluate","userengagement","terminalattributes"],
            "monetization": ["adsenseinfo","admobinfo"],
            "lifecycle": ["useroverview", "channeloverview", "refluxanalysis", "serveridbackflow", "lifesettings"],
            "tool": ["attribute", "logtool"],
            "export": ["logexport", "logdump", "report", "subcampaign"],
            "promotionManagement":["campaign","campgroup","datacb","systemparam"],
            "config": ["customevent","channelmanage","deeplink"],
            "server": ["fake", "fakepage", "fakedec"]
        };
        $scope.resizeStyle = function() {
            var mleft = '0px';
            if ($rootScope.noLeftMenus.indexOf($rootScope.pagePath) == -1) { //
                mleft = $rootScope.unfoldFlag ? '40px' : ($rootScope.lang == 'en' ? '200px' : '186px');
            }
            $(".conditionAlpha").css('left', mleft);
            $rootScope.panelw = $(window).width() - mleft.slice(0, -2) - 84;
            return {
                'margin-left': mleft
            };
        }
        $scope.toggleMenu = function() {
            $rootScope.unfoldFlag = !$rootScope.unfoldFlag;
            UtilService.setCookie("unfoldFlag", $rootScope.unfoldFlag);

            $scope.$broadcast("conentresize", true);
        }
        angular.element($window).bind('resize', function() {
            $scope.$apply(function() {
                $scope.$broadcast("conentresize", true);
            });
        });
        $scope.isHasCampGroup = function() {
            $scope.campaigninfoGroup = false;
            $rootScope.curRoleAuth.roleAuthDetailList.filter(function(item) {
                if (item.auth == "roi" || item.auth == "realtime" || item.auth == "campaigninfo") {
                    $scope.campaigninfoGroup = true;
                }
            });
        }
        $scope.showGoHomeBtn = function() {
            // isSHowHome {true: 显示goHome，false: 显示灵犀}
            //没有左侧菜单栏 不现实灵犀 除了app页
            var isShowHome = ($rootScope.noLeftMenus.indexOf($rootScope.pagePath) != -1);
            if ("app".indexOf($rootScope.pagePath) != -1) {
                isShowHome = false;
            }
            return isShowHome;
        }

        //flag:1一级菜单显示权限  2:编辑权限
        $rootScope.hasTheMenu = function(name, flag, getmenus) {
                var menus = $rootScope.curRoleAuth && $rootScope.curRoleAuth.roleAuthDetailList.filter(function(item) {
                    if (angular.isDefined(flag) && flag == 1) { //一级菜单显示权限判断
                        if ($rootScope.isweb) {
                            return item.parentAuth == name && $scope.webHideMenus.indexOf(item.auth) == -1;
                        } else {
                            return item.parentAuth == name;
                        }
                    }
                    if (angular.isDefined(flag) && flag == 2) { //编辑权限
                        return item.auth == name && item.edit == true;
                    } else {
                        if (name == 'export') {
                            return $rootScope.hasTheMenu(name, 1);
                        } else {
                            return item.auth == name && item.view == true;
                        }

                    }
                });
                if (angular.isDefined(getmenus)) {
                    return menus;
                } else {
                    return menus ? menus.length > 0 : false;
                }
            }
            //
        $rootScope.showMenu = function(name, flag) {
                
            
            if (name == null) {
                name = $scope.pagePath;
            }
            if ((name == 'customevent' || name == 'logdump') && $rootScope.isweb) {
                return false;
            }
            if (name == 'fake') {
                return $rootScope.isOpenFakePower;
            }
            if ($scope.isweb && $scope.webHideMenus.indexOf(name) > -1) {
                return false;
            }

            if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
                $scope.campaigninfoGroup = true;
                return true;
            } else {
                if ($rootScope.curRoleAuth) {
                    $scope.isHasCampGroup();
                    return $scope.hasTheMenu(name, flag);
                } else {
                    return false;
                }
        }
        }

        $rootScope.hasEditPower = function() {
                return $rootScope.showMenu(null, 2);
            }
            /**
             * 数据是否展示
             */
        $scope.showDataModel = function(m) {
                if ($rootScope.isweb && m == 'retention') {
                    return false;
                }
                if (m == 'flow') {
                    return true;
                }
                if (m == 'channel') {
                    return true;
                }

                var key = {
                    'pay': 'payAuth',
                    'retention': 'retentionAuth',
                    'isnatureopen': 'isNatureOpen',
                    'topauth': "topAuth",
                    'order': "orderAuth",
                    'event': "eventAuth"
                }[m];
                if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
                    return true;
                } else {
                    if ($rootScope.curRoleAuth) {
                        return $rootScope.curRoleAuth[key];
                    } else {
                        return false;
                    }
                }
            }
            // $scope.formTipMsg = $filter('translate')("信息没填全或数据格式有误，请检查");
        $translate("信息没填全或数据格式有误，请检查").then(function(tran) {
            $scope.formTipMsg = tran;
        }, function(tranId) {
            $scope.formTipMsg = tranId;
        });

        //路径切换监听
        $rootScope.$watch("pagePath+isweb+appid+lang", function(n, o) {
            n = $scope.pagePath;
            if (angular.isDefined(n) && n != '' && n != "product") {
                n = ($scope.isweb && (n == 'dashboard' || n == 'realtime' || n == 'channeleffect')) ? ('h5_' + n) : ((($scope.iswx || $scope.iswg) && (n == 'dashboard' || n == 'realtime' || n == 'channeleffect')) ? ('wx_' + n) : n);
                var tipGet = function() {
                    var tipPM = HttpService.getInfo("tip/" + n, {}); //查询当前页面'问号'内提示信息。
                    tipPM.then(function(data) {
                        $rootScope.currentPageTips = data;

                    }, function(data) {
                        $rootScope.currentPageTips = {};
                    });
                }
                if (n == "campaigninfo" && $scope.appid) {
                    n = "campaigninfo?appid=" + $scope.appid;
                    if (UtilService.isNullStr($scope.appid)) {
                        $timeout(function() {
                            n = "campaigninfo?appid=" + $scope.appid;
                            tipGet();
                        }, 300);
                    } else {
                        tipGet();
                    }
                } else {
                    tipGet();
                }

            } else {
                $rootScope.currentPageTips = {};
            }
            for (var menu in $scope.menus) {
                if ($scope.menus[menu].indexOf(n) > -1) {
                    $scope[menu] = true; //菜单判断显示
                }
            }
            $translate("信息没填全或数据格式有误，请检查").then(function(tran) {
                $scope.formTipMsg = tran;
            }, function(tranId) {
                $scope.formTipMsg = tranId;
            });
        });

        $scope.userLogout = function() {
            localStorage.removeItem('OfflineTip');

            var lgPM = HttpService.getInfo("login/logout", {});
            lgPM.then(function(data) {
                HttpService.logOutCookie();
            });
        }
        $scope.goHelp = function() {
            if ($rootScope.document) {
                if ($rootScope.doMainType == 0) {
                    window.open($rootScope.docDomain);
                } else if ($rootScope.doMainType == 1) {
                    window.open($rootScope.otherCompanyInfo.indexDocUrl);
                }
            } else {
                $state.go('collect.document')
            }
        }

        $scope.showNoticew = false;
        $scope.queryNotice = function() {
            var noticePM = HttpService.getInfo("notice/findDeploy", {});
            noticePM.then(function(data) {
                $scope.noticeList = data;
                var sortNotice = UtilService.cloneJSON(data);
                sortNotice && sortNotice.sort(function(a, b) {
                    return new Date(a.deployDate) > new Date(b.deployDate) ? -1 : 1;
                });
                if (sortNotice.length > 0) {
                    $scope.newNoticeInfo = sortNotice[0];
                }
            });
            $timeout($scope.queryNotice, 1000 * 60 * 3);
        }
        $scope.showNoticeWin = function() {
            $scope.showNoticew = true;
            ToolService.showAlp();
        }
        $scope.hideNoticeWin = function() {
            $scope.showNoticew = false;
            ToolService.hideAlp();
        }
        $scope.clickNotice = function(news) {
            var id = news.id;
            if ($scope.curNoticeId == id) {
                $scope.curNoticeId = -1;
            } else {
                $scope.curNoticeId = id;
                if (!news.isRead) {
                    news.isRead = true;
                    if ($scope.newNoticeInfo && $scope.newNoticeInfo.id == id) {
                        $scope.newNoticeInfo.isRead = true;
                    }
                    HttpService.postInfo("notice/saveReadLog/" + id, {});
                }

            }
        }
        $rootScope.menuSubmitData = function(submenu) {
            ToolService.getMenuSubmitData(submenu);
        }
        $rootScope.operSubmitData = function(opername) {
            ToolService.getOperSubmitData(opername);
        }
        $rootScope.$watch("thirdtab", function(n) {
            if (angular.isDefined(n)) {
                ToolService.getMenuSubmitData(n);
            }
        });
        $scope.queryIOUrl = function() {
            var urlPM = HttpService.getInfo("index/saasio", {});
            urlPM.then(function(data) {
                $scope.ioUrl = data;
            });
        }
        $scope.initpage = function() {
            $scope.queryLimit();
            $scope.queryApp();
            $scope.queryArea();
            $scope.queryNotice();
            $scope.queryIOUrl();

        }

        var lpath = $location.path();
        if (lpath != '/active/product') {
            $scope.initpage();
        }

        //防作弊权限判断。管理员查看是否开通；子账号，看母账号是否开通以及是否授权。
        $scope.getFakePower = function() {
            var isOpen = $rootScope.fakeType != -1 && $rootScope.fakeType != 0 && $rootScope.fakeType != 3;
            if ($rootScope.isall) {
                $rootScope.isOpenFakePower = isOpen;
            } else {
                $rootScope.isOpenFakePower = (isOpen && $scope.hasTheMenu("fake"));
            }
        }


        //判断是否需要向后台发送请求检测名称重复
        $scope.judgeNameChange = function(oldname, newname) {
            if (!UtilService.isNullStr(newname) && (oldname != '' && newname != '' && angular.lowercase(oldname) != angular.lowercase(newname) || (oldname == '' && newname != ''))) {
                return true;
            } else {
                return false;
            }
        }

        $scope.pwdPlacehold = $filter('translate')("仅支持数字，大小写字母，且至少包含其中2种，长度限制为6-18位");

        //红点
        var redCircle = UtilService.getCookie("ryioRedCircle");
        if (redCircle == 'true') {
            $scope.flowKnow = true;
        } else {
            $scope.flowKnow = false;
        }
        //移动关闭个人信息
        $scope.closeImformation = function() {
            $scope.flowKnow = false;
            $scope.showinfo = false;
            UtilService.setCookie("ryioRedCircle", false, 7);
        }

        //提示框
        $scope.closeFlow = function(type) {
            if ($rootScope.pastLong < 0 && !$rootScope.isChannelU) {
                $scope.userLogout();
            }
            // if (!$scope.behaviorAuth && $rootScope.trackPercentRel <= 0 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
            //     $scope.userLogout();
            // }
            // if ($scope.behaviorAuth && $rootScope.trackPercentRel <= 0 && $rootScope.ioPercentRel <= -0.05 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
            //     $scope.userLogout();
            // }

            if (type == undefined) {
                $scope.channelAlert = false;
            } else {
                $scope.flowKnow = true;
                UtilService.setCookie("ryioRedCircle", true, 7);
            }
            var params = {
                accountId: auid
            };
            if (type == 'trackAlert') {
                $scope.trafficReminderShow = false;
                return;
                // params.trackFlow = true;
            }
            if (type == 'trackDateAlert') {
                $scope.trackDateAlert = false;
                params.trackPastTime = true;
            }
            var closePM = HttpService.postInfo("mng/accountRestrict/confirm", params);
            closePM.then(function(data) {});
        }

        //关闭防作弊卫士提示
        $scope.closeFake = function() {
            var closePM = HttpService.putInfo("mng/fake/close");
            closePM.then(function(data) {
                if (data.content == "") {
                    $rootScope.fakeAlertType = false;
                }
            });
        }

        $scope.closeNewsTip = function(){
            $scope.$broadcast('closeTip', 'Data');            
        }
        $scope.closeOfflineTip = function(){
            $rootScope.showOfflineTip = false;
            localStorage.setItem("OfflineTip", "hide");  
        }
        $scope.goFake = function() {
            $state.go("collect.fake");
            $rootScope.operSubmitData($filter('translate')("了解详情"));
        }

        $scope.closeClickShowWin = function() {
            $rootScope.clickshowWin = false;

            var curUU = ToolService.getUser();
            curUU.notFirstLogin = true;
            localStorage.setItem("ry_user", JSON.stringify(curUU));
        }
        $scope.isShowLogExport = sessionStorage.getItem("limitInfo") && JSON.parse(sessionStorage.getItem("limitInfo")).platformExport == true || $rootScope.limitInfo && $rootScope.limitInfo.platformExport == true;
        //limitInfo变动时更新isShowLogExport值（limitInfo：46行查询中）
        $rootScope.$watch("limitInfo", function(n) {

            if (angular.isDefined(n)) {
                $scope.isShowLogExport = sessionStorage.getItem("limitInfo") && JSON.parse(sessionStorage.getItem("limitInfo")).platformExport == true || $rootScope.limitInfo && $rootScope.limitInfo.platformExport == true;
            }
        }, true);

        $scope.curLang = $rootScope.getLang();

    }
})();