(function () {
    angular.module("app.collect")
        .controller("adsenseinfoCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "$timeout", "$filter", "$translate", "$state", "$http","UtilService", adsenseinfoCtrl]);

    function adsenseinfoCtrl($rootScope, $scope, HttpService, ToolService, $timeout, $filter, $translate, $state, $http, UtilService) {
        $scope.report = false;
        $scope.initLoading = function () {
            $scope.campListLoading = true;
        };
        $scope.initLoading();
        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
        });
        $scope.getAdChannel = function(){
            var adPM = HttpService.getInfo("mng/channel/findChannelAdvertising");
            adPM.then(function(data){
                $scope.channelFilterData = data;
            })
        }
        $scope.getAdChannel();
        $scope.$on('AdIncomeId', function (e, msg) {
            $scope.incomeId= msg.info.id;
        });

        $scope.showBtn = true;
        $scope.addMore = function () {
            $scope.showBtn = !$scope.showBtn;
            $scope.activeCidList = []

        }
        $scope.okSelect = function () {
            $scope.showBtn = !$scope.showBtn;
            if($scope.activeCidList.length == 0){
                $scope.activeCidList = ['all']
            }
            $scope.query(false, false);
        }
        $scope.cancel = function () {
            $scope.showBtn = !$scope.showBtn;
            if($scope.showBtn){
                // 单选
                $scope.activeCidList = ['all']
            }else{
                $scope.activeCidList = [] 
            }
        }

        //变现收入管理
        $scope.menuLevel = '1';
        // 激活人渠道cid
        $scope.activeCidList = ['all']
        $scope.checkAllChannel = function(flag){
            var itemIndex = $scope.activeCidList.indexOf("all");
            if ($scope.showBtn) {
                // 单选
                $scope.activeCidList = ['all']
                $scope.query(false, false);
            } else {
                // 多选
                if (itemIndex != -1){
                    $scope.activeCidList = []
                }else{
                    $scope.activeCidList = ['all']
                    var channelLen = $scope.channelFilterData.length;
                    for (var i = 0; i < channelLen; i++){
                        var item = $scope.channelFilterData[i];
                        var iIndex = $scope.activeCidList.indexOf(item.cid);
                        if (iIndex == -1){
                            $scope.activeCidList.push(item.cid);
                        }
                    }
                }
            }
        }
        $scope.selectChannel = function (item,flag) {
            if ($scope.showBtn) {
                // 单选
                $scope.activeCidList = [item.cid]
                if(flag == 1){
                    $scope.query(false, false);
                }else{
                    $scope.queryReport();
                }
            }else{
                // 多选
                var itemIndex = $scope.activeCidList.indexOf(item.cid);
                if(itemIndex != -1){
                    // 取消
                    $scope.activeCidList.splice(itemIndex, 1);
                    var allIndex = $scope.activeCidList.indexOf('all');
                    if (allIndex != -1){
                        $scope.activeCidList.splice(allIndex, 1);
                    }
                }else{
                    // 选中
                    $scope.activeCidList.push(item.cid);
                    var fals = true;
                    var channelLen = $scope.channelFilterData.length;
                    for (var i = 0; i < channelLen; i++){
                        var item = $scope.channelFilterData[i];
                        if ($scope.activeCidList.indexOf(item.cid) == -1){
                            fals = false;
                            break;
                        }
                    }
                    if (fals){
                        $scope.activeCidList.push('all');
                    }
                }
            }
            if($scope.selectFlag != "adcreative"){
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
        }

        var selectFlagIndex = 0;
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $scope.MainSuper = true;
        } else {
            $scope.MainSuper = false;
        }
        $scope.$on("conentresize", function () {
            if ($scope.campList) $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);

        });
        $scope.clickBase = function (obj) {
            if (obj.isedit == false) { return false; }
            if (obj.fieldcode == 'rate_add_daily' && obj.ischeck == false) {
                $scope.baseList.filter(function (value) {
                    if (value.fieldcode == 'num_payer_new_user' && value.ischeck == false) {
                        value.ischeck = true;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            } else if (obj.fieldcode == 'num_payer_new_user' && obj.ischeck == true) {
                $scope.baseList.filter(function (value) {
                    if (value.fieldcode == 'rate_add_daily' && value.ischeck == true) {
                        value.ischeck = false;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            }
            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) {
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function (type) {
            if (!$scope.baseList) { return false; }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function (item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }

                }
            });
        }
        $scope.hasCheckAll = function (type) {
            if (!$scope.baseList) { return false; }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.hasType = function (type) {
            if (!$scope.baseList) { return false; }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type) {
                    count = 1;
                    break;
                }
            }
            return count > 0;
        }
        $scope.cleanEvent = "cleanEvent"
        $scope.change = function (title){
            //向子级作用域广播cleanEvent事件
            $scope.$broadcast($scope.cleanEvent);
       };
        //关闭
        $scope.closeArouseTip = function () {
            $scope.arouseTips = false;
            var url = "login/arouse_tips";
            var closePM = HttpService.postInfo(url);
            closePM.then(function (data) {
                $rootScope.arouseTips = false;
            });
        }
        $scope.showBaseWin = function () {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function (flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function (item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function () {
            ToolService.sendBehaviorUv("okBase");
            $scope.query(true, null);
            var url = "/campaign/viewcolumn/adsenseinfo?viewcolumn=";
            var vcol = [];
            $scope.baseList.filter(function (item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + url + vcol.join(","), {});
            updatePM.then(function (data) { });
            $scope.hideDialog(-1);
        }
        $scope.selectFlag = "adgroup";
        $scope.scenesHide = false;
        $scope.changeSelectFlag = function (flag) {
            ToolService.sendBehaviorUv(flag);
            if ($scope.selectFlag != flag) {
                $scope.infofalg = false;
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
            $scope.selectFlag = flag;
            selectFlagIndex++;
            $scope.filterTxt = "";
            $scope.nameleve1 = ""
            $scope.nameleve2 = ""
            $scope.change();
        }
        $scope.advSelectFlag = function(flag){
            $scope.advFlag = flag
            if(flag != 'all'){
                $scope.queryReport();
            }

        }
        $scope.getAdIncome = function(){
            var incomePM = HttpService.getInfo("mng/advertising/platform");
            incomePM.then(function(data){
                var data2 = JSON.parse(JSON.stringify(data));
                data2.unshift({id:'all',name:$filter('translate')('全部平台')});
                for(var i in data){
                    var item = data[i]
                    item.cid = item.id;
                }
                $scope.AdIncomeList = data2
                $scope.AdIncomeInit= $scope.incomeId = data2[0].id;
            })
        }
        $scope.getAdIncome();

        $scope.$on('flipinfo', function (e, msg) {
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });

        var flagNames;
        function init() {
            flagNames = {
                "adgroup": $translate.instant("广告组"),
                "adplan": $translate.instant("广告计划"),
                "adcreative": $translate.instant("广告创意")
            };
        }
        init();
        $scope.showZero = false;
        $scope.listRefresh = 1;

        /**
         * hasTotal:true/false  
         */
        $scope.query = function (flag, hasTotal) {
            var _flagNum = selectFlagIndex;
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.viewtype = $scope.selectFlag;
            params.func = "adsenseinfo";
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }
            var listPM = null,
                currentInfo = {},
                qReport = "",
                eptName = flagNames[$scope.selectFlag];
            if ($scope.currentReports && $scope.currentReports != null && $scope.currentReports.key) {
                params[$scope.currentReports.key] = $scope.currentReports.val;
                params[$scope.currentReports.key1] = $scope.currentReports.val1;
                currentInfo = UtilService.cloneJSON($scope.currentReports);
            } else if ($scope.selectFlag == 'adgroup') {
                $scope.allSubInfo = [];
                currentInfo = {
                    report: "adsenseinfo_byadgroup"
                }
                $scope.currentReports = currentInfo;
            } else if ($scope.selectFlag == 'adplan') {
                $scope.allSubInfo = [];
                currentInfo = {
                    report: "adsenseinfo_byadplan"
                }
                $scope.currentReports = currentInfo;
            } else if ($scope.selectFlag == 'adcreative') {
                $scope.allSubInfo = [];
                currentInfo = {
                    report: "adsenseinfo_byadcreative"
                }
                $scope.currentReports = currentInfo;
            }

            if (!flag || $scope.allSubInfo.length == 0) {
                $scope.allSubInfo.push(currentInfo);
            }

            qReport = $scope.currentReports.report;
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length>0){
                params.cid = $scope.activeCidList.join(',');
            }
            params.viewcolumn = $scope.getViewColumns();
            var condiParams = '';
            $scope.listTotal = undefined;
            if (hasTotal) return;
            listPM = HttpService.getReportData(qReport, params);
            condiParams && (params = condiParams);
            params.showall0 = $scope.showZero;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("变现收入-投放广告") + "-" + eptName, qReport, params);
            $scope.campListLoading = true;
            listPM.then(function (data) {
                if (_flagNum != selectFlagIndex) { //防止频繁点击分析维度，出现页面加载数据不对
                    return false;
                }
                $scope.campList = data;
                if ($scope.selectFlag != 'subaccount') {
                    $scope.infoListTotal = data.val[0];
                    $scope.campAllList = data.val.slice(1);
                } else {
                    $scope.campAllList = data.val;
                }
                $scope.campNoZeroList = $scope.campAllList.filter(function (item, index) {
                    return item.isall0 == false;
                });
                if ($scope.showZero || $scope.selectFlag == 'bdkeyword') {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
                $scope.campListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.searchTxt = "";
                if ($scope.isSubChannel()) {
                    if (fixChange) {
                        $scope.fixrefresh = ++rmd;
                    } else {
                        $scope.initrefresh = ++rmd;
                        $scope.fixrefresh = ++rmd;
                    }
                    fixChange = true;
                } else {
                    $scope.sortCol = "";
                    $scope.initrefresh = ++rmd;
                    $scope.fixrefresh = ++rmd;
                }
            });

        }

        $scope.queryReport = function(){
            ToolService.showLoading();
            var params = ToolService.getParams($scope);
            var qReport = $scope.advFlag == "advtype" ? "adsenseinfo_byadtype" : "adsenseinfo_byadid";
            params.datatype = 'list';
            params.viewtype = 'date';
            params.func = 'adsenseinfo';
            if($scope.selectFlag == 'adgroup'){
                params.adgroup_id = $scope.adgroup_id;
            }
            if($scope.selectFlag == 'adplan'){
                params.adplan_id = $scope.adplan_id;
            }
            if($scope.selectFlag == 'adcreative'){
                params.adcreative_id = $scope.adcreative_id;
            }
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length>0){
                params.plat_type_v = $scope.activeCidList.join(',');
            }
            if($scope.advFlag == "advtype"){
                if($scope.incomeId != 'all'){
                    params.adplatform = $scope.incomeId
                }
            }
            bxPM = HttpService.getReportData(qReport, params);
            
            var condiParams = '';
            condiParams && (params = condiParams);
            params.showall0 = $scope.showZero;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("变现收入-投放广告"), qReport, params);

            bxPM.then(function(data){
                $scope.campCashList = $scope.campList = data;
                $scope.infoListTotal = data.val[0];
                $scope.campAllList = data.val.slice(1);
                $scope.campNoZeroList = $scope.campAllList.filter(function (item, index) {
                    return item.isall0 == false;
                });
                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
                $scope.$broadcast("conentresize", true);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
                ToolService.hideLoading();
            })

        }
        //请求路径后缀
        function getSubFix(flag) {
            var subfix = flag;
            return subfix;
        }

        $scope.getViewColumns = function () {
            var vcol = [];
            $scope.baseList && $scope.baseList.filter(function (item) {
                if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention'))) {
                    //没有付费权限，不能查看付费
                } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                    //没有唤醒权限，不能查看付费
                } else {
                    if (item.ischeck == true) {
                        vcol.push(item.fieldcode);
                    }
                }
            });
            return vcol.join(",");
        }


        $scope.isSubChannel = function () {
            return $scope.currentReports && ($scope.currentReports.report == "advertisinginfo_byadplan" || $scope.currentReports.report == "advertisinginfo_byadcreative");
        }

        $scope.filterByTxt = function (txt) {
            $scope.filterTxt = txt;
            if($scope.menuLevel == '2'){
                $scope.queryReport()
            }else{
                $scope.query(true, false);
            }   
        }
        $scope.iscanSub = function () {
            return $scope.allSubInfo.length <= 3 || $scope.menuLevel != '2';
        }
        $scope.itemLeve1 = {}
        $scope.goList = function(){
            if($scope.nameleve2){
                $scope.nameleve2 ="";
                if ($scope.nameleve1){
                    $scope.selectFlag = 'adgroup'
                    $scope.clickSub($scope.itemLeve1)
                }else{
                    $scope.changeSelectFlag('adgroup')
                }
            }else{
                $scope.nameleve1 ="";
                $scope.changeSelectFlag('adgroup')
            }
            // $scope.query(false, false);
        }
        $scope.searchGroupInitf5 = 0;
        $scope.clickSub = function (info, obj) {
            if (!info) {
                var target = obj.target, data = target.getAttribute('data');
                info = $.parseJSON(data);
            }
            $scope.nextID = info.id;
            if (info.istotal || $scope.menuLevel == '2') { return; }
            $scope.filterTxt = "";
            $scope.searchGroupInitf5++;
            $scope.curinfo = info;
            $scope.isDetail = true;
            $scope.isInfoTotal = info.cid;
            var hasTotal = true;
            if ($scope.selectFlag == 'adgroup') {
                $scope.currentReports = {
                    report: "adsenseinfo_byadplan",
                    title: info[$scope.campList.columnkey[0]],
                    key: 'adgroup_id',
                    val: info.adgroup_id,
                    curInfo: info,
                    key1:'cid',
                    val1:info.channel
                }
                hasTotal = false
                if (hasTotal) {
                    fixChange = false;
                }
                $scope.itemLeve1 = info;
                $scope.nameleve1= info.name;
                $scope.nameleve2 ="";
                $scope.selectFlag = 'adplan';
            } else if ($scope.selectFlag == 'adplan') {
                $scope.currentReports = {
                    report: "adsenseinfo_byadcreative",
                    title: info[$scope.campList.columnkey[0]],
                    key: 'adplan_id',
                    val: info.adplan_id,
                    key1:'cid',
                    val1:info.channel
                }
                hasTotal = false
                if (hasTotal) {
                    fixChange = false;
                }
                $scope.nameleve2= info.name;
                $scope.selectFlag = 'adcreative'
            }
        }
        $scope.backTrack = function(){
            $scope.menuLevel = "1";
            $scope.query(false, false);
        }
        $scope.clickDetail = function(info,obj,key){
            if(key !=="cash_income" || $scope.menuLevel == '2'){
                return false;
            }
            $scope.menuLevel = '2';
            $scope.advFlag = 'adslot';
            $scope.adName =  flagNames[$scope.selectFlag]+"："+info.name;
            if($scope.selectFlag == 'adgroup'){
                $scope.adgroup_id = info.adgroup_id;
            }
            if($scope.selectFlag == 'adplan'){
                $scope.adplan_id = info.adplan_id;
            }
            if($scope.selectFlag == 'adcreative'){
                $scope.adcreative_id = info.adcreative_id;
            }
            $scope.queryReport();

        }
        // 显示全0数据
        $scope.clickZero = function () {
            ToolService.sendBehaviorUv("clickZero");
            $scope.showZero = !$scope.showZero;
            reCrateListCondition($scope.listCondition);
            if ($scope.showZero) {
                $scope.infoList = $scope.campAllList;
            } else {
                $scope.infoList = $scope.campNoZeroList;
            }
            $scope.fixrefresh = ++rmd;
        }

        /**
         * 重新生成‘导出’参数，添加‘显示全0数据’的值进去
         * @param listCondition
         */
        function reCrateListCondition(listCondition) {
            var isOk = false;
            if (listCondition && listCondition.conditions) {
                var cond = JSON.parse(listCondition.conditions);
                if (cond) {
                    cond.showall0 = $scope.showZero;
                    listCondition.conditions = JSON.stringify(cond);
                    isOk = true;
                }
            }
            if (!isOk) {
                ToolService.showTips("");
            }
        }

        var fixChange = true,
            orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function (predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.listRefresh = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("appid", function () {
            $scope.allSubInfo = [];
            $scope.currentReports = null;
        });

        $scope.$watch("date.startDate+date.endDate", function () {
            if ($scope.allSubInfo && $scope.allSubInfo.length > 0) {
                $scope.allSubInfo.pop()
            }
        });
        var oldappid = "";
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,selectFlag:selectFlag,lang:lang}", function (n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)) { return false; }
            if (!$scope.baseList || oldappid != $scope.appid) {
                //指标列表
                var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/adsenseinfo");
                basePM.then(function (data) {
                    $scope.baseList = data;
                    $scope.sdkList = data.filter(function (item) {
                        return item.type == 'sdkevent';
                    });
                    $scope.sdkeventNew = data.filter(function (item) {
                        return item.type == 'sdkevent_new';
                    });
                    $scope.menuLevel = "1";
                    $scope.query(false, false);

                });
            }else {
                if($scope.menuLevel == '2'){
                    $scope.queryReport()
                }else{
                    $scope.query(false, false);
                }
            }

            oldappid = $scope.appid;
            //语言切换
            if (n.lang && o.lang && n.lang !== o.lang) {
                init();
            }
            if (n.appid != o.appid) {
                $scope.allSubInfo = [];
                $scope.currentReports = null;
            }
        }, true);

        $scope.$watch("appid+incomeId", function (n,o) {
            if ($scope.appid) {
                $scope.industory = $scope.appInstance.industory;
            }
            if(angular.isDefined($scope.incomeId) && angular.isDefined($scope.appid) && $scope.menuLevel == '2'){
                $scope.queryReport();
            }
        });
    }
})();