(function(){
    angular.module("app.collect")
        .controller("asmeffectevaluateCtrl",["$scope","HttpService","ToolService","$timeout","$filter","UtilService","$location","$anchorScroll","$filter","$translate",asmeffectevaluateCtrl]);

    function asmeffectevaluateCtrl($scope,HttpService,ToolService,$timeout,$filter,UtilService,$location,$anchorScroll,$filter,$translate){
        $scope.initLoading = function(){
            $scope.asmListLoading = true;
        };
        $scope.initLoading();
        $scope.$on('curdate',function(e,msg){
            $scope.date = msg.date;
        });

        $scope.$on('flipinfo',function(e,msg){
            if(msg.listkey == 'detail'){
                $scope.flipPage_detail = msg;
                $scope.fixrefresh_detail = ++rmd;
            }
            else{
                $scope.flipPage = msg;
                $scope.fixrefresh = ++rmd;
            }
        });
        $scope.clickZero = function(){
            ToolService.sendBehaviorUv("checkBox");
            $scope.showZero = !$scope.showZero;
            if($scope.showZero){
                $scope.infoList = $scope.asmAllList;
            }else{
                $scope.infoList = $scope.asmNoZeroList;
            }
            $scope.infoList.filter(function(info){
                info.operation = $filter('translate')("查看设备");
            });
        }
        $scope.$on("conentresize",function(){
            $scope.colsStyle = ToolService.getTableColsWidth($scope.asmList.name);
            if($scope.detailTitle){
                $scope.deviceColsStyle = ToolService.getTableColsWidth($scope.deviceList.name);
            }
        });
        $scope.chakanStr = $translate.instant("查看");
        $scope.query = function(){
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.func = "asm";

            if($scope.filterTxt && $scope.filterTxt!=''){
                params.searchtxt = $scope.filterTxt;
            }

            var listPM = null,currentInfo = {},qReport = "asmeffectevaluate_total";
            
            
            listPM = HttpService.getReportData(qReport, params);
            
            $scope.asmListLoading = true;
            listPM.then(function(data){
                $scope.export();
                $scope.asmList = data;
                $scope.asmList.name.push($filter('translate')("查看"));
                $scope.asmList.columnkey.push("operation");
                $scope.asmAllList = data.val;
                $scope.asmNoZeroList = $scope.asmAllList.filter(function(item){
                    return item.isall0==false;
                });

                if($scope.showZero){
                    $scope.infoList = $scope.asmAllList;
                }else{
                    $scope.infoList = $scope.asmNoZeroList;
                }
                $scope.infoList.filter(function(info){
                    info.operation = $filter('translate')("查看设备");
                });
                $scope.sortCol = "";
                $scope.asmListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
            });
        }
        $scope.iscanSub = function(col){
            return col == 'operation';
        }
        $scope.export = function(){
            var qReport = "asmeffectevaluate_detail",params = {};

            params.startdate = $scope.date.startDate;
            params.enddate = $scope.date.endDate;
            params.appid = $scope.appid;
            params.datatype = 'list';
            params.func = "asmdetail";

            $scope.listCondition = ToolService.getChartConditions($filter('translate')("ASM延迟归因"),qReport,params);
        }
        $scope.clickSub = function(info){
            ToolService.sendBehaviorUv("deviceView");
            $scope.detailTitle = info.ds;
            var deviceListPM = null, qReport = "asmeffectevaluate_detail",params = {};

            params.startdate = info.ds==$filter('translate')('汇总')?$scope.date.startDate:info.ds;
            params.enddate = info.ds==$filter('translate')('汇总')?$scope.date.endDate:info.ds;
            params.appid = $scope.appid;
            params.datatype = 'list';
            params.func = "asmdetail";

            deviceListPM = HttpService.getReportData(qReport, params);

            $scope.deviceListLoading = true;
            deviceListPM.then(function(data){
                $scope.gotoDiv();
                $scope.deviceList = data;

                $scope.deviceInfoList = data.val;

                $scope.deviceListLoading = false;
                $scope.deviceColsStyle = ToolService.getTableColsWidth(data.name);
                $scope.initrefresh_detail = ++rmd;
                $scope.fixrefresh_detail = ++rmd;
            });
        }
        //控制滚动条
        $scope.gotoDiv = function () {
            $location.hash("deviceListDiv");
            $anchorScroll();
        };
        var orderBy = $filter('orderBy'),rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            var all = $scope.infoList[0];
            var orderInfoList = UtilService.cloneJSON($scope.infoList);
            orderInfoList = orderInfoList.slice(1);
            orderInfoList = orderBy(orderInfoList, predicate, reverse);
            orderInfoList.unshift(all)
            $scope.infoList = orderInfoList;
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("date.startDate+date.endDate+appid+lang",function(n){
            if(angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)){return false;}
            $scope.detailTitle = false;
            $scope.chakanStr = $translate.instant("查看");
            $scope.query();
        });
    }
})();
