(function(){
    angular.module("app.collect")
        .controller("effectevaluateCtrl",["$rootScope","$scope","HttpService","ToolService","$filter",effectevaluateCtrl]);

    function effectevaluateCtrl($rootScope,$scope,HttpService,ToolService,$filter){
        $scope.initLoading = function(){
            $scope.listDataLoading = true;
        };
        $scope.initLoading();
    	$scope.$on('curdate',function(e,msg){
            $scope.date = msg.date;
        });
        $scope.listflag = 'click';
        $scope.$on("conentresize",function(){
            $scope.colsStyle = ToolService.getTableColsWidth($scope.listData.name);
        });
        var rmd = new Date().getTime();
    	$scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });
        var flagNames = {
            "click":$filter('translate')("按点击汇总"),
            "install":$filter('translate')("按激活汇总")
        };
        $scope.changeFlag = function(flag){
            ToolService.sendBehaviorUv(flag);
            $scope.listflag = flag;
            $rootScope.thirdtab = flagNames[flag];
        }
        $scope.sendEve = function(){
            ToolService.sendBehaviorUv("search");      
        }
        $scope.query = function(){
        	var params = ToolService.getParams($scope);
        	params.datatype = "list";

            var areport = "delay_"+$scope.listflag+"_bycampaign";
        	var listPM = HttpService.getReportData(areport, params);
    		$scope.listDataLoading = true;
    		listPM.then(function(data){
    			$scope.listData = data;
    			$scope.infoList = data.val;
                $scope.searchKeyName = data.columnkey[0];
                $scope.sortCol = "";
                
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
                
                $scope.listDataLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.listCondition = ToolService.getChartConditions($filter('translate')("激活延迟分析-")+flagNames[$scope.listflag],areport,params);
    		});
        }

        var orderBy = $filter('orderBy'),rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("appid+date.startDate+date.endDate+listflag+lang",function(){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.date)){
        		$scope.query();
        	}
        });
    }
})();