(function() {
    angular.module("app.collect")
        .controller("fakeCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "DateService", "$timeout", "$filter", "UtilService", "$location", "$anchorScroll", "$translate", "$stateParams", fakeCtrl]);

    function fakeCtrl($rootScope, $scope, HttpService, ToolService, DateService, $timeout, $filter, UtilService, $location, $anchorScroll, $translate, $stateParams) {
        var pageInfo = $stateParams;
        var loadingTime = new Date().getTime();
        var durationTime = 1000 * 3;
        $scope.$on('curdate', function(e, msg) {
            $scope.date = msg.date;
        });

        $scope.$on("channelFakeid", function(e, msg) {
            $scope.channelFakeinfo = msg.info;
            var tempList = JSON.parse(JSON.stringify($scope.typeInfoList));
            $scope.typelistFakeInfo = '';
            $scope.typeInfoList = []
            setTimeout(function() {
                $scope.typeInfoList = tempList;
            }, 1000);
        });
        $scope.$on("typelistFakeIds", function(e, msg) {
            $scope.typelistFakeInfo = msg.info;
            var tempList = JSON.parse(JSON.stringify($scope.channelFakeList));
            $scope.channelFakeList = [];
            $scope.channelFakeinfo = '';
            setTimeout(function() {
                $scope.channelFakeList = tempList;
            }, 1000);
        });



        var loadTime = new Date().getTime();
        var duration1Time = 1000 * 4;
        $scope.$watch("appid+date+fakeType", function(n,o) {
            // if (angular.isUndefined($scope.appid)) { return false; }
            if (($rootScope.fakeType == 1 || $rootScope.fakeType == 2) && $scope.appid) {
                if (pageInfo.stateinfo == "fakedec") {
                    $scope.pageFlag = 3;
                } else if (pageInfo.stateinfo == "publicIP") {
                    $scope.pageFlag = 5;
                    $scope.publicIP();
                } else {
                    $scope.pageFlag = 2;
                    if (new Date().getTime() - loadTime < duration1Time) {
                        return false;
                    }
                    $scope.query();
                }
                $scope.firstQuery = true;
                $scope.firstSelectQuery = true;
            }
        });



        $scope.closeMaturity = function() {
            var url = "login/fake_tips";
            var closePM = HttpService.postInfo(url);
            closePM.then(function(data) {
                $scope.fakeTips = false;
            });
        }

        $scope.queryFakeSelectInfos = function() {
                $translate(["请选择", "自然量"]).then(function(translations) {
                    $scope.getFakeChannel(translations["请选择"], translations["自然量"]);
                }, function(tranIds) {
                    $scope.getFakeChannel(tranIds["请选择"], tranIds["自然量"]);
                });
            }
            //渠道  活动
        $scope.getFakeChannel = function(noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;
            channelPM.then(function(data) {
                $scope.firstSelectQuery = false;
                $scope.channelFakeList = data;
            });
            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            $scope.typeInfoname = noFilter + campaignparams.txt;
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;
            campaignPM.then(function(data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.filter(function(item) {
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                $scope.typeInfoList = data;
                $scope.campaignListAll = data;
                if ($scope.campaignListTotal.total >= 500) {
                    $scope.SearchFakeBtn = true;

                } else {
                    $scope.SearchFakeBtn = false;
                }
            });
        }

        $scope.clearTxtFakeId = "clearTxtFakeId";
        $scope.$on($scope.clearTxtFakeId, function(event, data) {
            $scope.typeInfoList = $scope.campaignListAll
        })

        $scope.SearchFakeBtn = true
        $scope.searchActiveFakeId = "searchActiveFakeId";
        $scope.$on($scope.searchActiveFakeId, function(event, data) {
            if (!data) {
                return false
            }

            var Pm = HttpService.getInfo($scope.appid + "/campaign/dropdown?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.typeInfoList = dataList
                }
            });
        });

        $scope.selectFlag = "date";
        $scope.changeSelectFlag = function(flag) {
            ToolService.sendBehaviorUv("flag");
            $scope.selectFlag = flag;
            $scope.query();
        }

        var curfilpPage = null,
            rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            if (msg.listkey == 'public') {
                $scope.flipPage = msg;
                $scope.flipChange = ++rmd;
            } else {
                $scope.flipPage2 = msg;
                $scope.fixrefresh = ++rmd;
            }
        });


        $scope.query = function() {
            var params = ToolService.getParams($scope);
            if ($scope.pageFlag != 2 || !params.startdate) { return false; }
            params.datatype = 'list';
            params.func = "fake";
            var listPM = null,
                currentInfo = {},
                qReport = "";
            if ($scope.selectFlag == "date") {
                qReport = "black_click_ds_v20";
            } else if ($scope.selectFlag == 'campaign') {
                qReport = "black_click_campaign_v20";
            } else {
                qReport = "black_click_channel_v20";
            }

            if (typeof $scope.typelistFakeInfo == 'string' && ($scope.typelistFakeInfo.split(',').length == $scope.typeInfoList.length && $scope.typeInfoList.length != 1)) {
                $scope.typelistFakeInfo = 'all'
            }

            params.cid = $scope.channelFakeinfo; //渠道id
            params.campaignid = $scope.typelistFakeInfo; //活动id

            listPM = HttpService.getReportData(qReport, params);
            $scope.asmListLoading = true;
            listPM.then(function(data) {
                $scope.export();
                $scope.firstQuery = false;
                $scope.asmList = data;
                $scope.infoList = data.val;

                $scope.infoListTotal = data.val[0];
                $scope.infoList = data.val.slice(1);

                $scope.sortCol = "";
                $scope.asmListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
                $scope.getNewTableHead();
                $scope.colsStyle = ToolService.getTableColsWidth($scope.firNameList);
                /*$scope.colsStyle = $scope.colsStyle.map(function(item){
                    var w = item.width;
                    var len = parseInt(Number(w.substring(0,w.length-2)));
                    return {'width':len +"px",'max-width':len +"px"}
                });*/
                $scope.getColsStyle1();
            });

        }
        //获取表头第二行所有的宽度。
        $scope.getColsStyle1 = function() {
                var colsStyle1 = UtilService.cloneJSON($scope.colsStyle), //复制第一行表头的th宽度
                    colsStyle2 = [];
                ($scope.firColumnKey && $scope.firColumnKey.length > 0) && $scope.sinRowHead.forEach(function(item, index) {
                    var a = $scope.firColumnKey.indexOf(item);
                    var begin = eval($scope.sinRowHeadSunNum.slice(0, index).join("+")); //第一行第n列合并的第二行列元素的开始位置。
                    begin = begin ? begin : 0; //第一次默认为0
                    a = a + begin - index; //元素替换后的新位置
                    var b = $scope.getColsStyle2(colsStyle1[a], $scope.sinRowHeadSunNum[index], $scope.secNameList);
                    colsStyle2 = colsStyle2.concat([], UtilService.cloneJSON(b));
                    // var b = styleList.slice(begin,begin+$scope.sinRowHeadSunNum[index]);//截取第一行合并第二行元素的宽度集合
                    b.unshift(1);
                    b.unshift(a);
                    Array.prototype.splice.apply(colsStyle1, b);
                });
                $scope.colsStyle1 = colsStyle1;
                $scope.colsStyle2 = colsStyle2;
            }
            /**
             * @param a 总共长度
             * @param b 分割数
             * @param c 要分割成的标题数组
             * @returns {Array}
             */
        $scope.getColsStyle2 = function(a, b, c) {
                var d = [];
                if (a) {
                    var totalW = a.width,
                        totalL = 0;
                    var totalWH = Number(totalW.substring(0, totalW.length - 2));
                    totalWH -= (b - 1) * 11;
                    for (var i = 0; i < c.length; i++) {
                        if (i < b) {
                            totalL += ToolService.getByteLen(c[i]);
                        } else {
                            break;
                        }
                    }

                    for (var i = 0; i < c.length; i++) {
                        if (i < b - 1) {
                            var e = ToolService.getByteLen(c[i]) / totalL;
                            var newW = Number(e * (totalWH));
                            d.push(newW);
                        } else {
                            break;
                        }
                    }
                    d.push(totalWH > 130 ? (totalWH - eval(d.join('+')) - 1) : (totalWH - eval(d.join('+'))));
                    return d.map(function(item) {
                        return { 'width': item + "px", 'max-width': item + "px" }
                    });
                }
            }
            //表头中非两行合并的第一行对照第二行的列数，在这写死
        $scope.sinRowHeadSunNum = [3, 2];
        //表头中非两行合并表头的第一行
        $scope.sinRowHead = ["num_install_black", "num_install_black_deviceid"];
        //新版表头
        $scope.getNewTableHead = function() {
            var nameList = $scope.asmList ? $scope.asmList.name : [], //新表头列中文名集合
                colList = $scope.asmList ? $scope.asmList.columnkey : [], //新表头列字段集合
                firNameList = [], //新表头第一行列中文名集合
                firColumnKey = [], //新表头第一行字段集合
                secNameList = [], //新表头未合并第二行中文名集合
                newColumnKey = [], //新表头第二行所有字段集合，包括一二行合并的第一行字段
                newColunmName = [], //新表头第二行所有列名集合，包括一二行合并的第二行列名
                reg = /^level(\d)+$/;
            colList && colList.forEach(function(item, index) {
                if (!reg.test(item)) { //leve1、level2、level3等字段属于表头第二行字段
                    firNameList.push(nameList[index]);
                    firColumnKey.push(item);
                } else {
                    secNameList.push(nameList[index]);
                }
                if ($scope.sinRowHead.indexOf(item) == -1) { //不在sinRowHead中的字段为表头第二行所有字段，也就是表体要迭代展示的字段。
                    newColumnKey.push(item);
                    newColunmName.push(nameList[index]);
                }
            });
            $scope.firNameList = firNameList;
            $scope.firColumnKey = firColumnKey;
            $scope.secNameList = secNameList;
            $scope.newColumnKey = newColumnKey;
            $scope.newColunmName = newColunmName;
        }

        $scope.$on("conentresize", function() {
            if ($scope.asmList) {
                // $scope.colsStyle = ToolService.getTableColsWidth($scope.asmList.name);
                $scope.colsStyle = ToolService.getTableColsWidth($scope.firNameList);
            }
        });

        $scope.export = function() {
                var qReport = "",
                    params = {};
                if ($scope.selectFlag == "date") {
                    qReport = "black_click_ds_v20";
                } else if ($scope.selectFlag == 'campaign') {
                    qReport = "black_click_campaign_v20";
                } else {
                    qReport = "black_click_channel_v20";
                }
                params.startdate = $scope.date.startDate;
                params.enddate = $scope.date.endDate;
                params.appid = $scope.appid;
                params.datatype = 'list';
                params.func = "fake";
                params.cid = $scope.channelFakeinfo;
                params.campaignid = $scope.typelistFakeInfo;
                $scope.listCondition = ToolService.getChartConditions($filter('translate')("防作弊卫士"), qReport, params);
            }
            //控制滚动条
        $scope.gotoDiv = function() {
            $location.hash("deviceListDiv");
            $anchorScroll();
        };
        var orderBy = $filter('orderBy');
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,lang:lang,typelistFakeInfo:typelistFakeInfo,channelFakeinfo:channelFakeinfo}", function(n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date) || n == o) {
                return false;
            }
            if (($rootScope.fakeType == 1 || $rootScope.fakeType == 2)) {
                if (($scope.typelistFakeInfo && n.typelistFakeInfo != "undefined") || ($scope.channelFakeinfo && n.typelistFakeInfo != "undefined") || (n.startDate != o.startDate)) {
                    $scope.query();
                }
            }
        })
        $scope.backFlag = function(id) {
            $scope.pageFlag = id;
            if (pageInfo.stateinfo == "publicIP") {
                $scope.pageFlag = 2;
            }
            $scope.query();
        }

        //修改防作弊
        $scope.fixFake = function() {
            ToolService.sendBehaviorUv("fixFake");
            $scope.pageFlag = 3;
            $rootScope.operSubmitData($filter('translate')("修改"));
        }

        //公共IP列表
        $scope.publicIP = function() {
                ToolService.sendBehaviorUv("publicIP");
                $scope.pageFlag = 5;
                var publicPM = HttpService.getInfo("mng/channelparam/find");
                ToolService.showLoading();
                publicPM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.campaignList = data;
                    $scope.selectIDS = [];
                    $scope.searchtxt = "";
                });
            }
            //公共IP保存
        $scope.saveIP = function() {
                // if($rootScope.demoU){return false;}
                var par = {
                    ip: $scope.ip
                };
                var verPar = {
                    ip: {
                        key: 'ipError',
                        val: $scope.ip
                    }
                };
                $scope.tip = formJudge(verPar);
                if ($scope.tip.succ != true) {
                    ToolService.showTips($scope.formTipMsg);
                    return false;
                }
                if ($scope.ip == oldIP) {
                    $scope.closeWin();
                    return false;
                }
                var savePM = null,
                    txtTips = $filter('translate')("添加成功，5分钟后可生效。");
                if ($scope.ipListId != null) {
                    par.id = $scope.ipListId;
                    savePM = HttpService.putInfo("mng/channelparam/update", par);
                    txtTips = $filter('translate')("修改成功，5分钟后可生效。");
                } else {
                    savePM = HttpService.postInfo("mng/channelparam/create", par);
                }
                ToolService.showLoading();
                savePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.code == -7000) {
                        $scope.tip = {
                            ip: {
                                status: true,
                                txt: $filter('translate')("IP地址已存在")
                            }
                        };
                    } else {
                        ToolService.showTips(txtTips);
                        $scope.closeWin();
                        $scope.publicIP();
                    }
                }, function(data) {
                    ToolService.hideLoading();
                    if (data.code == -7000) {
                        $scope.tip = {
                            ip: {
                                status: true,
                                txt: $filter('translate')("IP地址已存在")
                            }
                        };
                    }
                });

            }
            //新增或编辑IP
        var oldIP = "";
        $scope.createIP = function(info) {
            if (info == undefined) {
                $scope.ip = "";
                $scope.ipListId = null;
            } else {
                $scope.ipListId = info.id;
                $scope.ip = info.ip;
                oldIP = info.ip;
            }
            ToolService.showAlp();
            $scope.winFlag = 1;
            $scope.tip = {
                ip: {
                    status: false,
                    txt: ""
                }
            };
        }
        $scope.closeWin = function() {
                ToolService.hideAlp();
                $scope.winFlag = 0;
            }
            //选择、删除
        $scope.$watch("flipChange+campaignList", function() {
            if ($scope.flipPage && $scope.campaignList) {
                curfilpPage = { start: $scope.flipPage.start + 1, end: $scope.flipPage.end };
                if (curfilpPage.end > $scope.campaignList.length) {
                    curfilpPage.end = $scope.campaignList.length;
                }
            }
        });

        $scope.clickCkx = function(id) {
            var idx = $scope.selectIDS.indexOf(id);
            if (idx > -1) {
                $scope.selectIDS.splice(idx, 1);
            } else {
                $scope.selectIDS.push(id);
            }
        }
        $scope.setCurrentList = function() {
            var curList = $scope.campaignList;
            if (!UtilService.isNullStr($scope.searchTxt)) {
                var myFilterList = $scope.campaignList.filter(function(item) {
                    if ((item.name && angular.uppercase(String(item.name)).indexOf(angular.uppercase($scope.searchTxt)) > -1) || (item.trackurl && angular.uppercase(String(item.trackurl)).indexOf(angular.uppercase($scope.searchTxt)) > -1)) {
                        return true;
                    } else {
                        return false;
                    }
                });
                curList = myFilterList;
            }
            $scope.curShowList = curList;
        }
        $scope.curPageAll = function() {
            if (!$scope.flipPage || !$scope.campaignList) { return false; }

            $scope.setCurrentList();
            curfilpPage.end = $scope.curShowList.length > curfilpPage.end ? curfilpPage.end : $scope.curShowList.length;
            var len = curfilpPage.end - curfilpPage.start,
                count = 0;

            for (var i = curfilpPage.start; i < curfilpPage.end; i++) {
                var temp = $scope.curShowList[i];

                if ($scope.selectIDS.indexOf(temp.id) > -1) {
                    count++;
                }
            }
            $scope.onePageCount = count;
            return len == count && len > 0;
        }
        $scope.checkAllCurrent = function() {
            var bol = $scope.curPageAll();
            curfilpPage.end = $scope.curShowList.length > curfilpPage.end ? curfilpPage.end : $scope.curShowList.length;
            for (var i = curfilpPage.start; i < curfilpPage.end; i++) {
                var temp = $scope.curShowList[i],
                    idx = $scope.selectIDS.indexOf(temp.id);
                if (bol && idx > -1) {
                    $scope.selectIDS.splice(idx, 1);
                }
                if (!bol && idx == -1) {
                    $scope.selectIDS.push(temp.id);
                }
            }
        }

        $scope.checkAllPage = function() {
            $scope.selectIDS = [];
            var len = $scope.curShowList.length,
                count = 0;
            for (var i = 0; i < len; i++) {
                $scope.selectIDS.push($scope.curShowList[i].id);
            }
        }

        $scope.NocheckAllPage = function() {
            $scope.selectIDS = [];
        }

        $scope.$watch("searchTxt", function(n) {
            if (angular.isDefined(n)) {
                $scope.selectIDS = [];
            }
        });
        $scope.$watch("selectIDS", function(n) {
            if ($scope.selectIDS && $scope.selectIDS.length > 0) {
                $scope.iptHolder = $filter('translate')("搜索后，所选内容将清除");
            } else {
                $scope.iptHolder = $filter('translate')("输入名称或短链搜索");
            }
        });

        $scope.doBatchRemove = function() {
            $scope.delIPbatch = true;
        }

        $scope.removeBatchIP = function() {
            $scope.delIPbatch = false;
            var removePM = HttpService.deleteInfo("mng/channelparam/delete/" + $scope.selectIDS.join(","));
            ToolService.showLoading();
            removePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("删除成功"));
                $scope.publicIP();
            });
        }
        $scope.doRemoveIP = function(info) {
            $scope.delIPTips = $filter('translate')("是否删除") + info.ip + $filter('translate')("这个IP地址？");
            $scope.delIPstatus = true;
            $scope.delIPId = info.id;
        }
        $scope.removeInfoIP = function() {
                var removePM = HttpService.deleteInfo("mng/channelparam/delete/" + $scope.delIPId);
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.delIPstatus = false;
                    ToolService.showTips($filter('translate')("删除成功"));
                    $scope.publicIP();
                });
            }
            //防作弊设置
        $scope.cheatList = [
            { id: 0, name: $filter('translate')("严格") },
            { id: 1, name: $filter('translate')("普通") },
            { id: 2, name: $filter('translate')("宽松") }
        ];
        $scope.$on("cheat", function(e, msg) {
            $scope.cheat = msg.info.id;
        });

        $scope.openClose = function(flag) {
            if (flag == 1) {
                $scope.blackType = true;
                // if ($scope.cheatInit == 999) {
                //     $scope.cheatInit = 1;
                // }
            } else {
                $scope.blackType = false;
            }
        }

        //全渠道设置
        $scope.allSet = function() {
            var allPM = HttpService.getInfo("mng/channelparam/find/black/"+$scope.appid);
            ToolService.showLoading();
            allPM.then(function(data) {
                ToolService.hideLoading();
                $scope.allBlack = data.allChannelBlackMatch;
                if (data.blacklistLevel == -1) {
                    // $scope.cheatInit = 999;
                    $scope.cheatInit = 1;
                } else {
                    $scope.cheatInit = data.blacklistLevel;
                }

                if (angular.isArray(data.channelLevelClosed)) {
                    $scope.closeChannelLength = data.channelLevelClosed.length;
                    if (data.channelLevelClosed.length > 10) {
                        $scope.closeChannel = data.channelLevelClosed.slice(0, 10);
                    } else {
                        $scope.closeChannel = data.channelLevelClosed;
                    }
                    $scope.closeChannelname = $scope.closeChannel.toString();
                }
                if (data.channelLevelClosed == null) {
                    $scope.closeChannelLength = null;
                }

                if (angular.isArray(data.channelLevel)) {
                    $scope.noSameChannelLength = data.channelLevel.length;
                    if (data.channelLevel.length > 10) {
                        $scope.noSameChannel = data.channelLevel.slice(0, 10);
                    } else {
                        $scope.noSameChannel = data.channelLevel;
                    }
                    $scope.noSameChannelName = $scope.noSameChannel.toString();
                }
                if (data.channelLevel == null) {
                    $scope.noSameChannelLength = null;
                }
                $scope.blackType = data.blacklistStatus;
                $scope.deviceBlackStatus = data.deviceBlackStatus;
                $scope.datafresh2 = ++rmd;
                $scope.datafresh1 = ++rmd;
            });
        }
        $scope.$watch("{appid:appid}", function(n, o) {
            if (angular.isUndefined($scope.appid)) {
                return false;
            }
            $scope.allSet() 
            $scope.queryFakeSelectInfos();
        })
        setTimeout(function(){
            $scope.query();
        },300)
        $scope.saveAllSet = function(id, flag) {
                //应用全渠道限制
                // if(($scope.cheat == 999 && id == 0 && flag == "black" && $scope.blackType)|| $rootScope.demoU){
                //     return false;
                // }
                // if (($scope.cheat == 999 && id == 0 && flag == "black" && $scope.blackType)) {
                //     return false;
                // }

                var isall = true;
                if (id == 1) {
                    var isdefault = true;
                } else {
                    var isdefault = false;
                }
                var par = {
                    deviceBlackStatus: $scope.deviceBlackStatus ? true : false,
                    blacklistStatus: $scope.blackType
                };
                // if ($scope.cheat != 999) {
                //     par.blacklistStatus = $scope.blackType;
                // }
                if ($scope.deviceBlackStatus == true || $scope.blackType == true) {
                    par.blacklistLevel = $scope.cheat;
                } else {
                    par.blacklistLevel = -1;
                }
                par.app = $scope.appid;
                var allsavePM = HttpService.putInfo("mng/channelparam/update/" + flag + "?isall=" + isall + "&isdefault=" + isdefault, par);
                ToolService.showLoading();
                allsavePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data == 'success') {
                        ToolService.showTips($filter('translate')("保存成功，修改后第二天零点生效。"));
                        $rootScope.operSubmitData($filter('translate')("应用于全渠道"));
                        $scope.allSet();
                    }
                    if (flag == 'black') {
                        $scope.allBlack = true;
                    }
                });
            }
            //表头第二行最后一个元素无边框问题
        $scope.getLastStyle = function(val) {
                if (val) {
                    return {
                        'border-right': '1px solid #dcdcdc'
                    };
                } else {
                    return {};
                }
            }
            //设备防作弊状态初始值
            // $scope.deviceBlackStatus = false;
            /*  $scope.$watch("deviceBlackStatus",function(){
                      console.log("11:"+$scope.deviceBlackStatus);
                  })*/


    }
})();