(function () {
    angular.module("app.collect")
        .controller("funnelinfoCtrl", ["$rootScope", "$scope", "HttpService", "ToolService","DateService","ArrayConstant", "$timeout", "$filter", "$translate", "$state", "UtilService", funnelinfoCtrl]);

    function funnelinfoCtrl($rootScope, $scope, HttpService, ToolService, DateService, ArrayConstant,$timeout, $filter, $translate, $state, UtilService) {
        var rmd = new Date().getTime();
        var userList1 = [
            { id: "all", name: $translate.instant("所有用户") },
            { id: "1", name: $translate.instant("推广量") },
            { id: "-1", name: $translate.instant("自然量") }
        ]
        var userList2 = [{ id: "1", name: $translate.instant("推广量") },];
        var auths = JSON.parse(window.localStorage.getItem("ryioUauth"));
        $scope.userList = userList1;
        $scope.getNatureOpen = function(){
            if($rootScope.isCustomUser){
                for (var key in auths) {
                    if($scope.appid == key){
                        $scope.isNature = auths[key].isNatureOpen
                        if(!$scope.isNature){
                            $scope.userList = userList2
                        }
                    }
                }
            }
        }
        $scope.getNatureOpen();
        $scope.tab = "userfunnel";
        $scope.useridInit = "1";
        $scope.showSelectItem = true;
        $scope.$on("userid", function(e, msg) {
            $scope.user_id = msg.info.id;
            if(msg.info.id == "-1" || msg.info.id == "all"){
                $scope.showSelectItem = false;
            }else{
                $scope.showSelectItem = true;
            }
        });
        $scope.changeFlag = function(flag){
            $scope.tab = flag;
            $scope.reset();
        }
        $scope.isDemo = ToolService.isUser(ArrayConstant.demoEmail);
        if($scope.isDemo){
            $scope.activedate = ToolService.getLastDays(-7);
            $scope.paymentdate = ToolService.getLastDays(-7);
        }else{
            $scope.activedate = ToolService.getLastDays(-1);
            $scope.paymentdate = ToolService.getLastDays(-1);
        }
        $scope.$on('activedate',function(e,msg){
            $scope.activedate = msg;
            // $scope.paymentdate = msg;
        });
        $scope.$on('curdate',function(e,msg){
            $scope.activedate = msg.date;
        });
        $scope.$watch("activedate",function(){
            if(angular.isDefined($scope.activedate)){
                $scope.activedatestr = $scope.activedate.startDate + $filter('translate')("至") + $scope.activedate.endDate;
            }
        });

        $scope.$on('paymentdate',function(e,msg){
            $scope.paymentdate = msg;
        });
        $scope.$on('paydate',function(e,msg){
            $scope.paymentdate = msg.date;
        });
        $scope.$watch("paymentdate",function(){
            if(angular.isDefined($scope.paymentdate)){
                $scope.paymentdatestr = $scope.paymentdate.startDate + $filter('translate')("至") + $scope.paymentdate.endDate;
            }
        });
        
        //模板列表
        $scope.statusidInit = "选择模板";
        $scope.getTemplate = function(){
            var tpPM = HttpService.getInfo("sdkevent/funnel/template/list/"+$scope.appid);
            tpPM.then(function(data){
                // console.log(data)
            })
        }
        //添加事件
        $scope.eventNameInit = "选择事件";
        $scope.evtntList = function(){
            var eventPM = HttpService.getInfo("sdkevent/default/list/"+$scope.appid);
            eventPM.then(function(data) {
                $scope.eventList = data;
                $scope.eventidInit = $scope.eventList[0].key;
            })
        }
        $scope.$on('eventid',function(e,msg){
            $scope.event_id = msg.info;
        })

        $scope.querySelectInfos = function() {
            $translate(["不筛选", "自然量"]).then(function(translations) {
                $scope.initSelects(translations["不筛选"], translations["自然量"]);
            }, function(tranIds) {
                $scope.initSelects(tranIds["不筛选"], tranIds["自然量"]);
            });
        }

        $scope.initSelects = function(noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;
            channelPM.then(function(data) {
                $scope.channelList = data;
            });

            var campgroupparams = ToolService.getChannelCampaignParams("campgroup", $scope.appid);
            var campgroupPM = HttpService.getInfo(campgroupparams.url);
            $scope.campgroupNameInit = noFilter + campgroupparams.txt;
            $scope.campgroupInits = noFilter + campgroupparams.txt;
            campgroupPM.then(function(data) {
                data.unshift({ id: "all", name: $scope.campgroupNameInit });
                $scope.campgroupList = data;
                $scope.campgroupLists = $scope.campgroupList.filter(function(value){
                    return value.id != 'all'
                });
            });

             //获取活动
             var campgroupparams = ToolService.getChannelCampaignParams("campgroup", $scope.appid);
            var campgroupPM = HttpService.getInfo(campgroupparams.url);
            $scope.campgroupNameInit = noFilter + campgroupparams.txt;
            $scope.campgroupInits = noFilter + campgroupparams.txt;
            campgroupPM.then(function(data) {
                data.unshift({ id: "all", name: $scope.campgroupNameInit });
                $scope.campgroupList = data;
                $scope.campgroupLists = $scope.campgroupList.filter(function(value){
                    return value.id != 'all'
                });
            });

            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;
            campaignPM.then(function(data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.unshift({ id: "all", name: $scope.campaignNameInit });
                data.filter(function(item) {
                    // item.uid = item.id;
                    // item.id = item.campaignid;
                });
                $scope.campaignList = data;
                $scope.campaignListAll = data;
            });
        }
        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function(event, data) {
            $scope.campaignList = $scope.campaignListAll
        })

        $scope.searchTextId = "searchTextId";
        $scope.$on($scope.searchTextId, function(event, data) {
            if (!data) {
                return false
            }
            var Pm = HttpService.getInfo($scope.appid + "/campaign/dropdown?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.campaignList = dataList
                }

            });

        });
        $scope.$on("channelid", function(e, msg) {
            $scope.channelid = msg.info;
        })
        $scope.$on("campaignid", function(e, msg) {
            $scope.campaignid = msg.info.campaignid;
        });
        $scope.getMaxPercent = function(){
            var arr = $scope.funDataList;
            var max = arr[0].rate;
            for(var i=1; i<arr.length;i++){
                if(max<arr[i].rate) {
                    max=arr[i].rate;
                }
            }
            if(max <= 100){
                max = 100
            }
            return 100/max;
        }
        //生成漏斗
        $scope.getFunnelList = function(){
            if(!$scope.event_id){
                ToolService.showTips($filter('translate')("请选择事件"));
                return false
            }
            $scope.isReset = true;
            var qReport = "funnel_user_event_list";
            var params = ToolService.getParams($scope);
            params.start = $scope.activedate.startDate;
            params.end = $scope.activedate.endDate;
            params.ins_start = $scope.paymentdate.startDate;
            params.ins_end = $scope.paymentdate.endDate;
            params.datatype = "list";
            params.viewcolumn = $scope.event_id;
            params.func = "campaigninfo";
            params.viewtype = "funnel";
            params.usertype = $scope.user_id;
            params.campaignid = $scope.campaignid;
            params.cid =$scope.channelid;
            if($scope.tab == "userfunnel"){
                params.user_funnel = "1";
            }
            ToolService.showLoading()
            var listPM = HttpService.getReportData(qReport, params);
            listPM.then(function(data){
                ToolService.hideLoading();
                $scope.funDataList = data.val
                $scope.percentUnit = $scope.getMaxPercent();
            })
            delete params.campaignid;
            delete params.cid;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("事件转化漏斗"),qReport,params);
            $scope.exportTit = "导出详细报告";
        }
        $scope.isReset = true;
        $scope.reset = function(){
            $scope.userRes = ++rmd;
            $scope.eventRes = ++rmd;
            $scope.channelRe = ++rmd;
            $scope.campaignRes = ++rmd;
            $scope.useridInit = "1";
            $scope.activedatestr = $scope.activedate.startDate + $filter('translate')("至") + $scope.activedate.endDate;
            $scope.paymentdatestr = $scope.paymentdate.startDate + $filter('translate')("至") + $scope.paymentdate.endDate;
            $scope.eventNameInit = "选择事件";
            $scope.campaignInit = "不筛选活动"
            $scope.isReset = false;
            $scope.event_id = "";
        }
        $scope.$watch("appid", function() {
            if ($scope.appid) {
                $scope.evtntList();
                $scope.querySelectInfos();
                $scope.reset();
                $scope.getNatureOpen()
            }
        });
    }
})();