(function() {
    angular.module("app.collect")
        .controller("remarketingCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "$timeout", "$filter", "$translate", "$state", "UtilService", remarketingCtrl]);

    function remarketingCtrl($rootScope, $scope, HttpService, ToolService, $timeout, $filter, $translate, $state, UtilService) {
        $scope.report = false;
        $scope.initLoading = function() {
            $scope.campListLoading = true;
        };
        $scope.initLoading();
        $scope.$on('curdate', function(e, msg) {
            $scope.date = msg.date;
        });
        var selectFlagIndex = 0;
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $scope.MainSuper = true;
        } else {
            $scope.MainSuper = false;
        }
        $scope.$on("conentresize", function() {
            if ($scope.campList) $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);
        });
        $scope.clickBase = function(obj) {
            if (obj.isedit == false) { return false; }
            if (obj.fieldcode == 'rate_add_daily' && obj.ischeck == false) {
                $scope.baseList.filter(function(value) {
                    if (value.fieldcode == 'num_payer_new_user' && value.ischeck == false) {
                        value.ischeck = true;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            } else if (obj.fieldcode == 'num_payer_new_user' && obj.ischeck == true) {
                $scope.baseList.filter(function(value) {
                    if (value.fieldcode == 'rate_add_daily' && value.ischeck == true) {
                        value.ischeck = false;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            }
            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) { 
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function(type) {
            if (!$scope.baseList) { return false; }
            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function(item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }

                }
            });
        }
        $scope.hasCheckAll = function(type) {
            if (!$scope.baseList) { return false; }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.hasType = function(type) {
                if (!$scope.baseList) { return false; }

                var count = 0;
                for (var i = 0; i < $scope.baseList.length; i++) {
                    if ($scope.baseList[i].type == type) {
                        count = 1;
                        break;
                    }
                }
                return count > 0;
            }
            //关闭
        $scope.closeArouseTip = function() {
            $scope.arouseTips = false;
            var url = "login/arouse_tips";
            var closePM = HttpService.postInfo(url);
            closePM.then(function(data) {
                $rootScope.arouseTips = false;
            });
        }
        $scope.showBaseWin = function() {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function(flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function(item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function() {
            ToolService.sendBehaviorUv("okBase");
            // $scope.query(true);
            $scope.queryGdt(true, null, 1);

            var url = "";
            var wgame = "/campaign/viewcolumn/wgame?viewcolumn=";
            var weixin = "/campaign/viewcolumn/weixin?viewcolumn=";
            var campaign = "/campaign/viewcolumn/remarketing?viewcolumn=";
            var vcol = [];
            $scope.baseList.filter(function(item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            if ($scope.iswx) {
                url = weixin;

            } else if ($scope.iswg) {
                url = wgame
            } else {
                url = campaign
            }
            var updatePM = HttpService.postInfo($scope.appid + url + vcol.join(","), {});
            updatePM.then(function(data) {});
            $scope.hideDialog(-1);
        }
        $scope.selectFlag = "date";
        $scope.scenesHide = false;
        $scope.changeSelectFlag = function(flag) {
            ToolService.sendBehaviorUv(flag);
            if (flag != "channel") {
                $scope.showSubchannel = false
            }
            if (flag != "account") {
                $scope.isGdtDetail = false;
            }
            if ($scope.selectFlag != flag) {
                $scope.infofalg = false;
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
            (($scope.iswx || $scope.iswg) && (flag != 'campaign' && flag != 'channel')) && ($scope.isDetail = false);
            if ($scope.isDetail && flag == 'channel') {
                $scope.channelRe = new Date().getTime();
            }
            if (($scope.iswx || $scope.iswg) && (flag == 'scenes')) {
                $scope.scenesHide = true;
            } else {
                $scope.scenesHide = false;
            }
            $scope.selectFlag = flag;
            selectFlagIndex++;

        }

        $scope.querySelectInfos = function() {
            $translate(["不筛选", "自然量"]).then(function(translations) {
                $scope.initSelects(translations["不筛选"], translations["自然量"]);
            }, function(tranIds) {
                $scope.initSelects(tranIds["不筛选"], tranIds["自然量"]);
            });
        }

        $scope.initSelects = function(noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;
            channelPM.then(function(data) {                
            $scope.channelList = data.filter(function(item){
                return item.type == 'ry_coop';
            });
            });
            

            var campgroupparams = ToolService.getChannelCampaignParams("campgroup", $scope.appid);
            var campgroupPM = HttpService.getInfo(campgroupparams.url);
            $scope.campgroupNameInit = noFilter + campgroupparams.txt;
            $scope.campgroupInits = noFilter + campgroupparams.txt;
            campgroupPM.then(function(data) {
                data.unshift({ id: "all", name: $scope.campgroupNameInit});
                $scope.campgroupLists = data.filter(function(value){
                    return value.id != 'all' && value.deeplink;
                });
                $scope.campgroupList = data.filter(function(value){
                    return  value.id == 'all' || value.deeplink;
                });
            });

            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/remarketing/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;
            campaignPM.then(function(data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.unshift({ id: "all", name: $scope.campaignNameInit });
                data.filter(function(item) {
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                $scope.campaignList = data;
                $scope.campaignListAll = data;
            });
        }
        $scope.selectlistNum = 0;
        var current = "";
        $scope.loginuserName = UtilService.getCookie("ryioUname");
        $scope.$on("channelid", function(e, msg) {
            current = "channel";
            $scope.clearCurrentReports();
            $scope.resetList();
            $scope.channelid = msg.info;
            $scope.selectlistNum++;

            if ($scope.channelid == '5305') {
                $scope.getGuangList("5305");
                $scope.showUniqueName = true;

            } else {
                $scope.showUniqueName = false;
                if ($scope.selectFlag == 'account') {
                    $scope.selectFlag = 'date';
                }

            }

        });

        $scope.campgroupInit = "all";
        $scope.$on("campgroupid", function(e, msg) {
            current = "campgroup";
            $scope.resetList();
            $scope.campgroupid = msg.info.id;
            $scope.selectlistNum++;
            $scope.showUniqueName = false
        });

        $scope.$on("campgroupids", function(e, msg) {
            $scope.clearCurrentReports()
            $scope.campgroupids = msg.info;
            $scope.queryGdt(false, null, 1);
        });

        $scope.campaignInit = "all";
        $scope.$on("campaignid", function(e, msg) {
            current = "campaign";
            $scope.resetList();
            $scope.campaignid = msg.info.id;
            $scope.selectlistNum++;
            $scope.showUniqueName = false;
        });

        var cacheNameId = "",
            cacheAccountId = "";
        $scope.$on("gdtNamesId", function(e, msg) {
            cacheNameId = msg.info.id;
            $scope.clearCurrentReports()
            $scope.queryGdt(true, null, 1);
        });
        $scope.$on("gdtAccountsId", function(e, msg) {
            cacheAccountId = msg.info.sp_account_number;
            $scope.clearCurrentReports()
            $scope.queryGdt(true, null, 1);

        });
        //清空currentReports
        $scope.clearCurrentReports = function() {
            if ($scope.selectFlag == 'account') {
                $scope.isGdtDetail = false;
                $scope.currentReports = null;
                $scope.allSubInfo = [];

            }
        }
        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function(event, data) {
            $scope.campaignList = $scope.campaignListAll
        })

        $scope.searchTextId = "searchTextId";
        $scope.$on($scope.searchTextId, function(event, data) {
            if (!data) {
                return false
            }
            var Pm = HttpService.getInfo($scope.appid + "/campaign/remarketing/dropdown?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.campaignList = dataList
                }

            });

        });

        $scope.resetList = function() {
            if ($scope.selectlistNum >= 1) {
                var precur = "";
                // if ($scope.channelid != 'all' && current != 'channel') {//渠道单选变多选
                if ($scope.channelid != '' && current != 'channel') {
                    $scope.channelResh = $scope.selectlistNum;
                    // $scope.channelid = "all";//渠道单选变多选
                    $scope.channelid = "";
                } else if ($scope.campgroupid != 'all' && current != 'campgroup') {
                    $scope.campgroupResh = $scope.selectlistNum;
                    $scope.campgroupid = "all";
                } else if ($scope.campaignid != 'all' && current != 'campaign') {
                    $scope.campaignResh = $scope.selectlistNum;
                    $scope.campaignid = "all";
                }

                //为了等到数据赋值完成再查询
                $timeout(function() {
                    $scope.query();
                }, 100);
            }
        }

        //获取广点通对应下拉框列表
        $scope.getGuangList = function(cid) {
            // ToolService.showLoading();
            $scope.gdtNamesData = $filter('translate')("不筛选媒体名称");
            $scope.gdtAccountsData = $filter('translate')("不筛选投放账号");
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var params = ToolService.getParams($scope);
            var guangPM = HttpService.getInfo($scope.appid + "/channel/findGuangDianTongChannel?cid=" + cid + '&startdate=' + params.startdate + '&enddate=' + params.enddate);
            guangPM.then(function(data) {
                data.gdtMap.unshift({ name: $filter('translate')("不筛选媒体名称") });
                $scope.gdtNames = data.gdtMap;
                if (data.channelAccounts) {
                    data.channelAccounts.unshift({ sp_account_number: '', alias: $filter('translate')("不筛选投放账号") });
                    $scope.gdtAccounts = data.channelAccounts;
                }
            })
        };


        $scope.packList = ToolService.getPackTypeList();
        $scope.packageInit = $scope.packList[0].id;
        $scope.$on("packid", function(e, msg) {
            $scope.packageID = msg.info.id;
        });

        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
            if ($scope.isSubChannel()) {
                if (msg.current && msg.pagenum) {
                    if (!$scope.infoList) { fixChange = false; }
                    $scope.query(true);
                }
            } else {
                $scope.fixrefresh = ++rmd;
            }
        });


        var flagNames;

        function init() {
            flagNames = {
                "date": $translate.instant("日期"),
                "campaign": $translate.instant("活动"),
                "campgroup": $translate.instant("活动组"),
                "channel": $translate.instant("渠道"),
                "subchannel": $translate.instant("子渠道"),
                "subaccount": $translate.instant("子账号"),
                "account": $translate.instant("投放账号"),
                "h5": "H5",
                "scenes": $translate.instant("场景")
            };

            $scope.statusList = [
                { id: "", name: $translate.instant("不筛选推广活动状态") },
                { id: "false", name: $translate.instant("已启用推广活动") },
                { id: "true", name: $translate.instant("已停用推广活动") }
            ];
            $scope.subchannelList = [
                { id: "siteId", name: $translate.instant("广告位") },
                { id: "plan", name: $translate.instant("计划") },
                { id: "rate", name: $translate.instant("流量来源") }
            ];
        }

        init();

        $scope.statusidInit = "";
        $scope.subchannelInit = "siteId";
        $scope.$on("statusid", function(e, msg) {
            $scope.statusid = msg.info.id;
        });
        var isFlag = 0;
        $scope.$on("subchannelid", function(e, msg) { 
            $scope.subchannelid = msg.info.id;
            $scope.subchannelName = msg.info.name;
            if (isFlag >= 2) {
                $scope.queryGdt(true, $scope.isSubChannel(), 1);
            } else {
                isFlag = isFlag + 1;
            }
            $scope.subVl = false;
        });
        $scope.showZero = false;
        $scope.listRefresh = 1;



        /**
         * 根据gdtNameId判断
         * state: -1
         * state: 1 
         * hasTotal:true/false  
         */

        $scope.queryGdt = function(flag, hasTotal, state) {
                var _flagNum = selectFlagIndex;
                var params = ToolService.getParams($scope);
                params.datatype = 'list';
                params.viewtype = $scope.selectFlag;
                params.func = "remarketing";
                if ($scope.statusid != "") {
                    params.del_flag = $scope.statusid;
                }
                if ($scope.filterTxt && $scope.filterTxt != '') {
                    params.searchtxt = $scope.filterTxt;
                }

                var listPM = null,
                    currentInfo = {},
                    qReport = "",
                    eptName = flagNames[$scope.selectFlag];
                    // subTitle = $scope.subchannelList;

                if ($scope.appInstance.platform == "H5") {
                    qReport = "marketinginfo_h5_bycampaign";
                    params.viewtype = "campaign_h5";
                    eptName = flagNames["h5"];
                } else {
                    if ($scope.selectFlag == 'subchannel' || ($scope.selectFlag == 'campaign' && $scope.currentReports && $scope.currentReports != null) || $scope.selectFlag == 'account') { //有下钻的情况
                        if ($scope.currentReports && $scope.currentReports != null && $scope.currentReports.key ) {
                            params[$scope.currentReports.key] = $scope.currentReports.val;
                            if ($scope.currentReports.key1) {
                                params[$scope.currentReports.key1] = $scope.currentReports.val1;
                            }
                            if ($scope.currentReports.report == 'subchannel_bycampaign') {
                                params.cid = $scope.subchannelCID;
                            }
                            currentInfo = UtilService.cloneJSON($scope.currentReports);
                            if($scope.selectFlag == 'campaign'){
                                $scope.hideCondition = false;
                                params.marketinginfo_appmarket = 'APPMARKET';
                            }
                        }
                        if (!flag || $scope.allSubInfo.length == 0) {
                            $scope.allSubInfo.push(currentInfo);
                        }
                       
                        qReport = $scope.currentReports.report;
                    } else {
                        var subfix = getSubFix($scope.selectFlag);
                        if (($scope.selectFlag == 'date' || $scope.selectFlag == 'campgroup' || $scope.selectFlag == 'channel' || $scope.selectFlag == "campaign") && $scope.packageID != 'all' && $scope.isandroid) {
                            params.marketinginfo_appmarket = $scope.packageID;
                        }
                        $scope.hideCondition = true;
                        $scope.isDetail = false;
                        if ($scope.selectFlag == "date" || $scope.selectFlag == "campaign") {
                            if ($scope.channelid != '') {
                                params.cid = $scope.channelid;
                            } else if ($scope.campgroupid != 'all') {
                                params.cgroupid = $scope.campgroupid;
                            } else if ($scope.campaignid != 'all' && ($scope.selectFlag == "date" || $scope.selectFlag == "campaign")) {
                                params.campaignid = $scope.campaignid;
                            }
                        }

                        if ($scope.selectFlag == "campgroup" && $scope.campgroupids) {
                            params.cgroupid = $scope.campgroupids;
                        }

                        if (($scope.iswx || $scope.iswg) && $scope.selectFlag == 'scenes' && $scope.channelid != '') { //小程序-场景-查询 需要渠道筛选
                            params.cid = $scope.channelid;
                        }
                        if (($scope.iswx || $scope.iswg) && $scope.selectFlag == 'campgroup') {
                            subfix = "campaign";
                        }
                        qReport = (($scope.iswx || $scope.iswg) ? "wx_marketinginfo_by" : "marketinginfo_by") + subfix;
                    }

                    if ($scope.selectFlag != 'bdkeyword') {
                        if ($scope.appInstance.platform == "selfBuilt") {
                            params.viewcolumn = 'num_impression,num_click_total,num_click,dupnum_click_all,dupnum_click_day,num_install,rate_install,num_click_fake,rate_click_fake,num_install_fake,rate_install_fake,num_install_black_deviceid,dau'
                        } else {
                            params.viewcolumn = $scope.getViewColumns();
                        }
                    }
                }

                var condiParams = '';
                if ($scope.isSubChannel()) {
                    if (hasTotal) {
                        $scope.getSubChannelParams(qReport, params, hasTotal);
                    } else {
                        params = $scope.getSubChannelParams(qReport, params, hasTotal);
                        condiParams = UtilService.cloneJSON(params);
                        delete condiParams.pageIndex;
                        delete condiParams.pageNumber;
                    }
                } else {
                    $scope.listTotal = undefined;
                }
                if (hasTotal) return;
                var params = params;

                if (state == 1) {
                    if ($scope.channelid == '5305') {
                        if (cacheAccountId == '不筛选投放账号') {
                            cacheAccountId = ""
                        }
                        params.thirdAccountCode = cacheAccountId;
                        params.gdt = cacheNameId;
                    } else {
                        cacheNameId = "";
                        cacheAccountId = "";
                    }
                }
                if ($scope.currentReports && $scope.currentReports.isgdt) { //广点通投放账号
                    params.cid = 5305;
                    params.viewtype = "campaign";
                    if ($scope.currentReports.title == "广点通点击数据") {
                        params.thirdAccountCode = '-1'
                    } else {
                        params.thirdAccountCode = $scope.currentReports.title
                    }

                }
                listPM = HttpService.getReportData(qReport, params);
                condiParams && (params = condiParams);
                params.showall0 = $scope.showZero;
                if ($scope.showSubchannel && $scope.subchannelName) {
                    $scope.subchannelName = "-" + $scope.subchannelName;
                } else {
                    $scope.subchannelName = "";
                }
                eptName = eptName + $scope.subchannelName

                $scope.listCondition = ToolService.getChartConditions($filter('translate')("再营销活动详情") + "-" + eptName, qReport, params);
                $scope.campListLoading = true;
                listPM.then(function(data) {
                    if (_flagNum != selectFlagIndex) { //防止频繁点击分析维度，出现页面加载数据不对
                        return false;
                    }
                    $scope.campList = data;
                    if ($scope.selectFlag != 'subaccount') {
                        $scope.infoListTotal = data.val[0];
                        $scope.campAllList = data.val.slice(1);

                    } else {
                        $scope.campAllList = data.val;
                    }
                    $scope.campNoZeroList = $scope.campAllList.filter(function(item, index) {
                        return item.isall0 == false;
                    });

                    if ($scope.isandroid && ($scope.selectFlag == 'campaign' || $scope.selectFlag == 'channel') && !$scope.isDetail) {
                        $scope.doPackFilter();
                    } else {
                        if ($scope.showZero || $scope.selectFlag == 'bdkeyword') {
                            $scope.infoList = $scope.campAllList;
                        } else {
                            $scope.infoList = $scope.campNoZeroList;
                        }
                    }
                    $scope.campListLoading = false;
                    $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                    if ($scope.selectFlag != "subaccount") {
                        $scope.searchTxt = "";
                    }
                    if ($scope.isSubChannel()) {
                        if (fixChange) {
                            $scope.fixrefresh = ++rmd;
                        } else {
                            $scope.initrefresh = ++rmd;
                            $scope.fixrefresh = ++rmd;
                        }
                        fixChange = true;
                    } else {
                        $scope.sortCol = "";
                        $scope.initrefresh = ++rmd;
                        $scope.fixrefresh = ++rmd;
                    }
                });

            }
            /**
             * 这个是历史方法
             */
        $scope.query = function(flag, hasTotal) {
            $scope.queryGdt(flag, hasTotal, -1);
        }

        //请求路径后缀
        function getSubFix(flag) {
            var subfix = "campgroup",
                subFixObj = { date: 'date', channel: "channel", campgroup: "campgroup", subaccount: "campgroup", scenes: "scenes" };
            if ($scope.iswx || $scope.iswg) { //小程序时，活动跟活动组不一个路径，且只有活动。
                subFixObj.campaign = "campaign";
            }
            if (subFixObj.hasOwnProperty(flag)) {
                subfix = subFixObj[flag];
            }
            return subfix;
        }

        $scope.getViewColumns = function() {
            var vcol = [];
            $scope.baseList && $scope.baseList.filter(function(item) {
                if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention')) || ((item.type == 'sdkevent' || item.type == 'sdkevent_new') && !$scope.showDataModel('event'))) {
                    //没有付费权限，不能查看付费
                } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                    //没有唤醒权限，不能查看付费
                } else {
                    if ($scope.selectFlag == "date" || $scope.selectFlag == "campaign" || $scope.selectFlag == "channel" || $scope.selectFlag == "campgroup") {
                        if (item.ischeck == true) {
                            vcol.push(item.fieldcode);
                        }
                    } else {
                       
                        if (item.ischeck == true && item.type != "sdkevent" && item.type != "sdkevent_new") {
                            vcol.push(item.fieldcode);
                        }
                    }
                }
            });
            return vcol.join(",");
        }

        //场景点击下级页面
        $scope.queryScenes = function(info) {
            var params = ToolService.getParams($scope),
                qReport = "wx_marketinginfo_sub" + ($scope.selectFlag == 'channel' ? 'channel' : 'cam') + "_bysceneid";
            params.datatype = 'list';
            params.viewtype = $scope.selectFlag;
            params.func = "remarketing";
            params.searchtxt = $scope.filterTxt;
            params.viewcolumn = $scope.getViewColumns();
            info && (params.sceneid = info.orisceneid);
            // ($scope.selectFlag == 'campaign' && $scope.channelid != 'all') && (params.cid = $scope.channelid);//渠道单选变多选
            ($scope.selectFlag == 'campaign' && $scope.channelid != '') && (params.cid = $scope.channelid);
            var listPM = HttpService.getReportData(qReport, params);
            params.showall0 = $scope.showZero;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("再营销活动详情)-" + flagNames[$scope.selectFlag], qReport, params));
            $scope.campListLoading = true;
            listPM.then(function(data) {
                $scope.campList = data;
                $scope.infoListTotal = data.val[0];
                $scope.campAllList = data.val.slice(1);
                $scope.campNoZeroList = $scope.campAllList.filter(function(item) {
                    return item.isall0 == false;
                });
                $scope.infoList = $scope.showZero ? $scope.campAllList : $scope.campNoZeroList;
                $scope.campListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.searchTxt = "";
                $scope.initrefresh = ++rmd; //数据更新后，固定列和效果重新渲染
                $scope.fixrefresh = ++rmd; //同上
            });
        }

        $scope.isSubChannel = function() {
            return $scope.currentReports && $scope.currentReports.report == "subchannel_bysubchannel";
        }

        $scope.isCampaignPage = function() {
            return
        }

        $scope.getSubChannelParams = function(qReport, params, hasTotal) {
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }

            var listPM = null,
                currentInfo = {};
            if (hasTotal) {
                $scope.sortCol = "";
                var totalPM = HttpService.getReportData(qReport + "_count/number", params);

                totalPM.then(function(data) {
                    var total = 0;
                    if (angular.isDefined(data.content)) {
                        total = data.content;
                    } else {
                        total = data;
                    }

                    var preTotal = total + 1; //加1是为了total==0的时候不触发watch
                    if ($scope.listTotal == preTotal) {
                        ++$scope.listRefresh;
                    } else {
                        $scope.listTotal = preTotal;
                    }
                });
            } else {
                params.pageIndex = $scope.flipPage.current - 1;
                params.pageNumber = $scope.flipPage.pagenum;

                if ($scope.sortCol != '') {
                    params.orderby = $scope.sortCol;
                    params.isdesc = $scope.isDesc;
                }
                return params;
            }
        }

        $scope.filterByTxt = function(txt) {
            $scope.filterTxt = txt;
            var hasTotal = $scope.isSubChannel();
            if (hasTotal) {
                fixChange = false;
            }
            $scope.query(true, hasTotal);
        }
        $scope.iscanSub = function(cid) {
            var bol = false;
            var len = $scope.allSubInfo.length;
            if ($scope.selectFlag == 'channel') {
                bol = len <= 1 && cid == "今日头条";
            } else if ($scope.selectFlag == 'subchannel') {
                bol = len <= 2
            }

            return bol
        }

        $scope.keywordFlag = "creative"; //ceative,kwid
        $scope.changeKeyword = function(flag) {
            $scope.keywordFlag = flag;
            $scope.currentReports = $scope.allSubInfo[0];
            var preInfo = $scope.allSubInfo.slice(-1)[0];
            $scope.allSubInfo = $scope.allSubInfo.slice(0, 1);
            $scope.clickSub(preInfo);
        }
        $scope.threeQuery = false;
        $scope.isGdtDetail = false;
        $scope.showSubchannel = false

        $scope.clickSub = function(info, obj) {
            var hasTotal = false;
            if (!info) {
                var target = obj.target,
                    data = target.getAttribute('data');
                info = $.parseJSON(data);
            }
            if (info.istotal) return;
            if ($scope.iscanSub(info.cid)) {
                if ($scope.selectFlag == 'subchannel' || $scope.selectFlag == 'channel') {
                    if (info.cid) {
                        if (info.cid == "今日头条") {
                            $scope.infofalg = true;
                            $scope.showSubchannel = true;
                        } else {
                            $scope.showSubchannel = false
                            $scope.infofalg = false
                        }
                        $scope.currentReports = {
                            report: "subchannel_bysubchannel",
                            title: info[$scope.campList.columnkey[0]],
                            key: 'cid',
                            val: info.cid
                        }
                        $scope.subchannelCID = info.cid;
                        hasTotal = true;
                        if (hasTotal) {
                            fixChange = false;
                        }
                    } else {
                        $scope.currentReports = {
                            report: "subchannel_bycampaign",
                            title: info[$scope.campList.columnkey[0]],
                            key: 'subchannel',
                            val: info.subchannel,
                            godetail: true
                        }
                        $scope.threeQuery = true;
                    }
                }

                $scope.query(false, hasTotal);
            } else if ($scope.selectFlag == 'campaign' && info.ispackchannel) { //‘活动’分包 下级页面
                $scope.listname = info[$scope.campList.columnkey[0]];
                $scope.isDetail = true
                $scope.currentReports = {
                    report: "marketinginfo_bysubpackagecampaign",
                    title: info[$scope.campList.columnkey[0]],
                    key: 'parent_campaignid',
                    val: info.id
                }
                hasTotal = false;
                if (hasTotal) {
                    fixChange = false;
                }
                $scope.query(false, hasTotal);

            }
        }
        $scope.hideCondition = true;
        $scope.preSub = function(idx) {
            if ($scope.allSubInfo.length - 1 == idx) { return false; }
            $scope.currentReports = $scope.allSubInfo[idx];
            $scope.allSubInfo = $scope.allSubInfo.slice(0, idx);
            if ($scope.isSubChannel()) {
                fixChange = false;
            }
            $scope.query(false, $scope.isSubChannel());
        }
        $scope.clickZero = function() {
            ToolService.sendBehaviorUv("clickZero");
            $scope.showZero = !$scope.showZero;
            reCrateListCondition($scope.listCondition);
            if ($scope.isandroid && ($scope.selectFlag == 'campaign' || $scope.selectFlag == 'channel') && !$scope.isDetail) {
                $scope.doPackFilter();
            } else {
                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
            }
        }

        /**
         * 重新生成‘导出’参数，添加‘显示全0数据’的值进去
         * @param listCondition
         */
        function reCrateListCondition(listCondition) {
            var isOk = false;
            if (listCondition && listCondition.conditions) {
                var cond = JSON.parse(listCondition.conditions);
                if (cond) {
                    cond.showall0 = $scope.showZero;
                    listCondition.conditions = JSON.stringify(cond);
                    isOk = true;
                }
            }
            if (!isOk) {
                ToolService.showTips("");
            }
        }

        var fixChange = true,
            orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            if ($scope.isSubChannel()) {
                $scope.isDesc = reverse;
                $scope.query(true);
            } else {
                $scope.infoList = orderBy($scope.infoList, predicate, reverse);
                $scope.listf5 = ++rmd;
                $scope.fixrefresh = ++rmd;
            }
        };

        $scope.$watch("appid", function() {
            $scope.allSubInfo = [];
            $scope.currentReports = null;
        });
        $scope.$watch("currentReports", function() {
            if ($scope.isSubChannel()) {
                $scope.tipMsg = $filter('translate')("搜索子渠道名称或ID");
            } else {
                $scope.tipMsg = $filter('translate')("输入搜索关键词");
            }
        });
        $scope.$watch("date.startDate+date.endDate+statusid", function() {
            if ($scope.allSubInfo && $scope.allSubInfo.length > 0) {
                $scope.allSubInfo.pop()
            }
        });
        $scope.doPackFilter = function() {
            var myInfoList = [];
            if ($scope.showZero) {
                myInfoList = $scope.campAllList;
            } else {
                myInfoList = $scope.campNoZeroList;
            }
            $scope.infoList = myInfoList.filter(function(item) {
                return (item.ispackchannel == ($scope.packageID == 'APPMARKET')) || $scope.packageID == 'all';
            });
            $scope.fixrefresh = ++rmd;
        }
        $scope.$watch("packageID", function(n) {
            if (angular.isDefined(n) && $scope.infoList && $scope.isandroid) {
                $scope.queryGdt(true, null, 1);
            }
        });
        var oldappid = "";
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,selectFlag:selectFlag,statusid:statusid,lang:lang}", function(n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)) { return false; }
            if (!$scope.baseList || oldappid != $scope.appid) {
                //指标列表
                var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/" + ($scope.iswx ? "weixin" : $scope.iswg ? "wgame" : "remarketing"));
                basePM.then(function(data) {
                    $scope.baseList = data;
                    $scope.sdkList = data.filter(function(item) {
                        return item.type == 'sdkevent';
                    });
                    $scope.sdkeventNew = data.filter(function(item) {
                        return item.type == 'sdkevent_new';
                    });
                    if ($scope.isSubChannel()) {
                        fixChange = false;
                    }
                    $scope.queryGdt(false, $scope.isSubChannel(), 1);
                });
            } else {
                if ($scope.isSubChannel()) {
                    fixChange = false;
                }
                if (!$scope.wxFirstSub) {
                    $scope.queryGdt(false, $scope.isSubChannel(), 1);

                } else {
                    $scope.wxFirstSub = false;
                }
            }
            oldappid = $scope.appid;
            //语言切换
            if (n.lang && o.lang && n.lang !== o.lang) {
                init();
                $scope.querySelectInfos();
            }

            if (n.appid != o.appid) {
                $scope.allSubInfo = [];
                $scope.currentReports = null;
            }
        }, true);

        $scope.$watch("appid", function() {
            if ($scope.appid) {
                //切换产品时，维度恢复默认‘日期’
                $scope.selectFlag = "date";
                $scope.scenesHide = false;

                $scope.selectlistNum = 0;
                $scope.industory = $scope.appInstance.industory;
                if ($scope.appInstance.platform != "H5") {
                    $scope.querySelectInfos();
                }
            }
            $scope.queryReport();
        });

        //判断是否有权限导出（1.日期超过30天 2.只有推广活动详情-活动、渠道 纬度的报表时 3.下载报表设置为打开的状态）
        $scope.$on('showTipDesc', function(e, msg) {
            var date1 = new Date($scope.date.startDate);
            var date2 = new Date($scope.date.endDate);
            var curdate = (Date.parse(date2) - Date.parse(date1)) / 1000 / 60 / 60 / 24;
            var sType = msg.subType
            if ($scope.openSet1 == true && curdate + 1 > 30 && sType == "campaign") {
                $scope.report = true;
                $scope.exportCampaign = true;
                $scope.listCondition.exportCampaign = $scope.exportCampaign

            }
            if ($scope.openSet2 == true && curdate + 1 > 30 && sType == "channel") {
                $scope.report = true;
                $scope.exportChannel = true;
                $scope.listCondition.exportChannel = $scope.exportChannel
            }
        });

        // 查询下载设置报表
        $scope.queryReport = function() {
            if ($scope.appid) {
                var setPM = HttpService.getInfo("mng/export/report/" + $scope.appid + "/open/param/list");
                setPM.then(function(data) {
                    for (var i in data) {
                        if (data[0].opened == 1) { //1开启状态 0关闭状态
                            $scope.openSet1 = true
                        } else {
                            $scope.openSet1 = false
                        }
                        if (data[1].opened == 1) {
                            $scope.openSet2 = true
                        } else {
                            $scope.openSet2 = false
                        }

                    }

                })
            }

        }
        $scope.queryReport();
        $scope.goReport = function() {
                var iden = 'marketinginfo';
                $state.go("collect.report", { stateinfo: iden, pageid: "1" });

            }
            //小程序-场景维度-下级页面-点击数据详情返回
        $scope.preList = function() {
            $scope.isDetail = false;
            $scope.selectFlag = 'scenes';
            $scope.query();
        }

        $scope.openUrl = function() {
            window.open("https://developers.weixin.qq.com/miniprogram/dev/framework/app-service/scene.html");
        }
    }
})();