(function() {
    var tempVersion = new Date().getTime();

    // [{menu:"dashboard"},{menu:"managecentor",submenu:[{menu:"campaignmanage",hide:"retention,payment"}]}]
    angular.module("app.collect")
        .config(['$stateProvider', "$urlRouterProvider", function($stateProvider, $urlRouterProvider) {

            var menu = "collect",
                html = ["dashboard", "realtime", "channeleffect", "potentialusergroup", "campaigninfo","useroverview","channeloverview","refluxanalysis","serveridbackflow","lifesettings","advertisinginfo","adsenseinfo","admobinfo","remarketing","funnelinfo",
                    "export", "device", "effectevaluate", "paymentinsight", "roi", "attribute", "smresult", "keyword", "logexport",
                    "logdump", "logtool", "report", "subcampaign", "packageinfo", "expiration", "asmeffectevaluate", "fake", "fakedec", "fakepage", "recycleanalysis", "document", "notice","channelmanage","deeplink","systemparam","lifecycle","userengagement","terminalattributes"
                ];

            var hasDetail = [];
            $stateProvider.state(menu, {
                url: "",
                templateUrl: '/template/menu/' + menu + '.html?r=' + tempVersion,
                controller: "collectCtrl"
            });

            html.forEach(function(h) {
                $stateProvider.state(menu + '.' + h, {
                    url: "/" + menu + "/" + h,
                    params: {
                        stateinfo: null,
                        pageid: null
                    },
                    views: {
                        "content@": {
                            templateUrl: "/template/" + menu + "/" + h + '.html?r=' + tempVersion,
                            controller: h + "Ctrl"
                        }
                    }
                });
                if (hasDetail.indexOf(h) > -1) {
                    var v = h + "Detail";
                    $stateProvider.state('collect.' + v, {
                        url: "/" + menu + "/" + v,
                        params: {
                            aid: null
                        },
                        views: {
                            "content@": {
                                templateUrl: "/template/" + menu + "/" + v + '.html?r=' + tempVersion,
                                controller: v + "Ctrl"
                            }
                        }
                    });
                }
            });
        }]);
})();