(function(){
    angular.module("app.collect")
        .controller("subcampaignCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$filter",exportCtrl]);

    function exportCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$filter){
        $scope.UserId = $.cookie("ryioUid");

    	$scope.query = function(){
            ToolService.showLoading()
            var listPM = HttpService.getInfo("mng/campaign/subcampaign/export/list/"+$scope.appid);
            listPM.then(function(data){
                $scope.subcampList = data;
                ToolService.hideLoading();
            });
    	}

        $scope.$on('flipinfo',function(e,msg){
            $scope.flipPage3 = msg;
        });
        
        //子活动下载
        $scope.downCamp = function(info){
            ToolService.sendBehaviorUv("downCamp");
            if(info.status!='complete'){return false;}
            var id = info.id;

            ToolService.showLoading();
            var downPM =  HttpService.downFile("mng/campaign/subcampaign/"+id+"/download");
            downPM.then(function(){
                ToolService.hideLoading();
                $rootScope.operSubmitData($filter('translate')("下载"));
            });
        }
        //子活动失败刷新
        $scope.refreshCamp = function(id){
            ToolService.showLoading();
            HttpService.putInfo("mng/campaign/subcampaign/export/init/"+id,{}).then(function(data){
                $scope.query();
            });
        }

        $scope.doRemove = function(id){
            ToolService.sendBehaviorUv("doRemove");
            $scope.delstatus = true;
            $scope.delId = id;
        }
        $scope.removeInfo = function(){
            var url = "mng/campaign/subcampaign/download/delete/"+$scope.delId;
            var removePM = HttpService.deleteInfo(url);
            ToolService.showLoading();
            $scope.delstatus = false;
            removePM.then(function(data){
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("删除成功"))
                $scope.query();
            });
        }

        $scope.$watch("{appid:appid,lang:lang}",function(n,o){
            if(angular.isDefined(n.appid)){
                $scope.query();
            }
        },true);
    }
})();