(function () {
    'use strict';
    angular.module('app', [
        'app.login',
        // "pascalprecht.translate",
    ]);

    angular.module('app.login', [
        "pascalprecht.translate",
        "ngCookies",
    ])
    .config(["$translateProvider","$translateCookieStorageProvider",function($translateProvider,$translateCookieStorageProvider){
        $translateProvider.useStaticFilesLoader({
            prefix: '/data/translate/',
            suffix: '.json'
        });
        function getLang(){
            var get = $translateCookieStorageProvider.$get().get,ret = "zh_CN";
            if(get("lang") && get("lang")== "en"){
                ret = "en_US";
            }else if (get("lang") && get("lang") == 'zh'){
                ret = "zh_CN";
            }
            return ret;
        }
        $translateProvider.preferredLanguage(getLang());
        $translateProvider.useCookieStorage();
    }])
    .run(["$rootScope","$translateCookieStorage",function ($rootScope,$translateCookieStorage) {
        $rootScope.lang = $translateCookieStorage.get('lang');
    }]);
})();