(function() {
    angular.module("app.manage")
        .controller("addDataCallbackCtrl",["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$stateParams", "$filter", "$translate", addDataCallbackCtrl])
        function addDataCallbackCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$state,$stateParams,$filter,$translate){
            var editInfo = $stateParams.aid, infoId = null;
            $scope.initEdit = function(){
                var index=editInfo.specialkeys.lastIndexOf("key=");
                specialkeys = editInfo.specialkeys.substring(index+4,editInfo.specialkeys.length);
                $scope.custermUrl = editInfo.custermUrl
                $scope.securitykey = specialkeys
                $scope.customParametersOnId = $scope.customParametersInit = editInfo.custermParams
                $scope.AppInit = editInfo.name
                $scope.appOnId = editInfo.appid
                $scope.clickCallbackOnId = editInfo.eventType
                $scope.evnetName = editInfo.evnetName
                $scope.clickCallbackOnId = $scope.clickCallbackInit= editInfo.eventType
                if(!editInfo.custermParams){
                    $scope.customParametersInit = '请选择需要添加的自定义参数'
                }
            }
            
            // 表格查询
            $scope.queryAppList = function() {
                ToolService.showLoading();
                var listPM = HttpService.getInfo('app/find/cpcallback/app/downlist');
                listPM.then(function(data) {
                    ToolService.hideLoading();
                    data.unshift({appid:'0',name:'请选择需要回调数据的产品'})
                    $scope.AppList = data;
                    $scope.AppInit = data[0].appid;
                })

            }
            // 回调事件
            $scope.queryClickList = function(){
                var listPM = HttpService.getInfo('mng/cpcallback/envent?appkey='+$scope.appOnId);
                listPM.then(function(data) {
                    data.unshift({id:'0',name:'请选择需要回调的事件'})
                    $scope.clickCallbackList = data;
                    $scope.clickCallbackInit = data[0].id;
                })
            }
            $scope.cancel = function(){
                $state.go("collect.dataCallback");
            }
            $scope.customParametersList = [
                {id: "param1", name: "param1"},
                {id: "param2", name: "param2"},
                {id: "param3", name: "param3"},
                {id: "param4", name: "param4"},
                {id: "param5", name: "param5"}
            ]
            $scope.customParametersInit = '请选择需要添加的自定义参数'
            $scope.$on('customParametersId',function(e,msg){
                $scope.customParametersOnId = msg.info
             });
                
            $scope.$on('appId',function(e,msg){
               $scope.appOnId = msg.info.appid
               if (!editInfo) {
                    $scope.queryClickList()
                }
               
            });
            $scope.$on('clickCallbackId',function(e,msg){
                $scope.clickCallbackOnId = msg.info.id
             });
            $scope.$on('flipinfo',function(e,msg){
                $scope.flipPage = msg;
                $scope.flipChange = ++ rmd;
            });
            if (editInfo != null) {
                infoId = $scope.id = editInfo.id;
                $scope.initEdit()
            }else{
                $scope.queryAppList()
            }
            $scope.save = function() {
                var par = {
                    appid: $scope.appOnId,
                    specialkeys: $scope.securitykey,
                    custermUrl: $scope.custermUrl,
                    custermParams: $scope.customParametersOnId,
                    eventType: $scope.clickCallbackOnId
                };
                var verPar = {
                    securitykey: {
                        key: 'isNull',
                        val: $scope.securitykey
                    },
                    custermUrl:{
                        key: 'url',
                        val: par.custermUrl,
                        txt: $filter('translate')("仅支持http://或https://开头")
                    }
                }
                $scope.tip = formJudge(verPar);
                if($scope.appOnId == 0 || !$scope.appOnId){
                    if ($scope.tip.succ == true) {
                        $scope.tip.succ = false;
                    }
                    $scope.tip.applist = {
                        status:true,
                        txt:$filter('translate')("请选择需要回调数据的产品")
                    }
                }
                if($scope.clickCallbackOnId == 0){
                    if ($scope.tip.succ == true) {
                        $scope.tip.succ = false;
                    }
                    $scope.tip.clickCallback = {
                        status:true,
                        txt:$filter('translate')("请选择需要回调数据的产品")
                    }
                }
                // if(!$scope.customParametersOnId){
                //     if ($scope.tip.succ == true) {
                //         $scope.tip.succ = false;
                //     }
                //     $scope.tip.customPar = {
                //         status:true,
                //         txt:$filter('translate')("请选择自定义参数")
                //     }
                // }
                if ($scope.tip.succ != true) {
                    ToolService.showTips($filter('translate')("信息没填全或数据格式有误，请检查"));
                    return false;
                }
                if(infoId != null){
                    par.id = $scope.id
                }
                ToolService.showLoading();
                var saveUrl = HttpService.postInfo("mng/cpcallback/put", par);
                if(infoId != null){
                    saveUrl.then(function(data){
                        ToolService.hideLoading();
                        ToolService.showTips('修改成功');
                        $scope.cancel()
                    })
                }else{
                    saveUrl.then(function(data){
                        ToolService.hideLoading();
                        ToolService.showTips('添加成功');
                        $scope.cancel()
                    })
                }
            }
        }
})();
