
/*该文
    件
    未
    被
    使
    用*/


(function(){
    angular.module("app.manage")
        .controller("authCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$state","$filter",authCtrl])
        .controller("authDetailCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$q","$state","$stateParams","$filter",authDetailCtrl]);
    function authCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$state,$filter){

        $scope.demoUSuper = UtilService.getCookie("ryioUname") == 'demoadmin@reyun.com';
        //alert($scope.demoUSuper)

    	$scope.deviceList = [
            {id:1,name:$filter('translate')("已启用")},
            {id:2,name:$filter('translate')("已停用")}
        ];
        $scope.deviceInit = $scope.deviceList[0].id;
        $scope.$on("deviceId",function(e,msg){
            $scope.seeFlag = msg.info.id;
            if( $scope.seeFlag == 1){
                $scope.findName = 'enable';
            }else{
                $scope.findName = 'disable';
            }

            $scope.query();
        });
        if(!$rootScope.accountFlag){
            $rootScope.accountFlag = "account";
        }

    	$scope.query = function(flag){
            if(flag){
                $rootScope.accountFlag = flag;
                $rootScope.thirdtab = {'channel':$filter('translate')('渠道账号管理'),'account':$filter('translate')('子账号管理')}[flag];
            }
            if(angular.isUndefined($scope.findName)){return false;}

            $scope.authList = [];
            var authPM = null;

    		var authPM = HttpService.getInfo("mng/auth"+$scope.getSuburl()+"/list/"+$scope.findName);
            ToolService.showLoading();
	    	authPM.then(function(data){
                ToolService.hideLoading();
	    		$scope.authList = data;
	    	});
    	}
    	$scope.query();

    	$scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;
        });

        $scope.onUser = function(id){
            ToolService.showLoading();
        	var userPM = HttpService.putInfo("mng/auth"+$scope.getSuburl()+"/"+id+"/enable");
	    	userPM.then(function(data){
                ToolService.hideLoading();
	    		 ToolService.showTips($filter('translate')("启用成功"));
                 $rootScope.operSubmitData($filter('translate')("启用")+($scope.accountFlag == 'channel'?$filter('translate')("渠道账号"):""));
                 $scope.query();
	    	});
        }
        $scope.offUser = function(id){
        	var userPM = HttpService.putInfo("mng/auth"+$scope.getSuburl()+"/"+id+"/disable");
            ToolService.showLoading();
	    	userPM.then(function(data){
                ToolService.hideLoading();
	    		ToolService.showTips($filter('translate')("停用成功"));
                $rootScope.operSubmitData($filter('translate')("停用")+($scope.accountFlag == 'channel'?$filter('translate')("渠道账号"):""));
                $scope.query();
	    	});
        }
        $scope.deleteAuth = function(d){
            $scope.delInfo = d;
            $scope.wantDelete = true;
            ToolService.showAlp();
        }
        $scope.doDelete = function(){
            $scope.closeWin();
            ToolService.showLoading();
            var deletePM = HttpService.deleteInfo("mng/auth/"+$scope.delInfo.id+"/delete");
            deletePM.then(function(){
                ToolService.showTips($filter('translate')("删除成功"));
                ToolService.hideLoading();
                $scope.query();
            });
        }
        $scope.sendEmailAgain = function(send){
            var sendPM = HttpService.postInfo("mng/auth/mail/"+send.id+"/resend");
            ToolService.showLoading();
            sendPM.then(function(data){
                ToolService.hideLoading();
                send.send = 1;
                ToolService.showTips($filter('translate')("发送成功"));
            });
        }
        $scope.closeWin = function(flag){
            $scope.wantDelete = false;
            ToolService.hideAlp();
        }
        $scope.gopage = function(info){
            if(angular.isDefined(info)){
                if(!info.valid){return false;}

                $state.go("collect.authDetail",{aid:info.id});
            }else{
                $state.go("collect.authDetail");
            }
        }
        $scope.getSuburl = function(){
            var suburl = "";
            if($rootScope.accountFlag == 'channel'){
                suburl = "/channel";
            }
            return suburl;
        }
        $scope.isdetail = false;
        $scope.showDetails = function(info){
            $scope.detailInfo = info;
            ToolService.showAlp();
            $scope.isdetail = true;
            angular.element(document).on("click",function(){
                $scope.$apply(function(){
                    $scope.hideDetails();
                });
            });
        }
        $scope.hideDetails = function(){
            ToolService.hideAlp();
            $scope.isdetail = false;
        }
    }
    var copyArray = function(arr){
        return $.extend(true, [], arr);
    }
    function authDetailCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$q,$state,$stateParams,$filter){

        var infoId = $scope.id = $stateParams.aid;

        $scope.roleAdd = false;
        var rolePM = null;

        $scope.queryRoleList = function(){
            rolePM = HttpService.getInfo("mng/auth/role/find");
            rolePM.then(function(data){
                $scope.roleList = data;
            });
        }
        $scope.$watch("applistInfo",function(data){
            if(angular.isDefined(data)){
                $scope.authapplist = copyArray(data);
                if($scope.isAppManage && !UtilService.isNullStr(infoId)){
                    var hasAuthAppsPM = HttpService.getInfo("app/find/"+infoId+"/AuthApp");
                    hasAuthAppsPM.then(function(data){
                        $scope.init(data);
                    });
                }
                else{
                    $scope.init();
                }
            }
        });



        var menuId = 3;//3子账户，5渠道账号
        $scope.menucate = ['admonitor','behavior','export'];
        $scope.init = function(otherpowers){
            if($scope.accountFlag == 'channel'){
                menuId = 5;
                $scope.changeRole(5);
            }
            $scope.dataTips = true;
            $scope.authJSON = {};
            var menuPM = HttpService.getInfo("mng/auth/"+menuId+"/findMenu");
            menuPM.then(function(data){
                $scope.authMenuList = $scope.solveMenus(data.roleAuthDetails);
            });
            $scope.queryRoleList();

            $q.all([rolePM]).then(function(){
                if(!UtilService.isNullStr(infoId)){
                    ToolService.showLoading();
                    var accountPM = HttpService.getInfo("mng/auth/"+infoId+"/find");
                    accountPM.then(function(data){
                        ToolService.hideLoading();

                        $scope.accountInfo = data;
                        $scope.email = $scope.oldEmail = data.email;
                        $scope.name = data.name;
                        $scope.remark = data.remark;
                        $scope.parentRole = data.parentRole;
                        if(UtilService.isNullStr(data.name)){
                            $scope.nameNofix = false;
                        }else{
                            $scope.nameNofix = true;
                        }
                        $scope.roleCategory = data.roleCategory;

                        if($scope.roleCategory == 2){
                            $scope.authapplist = copyArray($scope.appAlllistInfo);
                        }
                        else{
                            $scope.authapplist = copyArray($scope.applistInfo);
                        }

                        if($scope.isAppManage){
                            var appids = [];
                            $scope.authapplist.filter(function(item){
                                appids.push(item.id);
                            });
                            otherpowers.filter(function(item){
                                if(appids.indexOf(item.id)==-1){
                                    item.nopower = true;//当前子应用没有该app权限
                                    $scope.authapplist.push(item);
                                }
                            });
                        }

                        var authStr = data.authList;

                        authStr.filter(function(power){
                            var curapp = null;
                            for(var i=0;i<$scope.authapplist.length;i++){
                                var appinfo = $scope.authapplist[i];
                                if(appinfo.id == power.app){
                                    $scope.authapplist[i].ischeck = true;
                                    curapp = appinfo;
                                    break;
                                }
                            }

                            $scope.authJSON[power.app] = {
                                menus:$scope.solveMenus(power.roleAuthDetailList),
                                appname:curapp.name,
                                nopower:curapp.nopower,
                                datas:null,
                                olddatas:power.dataAuth,
                                payAuth:power.payAuth,
                                orderAuth:power.orderAuth,
                                retentionAuth:power.retentionAuth,
                                orderAuth:power.orderAuth,
                                isNatureOpen:power.isNatureOpen,
                                topAuth:power.topAuth,
                                createAccount:power.createAccount,
                                createTime:power.createTime
                            }
                        });

                        $scope.steps = 1;
                        if($scope.roleCategory == 1){
                            $scope.steps = 0;
                            $scope.maxstep = 0;
                        }
                        else if($scope.roleCategory == 2){//子应用管理员
                            $scope.maxstep = 1;
                        }
                        else if($scope.roleCategory == 3 || $scope.roleCategory == 5){ //自定义、渠道账号
                            $scope.maxstep = 3;
                        }
                        else{
                            $scope.maxstep = 2;
                        }
                    });
                    $scope.allcheck = {
                        app:false,
                        camp:false,
                        auth:false
                    };
                }
            });
        }
        //把菜单列表转化成页面显示结构数据
        $scope.solveMenus = function(list){
            var authMenuList = [[],[],[]];
            if(angular.isArray(list)){
                list.filter(function(item){
                    var idx = $scope.menucate.indexOf(item.parentAuth);
                    if(idx>-1){
                        var children = list.filter(function(child){
                            if(!$scope.limitInfo.platformExport && child.auth == 'logexport'){
                                //母账户没有导出权限，子账户就没有日志导出权限
                            }
                            else{
                                return child.parentAuth == item.auth;
                            }
                        });
                        item.children = children;
                        authMenuList[idx].push(item);
                    }
                    else{
                        var idx = $scope.menucate.indexOf(item.auth);
                        if(idx>-1){
                            authMenuList[idx].unshift(item);
                        }
                    }
                });
            }
            authMenuList.filter(function(root){
                root.sort(function(a,b){
                    return a.sort > b.sort ? 1 : -1;
                });
                root.filter(function(item){
                    if(angular.isArray(item)){
                        item.sort(function(a,b){
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                    if(item.children){
                        item.children.sort(function(a,b){
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                });
            });
            return authMenuList;
        }

        //flag:1一级，2二级，3三级,4设置编辑
        $scope.checkMenu = function(flag,menu,iii){
            if($scope.isAppManage && $scope.roleAdd){return false;}
            if($scope.isAppManage && $scope.curAuthApp.nopower){return false;}

            var bol;
            if(typeof menu == 'boolean'){ //权限全选情况下
                bol = menu;
            }
            else{
                bol = !menu.view;
                $scope.allcheck['auth'] = false;
            }
            var set = function(list){
                list.filter(function(menu){
                    if(menu.auth == 'asmeffectevaluate' && !menu.isshow && !$scope.roleAdd)return;
                    menu.view = bol;
                    menu.edit = bol;
                    if(menu.children){
                        set(menu.children);
                    }
                });
            }
            if(flag == 1){
                if($scope.roleAdd){
                    set($scope.roleAuthInfos[iii]);
                }
                else{
                    set($scope.curAuthInfos[iii]);
                }
            }
            else if(flag == 2){
                //没有付费，注收比不可选
                if(menu.auth == 'roi' && (($scope.roleAdd && !$scope.roleAuthData.payAuth) || (!$scope.roleAdd && !$scope.authJSON[$scope.curAuthApp.id].payAuth))){
                    return false;
                }
                if(menu.auth == "asmeffectevaluate" && !menu.isshow && !$scope.roleAdd){
                    return false;
                }
                menu.view = bol;
                menu.edit = bol;
                if(menu.children){
                    set(menu.children);
                }
            }
            else if(flag == 3){
                //没有付费，注收比不可选
                if(menu.auth == 'roi' && (($scope.roleAdd && !$scope.roleAuthData.payAuth) || (!$scope.roleAdd && !$scope.authJSON[$scope.curAuthApp.id].payAuth))){
                    return false;
                }
                menu.view = bol;
                if(!bol){
                    menu.edit = false;
                }
                if(iii != undefined && iii.view == true){
                    var falseNum=0;
                    for(var i=0;i<iii.children.length;i++){
                        if(iii.children[i].view == false){
                            falseNum = falseNum +1;
                        }
                    }
                    if(falseNum == iii.children.length){
                        iii.view = false;
                    }
                }else if(iii != undefined && iii.view == false){
                    var falseNum=0;
                    for(var i=0;i<iii.children.length;i++){
                        if(iii.children[i].view == true){
                            falseNum = falseNum +1;
                        }
                    }
                    if(falseNum > 0){
                        iii.view = true;
                    }
                }
            }
            else if(flag == 4){
                if(menu.view){
                    menu.edit = !menu.edit;
                }
            }
        }
        $scope.checkedCss = function(menu){
            return $scope.curAuthApp.nopower && $scope.isAppManage && menu.view;
        }
        // $scope.parentIsCheck = function(menu){
        //     var menus = $scope.authJSON[$scope.curAuthApp.id].menus;
        //     angular.forEach(menus,function(item){

        //     });
        // }
        $scope.menuStyle = function(menu,flag){
            var css = {},cn = 'active';
            if((!$scope.roleAdd && $scope.isAppManage && $scope.curAuthApp && $scope.curAuthApp.nopower)
                || ($scope.isAppManage && $scope.roleAdd)){
                cn = 'checked';
            }
            if(flag == 1){
                css[cn] = menu.view && menu.edit;
            }
            else if(flag == 2){
                css[cn] = menu.edit;
                css['dis'] = !menu.view;
            }
            else if(flag == 3){
                var authObj = {};
                if($scope.roleAdd){
                    authObj = $scope.roleAuthData;
                }
                else if($scope.curAuthApp){
                    authObj = $scope.authJSON[$scope.curAuthApp.id];
                }

                css[cn] = menu.view && ((menu.auth == 'roi' && authObj.payAuth) || menu.auth!='roi');
                css['dis'] = !authObj.payAuth && menu == 'roi';
            }
            else{
                css[cn] = menu.view;
            }

            return css;
        }
        $scope.steps = 0;
        $scope.maxstep = 0;
        $scope.changeRole = function(flag){
            switch(flag){
                case 1: //管理员
                    $scope.steps = 0;
                    $scope.maxstep = 0;
                    break;
                case 2: //子应用管理员
                    $scope.steps = 1;
                    $scope.maxstep = 1;
                    break;
                case 3://自定义权限
                case 5://渠道账号
                    $scope.steps = 1;
                    $scope.maxstep = 3;
                    break;
                default: //应用角色
                    $scope.steps = 1;
                    $scope.maxstep = 2;
                    break;
            }

            if(flag == 2){ //子应用管理员可以赋予未调式的产品
                $scope.authapplist = copyArray($scope.appAlllistInfo);
            }
            else{
                $scope.authapplist = copyArray($scope.applistInfo);
            }

            $scope.authJSON = {};
            $scope.roleCategory = flag;
            $scope.allcheck = {
                app:false,
                camp:false,
                auth:false
            };
        }
        $scope.getTips = function(app){
            if(app.nopower){
                return "该应用权限由管理员添加，您无此应用权限";
            }
            else{
                return "";
            }
        }
        //全选操作
        $scope.doCheck = function(k){
            if((k == 'camp' || k == 'active') && $scope.curCampApp.nopower){return false;}
            if(k == 'auth' && $scope.curAuthApp.nopower){return false;}

            var bol = $scope.allcheck[k] = !$scope.allcheck[k];

            if(k == 'app'){ //选择应用时的全选
                $scope.authapplist.filter(function(item){
                    if(!item.nopower){
                        item.ischeck = bol;
                        //选择app初始化数据
                        if(bol && !$scope.authJSON[item.id]){
                            $scope.authJSON[item.id] = {
                                menus:copyArray($scope.authMenuList),
                                appname:item.name,
                                datas:null,
                                payAuth:false,
                                retentionAuth:false,
                                orderAuth:false,
                                isNatureOpen:false,
                                topAuth:false
                            }
                        }
                        else{
                            if(!bol){
                                delete $scope.authJSON[item.id];
                            }
                        }
                    }
                });
            }
            else if(k == 'camp'){ //选择渠道时的全选
                $scope.curCampInfos.filter(function(channel){
                    channel.isall = bol;
                    channel.issingle = false;
                    channel.camps = [];
                });
                if(bol == true){
                    $scope.curCampApp.allcheck = true;
                    $scope.allcheck['active'] = false;
                    $scope.curCampApp.isHideAll = true;
                    $scope.curCampApp.allActiveCheck = false;
                }else{
                    $scope.curCampApp.allcheck = false;
                    $scope.curCampApp.isHideAll = false;
                }
            }
            else if(k == 'active'){ //独立活动的全选
                $scope.curCampInfos.filter(function(channel){
                    channel.isall = false;
                    channel.issingle = bol;
                });
                if(bol == true){
                    $scope.curCampApp.allActiveCheck = true;
                }else{
                    $scope.curCampApp.allActiveCheck = false;
                }
            }
            else if(k == 'auth'){ //选择权限时的全选
                $scope.curAuthInfos.filter(function(mm,index){
                    $scope.checkMenu(1,bol,index);
                });
                /*if($rootScope.allowBehavior=='false'){
                    delete $scope.curAuthInfos[1];
                }*/
                if(bol == true){
                    $scope.curAuthApp.allAuth = true;
                }else{
                    $scope.curAuthApp.allAuth = false;
                }
            }
        }
        //下一步
        $scope.nextStep = function(){
            if($scope.emailHas == true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }

            var checkApps = $scope.authapplist.filter(function(item){
                return item.ischeck == true;
            });
            if(checkApps.length == 0){
                ToolService.showTips("请选择应用");
                return false;
            }
            $scope.checkappLength = checkApps.length;//选中APP个数
            var donext = true;
            if($scope.steps == 2){
                for(var app in $scope.authJSON){
                    var json = $scope.authJSON[app];
                    if(json.olddatas || json.nopower==true){
                        continue;
                    }
                    var hasnull = false;
                    if(json.datas == null){ //没有点击这个app
                        hasnull = true;
                    }
                    else if(json.datas.length>0){
                        hasnull = true;
                        for(var i=0;i<json.datas.length;i++){
                            var item = json.datas[i];
                            //判断是否有选择活动的渠道存在
                            if(item.isall || (item.camps && item.camps.length > 0) || item.issingle){
                                hasnull = false;
                                break;
                            }
                        }
                    }
                    if(json.datas){
                        json.datas.filter(function(channel){
                            if(channel.uniqueName == 'sads'){
                                json.menus[0].filter(function(menu){
                                    if(menu.auth == 'asmeffectevaluate'){
                                        menu.isshow = channel.isall?true:false;
                                        menu.channelName = channel.name;
                                        menu.view = menu.view && !channel.isall?false:menu.view;
                                    }
                                });
                            }
                        });
                    }
                    if(hasnull){
                        ToolService.showTips($filter('translate')("请选择")+json.appname+$filter('translate')("渠道活动"))
                        donext = false;
                        break;
                    }
                }
            }
            if(checkApps.length>0 && donext){
                $scope.steps ++;

                $scope.selCurrentApp(checkApps[0]);
            }
            $scope.isAllCheck();
        }
        $scope.isAllCheck = function(){
            if($scope.curCampInfos){
                var allChannel = 0, allActive = 0;
                $scope.curCampInfos.filter(function(channel){
                    if(channel.isall){
                        ++allChannel;
                    }
                    if(channel.issingle){
                        ++allActive;
                    }
                });
                if(allChannel == $scope.curCampInfos.length){
                    $scope.allcheck['camp'] = true;
                    $scope.allcheck['active'] = false;
                    $scope.curCampApp.isHideAll = true;
                }else{
                    $scope.allcheck['camp'] = false;
                }
                if(allActive == $scope.curCampInfos.length){
                    $scope.allcheck['active'] = true;
                }else{
                    $scope.allcheck['active'] = false;
                }
            }
        }
        //上一步
        $scope.preStep = function(){
            $scope.steps --;
        }
        //第一步选择app
        $scope.selectApp = function(app){
            if(app.ischeck == false){
                app.allcheck = false;
                $scope.allcheck['app'] = false;
            }
            app.ischeck = true;
            if(!$scope.authJSON[app.id]){
                $scope.authJSON[app.id] = {
                    menus:copyArray($scope.authMenuList),
                    appname:app.name,
                    datas:null,
                    payAuth:false,
                    retentionAuth:false,
                    orderAuth:false,
                    isNatureOpen:false,
                    topAuth:false
                }
            }
        }
        $scope.removeApp = function(app){
            if(app.nopower){return false;}

            app.ischeck = false;
            delete $scope.authJSON[app.id];
            $scope.allcheck['app'] = false;
        }
        //已选应用中选择应用
        $scope.selCurrentApp = function(app){
            $scope.iscurrentweb = app.platform == 'H5';
            $scope.isAndroidAPP = app.platform == 'Android';
            if($scope.steps == 2){ //渠道活动
                //切换应用重置全选
                if(app.allcheck == true){
                    $scope.allcheck.camp = true;
                }else{
                    $scope.allcheck.camp = false;
                }
                if(app.allActiveCheck == true){
                    $scope.allcheck.active = true;
                }else{
                    $scope.allcheck.active = false;
                }
                $scope.curCampApp = app;
                $scope.curCampInfos = $scope.authJSON[app.id].datas;
            }
            if($scope.steps == 3){//权限
                //切换应用重置全选
                if(app.allAuth == true){
                    $scope.allcheck.auth = true;
                }else{
                    $scope.allcheck.auth = false;
                }
                $scope.curAuthApp = app;
                $scope.curAuthInfos = $scope.authJSON[app.id].menus;
            }
            $scope.isAllCheck();
        }
        //选择app查询对应的渠道数据
        $scope.$watch("curCampApp",function(n){
            if(angular.isDefined(n) && ($scope.curCampInfos == null || $scope.authJSON[n.id].olddatas)){
                ToolService.showLoading();
                var channelPM = HttpService.getInfo(n.id+"/channel/find");
                channelPM.then(function(data){
                    $scope.curCampInfos = $scope.authJSON[n.id].datas = data;

                    $scope.getCurrentChannelList();
                });

                $q.all([channelPM]).then(function(){
                    //编辑信息赋值
                    var olddata = $scope.authJSON[n.id].olddatas;
                    if(olddata){
                        var oldjson = {};
                        olddata.filter(function(item){
                            oldjson[item.channel] = item;
                        });
                        var allChannel = 0, allActive = 0;
                        $scope.curCampInfos.filter(function(channel){
                            var temp = oldjson[channel.id];
                            if(temp){
                                channel.isall = temp.allCampaign;
                                channel.issingle = temp.channelPermit;
                                if(channel.isall){
                                    ++allChannel;
                                }
                                if(channel.issingle){
                                    ++allActive;
                                }
                                if(!channel.isall){
                                    channel.camps = temp.campaignList;
                                }
                                else{
                                    //$scope.allcheck.camp = true;
                                    channel.camps = [];
                                }
                            }
                        });
                        if(allChannel == $scope.curCampInfos.length){
                            $scope.allcheck['camp'] = true;
                            $scope.allcheck['active'] = false;
                            $scope.curCampApp.isHideAll = true;
                        }else{
                            $scope.allcheck['camp'] = false;
                        }
                        if(allActive == $scope.curCampInfos.length){
                            $scope.allcheck['active'] = true;
                        }else{
                            $scope.allcheck['active'] = false;
                        }
                        delete $scope.authJSON[n.id].olddatas;
                    }
                    ToolService.hideLoading();
                });
            }
            $scope.letter = "";
            if($scope.iscurrentweb){
                $scope.channType = null;
            }else{
                $scope.channType = "ry_coop";
            }
            $scope.getCurrentChannelList();

        });
        $scope.changeType = function(type){
            $scope.channType = type;
            $scope.letter = "";
            $scope.getCurrentChannelList();
        }
        $scope.getCurrentChannelList = function(){
            if(!$scope.curCampInfos){return false;}

            $scope.curChannelList = $scope.curCampInfos.filter(function(item){
                return item.type == $scope.channType;
            });
        }
        $scope.channelStyle = function(channel){
            var className = "";
            if(channel.isall){
                if($scope.curCampApp && $scope.curCampApp.nopower){
                    className = " checked";
                }
                else{
                    className = "active";
                }
            }
            else if(channel.camps && channel.camps.length>0){
                className = 'hased';
            }

            return className;
        }

        //点击渠道全选
        var allCTip = false;
        $scope.channelCheck = function(channel){
            if($scope.curCampApp.nopower){return false;}

            channel.isall = !channel.isall;
            if(channel.isall && !allCTip){
                ToolService.showTips($filter('translate')("全选表示选中该渠道下的所有活动，包括已创建的和之后新增的活动"),3000);
                allCTip = true;
            }
            channel.camps = [];
            channel.issingle = false;
            $scope.curCampApp.allcheck = false;
            $scope.allcheck['camp'] = false;
            var allCount = 0;
            $scope.curCampInfos.filter(function(channel){
                if(channel.isall){
                    ++allCount;
                }
            });
            if(allCount == $scope.curCampInfos.length){
                $scope.allcheck['camp'] = true;
                $scope.allcheck['active'] = false;
                $scope.curCampApp.isHideAll = true;
            }else{
                $scope.curCampApp.isHideAll = false;
            }
        }

        var hasSingle = false;//是否选过
        $scope.campCheck = function(channel){
            if($scope.curCampApp.nopower){return false;}

            channel.issingle = !channel.issingle;
            if(channel.issingle && !hasSingle){
                ToolService.showTips($filter('translate')("勾选第三步“权限设置”中推广活动的编辑权限，即可具备创建该渠道推广活动权限"),3000);
                hasSingle = true;
            }
            $scope.allcheck['active'] = false;
            var allCount = 0;
            $scope.curCampInfos.filter(function(channel){
                if(channel.issingle){
                    ++allCount;
                }
            });
            if(allCount == $scope.curCampInfos.length){
                $scope.allcheck['active'] = true;
            }else{
                $scope.allcheck['active'] = false;
            }
        }
        //展开渠道-活动
        $scope.showCamp = function(channel){
            if(channel.uniqueName == "gdt" || channel.uniqueName == "adwords"){
                var campPM = HttpService.getInfo($scope.curCampApp.id+"/campaign/findallthird/"+channel.id);
                campPM.then(function(data){
                    data.unshift({id:"",name:$filter('translate')("不筛选投放账号")});
                    $scope.statusList = data;
                });
            }
            $scope.statusidInit = $scope.statusid = "";

            $scope.allcheck['camp'] = false;
            $scope.searchCamp = "";
            if(channel.ischeck == true){
                channel.ischeck = false;
            }
            else{
                if($scope.channelCamp){
                    $scope.channelCamp.ischeck = false;
                }

                if(!channel.campaignList){
                    $scope.getChannelCamplist(channel);
                }
                if(!channel.camps){
                    channel.camps = [];
                }
                channel.ischeck = true;
                $scope.channelCamp = channel;
            }

        }

        $scope.$on("statusid",function(e,msg){
            $scope.statusid = msg.info.id;
        });

        $scope.showCampChecked = function(channel){
            if(channel.haschecked == true){
                channel.haschecked = false;
            }
            else{
                if(!channel.campaignList){
                    $scope.getChannelCamplist(channel);
                }
                channel.haschecked = true;
            }
            $(document).on("click",function(){
                channel.haschecked = false;
                $scope.$apply();
            });
        }
        $scope.getChannelCamplist = function(channel){
            ToolService.showLoading();
            var campaignPM = HttpService.getInfo($scope.curCampApp.id+"/campaign/findbychannel/all?channelid="+channel.id);
            campaignPM.then(function(data){
                channel.campaignList = data;
                ToolService.hideLoading();
            });
        }
        //选择活动
        $scope.clickCamp = function(camp){
            if($scope.curCampApp.nopower){return false;}

            if($scope.channelCamp.isall){ //当前是全选状态时，取消全选并且把当前选中取消
                $scope.channelCamp.isall = false;
                $scope.channelCamp.campaignList.map(function(item){
                    if(item.id != camp.id){
                        $scope.channelCamp.camps.push(item.id);
                    }
                });
            }
            else{
                var idx = $scope.channelCamp.camps.indexOf(camp.id);
                if(idx>-1){
                    $scope.channelCamp.camps.splice(idx,1);
                }
                else{
                    $scope.channelCamp.camps.push(camp.id);
                }
            }
            $scope.allcheck['camp'] = false;
        }
        $scope.campFilterCheck = function(channel,txt,flag){
            channel.campaignList.filter(function(camp){
                if(txt!='' && $scope.statusid==''){
                    if(camp.name.indexOf(txt)>-1){
                        var idx = channel.camps.indexOf(camp.id);
                        if(idx == -1 && flag == 1){
                            channel.camps.push(camp.id);
                        }
                        if(idx > -1 && flag == 2){
                            channel.camps.splice(idx,1);
                        }
                    }
                }else if(txt=='' && $scope.statusid!=''){
                    if(camp.thirdAccount==$scope.statusid){
                        var idx = channel.camps.indexOf(camp.id);
                        if(idx == -1 && flag == 1){
                            channel.camps.push(camp.id);
                        }
                        if(idx > -1 && flag == 2){
                            channel.camps.splice(idx,1);
                        }
                    }
                }else if(txt!='' && $scope.statusid!=''){
                    if(camp.name.indexOf(txt)>-1 && camp.thirdAccount==$scope.statusid){
                        var idx = channel.camps.indexOf(camp.id);
                        if(idx == -1 && flag == 1){
                            channel.camps.push(camp.id);
                        }
                        if(idx > -1 && flag == 2){
                            channel.camps.splice(idx,1);
                        }
                    }
                }

            });
        }
        //设置自然量、留存、付费
        $scope.dataSetting = function(){
            $scope.dataTips = false;

            var natureCurrent = {};
            if($scope.roleAdd){ //角色
               natureCurrent.payAuth = $scope.roleAuthData.payAuth;
               natureCurrent.retentionAuth = $scope.roleAuthData.retentionAuth;
               natureCurrent.orderAuth = $scope.roleAuthData.orderAuth;
               natureCurrent.isNatureOpen = $scope.roleAuthData.isNatureOpen;
               natureCurrent.topAuth = $scope.roleAuthData.topAuth;
            }
            else{
               var current = $scope.authJSON[$scope.curAuthApp.id];
               natureCurrent.payAuth = current.payAuth;
               natureCurrent.retentionAuth = current.retentionAuth;
               natureCurrent.orderAuth = current.orderAuth;
               natureCurrent.isNatureOpen = current.isNatureOpen;
               natureCurrent.topAuth = current.topAuth;
            }
            $scope.natureCurrent = natureCurrent;

            $scope.natureStatus = true;
            ToolService.showAlp();
        }
        $scope.closeNature = function(){
            $scope.natureStatus = false;
            ToolService.hideAlp();
        }
        $scope.changeStatus = function(type){
            if($scope.roleAdd && $scope.isAppManage){return false;}
            if(!$scope.roleAdd && $scope.curAuthApp.nopower){return false;}

            $scope.natureCurrent[type] = !$scope.natureCurrent[type];
        }
        //设置数据-确定
        $scope.okNature = function(){
            if($scope.roleAdd){ //角色
                $scope.roleAuthData.payAuth = $scope.natureCurrent.payAuth;
                $scope.roleAuthData.retentionAuth = $scope.natureCurrent.retentionAuth;
                $scope.roleAuthData.orderAuth = $scope.natureCurrent.orderAuth;
                $scope.roleAuthData.isNatureOpen = $scope.natureCurrent.isNatureOpen;
                $scope.roleAuthData.topAuth = $scope.natureCurrent.topAuth;
            }
            else{
                $scope.authJSON[$scope.curAuthApp.id].payAuth = $scope.natureCurrent.payAuth;
                $scope.authJSON[$scope.curAuthApp.id].retentionAuth = $scope.natureCurrent.retentionAuth;
                $scope.authJSON[$scope.curAuthApp.id].orderAuth = $scope.natureCurrent.orderAuth;
                $scope.authJSON[$scope.curAuthApp.id].isNatureOpen = $scope.natureCurrent.isNatureOpen;
                $scope.authJSON[$scope.curAuthApp.id].topAuth = $scope.natureCurrent.topAuth;
            }
            $scope.closeNature();
        }

        //新建角色
        $scope.addRole = function(){
            $scope.roleAdd = true;
            $scope.allcheck = {
                app:false,
                camp:false,
                auth:false
            };
            $scope.roleName = "";
            $scope.roleAuthInfos = copyArray($scope.authMenuList);
            $scope.roleAuthData = {
                payAuth:false,
                retentionAuth:false,
                orderAuth:false,
                isNatureOpen:false,
                topAuth:false
            }
            $scope.editRoleId = 0;
        }
        $scope.editRole = function(id){
            var menuPM = HttpService.getInfo("mng/auth/"+id+"/findMenu");
            menuPM.then(function(data){
                $scope.roleAuthInfos = $scope.solveMenus(data.roleAuthDetails);
                $scope.roleAuthData = {
                    payAuth:data.payAuth,
                    retentionAuth:data.retentionAuth,
                    orderAuth:data.orderAuth,
                    isNatureOpen:data.isNatureOpen,
                    topAuth:data.topAuth
                }
                $scope.roleName = data.roleName;

                $scope.roleAdd = true;
                $scope.allcheck = {
                    app:false,
                    camp:false,
                    auth:false
                };
            });
            $scope.editRoleId = id;
        }
        //把权限转化成数组
        $scope.getAuthInfo = function(auths){
            var arr = [];
            auths = copyArray(auths);
            var get = function(list){
                list.filter(function(item){
                    if(item.children){
                        var children = copyArray(item.children);
                        delete item.children;
                        if(item.view==true || item.edit==true){
                            arr.push(item);
                        }
                        get(children);
                    }
                    else{
                        if(item.view==true || item.edit==true){
                            arr.push(item);
                        }
                    }
                });
            }
            auths.filter(function(item){
                get(item);
            });
            return arr;
        }
        //保存角色
        $scope.saveRole = function(){
            var par = {
                    "roleName":$scope.roleName
                },
                roleAuth = $scope.getAuthInfo($scope.roleAuthInfos);

            var verPar = {
                roleName:{
                    key:"numLetter",
                    val:par.roleName,
                    nullTxt:$filter('translate')("请填写角色名称"),
                    max:12,
                    txt:$filter('translate')("请输入12位以内的中英文或数字")
                }
            };

            $scope.tip = formJudge(verPar);
            if($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var donext = false;
            for(var i=0;i<roleAuth.length;i++){
                var temp = roleAuth[i];
                if(temp.view == true){
                    donext = true;
                    break;
                }
            }
            if(!donext){
                ToolService.showTips($filter('translate')("请设置权限"));
                return false;
            }

            for(var k in $scope.roleAuthData){
                par[k] = $scope.roleAuthData[k];
            }
            par.roleAuthDetails = roleAuth;

            if(!donext){
                ToolService.showTips($filter('translate')("请设置")+auth.appname+$filter('translate')("权限"))
            }
            var savePM = null,txtTips = $filter('translate')("添加成功");
            if($scope.editRoleId!=0){
                par.id = $scope.editRoleId;
                savePM = HttpService.putInfo("mng/auth/role/"+$scope.editRoleId+"/update",par);
                txtTips = $filter('translate')("修改成功");
            }else{
                savePM = HttpService.postInfo("mng/auth/role/create",par);
            }
            ToolService.showLoading();
            savePM.then(function(data){
                if(data.code == -6001){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("该角色名称已存在"));
                }else if(data.code == -300){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("超过限定值，无法添加"));
                }else{
                    $scope.roleAdd = false;
                    ToolService.hideLoading();
                    ToolService.showTips(txtTips);
                    $scope.queryRoleList();
                }
            },
            function(data){
                if(data.code == -6001){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("该角色名称已存在"));
                }else if(data.code == -300){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')($filter('translate')("超过限定值，无法添加")));
                }
            });
        }
        $scope.deleteRole = function(d){
            $scope.delInfo = d;
            $scope.wantDelete = true;
            ToolService.showAlp();
        }
        $scope.doDelete = function(){
            $scope.closeWin();
            ToolService.showLoading();
            var deletePM = HttpService.deleteInfo("mng/auth/role/"+$scope.delInfo.id+"/delete");
            deletePM.then(function(data){
                ToolService.hideLoading();
                if(data.code == -1000){
                    ToolService.showTips($filter('translate')("删除失败，该自定义角色下有子账号！"));
                }
                else{
                    ToolService.showTips($filter('translate')("删除成功"));
                    $scope.queryRoleList();
                }
            });
        }
        $scope.closeWin = function(flag){
            $scope.wantDelete = false;
            ToolService.hideAlp();
        }

        //检验邮箱
        $scope.emailHas = false;
        $scope.nameNofix = false;
        $scope.oldUser = false;
        $scope.exixtName = function(){
            if($scope.accountFlag != 'channel'){
                $scope.emailHas = false;
                return false;
            }
            if(!$scope.tip){
                $scope.tip = {};
            }
            if($scope.judgeNameChange($scope.oldEmail,$scope.email)){
                ToolService.showLoading();
                var existPM = HttpService.getInfo("mng/auth/channel/find?email="+$scope.email);
                existPM.then(function(data){
                    ToolService.hideLoading();
                    if(data.content == null){
                        $scope.tip.email = {
                            status:false
                        };
                        $scope.emailHas = false;
                        $scope.nameNofix = false;
                    }
                    if(data.id != null){
                        $scope.name = data.name;
                        $scope.emailHas = false;
                        $scope.oldUser = true;
                        if(UtilService.isNullStr(data.name)){
                            $scope.nameNofix = false;
                        }else{
                            $scope.nameNofix = true;
                        }
                        $scope.tip.email = {
                            status:false
                        };
                    }
                },function(data){
                    ToolService.hideLoading();
                    if(data.code == -200){
                        $scope.tip.email = {
                            status:true,
                            txt : $filter('translate')("该账号为子账号不可注册为渠道账号")
                        };
                        $scope.emailHas = true;
                    }else if(data.code == -6000){
                        $scope.tip.email = {
                            status:true,
                            txt : $filter('translate')("该邮箱已存在")
                        };
                        $scope.emailHas = true;
                    }else if(data.code == -1005){
                        $scope.tip.email = {
                            status:true,
                            txt : $filter('translate')("该账号已过期")
                        };
                        $scope.emailHas = true;
                    }else if(data.code == -1010){
                        $scope.tip.email = {
                            status:true,
                            txt : $filter('translate')("该账号未激活，暂时无法授权")
                        };
                        $scope.emailHas = true;
                    }
                });
            }
            else{
                $scope.tip.email = {
                    status:false
                };
                $scope.nameHas = false;
            }
        }

        $scope.save = function(){
            var par = {
                    "email":$scope.email,
                    "name":$scope.name,
                    "roleCategory":$scope.roleCategory,
                    "remark":$scope.remark
                };
            var verPar = {
                email:{
                    key:"email",
                    val:par.email,
                    nullTxt:$filter('translate')("请填写邮箱")
                },
                name:{
                    key:"numLetter",
                    val:par.name,
                    nullTxt:$filter('translate')("请填写姓名"),
                    max:20,
                    txt:$filter('translate')("请输入20位以内的中英文或数字")
                }
            };
            if(!UtilService.isNullStr(par.remark)){
                verPar.remark = {
                    key:'nameLen',
                    val:par.remark,
                    max:200,
                    txt:$filter('translate')('最多可输入100字')
                }
            }

            $scope.tip = formJudge(verPar);
            if($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            else if(!$scope.roleCategory){
                ToolService.showTips($filter('translate')("请选择角色"));
                return false;
            }

            var donext = true;
            if($scope.roleCategory > 1){
                var appAuth = [];
                if($scope.roleCategory == 2){
                    $scope.authapplist.filter(function(item){
                        if(item.ischeck){
                            appAuth.push({app:item.id});
                        }
                    });

                    if(appAuth.length == 0){
                        ToolService.showTips($filter('translate')("请选择应用"));
                        return false;
                    }
                }
                else{
                    for(var k in  $scope.authJSON){
                        var auth =  $scope.authJSON[k],
                        power = {app:k,
                                payAuth:auth.payAuth,
                                retentionAuth:auth.retentionAuth,
                                orderAuth:auth.orderAuth,
                                isNatureOpen:auth.isNatureOpen,
                                topAuth:auth.topAuth,
                                roleAuthDetailList:[],
                                dataAuth:[]
                            };

                        if(auth.createAccount){
                            power.createAccount = auth.createAccount;
                            power.createTime = auth.createTime;
                        }
                        if(auth.olddatas){ //编辑赋值未点击app情况
                            power.dataAuth = auth.olddatas;
                        }
                        else{
                           if(auth.datas == null){
                                donext = false;
                                ToolService.showTips($filter('translate')("请选择")+auth.appname+$filter('translate')("渠道活动"))
                                break;
                            }

                            auth.datas.filter(function(channel){
                                if(channel.isall){
                                    power.dataAuth.push({channel:channel.id,campaignList:[],allCampaign:true,channelPermit:false});
                                }
                                else if((channel.camps && channel.camps.length>0) || channel.issingle){
                                    power.dataAuth.push({channel:channel.id,campaignList:channel.camps,allCampaign:false,channelPermit:channel.issingle});
                                }
                            });

                            if(auth.datas.length>0 && power.dataAuth.length == 0){
                                donext = false;
                                ToolService.showTips($filter('translate')("请选择")+auth.appname+$filter('translate')("渠道活动"))
                                break;
                            }
                        }

                        if($scope.roleCategory==3 || $scope.roleCategory==5){
                            donext = false;
                            power.roleAuthDetailList = $scope.getAuthInfo(auth.menus);
                            for(var i=0;i<power.roleAuthDetailList.length;i++){
                                var temp = power.roleAuthDetailList[i];
                                if(temp.view == true){
                                    donext = true;
                                    break;
                                }
                            }
                            if(!donext){
                                ToolService.showTips($filter('translate')("请设置")+auth.appname+$filter('translate')("权限"));
                                break;
                            }
                        }

                        appAuth.push(power);
                    }
                }
                par.authList = appAuth;
            }
            if(!donext){
                return false;
            }

            var savePM = null;
            if($scope.accountFlag == 'channel' && $scope.oldUser){
                var txtTips = $filter('translate')("创建成功");
            }else{
                var txtTips = $filter('translate')("已为该账号发送激活邮件，请在72小时内联系相关人员激活并设置密码");
            }
            if(infoId!=null){
                par.id = infoId;
                savePM = HttpService.putInfo("mng/auth"+$scope.getSuburl()+"/"+infoId+"/update",par);
                txtTips = $filter('translate')("修改成功");
            }else{
                savePM = HttpService.postInfo("mng/auth"+$scope.getSuburl()+"/create",par);
            }
            ToolService.showLoading();
            savePM.then(function(data){
                if(data.code == -6001){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("该邮箱已创建"));
                }else if(data.code == -300){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("管理员权限数量已达上限"));
                }else{
                    ToolService.hideLoading();
                    ToolService.showTips(txtTips);
                    $scope.cancel();
                    if(!infoId){
                        $rootScope.operSubmitData($filter('translate')("新建")+($scope.accountFlag == 'channel'?$filter('translate')("渠道账号"):""));
                    }
                }
            },function(data){
                if(data.code == -6001){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("该邮箱已创建"));
                }else if(data.code == -300){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("管理员权限数量已达上限"));
                }
            });
        }
        $scope.getSuburl = function(){
            var suburl = "";
            if($scope.accountFlag == 'channel'){
                suburl = "/channel";
            }
            return suburl;
        }
        $scope.cancel = function(){
            $state.go("collect.auth");
        }
    }
})();
