(function() {
    angular.module("app.manage")
        .controller("channelCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$stateParams", "$timeout", "$location", "$filter", "$translate", channelCtrl])
        .controller("channelDetailCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$filter", "$translate", channelDetailCtrl])
        .controller("channelAddCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$filter", "$translate", channelAddCtrl])
        .controller("channelSmCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelSmCtrl])
        .controller("channelAdwordsCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelAdwordsCtrl])
        .controller("channelToutiaoCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelToutiaoCtrl])
        .controller("channelBaiduCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelBaiduCtrl])
        .controller("channelKuaishouCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelKuaishouCtrl])
        .controller("channelWeixinmpCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelWeixinmpCtrl])
        
    function channelCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $stateParams, $timeout, $location, $filter, $translate) {
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.demoU || $rootScope.isAppManage) {
            $rootScope.editPower = true;
        } else {
            $rootScope.editPower = false;
        }
        $scope.$watch("fakeType", function(n) {
            if ($rootScope.fakeType == 1 || $rootScope.fakeType == 2) {
                $scope.hasBlacklist = true;
            } else {
                $scope.hasBlacklist = false;
            }
        });

        var type = $stateParams.aid;
        if (!UtilService.isNullStr(type) && type != 'adwords' && type != 'smsearch' && type != 'gdt' && type != 'baiduysgg' && type != 'kuaishou' && type != 'weixinmp') {
            $scope.channType = type;
        } else {
            $scope.channType = 'ry_coop';
        }

        if (angular.isDefined(type) && type != null) {
            if (type == 5) {
                $scope.pageFlag = 5;
            }
        }


        $scope.sendEve = function() {
            ToolService.sendBehaviorUv("search");
        }

        $scope.pageFlag = 1; //2渠道账号列表 3新建渠道账号

        $scope.filterTypeList = function(type) {
            ToolService.sendBehaviorUv(type);
            $scope.channType = type;
            $rootScope.channeluniqueName = 'normal';
            $rootScope.thirdtab = { 'ry_coop': $translate.instant('常规渠道'), 'custom': $translate.instant('自定义渠道'), 'ry_bd': $translate.instant('SEM渠道') }[type];
            $scope.query();
        }


        $scope.$on("deviceId", function(e, msg) {
            $scope.seeFlag = msg.info.id;
            if ($scope.customList && $scope.channType == 'custom') {
                $scope.filterList();
            }
        });

        $scope.query = function(bol) {
            var cPM = HttpService.getInfo("mng/channelaccount/channellist");
            cPM.then(function(data){
                $scope.channelList = data;
            })
        }

         //头条获取获取access_token
         $scope.getAccessToken = function(){     
            var searchParam = $location.search(); //获取当前url的参数的序列化json对象    
           if(searchParam.hasOwnProperty('auth_code')){
            var par = {
                appId: 1653688605754372,
                secret: "1e858757bdd8beaf7ca68579a8ab4d2a7b3296a3",
                grantType: "auth_code",
                authCode:searchParam.auth_code,
                alias:searchParam.state
            }
            if(document.domain == "tweb.trackingio.com"){ //判断腾讯云的域名
                par.appId = 1673612651270147,
                par.secret = "94270d0c9e248a25e768f30ec5188a6c2a8d2e4c"
            }
            $scope.pageFlag = 2;
            ToolService.showLoading();
            $.post("api/mng/channelaccount/getToutiaoAccessToken", par, function(data) {
                $rootScope.curChannel ={ id: 514, name: "今日头条", category: "ADVERTISING", type: "ry_coop", uniqueName: "toutiao"}
                $scope.goSub($rootScope.curChannel)
                ToolService.hideLoading();
            })
           }
        }

        //flag: true开关  false编辑
        $scope.doSwitch = function(info,flag){
            if(info.openDeepLink != "1" || !flag){
                $scope.dialogDpLink = true;
                ToolService.showAlp();
                $scope.switchState = "open"
            }else{
                $scope.dialogDpLink2 = true;
                $scope.switchState = "close"
            }
            
            $scope.feedbackSurl = info.feedbackoriginalurl;
            if(info.urlScheme){
                $scope.urlScheme = decodeURIComponent(info.urlScheme);
            }else{
                $scope.urlScheme = "";
            }
            
        }
        //启用预约监测 
        $scope.doSwitchMonitor = function(info){
            if(!info.openSubscribes){
                $scope.dialogMonitor = true;
                ToolService.showAlp();
                $scope.switchState = "open"
            }else{
                $scope.dialogMonitor2 = true;
                ToolService.showAlp();
                $scope.switchState = "close"
            }
            
            $scope.feedbackSurl = info.feedbackoriginalurl;
        }
        $scope.dpConfirm = function(){
            var par = {
                state:$scope.switchState,
                feedbackurl:$scope.feedbackSurl
            }
            if($scope.switchState != "close"){
                par.urlScheme=$scope.urlScheme;
                
                var verPar = {
                    urlScheme: {
                        key: 'isNull',
                        val: par.urlScheme,
                    }
                }
                $scope.tip = formJudge(verPar);
                if ($scope.tip.succ != true) {
                    return false;
                }
            }            
            //保存
            var dpPM = HttpService.postInfo("mng/channelaccount/renewalDeepLink",par);
            dpPM.then(function(data) {
                $scope.dialogDpLink = false;
                ToolService.hideAlp();
                $scope.bindingList();
            })

        }
        $scope.MonConfirm = function(){
            var par = {
                state:$scope.switchState,
                feedbackurl:$scope.feedbackSurl
            }
            var dpPM = HttpService.postInfo("mng/channelaccount/renewalSubscribes",par);
            dpPM.then(function(data){
                $scope.dialogMonitor =false;
                $scope.dialogMonitor2 =false;
                ToolService.hideAlp();
                $scope.bindingList();
            })
        }
        $scope.hideDialogMon = function(){
            $scope.dialogMonitor =false;
            $scope.dialogMonitor2 =false;
            ToolService.hideAlp();
        }

        $scope.cancelTip = function(){
            $scope.dpConfirm();
            $scope.dialogDpLink2 = false;
        }
        $scope.filterList = function() {
            if ($scope.channType == 'custom') {
                $scope.channelList = $scope.customList.filter(function(item) {
                    if (item.name == "优酷" || item.name == "优酷GD") {
                        return false;
                    }
                    if ($scope.seeFlag == 1) { return item.delFlag != true; }
                    if ($scope.seeFlag == 2) { return item.delFlag == true; }
                });
            } else {
                $scope.channelList = $scope.coopList.filter(function(item) {
                    if (item.name == "优酷" || item.name == "优酷GD") {
                        return false;
                    }
                    if ($scope.channType == "ry_bd") {
                        return item.type == $scope.channType;
                    } else {
                        return item.type == $scope.channType && item.category == 'ADVERTISING';
                    }
                    return true;
                });
            }
        }
        $scope.query();
        $scope.getAccessToken();

        var curfilpPage = null,
            rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            if (msg.listkey == 'account') {
                $scope.flipPage2 = msg;
            } else if (msg.listkey == 'public') {
                $scope.flipPage = msg;
                $scope.flipChange = ++rmd;
            } else {
                $scope.flipPage3 = msg;
            }
        });

        $scope.doRemove = function(info) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delId = info.id;
            $scope.delInfo = info;
            ToolService.showLoading();
            var prePM = HttpService.getInfo("mng/channel/delete/valid/" + $scope.delId);
            prePM.then(function(data) {
                ToolService.hideLoading();
                if (angular.isNumber(data) && data > 0) {
                    $scope.delflagStatus = 2;
                    $scope.campnum = data;
                } else {
                    $scope.delflagStatus = 1;
                }
                $scope.delstatus = true;
            });
        }
        $timeout(function() {
            var clipboard = new Clipboard('.copyBtnUrl');
            clipboard.on('success', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制成功"));
                });
            });
            clipboard.on('error', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制失败"));
                });
            });
        }, 200);

        $scope.removeInfo = function() {
            if ($scope.delflagStatus == 2) {
                $scope.delstatus = false;
                return false;
            }
            var removePM = HttpService.deleteInfo("mng/channel/delete/" + $scope.delId);
            ToolService.showLoading();
            $scope.delstatus = 0;
            removePM.then(function(data) {
                ToolService.hideLoading();

                ToolService.showTips($translate.instant("停用成功"))
                $scope.query(true);
                $rootScope.operSubmitData($translate.instant("停用"));
            });
        }
        $scope.enableInfo = function(info) {
            ToolService.sendBehaviorUv("enableInfo");
            var isEnablePM = HttpService.postInfo("mng/channel/channelname/check",{name:info.name,id:info.id});
            isEnablePM.then(function (data) {
                if (data.code && data.code== -5002) {
                    ToolService.showTips(data.message)
                } else {
                    var enablePM = HttpService.putInfo("mng/channel/enable/" + info.id);
                    ToolService.showLoading();
                    enablePM.then(function(data) {
                        ToolService.hideLoading();
                        ToolService.showTips($translate.instant("启用成功"))
                        $scope.query(true);
                        $rootScope.operSubmitData($translate.instant("启用"));
                    });
                }
            })
        }

        $scope.gopage = function(info) {
            ToolService.sendBehaviorUv("create");
            if (angular.isDefined(info)) {
                $state.go("collect.channelDetail", { aid: info });
            } else {
                $state.go("collect.channelDetail");
            }
        }

        $scope.goGdt = function(info, flag) {
            ToolService.sendBehaviorUv("goGdt");
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && flag != 10) {
                info.step = flag;
                $state.go("collect.channelAdd", { aid: info });
            } else {
                $state.go("collect.channelAdd");
            }
        }

        //查询广点通、adwords、神马有没有绑定账号
        $scope.bindChannelList = function() {
            var list =[]; var par = {};
            if($scope.channelList && $scope.channelList.length>0){
                for(var i=0;i<$scope.channelList.length;i++){
                    list.push($scope.channelList[i].id);   
                }
                par = {
                    channleids:list.join(",")
                }
            }
            ToolService.showLoading();
            var searchPM = HttpService.postInfo("mng/channelaccount/findcount", par);
            searchPM.then(function(data) {
                ToolService.hideLoading();
                $scope.showGdtBtn = data.gdt;
                $scope.showadwordsNtn = data.adwords;
                $scope.showsmsearchNtn = data.smsearch;
                $scope.showbaiduysggNtn = data.baiduysgg;
                $scope.showkuaishouNtn = data.kuaishou;
                $scope.showweixinmpNtn = data.weixinmp;
                
            })
        }
        $scope.goGdtList = function(info, flag) {
            ToolService.sendBehaviorUv("goGdtList");
            $scope.bindingList();
            if (flag) {
                $scope.pageFlag = 5;
            } else {
                $scope.backFlag(1);
            }
        }

        $scope.bindingList = function() {
                ToolService.showLoading();
                var tablePM = HttpService.getInfo("mng/channelaccount/findLinkedApp/5305");
                tablePM.then(function(data) {
                    ToolService.hideLoading();
                    // $scope.channelAddList = data;
                    $scope.channelAddList = data.filter(function(item) {
                        if (item.feedbackurl == "暂无") {
                            item.showCope = false;
                            item.feedbackurl = "暂无"
                        } else {
                            item.showCope = true;
                            var urlSchemeStr='';
                            var preorderStr =''
                            if(item.type == 2 && item.openSubscribes){ //预约广点通
                                preorderStr = '&preorder=true' 
                            }
                            if(item.urlScheme){
                                urlSchemeStr = "&rydp_path=null&ry_dp=true&rydp_url="+item.urlScheme;
                            }
                            item.feedbackoriginalurl = item.feedbackurl;

                            item.feedbackurl = "http://uri6.com/tkio/" + item.feedbackurl + "?noredirect=true"+urlSchemeStr+preorderStr
                        }

                        return true;
                    });
                });
            }
            //汉字、数字、字母、下划线，下划线 
        $scope.checkAliasName = function(aliasName) {
            var reg = /^([a-z_A-Z-.+0-9\u4e00-\u9fa5]+)$/gi;
            if (!reg.test(aliasName) || aliasName == undefined) {
                return false;
            }
            return true;
        }
        $scope.strlen = function(str) {
                var len = 0;
                for (var i = 0; i < str.length; i++) {
                    var c = str.charCodeAt(i);
                    //单字节加1
                    if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
                        len++;
                    } else {
                        len += 2;
                    }
                }
                return len;
            }
            //修改别名
        $scope.editAlias = function(info) {
            $scope.curEditId = info.id;
            info.salias = info.alias;
        }
        $scope.saveAlias = function(info) {
            if (info.alias == info.salias) {
                $scope.curEditId = -1;
                return false;
            }
            if (info.salias == '') {
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            } else {
                $scope.salias = info.salias;
                $scope.checkreAlias($scope.salias);
                var parmas = {
                    alias: $scope.salias,
                    rebate: 0,
                    id: info.id
                };
                if ($scope.checkAlias == true) {

                    var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.salias);
                    packPM.then(function(data) {
                        if (data.content == false) { //为true时说明名称已经存在
                            ToolService.showLoading();
                            var saveUpdataPM = HttpService.putInfo("mng/channelaccount/alias", parmas);
                            saveUpdataPM.then(function(data) {
                                ToolService.hideLoading();
                                ToolService.showTips($filter('translate')("修改成功"));
                            })
                            $scope.checkAlias = true;
                            info.alias = info.salias;
                            $scope.curEditId = -1;

                        } else {
                            ToolService.showTips($filter('translate')("该渠道账号别名已经被占用"));
                            $scope.checkAlias = false;
                        }
                    });
                }
            }
        }

        $scope.checkreAlias = function() {
            $scope.checkAlias = false;
            var checkAlias = $scope.checkAliasName($scope.salias);
            if (checkAlias == false) {
                ToolService.showTips($filter('translate')("请输入8位以内的中英文、数字、下划线或英文横线"));
                return false;
            }
            var strlen = $scope.strlen($scope.salias)
            if (strlen > 16) {
                ToolService.showTips($filter('translate')("请输入8位以内的中英文、数字、下划线或英文横线"));
                return false;
            } else {
                if ($scope.salias == "" || $scope.salias == undefined) {
                    return false;
                } else {
                    $scope.checkAlias = true
                }

            }
        }



        $scope.loginuserName = UtilService.getCookie("ryioUname");
        $scope.showGdtWin = function(info) {
            $scope.gdtPlan = info.plan;
            $scope.feedbackoriginalurl = info.feedbackoriginalurl;
            ToolService.showAlp();
            $scope.dialogGdt = true;

        }

        //广点通修改方案
        // $scope.gdtPlan = 2;
        // var cip = returnCitySN["cip"]; //获取用户的外网ip
        var cip = UtilService.getCookie("cip") 
        $scope.okBase = function() {
            cip = cip || "";
            ToolService.hideAlp();
            $scope.dialogGdt = false;
            ToolService.showLoading();
            var obj = {
                cip: cip,
                shortUrl: $scope.feedbackoriginalurl
            };
            // var obj = 'cip='+cip+'&shortUrl='+$scope.feedbackoriginalurl
            var planPM = HttpService.getInfo("mng/channelaccount/updatePlan/" + $scope.gdtPlan, obj);
            planPM.then(function(data) {
                // ToolService.hideLoading();
                // $scope.channelCheckPlan();
                $scope.bindingList();
                /*if(data != true){
                    ToolService.showTips($translate.instant("请先绑定投放账号后，再修改对接方式"));                   
                }*/
            })
        }

        $scope.hideDialog = function() {
            ToolService.hideAlp();
            $scope.dialogGdt = false;
            // $scope.gdtPlan=$scope.value;

        }
        $scope.hideDialogDp = function() {
            ToolService.hideAlp();
            $scope.dialogDpLink = false;

        }
        $scope.hideDialogDp2 = function() {
            ToolService.hideAlp();
            $scope.dialogDpLink2 = false;

        }
        $scope.goSm = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && !flag) {
                $state.go("collect.channelSm", { aid: info });
            } else {
                $state.go("collect.channelSm");
            }
        }

        $scope.goAdwords = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && flag != 10) {
                info.step = flag;
                $state.go("collect.channelAdwords", { aid: info });
            } else {
                $state.go("collect.channelAdwords");
            }
        }
        $scope.goToutiao = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && flag != 10) {
                info.step = flag;
                $state.go("collect.channelToutiao", { aid: info });
            } else {
                $state.go("collect.channelToutiao");
            }
        }
        $scope.goBaidu = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && !flag) {
                $state.go("collect.channelBaidu", { aid: info });
            } else {
                $state.go("collect.channelBaidu");
            }
        }
        $scope.goKuaishou = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && !flag) {
                $state.go("collect.channelKuaishou", { aid: info });
            } else {
                $state.go("collect.channelKuaishou");
            }
        }
        $scope.goWeixinmp = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && !flag) {
                $state.go("collect.channelWeixinmp", { aid: info });
            } else {
                $state.go("collect.channelWeixinmp");
            }
        }

        $scope.goSub = function(info, flag) {
            ToolService.sendBehaviorUv("goSub");
            $rootScope.curChannel = info;
            if (flag) {
                $scope.pageFlag = 3;
            } else {
                ToolService.showLoading();
                $scope.backFlag(2);
                $scope.gdtUrl = info.nodeUrl;
            }
            $scope.userType = 'authorize';

        }
        $scope.backFlag = function(flag) {
            $scope.pageFlag = flag;
            if (flag == 2) {
                
                if ($scope.curChannel == undefined) {
                    var subPM = HttpService.getInfo("mng/channelaccount/find/" + $scope.twoListID);
                } else {
                    var subPM = HttpService.getInfo("mng/channelaccount/find/" + $scope.curChannel.id);
                }
                subPM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.accountList = data;
                });
            }
            if (flag == 1) {
                $scope.filterTypeList($scope.channType);
                $state.go("collect.channel", { aid: 'ry_coop' });
            }
            if ($scope.pageFlag == 5) {
                $state.go("collect.channel", { aid: 'ry_coop' });
            }
        }
        $scope.appsListInit = "全部应用"
        $scope.authorizeList = function(type) {
            $scope.curEditId = -1;
            $scope.userType = type;
            $scope.accountList = [];
            if (type == 'authorize') {
                $scope.backFlag(2);
            } else {
                var authorizeID = "";
                if ($scope.curChannel == undefined) {
                    authorizeID = $scope.twoListID;
                } else {
                    authorizeID = $scope.curChannel.id;
                }
                var thirdAcount = 0
                if($scope.acountInfoId){
                    thirdAcount = $scope.acountInfoId;
                }
                var campPM = HttpService.getInfo(thirdAcount + "/campaign/findthirdback/" + authorizeID);
                ToolService.showLoading();
                campPM.then(function(data) {
                    ToolService.hideLoading();
                    data.apps.unshift({ id: "0", name: $scope.appsListInit });
                    $scope.accountList = data.accounts;
                    if(thirdAcount == 0){
                        $scope.appsListInfo = JSON.parse(JSON.stringify(data.apps))
                    }
                });
            }
        }
        var acountNum = 0;
        $scope.$on("appsListid", function(e, msg) {
            $scope.acountInfoId =  msg.info.id
            acountNum=acountNum+1
            if(acountNum>0){
                $scope.authorizeList();
                $scope.userType = 'backReturn';
            }
            
        })

        $scope.editName = function(info) {
            $scope.curEditId = info.id;
            info.thirdAccountAlias = info.name;
        }
        $scope.saveName = function(info) {
            if (info.name == info.thirdAccountAlias) {
                $scope.curEditId = -1;
                return false;
            }
            if (info.thirdAccountAlias == '') {
                ToolService.showTips($translate.instant("不能为空"));
                return false;
            }
            var verPar = {
                thirdAccountAlias: {
                    key: 'spcname1',
                    val: info.thirdAccountAlias,
                    txt: $translate.instant("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                }
            };

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ == true) {
                ToolService.showLoading();
                var authorizeID = "";
                if ($scope.curChannel == undefined) {
                    authorizeID = $scope.twoListID;
                } else {
                    authorizeID = $scope.curChannel.id;
                }
                var namePM = HttpService.putInfo("mng/campaign/" + authorizeID + "/alteralias?thirdAccountAlias=" + info.thirdAccountAlias + "&thirdAccount=" + $scope.curEditId);
                namePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data) {
                        ToolService.showTips($translate.instant("修改成功"));
                        info.name = info.thirdAccountAlias;
                        $scope.curEditId = -1;
                    } else {
                        ToolService.showTips($translate.instant("名称重复"));
                    }
                });
            } else {
                ToolService.showTips($scope.tip.thirdAccountAlias.txt);
            }

        }

        if (($rootScope.channeluniqueName != "normal" && $rootScope.channeluniqueName != undefined && window.location.href.indexOf('channel') > -1) || type == 'adwords' || type == 'gdt' || type == 'smsearch' || type == 'toutiao') {
            $scope.userType = "authorize";
            if (type == 'adwords' || type == 'gdt' || type == 'smsearch' || type == 'toutiao' || type == 'baiduysgg' || type == 'kuaishou' || type == 'weixinmp') {
                $rootScope.channeluniqueName = type;
            }
            $scope.$watch("appid", function(n) {
                if (angular.isDefined(n)) {
                    var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/" + $rootScope.channeluniqueName);
                    gdtPM.then(function(data) {
                        ToolService.hideLoading();
                        $scope.gdtData = data;
                        $scope.gdtDataId = data.id;
                        $scope.gdtName = data.name;
                        $scope.gdtUrl = data.nodeUrl;
                    });
                }
            });
            $scope.$watch("gdtDataId", function(n) {
                var stype = $stateParams.aid;
                if (angular.isDefined(n)) {
                    if (type == 5) {
                        $scope.pageFlag = 5;
                        $scope.bindingList();
                    }else if(!stype){
                        $scope.pageFlag = 1;
                        $rootScope.channeluniqueName = "normal"
                    }
                    else {
                        $scope.pageFlag = 2;
                    }
                    var subPM = HttpService.getInfo("mng/channelaccount/find/" + $scope.gdtDataId);
                    ToolService.showLoading();
                    subPM.then(function(data) {
                        ToolService.hideLoading();
                        $scope.accountList = data;
                    });
                }
            });
            //$rootScope.channeluniqueName = 'normal';
        }

        $scope.openUrl = function(url) {
            window.open(url);
        }

        $scope.isdetail = false;
        $scope.isAcountDetail = false;
        $scope.showDetails = function(info) {
            $scope.showDetailsInfo = info;
            $scope.channelAlias = info.alias;
            var listPM = null;
            listPM = HttpService.getInfo("mng/channelaccount/app/find/" + info.id);
            listPM.then(function(data) {
                $scope.detailInfo = data;
            });
            ToolService.showAlp();
            $scope.isdetail = true;
            angular.element(document).on("click", function() {
                $scope.$apply(function() {
                    $scope.hideDetails();
                });
            });
        }
        $scope.showAcountDetails = function(info) {
            $scope.showDetailsInfo = info;
            $scope.channelAliasName = info.name;
            ToolService.showLoading();
            var listPM = null;
            listPM = HttpService.getInfo("0/campaign/thirdback/applist/" + info.id);
            listPM.then(function(data) {
                ToolService.hideLoading();
                $scope.acountDetailInfo = data;
            });
            ToolService.showAlp();
            $scope.isAcountDetail = true;
            angular.element(document).on("click", function() {
                $scope.$apply(function() {
                    $scope.hideDetails();
                });
            });
        }

        $scope.hideDetails = function() {
            ToolService.hideAlp();
            $scope.isdetail = false;
            $scope.isAcountDetail = false;

        }

        $scope.disabledStatus = false;
        $scope.empowerType = false;
        $scope.showDisableModal = function(info) {
            $scope.curBaiduInfo = info;
            $scope.disabledStatus = true;
        }
        $scope.changeAuthorize = function(info) {
            $scope.curWeixinmpInfo = info;
            if($rootScope.redirectNewDoman){
                window.open("https://developers.e.qq.com/oauth/authorize?client_id=1106237187&redirect_uri=http://www.trackingio.com/api/mng/channelaccount/createByWeixinMP&state=" + info.alias+"&account_type=ACCOUNT_TYPE_WECHAT");
            }else{
                window.open("https://developers.e.qq.com/oauth/authorize?client_id=1110744256&redirect_uri=http://tweb.trackingio.com/api/mng/channelaccount/createByWeixinMP&state=" + info.alias+"&account_type=ACCOUNT_TYPE_WECHAT");
            }
            $scope.empowerType = true;
        }
        $scope.empowerTtOK = function() {
            var aliasPM = HttpService.getInfo("mng/channelaccount/checkWeixinMP?alias=" + $scope.curWeixinmpInfo.alias);
            aliasPM.then(function(data) {
                $scope.empowerType = false;
                $scope.changeAccoutStatus($scope.curWeixinmpInfo,2)
            },function(err){
                $scope.empowerType = false;
                ToolService.showTips("授权失败，请重试")
            });
        }
        $scope.changeAccoutStatus = function(info, flag) {
                var url = "",
                    txt = "";
                if (flag == 1) {
                    url = "mng/channelaccount/forbidden/" + info.id;
                    txt = $translate.instant("停用成功");
                } else {
                    url = "mng/channelaccount/enable/" + info.id;
                    txt = $translate.instant("启用成功");
                }

                var enablePM = HttpService.putInfo(url);
                ToolService.showLoading();
                enablePM.then(function(data) {
                    $scope.twoListID = data.channel;
                    ToolService.hideLoading();
                    ToolService.showTips(txt)
                    $scope.backFlag(2);
                });
            }
            /*var oldname = "";
            $scope.subDetail = {};
            $scope.goSubDetail = function(info){
                $scope.pageFlag = 3;
                $scope.tip = {};
                if(info){//编辑
                    $scope.subDetail = info;
                    $scope.channelname = info.name;
                    $scope.channelpwd = info.password;
                    $scope.channeluname = oldname = info.alias;
                    $scope.channelRebate = info.rebate;
                }
                else{
                    $scope.subDetail = {};
                    $scope.channelname = "";
                    $scope.channelpwd = "";
                    $scope.channeluname = oldname = "";
                    $scope.channelRebate = "";
                }
            }*/
            //判断名称是否存在
        $scope.existName = function(flag) {
            if ($scope.judgeNameChange(oldname, $scope.channeluname)) {
                ToolService.showLoading();
                var namePM = HttpService.getInfo("mng/channelaccount/valid", { name: $scope.channeluname });
                namePM.then(function(data) {
                    if (!$scope.tip) {
                        $scope.tip = {};
                    }
                    ToolService.hideLoading();
                    if (data != true) { //存在
                        $scope.tip = {
                            channeluname: {
                                status: true,
                                txt: $translate.instant("渠道账号别名已存在")
                            }
                        }
                    } else {
                        $scope.tip = {
                            channeluname: {
                                status: false
                            }
                        }
                        if (flag && flag == 1) {
                            $scope.saveChannelUser();
                        }
                    }
                });
            } else {
                $scope.tip = {
                    channeluname: {
                        status: false
                    }
                }
                if (flag && flag == 1) {
                    $scope.saveChannelUser();
                }
            }
        }
        $scope.saveChannelUser = function() {
            var par = {
                name: $scope.channelname,
                password: $scope.channelpwd,
                alias: $scope.channeluname,
                rebate: $scope.channelRebate,
                channel: $scope.curChannel.id
            };
            var verPar = {
                channelname: {
                    key: 'isNull',
                    val: $scope.channelname
                },
                channelpwd: {
                    key: 'isNull',
                    val: $scope.channelpwd
                },
                channeluname: {
                    key: 'username',
                    val: $scope.channeluname,
                    txt: $translate.instant('支持16位内汉字或32位内字母数字')
                }
            }

            $scope.tip = formJudge(verPar);
            if (!UtilService.isNullStr($scope.channelRebate)) {
                if (!angular.isNumber($scope.channelRebate) || Number($scope.channelRebate) < 0 || Number($scope.channelRebate) > 100) {
                    $scope.tip.succ = false;
                    $scope.tip.channelRebate = {
                        status: true,
                        txt: $translate.instant("填写数值过大或过小（取值范围[0.01-100]）")
                    }
                } else {
                    $scope.tip.channelRebate = {};
                }
            } else {
                $scope.tip.channelRebate = {};
            }

            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }

            var savePM = null,
                txtTips = $translate.instant("添加成功");
            if ($scope.subDetail.id != null) {
                par.id = $scope.subDetail.id;
                savePM = HttpService.putInfo("mng/channelaccount/update", par);
                txtTips = $translate.instant("修改成功");
            } else {
                savePM = HttpService.postInfo("mng/channelaccount/create", par);
            }
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (!data.id) {
                    ToolService.showTips($translate.instant("账号或密码错误，请检查更新后重新创建"));
                } else {
                    ToolService.showTips(txtTips);
                    $scope.backFlag(2);
                }
            });
        }

        var init = function() {
            $scope.dayList = [
                { id: 999, name: $translate.instant("未设置") },
                { id: 1, name: $translate.instant("1天") },
                { id: 2, name: 2 + $translate.instant("天") },
                { id: 3, name: 3 + $translate.instant("天") },
                { id: 4, name: 4 + $translate.instant("天") },
                { id: 5, name: 5 + $translate.instant("天") },
                { id: 6, name: 6 + $translate.instant("天") },
                { id: 7, name: 7 + $translate.instant("天") },
                { id: 15, name: 15 + $translate.instant("天") },
                { id: 30, name: 30 + $translate.instant("天") }
            ];
            $scope.dayList1 = [
                { id: 1, name: $translate.instant("1天") },
                { id: 2, name: 2 + $translate.instant("天") },
                { id: 3, name: 3 + $translate.instant("天") },
                { id: 4, name: 4 + $translate.instant("天") },
                { id: 5, name: 5 + $translate.instant("天") },
                { id: 6, name: 6 + $translate.instant("天") },
                { id: 7, name: 7 + $translate.instant("天") },
                { id: 15, name: 15 + $translate.instant("天") },
                { id: 30, name: 30 + $translate.instant("天") }
            ];
            $scope.deviceList = [
                { id: 1, name: $translate.instant("已启用") },
                { id: 2, name: $translate.instant("已停用") }
            ];
        }
        init();
        $scope.deviceInit = $scope.deviceList[0].id;
        //归因
        $scope.impAttributeList = [
            { id: true, name: $translate.instant("是") },
            { id: false, name: $translate.instant("否") }
        ];

        $scope.$on("ciDay", function(e, msg) {
            $scope.ciDay = msg.info.id;
        });
        $scope.$on("ciDayOne", function(e, msg) {
            $scope.ciDayOne = msg.info.id;
        });
        $scope.$on("impAttribute", function(e, msg) {
            $scope.impAttribute = msg.info.id;
        });
        $scope.cheatList1 = [
            { id: 0, name: $translate.instant("严格") },
            { id: 1, name: $translate.instant("普通") },
            { id: 2, name: $translate.instant("宽松") }
        ];
        $scope.$on("cheatOne", function(e, msg) {
            $scope.cheatOne = msg.info.id;
        });
        //全渠道设置
        var rmd = new Date().getTime();
        $scope.allSet = function() {
            ToolService.sendBehaviorUv("allSet");
            $scope.pageFlag = 3;
            var allPM = HttpService.getInfo("mng/channelparam/find/black");
            ToolService.showLoading();
            allPM.then(function(data) {
                ToolService.hideLoading();
                $scope.allData = data.allChannelValidMatch;
                if ($scope.allData == false) {
                    $scope.ciDayInit = 999;
                } else {
                    $scope.ciDayInit = data.ciDay;
                }
                $scope.datafresh2 = ++rmd;
                $scope.datafresh1 = ++rmd;
            });
        }
        $scope.saveAllSet = function(id, flag) {
                //应用全渠道限制
                if ($scope.ciDay == 999 && id == 0 && flag == "valid") {
                    return false;
                }

                var isall = true;
                if (id == 1) {
                    var isdefault = true;
                } else {
                    var isdefault = false;
                }
                var par = {};
                if ($scope.ciDay == 999) {
                    par.blacklistStatus = $scope.blackType
                }
                if ($scope.ciDay != 999) {
                    par.ciDay = $scope.ciDay;
                }
                var allsavePM = HttpService.putInfo("mng/channelparam/update/" + flag + "?isall=" + isall + "&isdefault=" + isdefault, par);
                ToolService.showLoading();
                allsavePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data == 'success') {
                        ToolService.showTips($translate.instant("保存成功"));
                    }
                    if (flag == 'black') {
                        $scope.allBlack = true;
                    } else {
                        $scope.allData = true;
                    }
                    if (id == 1) {
                        $scope.allSet();
                    }
                });
            }
            //渠道单独设置
        var oneSetId = 0;
        $scope.oneSet = function(info) {
            ToolService.sendBehaviorUv("oneSet");
            $scope.pageFlag = 4;
            $scope.channelParam = info;

            var onePM = HttpService.getInfo("mng/channelparam/find/" + info.id);
            ToolService.showLoading();
            onePM.then(function(data) {
                ToolService.hideLoading();
                oneSetId = data.id;
                $scope.winciDayOne = $scope.ciDayOneInit = data.ciDay;
                $scope.blackOneType = data.blacklistStatus;
                $scope.deviceBlackStatus = data.deviceBlackStatus;
                $scope.cheatOne = $scope.wincheatOne = $scope.cheatOneInit = data.blacklistLevel;
                $scope.wholeChannelNum = data.wholeChannelNum;
                if (data.blacklistLevel == -1) {
                    $scope.cheatOne = $scope.cheatOneInit = 1;
                }
                $scope.impAttributeInit = (data.impAttribute ? true : false);
            });
        }

        $scope.blackClick = function(id) {
            if (id == 1) {
                $scope.blackOneType = true;
                if ($scope.wincheatOne = -1) {
                    $scope.cheatOne = $scope.wincheatOne = $scope.cheatOneInit = 1;
                }
            } else {
                $scope.blackOneType = false;
            }
        }

        $scope.saveOne = function(id, flag) {
            // if($rootScope.demoU){return false;}
            var isall = false;
            if (id == 1) {
                var isdefault = true;
            } else {
                var isdefault = false;
            }
            var par = {
                id: oneSetId,
                cid: $scope.channelParam.id,
                ciDay: $scope.ciDayOne,
                blacklistStatus: $scope.blackOneType,
                wholeChannelNum: $scope.wholeChannelNum,
                impAttribute: $scope.impAttribute,
                deviceBlackStatus: $scope.deviceBlackStatus ? true : false
            };
            if (isdefault) {
                if (flag === "impression") {
                    par.impAttribute = isdefault = false;
                }
                if (flag === "black") {
                    par.deviceBlackStatus = isdefault = false;
                }
            }
            if ($scope.blackOneType == true) {
                par.blacklistLevel = $scope.cheatOne;
            } else {
                par.blacklistLevel = -1;
            }
            var onesavePM = HttpService.putInfo("mng/channelparam/update/" + flag + "?isall=" + isall + "&isdefault=" + isdefault, par);
            ToolService.showLoading();
            onesavePM.then(function(data) {
                ToolService.hideLoading();
                $scope.closeWin();
                ToolService.showTips($translate.instant("保存成功，修改后第二天零点生效。"));
                oneSetId = data.id;
                $scope.winciDayOne = $scope.ciDayOneInit = data.ciDay;
                $scope.blackOneType = data.blacklistStatus;
                $scope.deviceBlackStatus = data.deviceBlackStatus;
                $scope.cheatOne = $scope.wincheatOne = $scope.cheatOneInit = data.blacklistLevel;
                $scope.impAttributeInit = data.impAttribute;
            });
        }

        $scope.closeWin = function() {
            $scope.winFlag = 1;
            ToolService.hideAlp();
        }

        //数据有效期设置
        $scope.setData = function() {
                ToolService.sendBehaviorUv("setData");
                ToolService.showAlp();
                $scope.winFlag = 2;
            }
            //黑名单设置
        $scope.setBlock = function() {
                ToolService.showAlp();
                $scope.winFlag = 3;
            }
            //展示归因设置
        $scope.setAttr = function() {
            ToolService.showAlp();
            $scope.winFlag = 4;
        }

        /* $scope.clickShowList = [
             {id:1,name:"是"},
             {id:0,name:"否"}
         ];*/

        $scope.$watch("lang", function(n, o) {
            if (n && o && n != o) {
                init();
                $scope.query();
            }
        });
    }

    function channelDetailCtrl($scope, $rootScope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $filter, $translate) {
        var editInfo = $stateParams.aid,
            infoId = null;
        if (angular.isDefined(editInfo) && editInfo != null) {
            infoId = $scope.id = editInfo.id;
        }
        var eInfo = $stateParams.aid;
        if (angular.isDefined(eInfo) && eInfo != null) {
            if (eInfo == 5) {
                $scope.pageFlag = 5;
            }
        } else {
            $scope.pageFlag = 1;
        }
        $scope.findCoop = function() {
            var channelPM = HttpService.getInfo("1/channel/findcoop");
            channelPM.then(function(data) {
                $scope.channelList = data;
            });
        }

        $scope.findCoop();

        var inName = "";
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null && editInfo !="channelManage") {
                $scope.name = inName = editInfo.name;
                $scope.category = editInfo.category;
                $scope.url = editInfo.url;

                $scope.osIos = editInfo.osIos;
                $scope.osAndroid = editInfo.osAndroid;
                $scope.osWeb = editInfo.osWeb;
                $scope.osWeixin = editInfo.osWeixin;

                if (editInfo.osIos) {
                    $scope.os1 = 0;
                }
                if (editInfo.osAndroid) {
                    $scope.os2 = 1;
                }
                if (editInfo.osWeb) {
                    $scope.os3 = 2;
                }
                if (editInfo.osWeixin) {
                    $scope.os4 = 3;
                }
            } else {
                $scope.osIos = false;
                $scope.osAndroid = false;
                $scope.osWeb = false;
                $scope.osWeixin = false;
                $scope.category = 'ADVERTISING';
                $scope.os = 0;
                inName = "";
            }
        };
        $scope.tipStatus = false;
        $scope.changeName = function() {
                if (angular.isDefined(editInfo) && editInfo != null) {

                } else {
                    var isCheck = !$scope.osIos && !$scope.osAndroid && !$scope.osWeb && !$scope.osWeixin;
                    if (isCheck) {
                        $("#name").blur();
                        ToolService.showTips($translate.instant("请先选择平台"));
                    }
                }
            }
            //监控渠道类型
        $scope.$watch("category", function(n) {
            if (angular.isDefined(n)) {
                $scope.osIos = false;
                $scope.osAndroid = false;
                $scope.osWeb = false;
            }
        });
        $scope.filterName = function() {
            if (!$scope.name) { return false; }
            if ($scope.name != inName) {
                $scope.filterChannels = $scope.channelList.filter(function(item) {
                    var result = (item.name.indexOf($scope.name) > -1 || $scope.name.indexOf(item.name) > -1) && item.category == $scope.category;
                    if (!result) { return false; }
                    if ($scope.osIos) {
                        result = result && item.osIos;
                    }
                    if ($scope.osAndroid) {
                        result = result && item.osAndroid;
                    }
                    if ($scope.osWeb) {
                        result = result && item.osWeb;
                    }
                    if ($scope.osWeixin) {
                        result = result && item.osWeixin;
                    }
                    return result;
                });
                $scope.tipStatus = false;
            } else {
                $scope.filterChannels = [];
            }
        }

        $scope.clearFilter = function() {
            $scope.filterChannels = [];
        }
        $scope.doTips = function(channel) {
            $scope.coopchannel = channel;
            $scope.name = channel.name;
            $scope.tipStatus = true;
            $scope.filterChannels = [];
        }

        $scope.checkTypes = function(os) {
            if (os == 1) {
                $scope.osIos = !$scope.osIos;
            } else if (os == 2) {
                $scope.osAndroid = !$scope.osAndroid;
            } else if (os == 3) {
                $scope.osWeb = !$scope.osWeb;
            } else if (os == 4) {
                $scope.osWeixin = !$scope.osWeixin;
            }
            if ($scope.osIos || $scope.osAndroid || $scope.osWeb || $scope.osWeixin) {
                $scope.typeTip = "";
            }
        }
        $scope.init();
        $scope.save = function() {
            var par = {
                name: $scope.name,
                category: $scope.category,
                url: $scope.url,
                // os:$scope.os,
                osIos: $scope.osIos,
                osAndroid: $scope.osAndroid,
                osWeb: $scope.osWeb,
                osWeixin: $scope.osWeixin
            };
            var verPar = {
                name: {
                    key: 'spcname',
                    val: par.name
                }
            }
            $scope.tip = formJudge(verPar);
            var isCheck = !$scope.osIos && !$scope.osAndroid && !$scope.osWeb && !$scope.osWeixin;
            if ($scope.tip.succ != true || (isCheck && !infoId)) {
                if (isCheck && !infoId) { $scope.typeTip = $translate.instant("请至少选择一个平台"); }
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null,
                txtTips = $translate.instant("添加成功"),
                txtTipsRepeat = $translate.instant("渠道名称已存在");
            if (infoId != null) {
                par.id = infoId;
                savePM = HttpService.putInfo("mng/channel/update", par);
                txtTips = $translate.instant("修改成功");
            } else {
                savePM = HttpService.postInfo("mng/channel/create", par);
            }
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (data.code == -5002) {
                    ToolService.showTips(txtTipsRepeat);
                } else {
                    ToolService.showTips(txtTips);
                    $scope.cancel();
                    if (!infoId) {
                        $rootScope.operSubmitData($translate.instant("新建"));
                    }
                }
            },function (data) {
                ToolService.showTips(data.message);
            });
        }
        $scope.cancel = function() {
            var iden = 'channelManage';
            if(editInfo == iden){
                $state.go("collect.channelmanage", { stateinfo: iden, pageid: 'custom' });
            }else{
                $state.go("collect.customchannel", { aid: 'custom' });
            }
            
        }

        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.findCoop();
                $scope.init();
            }
        });

    }


    function channelAddCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $filter, $translate) {
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $scope.editPower = true;
        } else {
            $scope.editPower = false;
        }

        $rootScope.channeluniqueName = 'gdt';
        $scope.stepflag = 0; //1、2、3步
        $scope.step1 = 'normal'; //第一步   normal   failure  success
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            infoId = $scope.id = editInfo.id;
            if (editInfo.step == 1) {
                $scope.stepflag = 1;
            }
        }

        /*else{
            $scope.hasEnable = true;
        }*/
        var oldname = "";
        var oldthirdAccountCode = "";
        var oldalias = "";
        $scope.pastStatus = false;
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.state = oldname = editInfo.name;
                // $scope.accountid = oldthirdAccountCode = editInfo.thirdAccountCode; // 回显  删除
                $scope.rebate = parseFloat(editInfo.rebate);
                $scope.alias = oldalias = editInfo.alias;
                $scope.pastStatus = editInfo.pastStatus;
                $scope.thirdAccountCode = editInfo.thirdAccountCode;
                $scope.step1 = 'success';

            } else {
                $scope.rebate = 0;
            }
        };
        $scope.init();
        if ($scope.id == undefined) {
            $scope.flag = 1;
        } else {
            $scope.flag = 0;
        }


        $scope.gotoGdtList = function(info, flag) {
            $scope.bindingList();
            $scope.pageFlag = flag;
            $state.go("collect.channel", { aid: $scope.pageFlag });
        }
        $scope.bindingList = function() {
            ToolService.showLoading();
            var tablePM = HttpService.getInfo("mng/channelaccount/findLinkedApp/5305");
            tablePM.then(function(data) {
                ToolService.hideLoading();
                // $scope.channelAddList = data;
                $scope.channelAddList = data.filter(function(item) {
                    if (item.feedbackurl == "暂无") {
                        item.showCope = false;
                        item.feedbackurl = "暂无"
                    } else {
                        item.showCope = true;
                        item.feedbackurl = "http://uri6.com/tkio/" + item.feedbackurl + "?noredirect=true&"
                    }

                    return true;
                });
            });
        }

        $scope.cancel = function() {
            if ($scope.empowerType == true) {
                var savePM = null;
                savePM = HttpService.deleteInfo("mng/channelaccount/delete/authorize/" + $scope.flag + "/" + $scope.state);
                savePM.then(function(data) {
                    $state.go("collect.channel", { aid: editInfo });
                });
            } else {
                $state.go("collect.channel", { aid: editInfo });
            }

        }
        $scope.saveZero = function() {
            $scope.nextStep();
        }
        $scope.setStep = function(stepflag) {
            $scope.stepflag = stepflag;
        }
        $scope.nextStep = function() {
            $scope.stepflag = $scope.stepflag + 1;
        }
        $scope.lastStep = function() {
                $scope.stepflag = $scope.stepflag - 1;
                $scope.checkAlias = false;
            }
            //弹窗 
        $scope.openDialog = function() {
            if ($rootScope.doMainType == 0) {
                window.open($rootScope.docDomain+"广点通-MarketingAPI.html");
            } else if ($rootScope.doMainType == 1) {
                window.open($rootScope.otherCompanyInfo.gdtDocUrl)
            }
        }

        $scope.empower = function() {
            $scope.aliasID = $scope.aliasID;
            $scope.promiseF().then(function() {
                    // var par = {
                        // state: $scope.state,
                        // accountid: $scope.accountid  // 点击授权  删除
                    // };
                    // var verPar = {
                        // state: {
                        //     key: 'num',
                        //     val: par.state,
                        //     txt: $translate.instant('合法性为仅支持输入数字，长度不限')
                        // },
                        // accountid: {
                        //     key: 'num',
                        //     val: par.accountid,
                        //     txt: $translate.instant('合法性为仅支持输入数字，长度不限')
                        // }
                    // }
                    // $scope.tip = formJudge(verPar);
                    // if ($scope.tip.succ != true) {
                    //     ToolService.showTips($scope.formTipMsg);
                    //     return false;
                    // }
                    if($rootScope.redirectNewDoman){
                        // window.open("https://developers.e.qq.com/oauth/authorize?client_id=1106237187&redirect_uri=http://www.trackingio.com/api/mng/channelaccount/code&state=" + $scope.state + "&alias=" + $scope.alias);
                        window.open("https://developers.e.qq.com/oauth/authorize?client_id=1106237187&redirect_uri=http://www.trackingio.com/api/mng/channelaccount/code&state=" + $scope.alias); 
                        
                    }else{
                        window.open("https://developers.e.qq.com/oauth/authorize?client_id=1110744256&redirect_uri=http://tweb.trackingio.com/api/mng/channelaccount/code&state=" + $scope.alias);
                    }
                    $scope.empowerType = true;
                })
        }

        $scope.empowerError = function() {
            $scope.empowerType = false;
        }

        $scope.empowerOK = function() {
            var savePM = null;
            // savePM = HttpService.getInfo("mng/channelaccount/valid/qq?qq=" + $scope.state);
            var savePM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
            savePM.then(function(data) {
                $scope.empowerType = false;
                if (data == true) {
                    $scope.step1 = 'success';
                    $scope.accountAuthorization();
                    $scope.getByAlias();
                } else {
                    $scope.step1 = 'failure';
                }
            });
        }
        $scope.getByAlias = function(){
            var aliasPM = HttpService.getInfo("mng/channelaccount/valid/getByAlias?alias=" + $scope.alias);
            aliasPM.then(function(data){
                if(data){
                    $scope.thirdAccountCode = data.thirdAccountCode
                    $scope.state = data.name
                }
            })
        }
        $scope.powerAgain = function() {
                $scope.step1 = 'normal';
            }
            // $scope.checkQQ = true;
        $scope.exixtQQ = function() {
                // $scope.checkQQ = true;
                if (oldname == $scope.state) {
                    $scope.checkQQ = false;
                } else {
                    if ($scope.state == "" || $scope.state == undefined) {}
                    var packPM = HttpService.getInfo("mng/channelaccount/valid/qq?qq=" + $scope.state);
                    return packPM.then(function(data) {
                        if (data.content == false) {
                            $scope.checkQQ = false;
                            $scope.tip = {
                                state: {
                                    status: false,
                                    txt: ''
                                }
                            };
                        } else {
                            $scope.checkQQ = true;
                            $scope.tip = {
                                state: {
                                    status: true,
                                    txt: $translate.instant('该渠道账号已被授权，如果需要对该账号重新授权，请到对应账号进行修改。')
                                }
                            };
                        }
                    });
                }
            }
            // $scope.checkID = true;
        // $scope.exixtID = function() { // 失去焦点验证重复
        //     // $scope.checkID = true;
        //     if (oldthirdAccountCode == $scope.accountid) {
        //         $scope.checkID = false;
        //     } else {
        //         if ($scope.accountid == "" || $scope.accountid == undefined) {
        //             return false;
        //         }
        //         var packPM = HttpService.getInfo("mng/channelaccount/valid/accountid?accountid=" + $scope.accountid);
        //         packPM.then(function(data) {
        //             if (data.content == false) {
        //                 $scope.checkID = false;
        //                 $scope.tip = {
        //                     accountid: {
        //                         status: false,
        //                         txt: ''
        //                     }
        //                 };
        //             } else {
        //                 $scope.checkID = true;
        //                 $scope.tip = {
        //                     accountid: {
        //                         status: true,
        //                         txt: $translate.instant('该账号id已被绑定到其他渠道账号，请到对应账号进行修改')
        //                     }
        //                 };
        //             }
        //         });
        //     }
        // }
        
        $scope.accountAuthorization = function() {
            var par = {
                name: $scope.state,
                alias: $scope.alias
                // thirdAccountCode: $scope.accountid  // 点击授权删除参数
            };
            var savePM = null;
            savePM = HttpService.postInfo("mng/channelaccount/authorize", par);
            savePM.then(function(data) {
                $scope.aliasID = data.id;
            });
        }

        $scope.saveOne = function() {
            $scope.saveTwo();
            $scope.nextStep();
        }

        //汉字、数字、字母、下划线，下划线 
        $scope.checkAliasName = function(aliasName) {
            var reg = /^([a-z_A-Z-.+0-9\u4e00-\u9fa5]+)$/gi;
            if (!reg.test(aliasName) || aliasName == undefined) {
                return false;
            }
            return true;
        }
        $scope.strlen = function(str) {
                var len = 0;
                for (var i = 0; i < str.length; i++) {
                    var c = str.charCodeAt(i);
                    //单字节加1
                    if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
                        len++;
                    } else {
                        len += 2;
                    }
                }
                return len;
            }
            //第二步
        $scope.saveTwo = function() {
            if ($scope.checkAlias == undefined || $scope.checkAlias == false) {
                $scope.exixtAlias();
            }
            if ($scope.checkAlias == false) {
                return false;
            }
            if ($scope.aliasID == null || $scope.aliasID == undefined || $scope.aliasID == "") {
                $scope.aliasID = $scope.id
            }
            var parmas = {
                alias: $scope.alias,
                rebate: $scope.rebate,
                id: $scope.aliasID
            };

            var verParmas = {
                alias: {
                    key: 'isNull',
                    val: $scope.alias
                }
            }
            $scope.tip = formJudge(verParmas);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }

            if ($scope.checkAlias == true) {
                var savePM = null;
                savePM = HttpService.putInfo("mng/channelaccount/alias", parmas);
                savePM.then(function(data) {
                    if (data.id != null) {
                        $scope.createID = data.id;
                    }
                });

            }
        }
        $scope.promiseF = function() {
            return new Promise(function(resolve, reject) {
                var checkAlias = $scope.checkAliasName($scope.alias);
                if (checkAlias == false) {
                    $scope.tip = {
                        alias: {
                            status: true,
                            txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                        }
                    };
                    return false;
                }
                // var strlen = $scope.strlen($scope.alias)
                // if (strlen > 16) {
                //     $scope.tip = {
                //         alias: {
                //             status: true,
                //             txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                //         }
                //     };
                //     return false;
                // }
                if (oldalias == $scope.alias) {
                    $scope.checkAlias = true;
                    
                } else {
                    if ($scope.alias == "" || $scope.alias == undefined) {
                        return false;
                    }
                    var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
                    packPM.then(function(data) {
                        if (data.content == false) { //为true时说明名称已经存在
                            $scope.checkAlias = true;
                            $scope.tip = {
                                alias: {
                                    status: false,
                                    txt: ''
                                }
                            };
                            resolve();
                            
                        } else {
                            $scope.tip = {
                                alias: {
                                    status: true,
                                    txt: $translate.instant('该渠道账号别名已经被占用')
                                }
                            };
                        }
                    });
                }
            })
        }
        $scope.exixtAlias = function() {
            $scope.checkAlias = false;
            var checkAlias = $scope.checkAliasName($scope.alias);
            if (checkAlias == false) {
                $scope.tip = {
                    alias: {
                        status: true,
                        txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                    }
                };
                return false;
            }

            var strlen = $scope.strlen($scope.alias)
            if (strlen > 16) {
                $scope.tip = {
                    alias: {
                        status: true,
                        txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                    }
                };
                return false;
            }


            if (oldalias == $scope.alias) {
                $scope.checkAlias = true;
            } else {
                if ($scope.alias == "" || $scope.alias == undefined) {
                    return false;
                }
                var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
                // var packPM = HttpService.getInfo("mng/channelaccount/valid?name="+$scope.alias);
                packPM.then(function(data) {
                    if (data.content == false) { //为true时说明名称已经存在
                        $scope.checkAlias = true;
                        $scope.tip = {
                            alias: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.tip = {
                            alias: {
                                status: true,
                                txt: $translate.instant('该渠道账号别名已经被占用')
                            }
                        };
                    }
                });
            }
        }

        //第三步
        var rmd = new Date().getTime();
        $scope.productList = function() {
                var savePM = null;
                if ($scope.createID == null || $scope.createID == undefined) {
                    $scope.createID = $scope.id;
                }
                //savePM = HttpService.getInfo("mng/channelaccount/app/list?accountid="+$scope.accountid);
                savePM = HttpService.getInfo("mng/channelaccount/" + $scope.createID + "/app/list?linkuserid=" + $scope.createID + "&unique_name=gdt");
                savePM.then(function(data) {
                    $scope.dayList = data;
                    $scope.appnameInit = data[0].id;
                    $scope.$on("appname", function(e, msg) {
                        $scope.appname = msg.info.id;
                        $scope.appType = msg.info.platform;
                        $scope.appkey = msg.info.appkey;
                        if ($rootScope.channeluniqueName = 'gdt') {
                            $scope.isOpenGdtCampaign(5305, $scope.appname); //广点通ID
                        }
                    });
                });
                $scope.datafresh = ++rmd;
            }
            /**
             * 判断产品下是否有启动的‘广点通’推广活动
             * @param channelId
             * @param appId
             */
        $scope.isOpenGdtCampaign = function(channelId, appId) {
            var pm = HttpService.getInfo("mng/campaign/checkCamValid?channelid=" + channelId + "&appid=" + appId);
            pm.then(function(data) {
                // data.activeCampaign = true;
                $scope.activeCampaign = data.activeCampaign;
            });
        }

        $scope.tableList = function() {
            var savePM = null;
            if ($scope.createID == null || $scope.createID == undefined) {
                $scope.createID = ($scope.id ? $scope.id : $scope.aliasID);
            }
            savePM = HttpService.getInfo("mng/channelaccount/app/find/" + $scope.createID);
            savePM.then(function(data) {
                $scope.tableData = data;
            });
        }




        $scope.$watch("stepflag", function(n) {
            if (angular.isDefined(n)) {
                if ($scope.stepflag == 1) {
                    $scope.tableList(); //回显绑定的产品

                }
            }
        });

        //监测appname
        $scope.$watch("appname", function(n) {
            $scope.nodata();
        });

        $scope.nodata = function() {
            $scope.isDisable = true;
            $scope.createType = 'noadd';
            $scope.thirdAppId = "";
            var str = '';
            if($scope.thirdAccountCode){
                if($scope.thirdAccountCode.indexOf(",") != -1){
                    $scope.isDisable = false;
                }
                str = $scope.thirdAccountCode.indexOf(",") != -1 ? '':$scope.thirdAccountCode
            }
            $scope.accountid = str;// 回显投放账号ID
            $scope.userActionSetId = "";
            $scope.tip = {
                thirdAppId: {
                    status: false
                }
            };
        }

        $scope.addType = false;
        $scope.addProduct = function() {
            if ($scope.createType == "inadd" || $scope.createType == "erroradd" || $scope.createType == "openadd") {
                ToolService.showTips($translate.instant("请先完成当前产品测试，再添加下一个产品。"));
            } else {
                $scope.userActionSetIdTxt = $translate.instant("点击右侧按钮获取行为数据源ID");
                $scope.createType = "openadd";
                $scope.addType = true;
                $scope.productList();
            }
        }
        $scope.closeProduct = function() {
            $scope.addType = false;
            $scope.nodata();
        }

        //获取行为数据源ID
        $scope.getDmpCode = function() {
            var par = {
                thirdAppId: $scope.thirdAppId,
                linkUserId: $scope.createID,
                appName: $scope.appname,
                appType: $scope.appType,
                accountId: $scope.accountid,
                // channelid:5305,
            };
            var verPar = {
                thirdAppId: {
                    key: 'isNull',
                    val: par.thirdAppId
                },
                accountid: {
                    key: 'num',
                    val: par.accountId,
                    txt: $translate.instant('合法性为仅支持输入数字，长度不限')
                }
            }
            if (!$scope.id) {
                par.channelid = 5305;
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null;
            ToolService.showLoading();
            savePM = HttpService.postInfo("mng/channelaccount/userid/create", par);
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (data.data != null || data.data != undefined) {
                    $scope.userActionSetId = data.data;
                    $scope.userActionSetIdTxt = "";
                } else {
                    $scope.tip = {
                        thirdAppId: {
                            status: true,
                            txt: data.msg || data.message
                        }
                    };
                }
            });
        }
        $scope.$on('appname', function(e, msg) {
            $scope.data = msg.info;
            $scope.app = $scope.data.id;
            $scope.name = $scope.data.name;
            $scope.platform = $scope.data.platform;
            $scope.url = $scope.data.url;
        });
        //生产feedback URL       
        $scope.createGdtUrl = function() {
            var par = {
                app: $scope.app,
                batchNumber: 1,
                channel: "5305",
                holderids: "",
                name: $scope.name,
                os: $scope.platform,
                url: $scope.url
            };
            urlPM = HttpService.postInfo("mng/campaign/" + $scope.app + "/creategdt", par);
            urlPM.then(function(data) {
                if (data.length > 0) {
                    $scope.surlList = data[0].surl;
                    $scope.surl = "http://uri6.com/tkio/" + $scope.surlList + "?noredirect=true"
                }
            })
        }


        //noadd未添加  openadd打开弹窗     inadd添加中    okadd添加成功    erroradd添加失败
        $scope.createType = "noadd";

        //连接测试
        $scope.testDmp = function() {
            var par = {
                thirdAppId: $scope.thirdAppId,
                appName: $scope.appname,
                appkey: $scope.appkey,
                userActionSetId: $scope.userActionSetId,
                linkUserId: $scope.createID,
                appType: $scope.appType,
                accountId: $scope.accountid
            };
            var verPar = {
                thirdAppId: {
                    key: 'isNull',
                    val: $scope.thirdAppId
                },
                accountid: {
                    key: 'num',
                    val: $scope.accountid,
                    txt: $translate.instant('合法性为仅支持输入数字，长度不限')
                },
                userActionSetId: {
                    key: 'isNull',
                    val: $scope.userActionSetId
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null;
            $scope.createType = "inadd";
            savePM = HttpService.postInfo("mng/channelaccount/app/create", par);
            savePM.then(function(data) {
                if (data.code == 0) {
                    $scope.createType = "okadd";
                    $scope.tableList();
                    $scope.closeProduct();
                    $scope.createGdtUrl();
                } else {
                    $scope.createType = "erroradd";
                    $scope.failureText = data.message;
                }
            });
        }



        //删除
        $scope.deletePro = function(obj) {
            $scope.delstatus = true;
            $scope.delId = obj.id;
        }
        $scope.removeInfo = function() {
            var removePM = HttpService.deleteInfo("mng/channelaccount/delete/app/" + $scope.delId);
            ToolService.showLoading();
            removePM.then(function(data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($translate.instant("删除成功"));
                $scope.tableList();
            });
        }

        //保存
        $scope.save = function() {
                $state.go("collect.channel", { aid: 'ry_coop' });
            }
            //转到推广活动管理
        $scope.goCampaign = function() {
            // $scope.$parent.appid = $scope.appname;
            $scope.$emit("mngappTo", $scope.appname);
            $state.go("collect.campaign");
        }

        //
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
                $scope.userActionSetIdTxt = $translate.instant("点击右侧按钮获取行为数据源ID");
            }
        });
    }

    function channelSmCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        $rootScope.channeluniqueName = 'smsearch';
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            var infoId = $scope.id = editInfo.id;
        }

        var oldalias = "";
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.alias = oldalias = editInfo.alias;
                $scope.name = editInfo.name;
                $scope.password = editInfo.password;
                //pastStatus   false为授权成功
                if (editInfo.pastStatus == false) {
                    $scope.step1 = 'success';
                } else {
                    $scope.step1 = 'failure';
                }
            }
        };
        $scope.init();

        var channelID = "";
        $scope.$watch("appid", function(n) {
            if (angular.isDefined(n)) {
                var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/smsearch");
                gdtPM.then(function(data) {
                    ToolService.hideLoading();
                    channelID = data.id;
                });
            }
        });

        $scope.cancel = function() {
            $state.go("collect.channel", { aid: editInfo });
        }

        $scope.exixtName = function() {
            if (oldalias == $scope.alias) {
                $scope.checkName = true;
            } else {
                if ($scope.alias == "" || $scope.alias == undefined) {
                    return false;
                }
                ToolService.showLoading();
                var packPM = HttpService.getInfo("mng/channelaccount/valid?name=" + $scope.alias);
                packPM.then(function(data) {
                    ToolService.hideLoading();
                    if (data == true) {
                        $scope.checkName = true;
                        $scope.tip = {
                            alias: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.checkName = false;
                        $scope.tip = {
                            alias: {
                                status: true,
                                txt: $translate.instant('该账号别名已存在，请更换。')
                            }
                        };
                    }
                });
            }
        }
        $scope.empowerType = false;
        $scope.empower = function() {
            if ($scope.checkName == false) {
                return false;
            }
            var par = {
                channel: channelID,
                alias: $scope.alias,
                name: $scope.name,
                password: $scope.password
            };
            var verPar = {
                alias: {
                    key: 'isNull',
                    val: par.alias
                },
                name: {
                    key: 'isNull',
                    val: par.name
                },
                password: {
                    key: 'isNull',
                    val: par.password
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            ToolService.showLoading();
            var savePM = null;
            if ($scope.id != null) {
                par.id = $scope.id;
                savePM = HttpService.putInfo("mng/channel/account/update", par);
            } else {
                savePM = HttpService.postInfo("mng/channel/account/create", par);
            }
            savePM.then(function(data) {
                ToolService.hideLoading();
                $scope.empowerType = true;
                $scope.id = $scope.empowerID = data.id;
                if($rootScope.redirectNewDoman){
                    window.open("https://e.sm.cn/auth/appAuthorize/authorizationRequest?response_type=code&state=" + $scope.empowerID + "&scope=1,2&redirect_uri=http://www.trackingio.com/api/third/getToken&client_id=434&client_secret=3e1bdcb210290c0668566e414373c8c3");
                }else{
                //腾讯云地址
                    window.open("https://e.sm.cn/auth/appAuthorize/authorizationRequest?response_type=code&state=" + $scope.empowerID + "&scope=1,2&redirect_uri=http://tweb.trackingio.com/api/third/getToken&client_id=431&client_secret=ae59ae4df9bea4f646a63c2d323d90bc");
                }

            });
        }
        $scope.failureAlert = false;
        $scope.empowerOK = function() {
            var savePM = null;
            savePM = HttpService.getInfo("mng/channel/account/checkstatus?id=" + $scope.empowerID);
            savePM.then(function(data) {
                $scope.empowerType = false;
                if (data == true) {
                    $scope.step1 = 'success';
                    ToolService.showTips($translate.instant("授权成功"));
                    $scope.cancel();
                } else {
                    $scope.step1 = 'failure';
                    $scope.failureAlert = true;
                }
            });
        }

        $scope.empowerError = function() {
            $scope.empowerType = false;
            $scope.pastStatus = true;
        }

        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });
    }

    function channelAdwordsCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $rootScope.editPower = true;
        } else {
            $rootScope.editPower = false;
        }
        $scope.stepflag = 1;
        $rootScope.channeluniqueName = 'adwords';
        var editInfo = $stateParams.aid;
        
        if (angular.isDefined(editInfo) && editInfo != null) {
            var infoId = $scope.id = editInfo.id;
            if (editInfo.step == 2) {
                $scope.stepflag = 2;
            }
        }
        var oldname = "";
        var oldthirdAccountCode = "";
        var oldalias = "";
        $scope.pastStatus = false;
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.name = oldname = editInfo.name;
                $scope.thirdAccountCode = oldthirdAccountCode = editInfo.thirdAccountCode;
                $scope.alias = oldalias = editInfo.alias;
            }
        };
        $scope.init();
        $scope.cancel = function() {
            $state.go("collect.channel", { aid: editInfo});
        }

        var channelID = "";
        $scope.$watch("appid", function(n) {
            if (angular.isDefined(n)) {
                var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/adwords");
                gdtPM.then(function(data) {
                    ToolService.hideLoading();
                    channelID = data.id;
                });
            }
        });

        //弹窗
        $scope.openDialog = function() {
            if ($rootScope.doMainType == 0) {
                window.open($rootScope.docDomain+"Adwords.html");
            } else if ($rootScope.doMainType == 1) {
                window.open($rootScope.otherCompanyInfo.adwordsDocUrl)
            }
        }

        $scope.saveOne = function() {
            //$scope.stepflag = 2;
            var par = {
                channel: channelID,
                alias: $scope.alias,
                name: $scope.name,
                thirdAccountCode: $scope.thirdAccountCode
            };
            var verPar = {
                alias: {
                    key: 'spcname',
                    max: 40,
                    val: $scope.alias,
                    txt: $translate.instant("含非法字符或过长（支持输入汉字、大小写字母、数字、下划线、中划线，长度限制40字符以内）")
                },
                name: {
                    key: 'isNull',
                    val: $scope.name
                },
                thirdAccountCode: {
                    key: 'isNull',
                    val: $scope.thirdAccountCode
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            var savePM = null;
            if ($scope.id != null) {
                par.id = $scope.id;
                savePM = HttpService.putInfo("mng/channel/account/update", par);
            } else {
                savePM = HttpService.postInfo("mng/channel/account/create", par);
            }
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (data.code == -5002) {
                    $scope.tip = {
                        alias: {
                            status: true,
                            txt: data.message
                        }
                    };
                } else if (data.code == -5003) {
                    $scope.tip = {
                        thirdAccountCode: {
                            status: true,
                            txt: data.message
                        }
                    };
                } else {
                    $scope.createID = $scope.aliasID = data.id;
                    $scope.stepflag = $scope.stepflag + 1;
                }
            });
        }

        $scope.lastStep = function() {
            $scope.stepflag = $scope.stepflag - 1;
        }


        var rmd = new Date().getTime();
        var currentAccountId = UtilService.getCookie("ryioUid");
        var rootParentDl = UtilService.getCookie("rootParent");
        $scope.productList = function() {
            var savePM = null;
            if ($scope.createID == null || $scope.createID == undefined) {
                $scope.createID = $scope.id;
            }
            //应用列表
            savePM = HttpService.getInfo("mng/channelaccount/" + $scope.createID + "/app/list?linkuserid=" + $scope.createID + "&unique_name=adwords");
            savePM.then(function(data) {
                $scope.dayListALL = data;
                $scope.dayList = $scope.dayListALL.filter(function(item) {
                    return item.platform == 'iOS' || ((currentAccountId=='19059'||rootParentDl=='19059')?item.platform == 'Android':false);//滴滴用户及子账号可以看见Android 其他不可以
                })
                $scope.appnameInit = $scope.dayList[0].id;
                $scope.$on("appname", function(e, msg) {
                    $scope.appname = msg.info.id;
                    $scope.appType = msg.info.platform;
                    $scope.appkey = msg.info.appkey;
                });
            });
            $scope.datafresh = ++rmd;
        }

        //已保存产品列表  adwords
        $scope.tableList = function() {
            var savePM = null;
            if ($scope.createID == null || $scope.createID == undefined) {
                $scope.createID = $scope.id;
            }
            savePM = HttpService.getInfo("mng/channelaccount/app/find/" + $scope.createID);
            savePM.then(function(data) {
                $scope.tableData = data;
            });
        }

        $scope.$watch("stepflag", function(n) {
            if (angular.isDefined(n)) {
                if ($scope.stepflag == 2) {
                    $scope.tableList();
                }
            }
        });

        //监测appname
        $scope.$watch("appname", function(n) {
            $scope.nodata();
        });
        $scope.nodata = function(num) {
            if (num == 1) {
                $scope.createType = 'noadd';
            }
            $scope.userActionSetId = "";
            $scope.tip = {
                userActionSetId: {
                    status: false,
                    txt: ''
                }
            };
        }

        //添加和关闭
        $scope.addType = false;
        $scope.addProduct = function() {
            if ($scope.createType == "inadd" || $scope.createType == "erroradd" || $scope.createType == "openadd") {
                ToolService.showTips($translate.instant("请先完成当前产品测试，再添加下一个产品。"));
            } else {
                $scope.createType = "openadd";
                $scope.addType = true;
                $scope.productList();
            }
        }
        $scope.closeProduct = function() {
            $scope.addType = false;
            $scope.nodata(1);
        }

        //检测linkid
        /*$scope.checkLinkID = false;
        $scope.exixtLinkId = function(){
            var par = {
                linkUserId: $scope.createID,
                channel: channelID,
                fieldkey: 'linkid',
                fieldvalue: $scope.userActionSetId
            };
            var verPar = {
                fieldvalue: {
                    key: 'isNull',
                    val: par.fieldvalue
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            var packPM = HttpService.getInfo("mng/channelaccount/109/app/checkname",par);
            packPM.then(function(data){
                ToolService.hideLoading();
                if(data == true){
                    $scope.checkLinkID = true;
                    $scope.tip = {
                        userActionSetId:{
                            status:false,
                            txt:''
                        }
                    };
                }else{
                    $scope.checkLinkID = false;
                    $scope.tip = {
                        userActionSetId:{
                            status:true,
                            txt:$translate.instant('该LinkID已存在，请更换。')
                        }
                    };
                }
            });
        }*/

        //noadd未添加  openadd打开弹窗     inadd添加中    okadd添加成功    erroradd添加失败
        $scope.createType = "noadd";
        //连接测试
        $scope.testDmp = function() {
            /*if($scope.checkLinkID == false){
                return false;
            }*/
            var par = {
                appName: $scope.appname,
                appkey: $scope.appkey,
                userActionSetId: $scope.userActionSetId,
                linkUserId: $scope.createID,
                appType: $scope.appType
            };
            var verPar = {
                userActionSetId: {
                    key: 'isNull',
                    val: par.userActionSetId
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null;
            $scope.createType = "inadd";
            savePM = HttpService.postInfo("mng/channelaccount/" + $scope.createID + "/app/create", par);
            savePM.then(function(data) {
                if (data.id != undefined) {
                    $scope.createType = "okadd";
                    // $scope.checkLinkID = false;
                    $scope.tableList();
                    $scope.closeProduct();
                } else {
                    $scope.createType = "erroradd";
                    $scope.failureText = data.message;
                }
            });
        }

        //删除
        $scope.deletePro = function(obj) {
            $scope.delstatus = true;
            $scope.delId = obj.id;
        }
        $scope.removeInfo = function() {
            var removePM = HttpService.deleteInfo("mng/channelaccount/delete/app/" + $scope.delId);
            ToolService.showLoading();
            removePM.then(function(data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($translate.instant("删除成功"));
                $scope.tableList();
            });
        }

        //保存
        $scope.save = function() {
                if ($scope.createType == "openadd") {
                    ToolService.showTips($translate.instant("请先完成当前产品测试"));
                } else if ($scope.createType == "erroradd") {
                    ToolService.showTips($translate.instant("link_ID有误，请重新测试"));
                } else {
                    $state.go("collect.channel", { aid: 'ry_coop' });
                }
            }
            /**
             * 语言切换
             */
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });
    }

    function channelToutiaoCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        $scope.cancel = function() {
            $state.go("collect.channel");
        }
        $scope.showItem = true;
        $scope.getCount = function(){
           var countPM = HttpService.getInfo("mng/channelaccount/checkToutiaoNum");
           countPM.then(function(data){
            $scope.showItem = data.status;
            if(data.toutiaoCount){
                $scope.toutiaoCount = data.toutiaoCount
            }
           })
        }
        // $scope.getCount();
        $scope.authStatus = '';
        $scope.saveAuthorize = function(flag){
            $scope.authStatus = '';
            var verPar = {
                aliasName: {
                    key: 'spcname',
                    val: $scope.aliasName,
                    txt: $translate.instant("仅支持输入汉字、大小写字母、数字、下划线、中划线，长度限制40字符以内")
                },
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            var aliasPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.aliasName);
            aliasPM.then(function(data) {
                if(flag == 1){
                    if(data.content == false){
                        $scope.authStatus = 'failure';
                    }else{
                        $scope.authStatus = 'success';
                    }
                }else{
                    if (data.content == false) { //true 表示名称已经存在 
                        $scope.tip = {
                            aliasName: {
                                status: false,
                                txt: ''
                            }
                        };
                        if($rootScope.redirectNewDoman){
                            window.open("https://ad.oceanengine.com/openapi/audit/oauth.html?app_id=1653688605754372&state="+$scope.aliasName+"&redirect_uri=http%3A%2F%2Fwww.trackingio.com%2Findex.html%23%2Fmanage%2Fchannel");
                        }else{
                            window.open("https://ad.oceanengine.com/openapi/audit/oauth.html?app_id=1673612651270147&state="+$scope.aliasName+"&redirect_uri=http%3A%2F%2Ftweb.trackingio.com%2Findex.html%23%2Fmanage%2Fchannel");
                        }
                        $scope.empowerType = true;
                    } else {
                        $scope.tip = {
                            aliasName: {
                                status: true,
                                txt: $translate.instant('该渠道账号别名已经被占用')
                            }
                        };
                    }
                }
                
            });
        }
        $scope.empowerTtError = function() {
            $scope.empowerType = false;
        }
        $scope.empowerTtOK = function() {
            $scope.empowerType = false;
            $scope.saveAuthorize(1)
        }
    }

    function channelBaiduCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        $rootScope.channeluniqueName = 'baiduysgg';
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            var infoId = $scope.id = editInfo.id;
        }
        var oldalias = "";
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.alias = oldalias = editInfo.alias;
                $scope.name = editInfo.name;
                $scope.password = editInfo.password;
                $scope.accessToken = editInfo.accessToken;
            }
        };
        $scope.init();

        $scope.cancel = function() {
            $state.go("collect.channel", { aid: editInfo });
        }
        
        $scope.exixtName = function() {
            if (oldalias == $scope.alias) {
                $scope.checkName = true;
            } else {
                if ($scope.alias == "" || $scope.alias == undefined) {
                    return false;
                }
                ToolService.showLoading();
                var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
                packPM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.content == false) {
                        $scope.checkName = true;
                        $scope.tip = {
                            alias: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.checkName = false;
                        $scope.tip = {
                            alias: {
                                status: true,
                                txt: $translate.instant('该账号别名已存在，请更换。')
                            }
                        };
                    }
                });
            }
        }

        $scope.empowerType = false;
        $scope.failuretip = '';
        $scope.empower = function() {
            if ($scope.checkName == false) {
                return false;
            }
            var par = {
                alias: $scope.alias,
                name: $scope.name,
                password: $scope.password,
                accessToken: $scope.accessToken
            };
            var verPar = {
                alias: {
                    key: 'isNull',
                    val: par.alias
                },
                name: {
                    key: 'isNull',
                    val: par.name
                },
                password: {
                    key: 'isNull',
                    val: par.password
                },
                accessToken: {
                    key: 'isNull',
                    val: par.accessToken
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            ToolService.showLoading();
            var savePM = null;
            if ($scope.id != null) {
                par.id = $scope.id;
                savePM = HttpService.postInfo("mng/channelaccount/updateByBaidu", par);
            } else {
                savePM = HttpService.postInfo("mng/channelaccount/createByBaidu", par);
            }
            savePM.then(function(data) {
                ToolService.hideLoading();
                if(data == 'SUCCESS') {
                    $state.go("collect.channel", { aid: true });
                } else {
                    $scope.failuretip = data.message;
                    $scope.empowerType = true;
                }
            });
        }
        
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });
    }

    function channelKuaishouCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        $rootScope.channeluniqueName = 'kuaishou';
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            var infoId = $scope.id = editInfo.id;
        }
        var oldalias = "";
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.alias = oldalias = editInfo.alias;
                $scope.name = editInfo.name;
                $scope.password = editInfo.password;
                $scope.refreshToken = editInfo.refreshToken;
            }
        };
        $scope.init();

        $scope.cancel = function() {
            $state.go("collect.channel", { aid: editInfo });
        }
        
        $scope.exixtName = function() {
            if (oldalias == $scope.alias) {
                $scope.checkName = true;
            } else {
                if ($scope.alias == "" || $scope.alias == undefined) {
                    return false;
                }
                ToolService.showLoading();
                var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
                packPM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.content == false) {
                        $scope.checkName = true;
                        $scope.tip = {
                            alias: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.checkName = false;
                        $scope.tip = {
                            alias: {
                                status: true,
                                txt: $translate.instant('该账号别名已存在，请更换。')
                            }
                        };
                    }
                });
            }
        }

        $scope.empowerType = false;
        $scope.failuretip = '';
        $scope.empower = function() {
            // if ($scope.checkName == false) {
            //     return false;
            // }
            var par = {
                alias: $scope.alias,
                name: $scope.name,
                password: $scope.password,
                refreshToken: $scope.refreshToken
            };
            var verPar = {
                alias: {
                    key: 'isNull',
                    val: par.alias
                },
                name: {
                    key: 'isNull',
                    val: par.name
                },
                password: {
                    key: 'isNull',
                    val: par.password
                },
                refreshToken: {
                    key: 'isNull',
                    val: par.refreshToken
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            ToolService.showLoading();
            var savePM = null;
            if ($scope.id != null) {
                par.id = $scope.id;
                savePM = HttpService.postInfo("mng/channelaccount/updateByKuaishou", par);
            } else {
                savePM = HttpService.postInfo("mng/channelaccount/createByKuaishou", par);
            }
            savePM.then(function(data) {
                ToolService.hideLoading();
                if(data == 'SUCCESS') {
                    $state.go("collect.channel", { aid: true });
                } else {
                    $scope.failuretip = data.message;
                    $scope.empowerType = true;
                }
            });
        }
        
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });
    }
    function channelWeixinmpCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        $rootScope.channeluniqueName = 'weixinmp';
        $scope.cancel = function() {
            $state.go("collect.channel");
        }
        $scope.authStatus = '';
        $scope.saveAuthorize = function(flag){
            $scope.authStatus = '';
            var verPar = {
                aliasName: {
                    key: 'spcname',
                    val: $scope.aliasName,
                    txt: $translate.instant("仅支持输入汉字、大小写字母、数字、下划线、中划线，长度限制40字符以内")
                },
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            var aliasPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.aliasName);
            aliasPM.then(function(data) {
                if (data.content == false) { //true 表示名称已经存在 
                    $scope.tip = {
                        aliasName: {
                            status: false,
                            txt: ''
                        }
                    };
                    if($rootScope.redirectNewDoman){
                        window.open("https://developers.e.qq.com/oauth/authorize?client_id=1106237187&redirect_uri=http://www.trackingio.com/api/mng/channelaccount/createByWeixinMP&state=" + $scope.aliasName+"&account_type=ACCOUNT_TYPE_WECHAT");
                    }else{
                        window.open("https://developers.e.qq.com/oauth/authorize?client_id=1110744256&redirect_uri=http://tweb.trackingio.com/api/mng/channelaccount/createByWeixinMP&state=" + $scope.aliasName+"&account_type=ACCOUNT_TYPE_WECHAT");
                    }
                    $scope.empowerType = true;
                } else {
                    $scope.tip = {
                        aliasName: {
                            status: true,
                            txt: $translate.instant('该渠道账号别名已经被占用')
                        }
                    };
                }
                
            });
        }
        $scope.empowerTtOK = function() {
            $scope.empowerType = false;
            var aliasPM = HttpService.getInfo("mng/channelaccount/checkWeixinMP?alias=" + $scope.aliasName);
            aliasPM.then(function(data) {
                $scope.authStatus = 'success';
                $state.go("collect.channel", { aid: true });
            },function(err){
                $scope.authStatus = 'failure';
            });
        }
    }
})();