(function() {
    angular.module("app.manage")
        .controller("dataCallbackCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$stateParams", "$filter", "$translate", dataCallbackCtrl])

        function dataCallbackCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$state,$stateParams,$filter,$translate){
            // 表格查询
            $scope.query = function() {
                ToolService.showLoading();
                var list = HttpService.getInfo("mng/cpcallback/list");
                list.then(function(data){
                    ToolService.hideLoading();
                    $scope.dataCallbackList = data;
                })

            }
            // 新建回调
            $scope.addCallback = function(info){
                if (angular.isDefined(info)) {
                    $state.go("collect.addDataCallback", { aid: info });
                } else {
                    $state.go("collect.addDataCallback");
                }
            }
            $scope.close = function(){
                ToolService.hideAlp();
               }
            $scope.doRemove = function(info){
                $scope.openStatus = true
                $scope.openAndClose= info.status
                $scope.openId= info.id
                $scope.openServerName= info.name
                ToolService.showAlp();
               }
               $scope.openSure = function(){
                // status=0关闭  status=1开启
                var status = 1
                if($scope.openAndClose == 1){
                    status = 0
                }
                ToolService.hideAlp();
                let par = {
                    id: $scope.openId,
                    status: status
                }
                var drPM = HttpService.postInfo("mng/cpcallback/status", par);
                drPM.then(function(data){
                    $scope.query();
                })
               }

            $scope.query()
            var rmd = new Date().getTime();
            $scope.$on('flipinfo', function (e, msg) {
                $scope.flipPage = msg;
                $scope.fixrefresh = ++rmd;
            });
            }
})();
