(function(){
    angular.module("app.manage")
        .controller("downloadurlCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$filter",downloadurlCtrl]);

    function downloadurlCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$filter){
        $scope.infoFlag = 1;
        $scope.query = function(){
            $scope.curEditId = -1;
            if($scope.infoFlag>1 && $scope.urlInfos == null){
                $scope.infoFlag = 1;
            }
            switch($scope.infoFlag){
                case 2://推广活动
                    urllistPM = HttpService.postInfo("mng/campaign/downloadurl/find/campaign/"+$scope.appid,{url:$scope.urlInfos.url});
                    break;
                case 3://子活动
                    urllistPM = HttpService.postInfo("mng/campaign/subcampaign/downloadurl/find/"+$scope.appid,{url:$scope.urlInfos.url});
                    break;
                default:
                    urllistPM = HttpService.getInfo("mng/campaign/downloadurl/find/"+$scope.appid);
            }
           
            ToolService.showLoading();
            urllistPM.then(function(data){
                ToolService.hideLoading();
                if($scope.infoFlag==2||$scope.infoFlag==3){
                    $scope.campList = data;
                }
                else{
                    $scope.infoList = data;
                }
            });
        }
        $scope.editUrlModal = false;
        $scope.editUrl = function(info,num){
            if(num=='1'){
                $scope.infoFlag = 4;
                $scope.urlInfos = info;
                $scope.editDownUrlObj.getCampaignList();
                $scope.editDownUrlObj.getSubCampaignList();
                $scope.editDownUrlObj.form.newUrl = '';
                $scope.editDownUrlObj.form.urlName = '';
                $scope.editDownUrlObj.form.campaings = [];
                $scope.editDownUrlObj.searchTxt = '';
                $scope.editDownUrlObj.searchTxt2 = '';
                $scope.editDownUrlObj.type = 1;
                $scope.editDownUrlObj.type2 = 1;
                $scope.editDownUrlObj.isCheckAll = false;
                $scope.editDownUrlObj.isCheckAll2 = false;
                $scope.editDownUrlObj.checked1Num = 0;
                $scope.editDownUrlObj.checked1Num = 0;
                $scope.tip = {};
                /*$scope.curEditId = info.url;
                info.reurl = info.url;*/
            }else if(num=='2'){
                $scope.curEditId = info.url+'Name';
                info.newUrlName = info.urlName;
            }

        }
        $scope.saveUrlName = function(info){
            if(info.urlName==info.newUrlName){
                $scope.curEditId = -1;
                ToolService.showTips($filter('translate')("修改前后下载地址名称相同，系统将不会做修改。"));
            }else{
                ToolService.showLoading();
                var namePM = HttpService.postInfo("mng/campaign/downloadurl/modifyname",{campaignId:info.campaignId,tabType:info.tabType,urlName:info.newUrlName});
                namePM.then(function(data){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("修改成功"));
                    $scope.query();
                });
            }
        };
        $scope.saveUrl = function(info){
            if(info.url == info.reurl){
                $scope.curEditId = -1;
                ToolService.showTips($filter('translate')("修改前后下载地址相同，系统将不会做修改。"));
                return false;
            }
            if(info.reurl==''){
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            }
            var verPar = {
                reurl: {
                    key: 'url',
                    val: info.reurl
                }
            };

            $scope.tip = formJudge(verPar);
            if($scope.tip.succ == true){
                $scope.hasExists = $scope.infoList.filter(function(item){
                    return item.url == info.reurl;
                });
                $scope.updateObjs = info;
                ToolService.showAlp();
                $scope.doUpdate = true;
            }
            else{
                ToolService.showTips($scope.tip.reurl.txt);
            }
        }
        $scope.closeUpdate = function(){
            ToolService.hideAlp();
            $scope.doUpdate = false;
            $scope.curEditId = -1;
        }
        $scope.doUpdateUrl = function(){
            ToolService.showLoading();
            $scope.closeUpdate();
            var namePM = HttpService.putInfo("mng/campaign/downloadurl/update/"+$scope.appid,{url:$scope.updateObjs.url,newUrl:$scope.updateObjs.reurl});
            namePM.then(function(data){
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("修改成功"));
                $scope.query();
            });
        }
        
        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.appid)){
                $scope.urlInfos = null;
                $scope.query();
            }
        });
        $scope.changeFlagList = function(flag){
            $scope.infoFlag = flag;
            $scope.query();
        }
      
        $scope.$on('flipinfo',function(e,msg){
            if(msg.listkey == 'camptab'){
                $scope.flipPage2 = msg;
            }
            else{
                $scope.flipPage = msg;
            }
        });


        $scope.goList = function(info){
            $scope.urlInfos = info;
            $scope.changeFlagList(2);
        }
        $scope.editDownUrlObj = {
            searchTxt:'',
            searchTxt2:'',
            type:1,
            type2:1,
            isCheckAll:false,
            isCheckAll2:false,
            checked1Num:0,
            checked2Num:0,
            campaignList:[],
            subCampaignList:[],
            form:{
                newUrl:'',
                urlName:'',
                campaings:[]
            },
            getCampaignList:function () {
                campaignListPM = HttpService.postInfo("mng/campaign/downloadurl/find/campaign/"+$scope.appid,{url:$scope.urlInfos.url});
                campaignListPM.then(function(data){
                    // ToolService.hideLoading();
                    $scope.editDownUrlObj.campaignList = data;
                });
            },
            getSubCampaignList:function () {
                subCampaignListPM = HttpService.postInfo("mng/campaign/subcampaign/downloadurl/find/"+$scope.appid,{url:$scope.urlInfos.url});
                subCampaignListPM.then(function(data){
                    // ToolService.hideLoading();
                    $scope.editDownUrlObj.subCampaignList = data;
                });
            },
            checkAll:function () {
                if (this.campaignList.length==0){
                    return
                }
                if (this.isCheckAll == false){
                    this.isCheckAll = true;
                    this.campaignList.filter(function (value) {
                        value.ischeck = true
                    });
                    this.checked1Num = this.campaignList.length
                } else {
                    this.isCheckAll = false;
                    this.campaignList.filter(function (value) {
                        value.ischeck = false
                    });
                    this.checked1Num = 0
                }
            },
            checkAll2:function () {
                if (this.subCampaignList.length==0){
                    return
                }
                if (this.isCheckAll2 == false){
                    this.isCheckAll2 = true;
                    this.subCampaignList.filter(function (value) {
                        value.ischeck = true
                    });
                    this.checked2Num = this.subCampaignList.length
                } else {
                    this.isCheckAll2 = false;
                    this.subCampaignList.filter(function (value) {
                        value.ischeck = false
                    });
                    this.checked2Num = 0
                }
            },
            selectInfo:function (info,num) {
                info.ischeck = !info.ischeck;
                if (num==2){
                    this.checkSelectAll2();
                } else {
                    this.checkSelectAll();
                }
            },
            checkSelectAll:function(){
                this.checked1Num = this.campaignList.filter(function (value) {
                    return value.ischeck == true
                }).length;
                if (this.campaignList.length == this.checked1Num){
                    this.isCheckAll = true;
                } else {
                    this.isCheckAll = false;
                }
            },
            checkSelectAll2:function(){
                this.checked2Num = this.subCampaignList.filter(function (value) {
                    return value.ischeck == true
                }).length;
                if (this.subCampaignList.length == this.checked2Num){
                    this.isCheckAll2 = true;
                } else {
                    this.isCheckAll2 = false;
                }
            },
            filterAllCheck:function () {
                var that = this;
                this.campaignList.filter(function (value) {
                    if(value.campaignName.indexOf(that.searchTxt)>-1&&that.type==1){
                        value.ischeck = true
                    }
                });
                this.checkSelectAll();
            },
            filterAllCancel:function () {
                var that = this;
                this.campaignList.filter(function (value) {
                    if(value.campaignName.indexOf(that.searchTxt)>-1){
                        value.ischeck = false
                    }
                });
                this.checkSelectAll();
            },
            filterAllCheck2:function () {
                var that = this;
                this.subCampaignList.filter(function (value) {
                    if(value.subCampaignName.indexOf(that.searchTxt2)>-1&&that.type2==1){
                        value.ischeck = true
                    }
                });
                this.checkSelectAll2();
            },
            filterAllCancel2:function () {
                var that = this;
                this.subCampaignList.filter(function (value) {
                    if(value.subCampaignName.indexOf(that.searchTxt2)>-1){
                        value.ischeck = false
                    }
                });
                this.checkSelectAll2();
            },
            changeType:function (type,num) {
                if (num==2){
                    this.type2 = type
                } else {
                    this.type = type;
                }
            },
            save:function () {
                var verPar = {
                    newUrl: {
                        key: 'url',
                        val: this.form.newUrl
                    }
                };
                $scope.tip = formJudge(verPar);
                if($scope.tip.succ != true){
                    ToolService.showTips($filter('translate')("信息没填全或数据格式有误，请检查"));
                    return false;
                }
                var arr = [],arr1 = [],arr2=[];
                this.campaignList.forEach(function (value) {
                    if (value.ischeck){
                        arr1.push({
                            campaignId:value.campaignId,
                            tabType:value.tabType
                        })
                    }
                });
                this.subCampaignList.forEach(function (value) {
                    if (value.ischeck){
                        arr2.push({
                            subCampaignId:value.subCampaignId,
                            tabType:value.tabType
                        })
                    }
                });
                arr = UtilService.merge(arr1,arr2);
                if (arr.length==0){
                    ToolService.showTips($filter('translate')("请选择活动"));
                    return false;
                }
                this.form.campaings = arr;
                savePM = HttpService.putInfo("mng/campaign/downloadurl/update/"+$scope.appid+"/campainids",this.form);
                savePM.then(function(data){
                    $scope.changeFlagList(1);
                });
            }
        }
    }
 
})();
        