(function(){
    angular.module("app.manage")
        .controller("exportsettingCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$http","$timeout","$filter",exportsettingCtrl]);

    function exportsettingCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$http,$timeout,$filter){
        //回显展示监测链接
        $scope.$watch("appid", function(n) {
            if (angular.isDefined(n)) {
                $scope.getExportCampaign();
            }
        });
        $scope.status = 0
        $scope.getExportCampaign = function(){
            ToolService.showLoading();
            var exPM = HttpService.getInfo("mng/campaign/" + $scope.appid + "/getExportCampaignConfig");
            exPM.then(function(data) {
                ToolService.hideLoading();
                if(data === true){
                    $scope.status = 1;
                }else{
                    $scope.status = 0;
                }
            })
        }
        $scope.setStatus = function(flag){
            $scope.status = flag;
        }
        
        $scope.save = function(){
            var confPM = HttpService.getInfo("mng/campaign/" + $scope.appid +"/"+ $scope.status + "/controlExportCampaignConfig");
            confPM.then(function(data){
                $scope.goPage('collect.campaign');
            })
        }
    }
})();
        