(function(){
    angular.module("app.manage")
        .controller("subcampaignlistCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$state","$stateParams","$timeout","$location","$filter",subcampaignlistCtrl])
        .controller("subcampaignlistDetailCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$state","$stateParams","$http","$timeout","$filter",subcampaignlistDetailCtrl]);

    function subcampaignlistCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$state,$stateParams,$timeout,$location,$filter){
        //判断从哪个url过来    campaign    subpackage
        $scope.fromUrl = $rootScope.campaignUrl;

        $scope.campChannel = $rootScope.campChannel;
        if(UtilService.isNullStr($scope.campChannel)){
            $scope.goPage('collect.campaign');
            return false;
        }
        $scope.channType = $rootScope.campaignChannType;
        var rmd = new Date().getTime();
        $scope.subcampaignTypeList = [
            { id: "", name: $filter('translate')("不筛选分包子活动类型") },
            { id: "1", name: $filter('translate')("新客获取分包子活动") },
            { id: "2", name: $filter('translate')("再营销分包子活动") }
        ];
        $scope.subcampaignTypeInit = $scope.subcampaignTypeList[0].id;
        $scope.$on("subcampaignTypeId",function(e,msg){
            $scope.subcampaignId = msg.info.id;
            if($scope.campaignListCope){
              if ($scope.subcampaignId != '1' && $scope.subcampaignId != '2'){
                $scope.campaignList = $scope.campaignListCope;
              }else {
                $scope.campaignList = $scope.campaignListCope.filter(function(item) {
                if ($scope.subcampaignId == '1') {
                          return !item.deeplink;
                      }else if($scope.subcampaignId == '2'){
                        return item.deeplink;
                    }
                  });
              }
            }
        });

        $scope.deviceList = [
            {id:1,name:$filter('translate')("已启用")},
            {id:2,name:$filter('translate')("已停用")}
        ];
        $scope.deviceInit = $scope.deviceList[0].id;
        $scope.$on("deviceId",function(e,msg){
            $scope.seeFlag = msg.info.id;
            if( $scope.seeFlag == 1){
                $scope.findName = 'list';
            }else{
                $scope.findName = 'listDisable';
            }
            $scope.query($scope.subcampaignId);
        });
        $scope.typefresh = ++rmd;

        $scope.query = function(id){
            if($scope.findName == undefined){
                return false;
            }
            if($scope.fromUrl == 'subpackage'){
                var campaignPM = HttpService.getInfo("mng/campaign/packagesubcampaign/"+$scope.campChannel.id+"/"+$scope.findName);
            }else{
                var campaignPM = HttpService.getInfo("mng/campaign/subcampaign/"+$scope.campChannel.id+"/"+$scope.findName);
            }
            ToolService.showLoading();
            campaignPM.then(function(data){
                ToolService.hideLoading();
                if($scope.fromUrl == 'subpackage'){
                    $scope.campaignListCope  = $scope.campaignList = data.filter(function(info){
                        return info.name != "爱奇艺模糊归因"
                    });
                    
                } else {
                    $scope.campaignList = data
                }
                $scope.selectIDS = [];
                if(id){
                    $scope.campaignList = $scope.campaignList.filter(function(item) {
                        if (id == '1') {
                              return !item.deeplink;
                          }else if(id == '2'){
                              return item.deeplink;
                          }else{
                              return true;
                          }
                    });
                }
            });
        }
        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.appid)){
                $scope.flipPage = null;
                if($scope.appid!=$scope.campChannel.app){
                    $scope.goCamp();
                    return false;
                }

                var channelPM = HttpService.getInfo($scope.appid+"/channel/findall");
                channelPM.then(function(data){
                    $scope.channelList = data;
                    for(var i=0;i<$scope.channelList.length;i++){
                        if($scope.channelList[i].id == $scope.campChannel.channel){
                            $scope.campChannel.channelname = $scope.channelList[i].name;
                            break;
                        }
                    }
                });

                $scope.query();
            }
        });

        var curfilpPage = null,rmd = new Date().getTime();
        $scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;

            $scope.flipChange = ++ rmd;
        });
        $scope.$watch("flipChange+campaignList",function(){
            if($scope.flipPage && $scope.campaignList){
                curfilpPage = {start:$scope.flipPage.start+1,end:$scope.flipPage.end};
                if(curfilpPage.end > $scope.campaignList.length){
                    curfilpPage.end = $scope.campaignList.length;
                }

                $timeout(function(){
                    var clipboard = new Clipboard('.copyBtn');
                    clipboard.on('success', function(e) {
                        $scope.$apply(function(){
                            ToolService.showTips($filter('translate')("复制成功"));
                        });
                    });

                    clipboard.on('error', function(e) {
                        $scope.$apply(function(){
                            ToolService.showTips($filter('translate')("复制成功"));
                        });
                    });
                },200);
            }
        });

        $scope.doRemove = function(info){
            if(info.keyword == undefined){
                info.keyword = info.name;
            }
            if($scope.seeFlag == 1){
                if(UtilService.isNullStr(info.creative)){
                    $scope.delTips = $filter('translate')("是否停用 “")+info.keyword+$filter('translate')("” 子活动？");
                }
                else{
                    $scope.delTips = $filter('translate')("是否停用 “")+info.keyword + "-" + info.creative+$filter('translate')("” 子活动？");
                }
                $scope.delstatus = true;
                $scope.delId = info.id;
            }else{
                $scope.delTips = $filter('translate')("是否启用 “")+info.keyword+$filter('translate')("” 子活动？");
                $scope.delstatus = true;
                $scope.delId = info.id;
            }
        }

        $scope.removeInfo = function(){
            if($scope.seeFlag == 1){
                if($scope.fromUrl == 'campaign'){
                    var removePM = HttpService.deleteInfo("mng/campaign/subcampaign/del?ids="+$scope.delId);
                }else if($scope.fromUrl == 'subpackage'){
                    var removePM = HttpService.deleteInfo("mng/campaign/packagesubcampaign/del?ids="+$scope.delId);
                }
                ToolService.showLoading();
                removePM.then(function(data){
                    ToolService.hideLoading();
                    $scope.delstatus = false;
                    ToolService.showTips($filter('translate')("停用成功"));
                    $scope.searchTxt = '';
                    $scope.query();
                });
            }else{
                if($scope.fromUrl == 'campaign'){
                    var removePM = HttpService.putInfo("mng/campaign/subcampaign/enable?ids="+$scope.delId);
                }else if($scope.fromUrl == 'subpackage'){
                    var removePM = HttpService.putInfo("mng/campaign/packagesubcampaign/enable?ids="+$scope.delId);
                }
                ToolService.showLoading();
                removePM.then(function(data){
                    ToolService.hideLoading();
                    $scope.delstatus = false;
                    ToolService.showTips($filter('translate')("启用成功"))
                    $scope.query(1);
                });
            }

        }

        $scope.clickCkx = function(id){
            var idx = $scope.selectIDS.indexOf(id);
            if(idx > -1){
                $scope.selectIDS.splice(idx,1);
            }else{
                $scope.selectIDS.push(id);
            }
        }
        $scope.setCurrentList = function(){
            var curList = $scope.campaignList;
            if(!UtilService.isNullStr($scope.searchTxt)){
                var myFilterList = $scope.campaignList.filter(function(item){
                    if((item.keyword && angular.uppercase(String(item.keyword)).indexOf(angular.uppercase($scope.searchTxt))>-1) || (item.creative && angular.uppercase(String(item.creative)).indexOf(angular.uppercase($scope.searchTxt))>-1) || (item.name && angular.uppercase(String(item.name)).indexOf(angular.uppercase($scope.searchTxt))>-1) || (item.trackUrl && angular.uppercase(String(item.trackUrl)).indexOf(angular.uppercase($scope.searchTxt))>-1)){
                        return true;
                    }
                    else{
                        return false;
                    }
                });
                curList = myFilterList;
            }
            $scope.curShowList = curList;
        }
        $scope.curPageAll = function(){
            if(!$scope.flipPage || !$scope.campaignList){return false;}

            $scope.setCurrentList();
            curfilpPage.end = $scope.curShowList.length>curfilpPage.end ? curfilpPage.end:$scope.curShowList.length;
            var len = curfilpPage.end - curfilpPage.start,count = 0;

            for(var i = curfilpPage.start;i<curfilpPage.end;i++){
                var temp = $scope.curShowList[i];

                if($scope.selectIDS.indexOf(temp.id)>-1){
                    count ++;
                }
            }
            $scope.onePageCount = count;
            return len == count && len>0;
        }
        $scope.checkAllCurrent = function(){
            var bol = $scope.curPageAll();//判断当前页数据是否全是选中
            curfilpPage.end = $scope.curShowList.length>curfilpPage.end ? curfilpPage.end:$scope.curShowList.length;
            for(var i = curfilpPage.start;i<curfilpPage.end;i++){
                var temp = $scope.curShowList[i],idx = $scope.selectIDS.indexOf(temp.id);
                if(bol && idx>-1){
                    $scope.selectIDS.splice(idx,1);
                }
                if(!bol && idx==-1){
                    $scope.selectIDS.push(temp.id);
                }
            }
        }

        $scope.checkAllPage = function(){
            $scope.selectIDS = [];
            var len = $scope.curShowList.length,count = 0;
            for(var i = 0;i<len;i++){
                $scope.selectIDS.push($scope.curShowList[i].id);
            }
        }
        $scope.$watch("selectIDS",function(n){
            if($scope.selectIDS && $scope.selectIDS.length>0){
                $scope.iptHolder = $filter('translate')("搜索后，所选内容将清除");
            }
            else{
                if($scope.fromUrl == 'campaign'){
                    $scope.iptHolder = $filter('translate')("输入关键词或创意搜索");
                }else if($scope.fromUrl == 'subpackage'){
                    $scope.iptHolder = $filter('translate')("请输入名称或短链搜索");
                }
            }
        });
        $scope.NocheckAllPage = function(){
            $scope.selectIDS = [];
        }

        $scope.$watch("searchTxt",function(n){
            if(angular.isDefined(n)){
                $scope.selectIDS = [];
            }
        });

        $scope.doBatchRemove = function(){
            $scope.delbatch = true;
        }

        $scope.removeBatch = function(){
            if($scope.seeFlag == 1){
                $scope.delbatch = false;
                if($scope.fromUrl == 'campaign'){
                    var removePM = HttpService.deleteInfo("mng/campaign/subcampaign/del?ids="+$scope.selectIDS.join(","));
                }else if($scope.fromUrl == 'subpackage'){
                    var removePM = HttpService.deleteInfo("mng/campaign/packagesubcampaign/del?ids="+$scope.selectIDS.join(","));
                }
                ToolService.showLoading();
                removePM.then(function(data){
                    ToolService.hideLoading();
                    $scope.searchTxt = '';
                    ToolService.showTips($filter('translate')("停用成功"));
                    $scope.query();
                });
            }else{
                $scope.delbatch = false;
                if($scope.fromUrl == 'campaign'){
                    var removePM = HttpService.putInfo("mng/campaign/subcampaign/enable?ids="+$scope.selectIDS.join(","));
                }else if($scope.fromUrl == 'subpackage'){
                    var removePM = HttpService.putInfo("mng/campaign/packagesubcampaign/enable?ids="+$scope.selectIDS.join(","));
                }
                ToolService.showLoading();
                removePM.then(function(data){
                    ToolService.hideLoading();
                    $scope.searchTxt = '';
                    ToolService.showTips($filter('translate')("启用成功"));
                    $scope.query();
                });
            }

        }
        $scope.exportBatch = function(){
            ToolService.showLoading();
            if($scope.fromUrl == 'campaign'){
                var exportPM = HttpService.postInfo("mng/campaign/subcampaign/export/"+$scope.campChannel.id,{ids:$scope.selectIDS});
                exportPM.then(function(data){
                    if(data==true){
                        ToolService.hideLoading();
                        ToolService.showTips($filter('translate')("导出成功，正在为您下载！稍后请到”数据导出-子活动导出“中查看下载进度"));
                    }
                    else{
                        ToolService.showTips($filter('translate')("导出失败"));
                    }
                });
            }else if($scope.fromUrl == 'subpackage'){
                ToolService.hideLoading();
                //window.location.href = "api/mng/campaign/"+$scope.appid+"/exportsurls?ids="+$scope.selectIDS.join(",")+"&son=1";
                window.location.href = "api/mng/campaign/packagesubcampaign/export/"+$scope.campChannel.id+"?ids="+$scope.selectIDS.join(",");
                //window.location.href = "api/mng/campaign/1227/exportsurls?ids=161650";
            }


        }

        $scope.gopage = function(info){
            $state.go("collect.subcampaignlistDetail",{aid:info});
        }

        $scope.gopagePackage = function(info){
            $state.go("collect.subpackageDetail",{aid:info});
        }

        $scope.goCamp = function(){
            if($scope.fromUrl == 'campaign'){
                $state.go("collect.campaign",{aid:'ry_bd'});
            }else if($scope.fromUrl == 'subpackage'){
                $state.go("collect.subpackage");
            }

        }
    }

    function subcampaignlistDetailCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$state,$stateParams,$http,$timeout,$filter){
        var info = $stateParams.aid;
        $scope.subType = "hand"; //hand,auto
        $scope.changeType = function(type){
            $scope.subType = type;
        }
        $scope.valueList = [];
        $scope.init = function(){
            $scope.campChannel = $rootScope.campChannel;
            if(UtilService.isNullStr($scope.campChannel)){
                $scope.goPage('collect.campaign');
                return false;
            }

            $scope.campname = $scope.campChannel.name;
            var channelPM = HttpService.getInfo($scope.appid+"/channel/findall");
            channelPM.then(function(data){
                $scope.channelList = data;
                for(var i=0;i<$scope.channelList.length;i++){
                    if($scope.channelList[i].id == $scope.campChannel.channel){
                        $scope.campChannel.channelname = $scope.channelList[i].name;
                        break;
                    }
                }
                $scope.channelname = $scope.campChannel.channelname;
            });

            $scope.valueList = [];
            if(info){
                $scope.id = info.id;
                $scope.keyword = info.keyword;
                $scope.creative = info.creative;
                $scope.url = info.url;

                $scope.valueList = [info.creative];
                // $scope.surl = info.surl;
                $scope.surl = info.subCampaignUrl;
            }
            else{
                if($scope.demoU){
                    $scope.url = "http://www.reyun.com";
                }
                else{
                    $scope.url = $scope.campChannel.url;
                }
            }
        }
        $scope.$watch("appid",function(n){
            if(angular.isDefined(n)){
                if(!$scope.campChannel || n!=$scope.campChannel.app){
                    $scope.goCamp();
                    return false;
                }
            }
        });
        $scope.setValue = function(val,flag){
            //if(val==''){return false;}
            if(val == '' || val == undefined){
                $scope.valueList = [];
            }else{
                if($scope.valueList.length>=100){
                    ToolService.showTips($filter('translate')("创意个数不能超过100"));
                    return false;
                }
                var idx = $scope.valueList.indexOf(val);
                if(idx == -1){
                    if(val.replace(/[^\x00-\xff]/g, '00').length>40){
                        ToolService.showTips($filter('translate')("创意过长（长度限制40字符以内）"));
                        return false;
                    }
                    else{
                        $scope.valueList.push(val);
                    }
                }
                else{
                    if(angular.isUndefined(flag)){
                        ToolService.showTips($filter('translate')("不能重复哦"));
                    }
                }
            }
            $scope.valTxt = "";
            if(flag){
                $scope.save();
            }
        }
        $scope.removeValue = function(idx){
            $scope.valueList.splice(idx,1);
        }
        $scope.removeVs = function(event){
            if($scope.valTxt!=''){return false;}
            if(event.keyCode==8 && $scope.valueList.length>0){
                $scope.valueList.pop();
            }
        }
        $scope.init();

        //文件未上传状态
        $scope.uploadType = 'noupload';

        $scope.$on("myFile",function(e,file){
            var name = file.name;
            var subIdx = name.lastIndexOf(".")+1,subTxt = name.substring(subIdx);
            if(subTxt == 'xls' || subTxt == 'xlsx'){
                var size = file.size;
                if(size > 1 * 1024 * 1024){
                    ToolService.showTips($filter('translate')("文件不能大于1M"));
                }
                else{
                    $scope.uploadname = name;
                    $scope.uploadFile(file);
                }
            }
            else{
                ToolService.showTips($filter('translate')("仅支持excel"));
            }
        });

        $scope.noActive = 0;
        $scope.sameUpload = false;
        $scope.closeWin = function(){
            $scope.noActive = 0;
            $scope.sameUpload = false;
        }
        $scope.sendSame = function(){
            $scope.sameUpload = true;
            $scope.saveUpload();
        }

        $scope.hasUpload = false;
        $scope.uploadFile = function(file){
            $scope.uploadType = 'inupload';
            var fd = new FormData();
            fd.append('file', file);

            ToolService.showLoading();
            $http({
                method:'POST',
                url:"/api/mng/campaign/subcampaign/"+$scope.campChannel.id+"/upload",
                data: fd,
                headers: {'Content-Type':undefined},
                transformRequest: angular.identity
            })
            .success(function(data)
            {
                data = data.content;
                ToolService.hideLoading();
                $scope.errorType = data.errorType;
                $scope.uploadType = 'upload';
                //alert($scope.errorType);
                if($scope.errorType == 'EMPTY'){
                    ToolService.showTips($filter('translate')("未检测到子活动数据（空文件、只包含表头、或第一个工作表内无数据），请检查更新后重新上传。"));
                    $scope.uploadType = 'noupload';
                }else if($scope.errorType == 'HEAD_ERROR'){
                    ToolService.showTips($filter('translate')("表头匹配有错误，请按照模板表头内文字检查更新后重新上传。"));
                    $scope.uploadType = 'noupload';
                }else if($scope.errorType == 'READ_ERROR'){
                    ToolService.showTips($filter('translate')("系统异常，请重新上传。"));
                    $scope.uploadType = 'noupload';
                }else if($scope.errorType == 'REPEAT_ALL'){
                    //全部重复
                    ToolService.showTips($filter('translate')("您上传表格中的子活动均与系统内已创建子活动重复，请检查更新后重新上传。"));
                    $scope.uploadType = 'noupload';

                }else if($scope.errorType == 'CONTENT_ERROR'){
                    $scope.uploadType = 'noupload';
                    $scope.uploadRow = data.rowNumber;
                    //$scope.tableErrorTxT = data.innerRepeatList; //表内重复
                    $scope.tableErrorTxT = '';
                    for(var i=0;i< data.innerRepeatList.length; i++){
                        $scope.tableErrorTxT = $scope.tableErrorTxT + ' ('+data.innerRepeatList[i]+') ';
                    }
                    $scope.tableErrorTxT = $scope.tableErrorTxT +$filter('translate')('，');
                    $scope.tableError = data.innerRepeatList;
                    $scope.uploadErrorTxT = data.uploadErrorList.slice(0,10).join("、");//内容错误
                    $scope.uploadError = data.uploadErrorList;
                    $scope.uploadRepeatedListTxT = data.uploadRepeatedList.slice(0,10).join("、");//数据库重复
                    $scope.uploadRepeatedList = data.uploadRepeatedList;
                    if(data.uploadRepeatedList.length != 0){
                        $scope.sameUpload = false;
                    }else{
                        $scope.sameUpload = true;
                    }
                }else if($scope.errorType == null){
                    $scope.hasUpload = true;
                    $scope.uploadId = data.id;

                    $scope.uploadType = 'upload';
                    $scope.uploadRow = data.rowNumber;
                    //表内重复
                    $scope.tableErrorTxT = '';
                    for(var i=0;i< data.innerRepeatList.length; i++){
                        $scope.tableErrorTxT = $scope.tableErrorTxT + ' ('+data.innerRepeatList[i]+') ';
                    }
                    $scope.tableErrorTxT = $scope.tableErrorTxT +'，';
                    $scope.tableError = data.innerRepeatList;
                    $scope.uploadRepeatedListTxT = data.uploadRepeatedList.slice(0,10).join("、");//数据库重复
                    $scope.uploadRepeatedList = data.uploadRepeatedList;
                    if(data.uploadRepeatedList.length != 0){
                        $scope.sameUpload = false;
                    }else{
                        $scope.sameUpload = true;
                    }
                }

            })
            .error(function(data){
                $scope.uploadType = 'noupload';
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("网络超时，请重新上传"));
            });
        }

        $scope.saveUpload = function(){
            if(!$scope.sameUpload){
                $scope.noActive = 1;
                return false;
            }
            if(!$scope.hasUpload){
                ToolService.showTips($filter('translate')("请先上传数据"));
                return false;
            }
            ToolService.showLoading();
            var okPM = HttpService.postInfo("mng/campaign/subcampaign/"+$scope.campChannel.id+"/"+$scope.uploadId+"/save",{})
            okPM.then(function(data){
                ToolService.hideLoading();

                var ids = [];
                data.filter(function(item){
                  ids.push(item.id);
                });
                if(ids.length>0){
                  $scope.downloadSubCampaign(ids.join(","));
                }

                if($scope.rowNumber>1000){
                    ToolService.showTips($filter('translate')("成功为您创建1000个子活动"));
                }
                else{
                    ToolService.showTips($filter('translate')("创建成功"));
                }
                $scope.cancel();
            });
        }
        $scope.save = function(){
            if($scope.valTxt!=''){
                $scope.setValue($scope.valTxt,1);
                return false;
            }
            ToolService.showLoading();
            var par = {
                channelId: $scope.campChannel.channel,
                campaignId: $scope.campChannel.id,
                keyword: $scope.keyword,
                url: $scope.url,
                creative:$scope.valueList.join(",")
            };
            var verPar = {
                keyword: {
                    key: 'keyword',
                    val: par.keyword,
                    txt:$filter('translate')("含非法字符或过长（支持输入汉字、大小写字母、数字、中划线、点，长度限制40字符以内）")
                },
                url:{
                    key: 'url',
                    val:$scope.url,
                    txt: $filter('translate')("url不合法（支持输入以http://或https://开头的链接地址）")
                }
            };

            $scope.tip = formJudge(verPar);
            $scope.errorValues = [];
            if($scope.tip.succ == true) {
                var savePM = null,txtTips = $filter('translate')("添加成功");
                if($scope.id){
                    par.id = $scope.id;
                    savePM = HttpService.putInfo("mng/campaign/subcampaign/update",par);
                    txtTips = $filter('translate')("修改成功");
                }
                else{
                    savePM = HttpService.postInfo("mng/campaign/subcampaign/create",par);
                }

                savePM.then(function(data){
                    ToolService.hideLoading();
                    if(!$scope.id && data.duplicate && data.duplicate.length>0){
                        if($scope.valueList.length>0){
                            ToolService.showTips($filter('translate')("创意与已创建子活动重复，请检查"));
                            $scope.errorValues = data.duplicate;
                        }
                        else{ //关键词重复
                            ToolService.showTips($filter('translate')("关键词与已创建子活动重复，请检查"));
                            $scope.tip = {
                                keyword:{
                                    status:true,
                                    txt:$filter('translate')("重复")
                                }
                            }
                        }
                    }
                    else{
                        if(!$scope.id && data.success.length>0){
                          var ids = [];
                          data.success.filter(function(item){
                            ids.push(item.id);
                          });
                          if(ids.length>0){
                            $scope.downloadSubCampaign(ids.join(","));
                          }
                        }
                        ToolService.showTips(txtTips);
                        $scope.cancel();
                    }
                });
            }
            else{
                ToolService.hideLoading();
                ToolService.showTips($scope.formTipMsg);
            }
        }
        $scope.downloadSubCampaign = function(ids,name){
            var downPM =  HttpService.downFile("mng/campaign/subcampaign/export/rt?ids="+ids);
            //ToolService.showLoading();
            downPM.then(function(data){
                //ToolService.hideLoading();
            });
        }
        $scope.cancel = function(){
            $scope.goPage("collect.subcampaignlist");
            $rootScope.campaignUrl = 'campaign';
        }

        var qrcode = null;
        try{
            qrcode = new QRCode(document.getElementById("mainfo"), {
                    width : 300,
                    height : 300
                });
        }catch(e){
            // window.location.href="login.html";
        }
        $scope.showMa = false;
        $scope.createMa = function(){
            qrcode.makeCode($scope.surl);
            $("#mainfo img").css({"height":"60px","width":"60px"});
            $timeout(function(){
                $scope.showMa = true;
            },200)
           
        };
        $scope.downMa = function(){
            var src = $("#mainfo img").attr("src");
            $("#erwm").attr("href",src);
            $("#erwm").click();
        }
        $scope.goCamp = function(){
            $state.go("collect.campaign",{aid:'ry_bd'});
            $rootScope.campaignUrl = 'campaign';
        }

        /**
         * 语言切换
         */
        $scope.$watch("lang",function (n,o) {
            if(n && o && n!==o){
                $scope.init();
            }
        });
    }
})();
