package com.reyun.controller;

import com.reyun.security.annotation.AuthorizationMenu;
import com.reyun.service.AttributionService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

/**
 * Created by sunhao on 17/3/14.
 * description:归因查询
 */
@Controller
@RequestMapping("attr")
public class AttributionController {

    @Autowired
    private AttributionService attributionService;

    @RequestMapping(value = "findAttr/{appId}", method = RequestMethod.GET)
    @ResponseBody
    @AuthorizationMenu("attribute")
    public ResultModel findAttributionByDeviceAndApp(@PathVariable Long appId, @RequestParam String deviceid) {

        return ResultModel.OK(attributionService.findAttributionByInstallId(appId, deviceid));
    }
}
