package com.reyun.controller;

import com.reyun.model.Account;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.CampaignGroupService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * Created by nolan on 26/12/2016.
 * description:
 */
@Controller
@RequestMapping("/{appid}/campgroup")
public class CampaignGroupController {

    @Autowired
    private CampaignGroupService campaignGroupService;

    @RequestMapping(value = "findall", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAll(@PathVariable Long appid, @CurrentAccount Account loginAccount) {
        return ResultModel.OK(campaignGroupService.listCamgroupByAccountAndApp(appid, loginAccount.getId()));
    }
}
