package com.reyun.controller;

import com.reyun.service.MessageCodeService;
import com.reyun.util.IPAddrUtil;
import com.reyun.util.ResultModel;
import com.reyun.util.ResultStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * Created by Administrator on 2017/6/8 0008.
 */
@Controller
@RequestMapping("/messagecode")
public class MessageCodeController {

//    /messagecode/sendMessagecode

    @Autowired
    MessageCodeService messageCodeService;

    @RequestMapping(value = "/sendMessagecode", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel sendMesagecode(HttpServletRequest request , @RequestParam String phone)
    {

        String ip = IPAddrUtil.getIpAddrNew(request);

        System.out.println("ip ====="+ip);
        String result = messageCodeService.sendMessageCode(phone , ip);

        if ("manytimes".equals(result))
        {
            return ResultModel.ERROR(ResultStatus.MSG_SMS_REQUESTTIMES);
        }
        else if("ipmanytimes".equals(result))
        {
            return ResultModel.ERROR(ResultStatus.MSG_SMS_IPREQUESTTIMES);
        }
        else if("iperror".equals(result))
        {
            return ResultModel.ERROR(ResultStatus.MSG_SMS_IPERROR);
        }
        return ResultModel.OK(result);
    }

    @RequestMapping(value = "/verifyMessagecode", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel verifyMesagecode(@RequestParam String phone, @RequestParam String code)
    {
        String result = messageCodeService.varifyMessagecode(phone , code);
        return ResultModel.OK(result);
    }


}
