package com.reyun.controller;

import com.alibaba.fastjson.JSON;
import com.reyun.model.Account;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.SmSearchService;
import com.reyun.util.Constant;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;

/**
 * Created by sunhao on 17/3/21.
 * Description:第三方账户操作
 */
@Controller
@RequestMapping("third")
public class ThirdAccountController {
    @Autowired
    private SmSearchService smSearchService;

    @RequestMapping(value = "getToken",method = RequestMethod.GET)
    public void updateThirdAccountToken(@CurrentAccount Account account, String code, String state, HttpServletResponse response){
        response.setStatus(HttpServletResponse.SC_MOVED_PERMANENTLY);
        smSearchService.callbackUpdateTokenByCode(Long.parseLong(state), code);
            response.setHeader("Location", "http://"+Constant.getDomainStr());
    }

    @RequestMapping(value = "/testdownloads",method = RequestMethod.GET)
    public ResultModel testDownload(@RequestParam Long channelaccountid){
        smSearchService.task();
        return ResultModel.OK();
    }
    @RequestMapping(value = "/gdt")
    @ResponseBody
    public Object testGdt(){
        String testString = "";
        //if("gdt".equals(name)){
             testString = "{ \"clickTime_new\": \"2020-05-14 21:50:05\", \"message\": \"\", \"paymentAmount\": 600.0, \"trace_id\": \"2a70d747323a27c7a8b14bd63d39f1df\", \"data\": { \"attribution\": [{ \"click_time\": "+(System.currentTimeMillis()-3600000)/1000+", \"creative_id\": 279066297, \"claim_type\": 0, \"adgroup_name\": \"XQ-TP-KL-0512_01\", \"impression_time\": 1589464194, \"campaign_name\": \"XQ-TP-KL-0512\", \"advertiser_id\": 15274132, \"ad_platform_type\": 1, \"user_id\": { \"wechat_unionid\": \"\", \"hash_oaid\": \"\", \"mqq_openid\": \"\", \"hash_imei\": \"6782c5550dfb99a346a153a7ae96c96a\", \"qadid\": \"\", \"hash_android_id\": \"\", \"wuid\": \"\", \"sec_gdt_uid\": \"\", \"hash_mac\": \"\", \"qaid\": \"\", \"hash_idfa\": \"\", \"wechat_openid\": \"\", \"mqq_app_id\": \"\", \"taid\": \"\", \"wechat_app_id\": \"\", \"hash_phone\": \"\", \"gdt_openid\": \"\", \"ad_cookie\": \"\", \"turing_oaid\": \"\", \"idfa\": \"\", \"oaid\": \"\" },\"impression_id\": \"76r6l6nrauycu02\", \"site_set\": 25, \"click_id\": \"qbgl2xqnaaandtkmpqfq\", \"adgroup_id\": 241935118, \"campaign_id\": 109700480, \"creative_name\": \"横版大图 16:9-创意1\" }]},\"message_cn\": \"\", \"code\": 0 }";
        //}
        return JSON.parseObject(testString);
    }
}
