package com.reyun.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import com.reyun.service.TipService;
import com.reyun.util.ResultModel;

import javax.servlet.http.HttpServletRequest;

/**
 * Created by nolan on 22/12/2016.
 * description:
 */
@Controller
@RequestMapping("tip")
public class TipController {

    @Autowired
    private TipService tipService;

    /**
     * @param menu
     * @param request
     * @param lanType
     * @return
     */
    @RequestMapping(value = "{menu}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findByMenu(@PathVariable String menu, HttpServletRequest request
            ,@RequestHeader(name = "lang", defaultValue = "zh") String lanType) {
        String appid = request.getParameter("appid");
        Long id = null;
        if (appid != null && !"undefined".equals(appid)) {
            id = Long.parseLong(appid);
        }
        return ResultModel.OK(tipService.findAllByMenu(menu, id, lanType));
    }
}
