package com.reyun.dic;

/**
 * Created by sunhao on 17/3/6.
 * 配置表KEY字段字典
 */
public enum ConfigEnumType {

    MASTER_PWD_PREFIX("master_pwd_prefix","万能密码前缀"),
    UNIVERSAL_PWD("universal_pwd","24小时万能密码前缀"),
    SM_CLIENT_ID("client_id","神马应用ID"),
    SM_CLIENT_SECRET("client_secret","神马应用密匙"),
    SM_REDIRECT_URI("redirect_uri","神马重定向"),
    DOWNLOAD_FILE_PATH("download_file_path","下载文件地址"),
    SERVER_REGED_DOWNLOAD_URL("reged_download_url", "注册","Registers"),
    SERVER_INSTALL_DOWNLOAD_URL("install_download_url", "激活","Install"),
    SERVER_CLICK_DOWNLOAD_URL("click_download_url", "点击","Click"),
    SERVER_BLACKLIST_DOWNLOAD_URL("blacklist_download_url", "防作弊拦截点击","Blocked Clicks"),
    SERVER_FAKE_INSTALL_DOWNLOAD_URL("fake_install_download_url", "防作弊拦截激活","Blocked Install"),
    SERVER_PAY_DOWNLOAD_URL("pay_download_url", "付费","Payments"),
    ORDER_DOWNLOAD_URL("order_download_url", "订单","Orders"),
    OPENAPI_TOKEN("OPENAPI_TOKEN", "对外开放接口TOKEN"),
    SERVER_DEVICELOGIN_DOWNLOAD_URL("loggedin_download_url","登录","Login");


    private String key;
    private String value;
    private String en_value;

    ConfigEnumType(String key, String value) {
        this.key = key;
        this.value = value;
    }

    ConfigEnumType(String key, String value,String en_value) {
        this.key = key;
        this.value = value;
        this.en_value = en_value;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getEn_value() {
        return en_value;
    }

    public void setEn_value(String en_value) {
        this.en_value = en_value;
    }
}
