package com.reyun.dic;


/**
 * 语种枚举类
 */
public enum LanguageTypeEnum {
    CHINESE("zh", "中文"),
    ENGLISH("en", "英文");

    private String code;
    private String val;

    LanguageTypeEnum(String code, String val) {
        this.code = code;
        this.val = val;
    }

    public static LanguageTypeEnum getVal(String code) {
        for (LanguageTypeEnum appTypeEnum : LanguageTypeEnum.values()) {
            if (appTypeEnum.getCode().equals(code)) {
                return appTypeEnum;
            }
        }
        return CHINESE;
    }

    public String getCode() {
        return code;
    }

    public String getVal() {
        return val;
    }
}
