package com.reyun.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

@Entity
public class Campaign
{

    private Long id;
    private Long app;
    private String os;
    private String type;
    private Long channel;
    private String channelCategory;
    private String channelType;
    private String campaignid;

    private String name;
    private String callback;
    private String url;
    private String urlName;
    private String surl;
    private Integer addParam;
    private String campaignpackid;

    private String specialKeys;

    private String advertiserid;

    private String bundleid;

    private Boolean awssuccess = false;

    private Date createTime;
    private Long createAccount;
    private Date modifyTime;
    private Long modifyAccount;
    private Boolean delFlag = false;
    private Integer impressionStop;

    private Long account;

    private String holderids;
    private String pack_channelid;
    private int batchNumber;

    private int startNumber;
    private String campaignName;
    private String thirdAccount;
    private String thirdAccountAlias;

    private String mipType;
    private String qrCodeAddress;
    private String advertisid;

    private boolean newInsert = false;

    private Boolean clickLinkType;

    private AppDeepLink appDeepLink;

    private String uniqueName;

    private boolean vivo2DDb;


    private boolean deeplink;

    private Boolean subscribes;//预约活动

    private String onlineDate;//预约上线时间

    @Transient
    private boolean noLimit = false;//true不分页

    private List<PackageSubCampaign> pkgSubCampaignList;

    public boolean getDeeplink() {
        return deeplink;
    }

    public void setDeeplink(boolean deeplink) {
        this.deeplink = deeplink;
    }

    @Transient
    public boolean isVivo2DDb() {
        return vivo2DDb;
    }

    public void setVivo2DDb(boolean vivo2DDb) {
        this.vivo2DDb = vivo2DDb;
    }

    @Transient
    public String getUniqueName() {
        return uniqueName;
    }

    public void setUniqueName(String uniqueName) {
        this.uniqueName = uniqueName;
    }

    @Transient
    public String getAdvertisid() {
        return advertisid;
    }

    public void setAdvertisid(String advertisid) {
        this.advertisid = advertisid;
    }

    @Transient
    public int getStartNumber() {
        return startNumber;
    }

    public void setStartNumber(int startNumber) {
        this.startNumber = startNumber;
    }

    @Transient
    public String getCampaignName() {
        return campaignName;
    }

    public void setCampaignName(String campaignName) {
        this.campaignName = campaignName;
    }

    @Transient
    public int getBatchNumber()
    {
        return batchNumber;
    }

    public void setBatchNumber(int batchNumber)
    {
        this.batchNumber = batchNumber;
    }

    @Transient
    public String getHolderids()
    {
        return holderids;
    }

    public void setHolderids(String holderids)
    {
        this.holderids = holderids;
    }

    public Long getAccount()
    {
        return account;
    }

    public void setAccount(Long account)
    {
        this.account = account;
    }

    public Campaign()
    {
        super();
    }

    public Campaign(String campaignid, String name)
    {
        this.campaignid = campaignid;
        this.name = name;
    }
    public Campaign(Long id, String campaignpackid, Long channel, String pack_channelid, String campaignid,Boolean subscribes) {
        this.id = id;
        this.campaignpackid = campaignpackid;
        this.channel = channel;
        this.pack_channelid = pack_channelid;
        this.campaignid = campaignid;
        this.subscribes = subscribes;
    }
    public Long getApp()
    {
        return app;
    }

    public String getCallback()
    {
        return callback;
    }

/*	public Long getCampaignGroup() {
        return campaignGroup;
	}*/

    public Long getChannel()
    {
        return channel;
    }

    @Id
    @GeneratedValue
    public Long getId()
    {
        return id;
    }

    public String getName()
    {
        return name;
    }

    public String getSurl()
    {
        return surl;
    }

    public String getType()
    {
        return type;
    }

    public String getUrl()
    {
        return url;
    }

    public void setApp(Long app)
    {
        this.app = app;
    }

    public void setCallback(String callback)
    {
        this.callback = callback;
    }

/*	public void setCampaignGroup(Long campaignGroup) {
		this.campaignGroup = campaignGroup;
	}*/

    public String getUrlName() {
        return urlName;
    }

    public void setUrlName(String urlName) {
        this.urlName = urlName;
    }

    public void setChannel(Long channel)
    {
        this.channel = channel;
    }

    public String getChannelCategory()
    {
        return channelCategory;
    }

    public void setChannelCategory(String channelCategory)
    {
        this.channelCategory = channelCategory;
    }

    public String getChannelType()
    {
        return channelType;
    }

    public void setChannelType(String channelType)
    {
        this.channelType = channelType;
    }

    public void setId(Long id)
    {
        this.id = id;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public void setSurl(String surl)
    {
        this.surl = surl;
    }

    public void setType(String type)
    {
        this.type = type;
    }

    public void setUrl(String url)
    {
        this.url = url;
    }

    public String getSpecialKeys()
    {
        return specialKeys;
    }

    public void setSpecialKeys(String specialKeys)
    {
        this.specialKeys = specialKeys;
    }

    public Integer getAddParam()
    {
        return addParam;
    }

    public void setAddParam(Integer addParam)
    {
        this.addParam = addParam;
    }

    public String getOs()
    {
        return os;
    }

    public void setOs(String os)
    {
        this.os = os;
    }

    public boolean isAwssuccess()
    {
        return awssuccess;
    }

    public void setAwssuccess(boolean awssuccess)
    {
        this.awssuccess = awssuccess;
    }

    public String getCampaignpackid()
    {
        return campaignpackid;
    }

    public void setCampaignpackid(String campaignpackid)
    {
        this.campaignpackid = campaignpackid;
    }

    public String getAdvertiserid()
    {
        return advertiserid;
    }

    public void setAdvertiserid(String advertiserid)
    {
        this.advertiserid = advertiserid;
    }

    public String getBundleid()
    {
        return bundleid;
    }

    public void setBundleid(String bundleid)
    {
        this.bundleid = bundleid;
    }

    public Date getCreateTime()
    {
        return createTime;
    }

    public void setCreateTime(Date createTime)
    {
        this.createTime = createTime;
    }

    public Date getModifyTime()
    {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime)
    {
        this.modifyTime = modifyTime;
    }

    public Boolean getDelFlag()
    {
        return delFlag;
    }

    public void setDelFlag(Boolean delFlag)
    {
        this.delFlag = delFlag;
    }

    public Integer getImpressionStop() {
        return impressionStop;
    }

    public void setImpressionStop(Integer impressionStop) {
        this.impressionStop = impressionStop;
    }

    public String getCampaignid()
    {
        return campaignid;
    }

    public void setCampaignid(String campaignid)
    {
        this.campaignid = campaignid;
    }

    public Long getCreateAccount()
    {
        return createAccount;
    }

    public void setCreateAccount(Long createAccount)
    {
        this.createAccount = createAccount;
    }

    public Long getModifyAccount()
    {
        return modifyAccount;
    }

    public void setModifyAccount(Long modifyAccount)
    {
        this.modifyAccount = modifyAccount;
    }

    public String getPack_channelid()
    {
        return pack_channelid;
    }

    public void setPack_channelid(String pack_channelid)
    {
        this.pack_channelid = pack_channelid;
    }

    public Boolean getAwssuccess()
    {
        return awssuccess;
    }

    public void setAwssuccess(Boolean awssuccess)
    {
        this.awssuccess = awssuccess;
    }

    public String getThirdAccount()
    {
        return thirdAccount;
    }

    public void setThirdAccount(String thirdAccount)
    {
        this.thirdAccount = thirdAccount;
    }

    public String getThirdAccountAlias()
    {
        return thirdAccountAlias;
    }

    public void setThirdAccountAlias(String thirdAccountAlias)
    {
        this.thirdAccountAlias = thirdAccountAlias;
    }

    public String getMipType() {
        return mipType;
    }

    public void setMipType(String mipType) {
        this.mipType = mipType;
    }

    public String getQrCodeAddress() {
        return qrCodeAddress;
    }

    public void setQrCodeAddress(String qrCodeAddress) {
        this.qrCodeAddress = qrCodeAddress;
    }

    public boolean isNewInsert() {
        return newInsert;
    }

    public void setNewInsert(boolean newInsert) {
        this.newInsert = newInsert;
    }
    @Transient
    public AppDeepLink getAppDeepLink() {
        return appDeepLink;
    }

    public void setAppDeepLink(AppDeepLink appDeepLink) {
        this.appDeepLink = appDeepLink;
    }

    public Boolean getClickLinkType() {
        return clickLinkType;
    }

    public void setClickLinkType(Boolean clickLinkType) {
        this.clickLinkType = clickLinkType;
    }

    public Boolean getSubscribes() {
        return subscribes;
    }

    public void setSubscribes(Boolean subscribes) {
        this.subscribes = subscribes;
    }
    @Transient
    public String getOnlineDate() {
        return onlineDate;
    }

    public void setOnlineDate(String onlineDate) {
        this.onlineDate = onlineDate;
    }

    @Transient
    public List<PackageSubCampaign> getPkgSubCampaignList() {
        return pkgSubCampaignList;
    }

    public void setPkgSubCampaignList(List<PackageSubCampaign> pkgSubCampaignList) {
        this.pkgSubCampaignList = pkgSubCampaignList;
    }

    @Transient
    public boolean isNoLimit() {
        return noLimit;
    }

    public void setNoLimit(boolean noLimit) {
        this.noLimit = noLimit;
    }

    @Override
    public String toString() {
        return "Campaign{" +
                "id=" + id +
                ", app=" + app +
                ", os='" + os + '\'' +
                ", type='" + type + '\'' +
                ", channel=" + channel +
                ", channelCategory='" + channelCategory + '\'' +
                ", channelType='" + channelType + '\'' +
                ", campaignid='" + campaignid + '\'' +
                ", name='" + name + '\'' +
                ", callback='" + callback + '\'' +
                ", url='" + url + '\'' +
                ", urlName='" + urlName + '\'' +
                ", surl='" + surl + '\'' +
                ", addParam=" + addParam +
                ", campaignpackid='" + campaignpackid + '\'' +
                ", specialKeys='" + specialKeys + '\'' +
                ", advertiserid='" + advertiserid + '\'' +
                ", bundleid='" + bundleid + '\'' +
                ", awssuccess=" + awssuccess +
                ", createTime=" + createTime +
                ", createAccount=" + createAccount +
                ", modifyTime=" + modifyTime +
                ", modifyAccount=" + modifyAccount +
                ", delFlag=" + delFlag +
                ", impressionStop=" + impressionStop +
                ", account=" + account +
                ", holderids='" + holderids + '\'' +
                ", pack_channelid='" + pack_channelid + '\'' +
                ", batchNumber=" + batchNumber +
                ", startNumber=" + startNumber +
                ", campaignName='" + campaignName + '\'' +
                ", thirdAccount='" + thirdAccount + '\'' +
                ", thirdAccountAlias='" + thirdAccountAlias + '\'' +
                ", mipType='" + mipType + '\'' +
                ", qrCodeAddress='" + qrCodeAddress + '\'' +
                ", advertisid='" + advertisid + '\'' +
                ", newInsert=" + newInsert +
                ", clickLinkType=" + clickLinkType +
                ", appDeepLink=" + appDeepLink +
                ", uniqueName='" + uniqueName + '\'' +
                ", vivo2DDb=" + vivo2DDb +
                ", deeplink=" + deeplink +
                ", subscribes=" + subscribes +
                '}';
    }
}
