package com.reyun.report.parse;

import com.reyun.model.ReportChartResult;
import com.reyun.report.AbstractChartReportParse;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class ChartTransNameParse extends AbstractChartReportParse {

    @Override
    public ReportChartResult parse(ReportChartResult reportResult, Long app, Long account, String reportName) {

        if(reportName.startsWith("black_top5_") || reportName.startsWith("userengagement_") ){

            if(reportName.endsWith("_cid")||reportName.endsWith("_bychannel")){
                reportResult.setKey(transChannelNameList(reportResult.getKey(), app, account));
            }else if(reportName.endsWith("_campaignid")){
//                reportResult.setKey(transCampaignNameList(reportResult.getKey(), app, account));
                reportResult.setKey(transCampaignNameListShortColum(reportResult.getKey(), app, account));
            }

        }else if (isReplaceLableName(reportName)) {
            reportResult.setName(transChannelNameList(reportResult.getName(), app, account));
        } else if (isReplaceLableKey(reportName)) {
            reportResult.setKey(transChannelNameList(reportResult.getKey(), app, account));
        } else if (isReplaceCategoryNameFromKey(reportName)) {
            reportResult.setKeyId(reportResult.getKey());
            reportResult.setKey(transCategoryNameList(reportResult.getKey()));
        }else if(isReplaceScene(reportName)){
            reportResult.setKey(transSceneNameList(reportResult.getKey(), app, account));
        }else if(isReplaceCampinName(reportName)){
            reportResult.setKey(transCampaignNameList(reportResult.getKey(), app, account));
        }
        return reportResult;
    }
}

