package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.service.impl.RecoveryReportServiceImpl;
import org.json.JSONException;

import java.util.List;
import java.util.Map;

/**
 * Created by mxq on 2017/7/24.
 */
public class CostRecoveryParse extends AbstractListReportParse {
    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) throws JSONException {

        if(reportName.equals("recovery_byweek")){
            return new RecoveryReportServiceImpl().parseWeek(reportResult);
        }
        if(reportName.equals("recovery_bymonth")){
            return new RecoveryReportServiceImpl().parseMonth(reportResult);
        }
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }
}
