package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractNoDivideReportParse;
import org.json.JSONException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ListCampaignNoDivideParse extends AbstractNoDivideReportParse{

    private static final Logger logger = LoggerFactory.getLogger(ListCampaignNoDivideParse.class);

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns,
                                  String reportName, boolean isSearchText, List<String> dataIds) {

        if (isSearchText) {
            setDefaultValue(reportResult, dataIds);
        }

        //翻译名字,补全全零数据
        reportResult.setVal(super.transCampaignName(reportResult.getVal(), app, account));
        //统计汇总
        reportResult.setVal(super.calFirstTotalRow(reportResult, viewColumns));

        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Map<String, String> conditions) {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId() {
        return "campaignid";
    }
}
