package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractNoDivideReportParse;
import org.json.JSONException;

import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ListChannelNoDivideParse extends AbstractNoDivideReportParse
{

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds)
    {
        if (isSearchText) {
            setDefaultValue(reportResult, searchIds);
        }
        reportResult.setVal(super.transChannelName(reportResult.getVal(), app, account));
        List<Map<String, Object>> newResult = super.calFirstTotalRow(reportResult, viewColumns);
        reportResult.setVal(newResult);
        this.createColumByReplace(reportResult);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Map<String, String> conditions) {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "channelname";
    }
}