package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.ValidateUtil;
import org.json.JSONException;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class RemarketingParse
        extends ListChannelByChannelParse
{
    /*private String reportName;
    private String firstRow;*/
    /*@Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds)
    {
        if (isSearchText) {
            setDefaultValue(reportResult, searchIds);
        }
        reportResult.setVal(super.transChannelAdvertisinginName(reportResult.getVal(), app, account));
        this.reportName=reportName;
        List<Map<String, Object>> newResult = super.calFirstTotalRow(reportResult, viewColumns);
        reportResult.setVal(newResult);
        return reportResult;
    }*/

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns,
                                  String reportName, boolean isSearchText, List<String> dataIds) {
        if (isSearchText) {
            setDefaultValue(reportResult, dataIds);
        }
        Map<String, Object> totalResult = new HashMap<>();
        List<Map<String, Object>> values = new ArrayList<>();
        List<Map<String, Object>> val = reportResult.getVal();
        if(ValidateUtil.isValid(val)){
            for (Map<String, Object> map : val) {
                Map<String, Map<String, Object>> result = super.advertisingByDimension( map, viewColumns, totalResult);
                Map<String, Object> tmpResultValue = result.get("single");
                values.add(tmpResultValue);
            }
        }

        //翻译名字,补全全零数据
        reportResult.setVal(super.transRemarketingName(values, app, account));
        //统计汇总
        reportResult.setVal(super.calFirstTotalRow(reportResult, viewColumns));

        return reportResult;
    }


    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "cid";
    }
}