package com.reyun.repository;

import com.reyun.model.AccountLoginIp;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface AccountLoginIpRepository extends JpaRepository<AccountLoginIp, Long> {

    @Query(value = "select ip from account_login_ip where email = ?1", nativeQuery = true)
    List<String> findAllByEamil(String email);

    /*@Query(value = "select ip from account_login_ip where root_parent = ?1", nativeQuery = true)
    List<String> findIpByEamil(Long root_parent);*/
}
