package com.reyun.repository;

import com.reyun.model.AdvertisingPlatform;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface AdvertisingPlatformRepository extends JpaRepository<AdvertisingPlatform, Long> {


    @Query(value = "select * from advertising_platform where type_name = ?1 ", nativeQuery = true)
    AdvertisingPlatform findByPlatform(String id);

    @Query(value = "select * from advertising_platform where base_long = ?1 ", nativeQuery = true)
    AdvertisingPlatform findByLongBase(int i);

    @Query(value = "select name,type_name,type from advertising_platform order by sort ", nativeQuery = true)
    List<Object[]> findNameAndType();

}
