package com.reyun.repository;

import com.reyun.model.AppTip;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

@Transactional
public interface AppTipRepository extends JpaRepository<AppTip, Long> {

    @Query(value = "select * from app_tip where app  = ?1 limit 1", nativeQuery = true)
    AppTip findByAppId(Long id);
}
