package com.reyun.repository;

import com.reyun.model.CampaignExpired;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface CampaignExpiredRepository extends JpaRepository<CampaignExpired, Long>, JpaSpecificationExecutor<CampaignExpired> {

    @Query(value = "select surl from campaign_expired", nativeQuery = true)
    List<String> findAllSurl();

    @Query(value = "SELECT campaignid FROM campaign_expired WHERE campaignid IN (SELECT campaignid FROM campaign WHERE account IN (SELECT id  FROM account WHERE past_date < ?1))", nativeQuery = true)
    List<String> findDinstinctCampaignid(String date15);
}

