package com.reyun.repository;

import com.reyun.model.ChannelAdvertising;
import com.reyun.model.ChannelAdvertisingPackage;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author: liyin
 * @create: 2020-3-14 01:35:44
 **/
@Transactional
public interface ChannelAdvertisingPackageRepository extends JpaRepository<ChannelAdvertisingPackage,Long> {


    @Query(value = "select * from channel_advertising_package where status = true ", nativeQuery = true)
    List<ChannelAdvertisingPackage> listAll();

}
