package com.reyun.repository;

import com.reyun.model.ClickMonitor;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

/**
 */
public interface ClickMonitorRepository extends JpaRepository<ClickMonitor,Integer> {

    @Query(value = "select * from click_monitor where  dt = ?1 and  email = ?2 and ip= ?3 and clicktoken = ?4 limit 1", nativeQuery = true)
    ClickMonitor getOneByDateAndAccountAndIp(String format, String email ,String ip,String clickToken);



    @Query(value = "select * from click_monitor_pv where  dt = ?1 and  email = ?2 and ip= ?3 and clicktoken = ?4 limit 1", nativeQuery = true)
    ClickMonitor getPvByDateAndAccountAndIp(String today, String email, String ip,String clickToken);
}
