package com.reyun.repository;

import com.reyun.model.DataAuthPkgsubcampaign;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface DataAuthPkgsubcampaignRepository extends JpaRepository<DataAuthPkgsubcampaign, Long> {

    @Query(value = "select * from data_auth_pkgsubcampaign where account =?1 and app = ?2 and campaign = ?3", nativeQuery = true)
    List<DataAuthPkgsubcampaign> findPkgsubcampaignList(Long account,Long app ,Long campaign);

    @Transactional
    @Modifying
    @Query(value = "delete from data_auth_pkgsubcampaign where account =?1", nativeQuery = true)
    int delByAccount(Long account);

    @Query(value = "select * from data_auth_pkgsubcampaign where account =?1 and app = ?2", nativeQuery = true)
    List<DataAuthPkgsubcampaign> findPkgsubcampaignListByApp(Long id, Long app);

    /*@Transactional
    @Modifying
    @Query(value = "delete from data_auth where account = ?1", nativeQuery = true)
    void deleteAuthByAccount(Long account);*/
}
