package com.reyun.repository;

import com.reyun.model.DingSales;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface DingSalesRepository extends JpaRepository<DingSales, Long> {

    @Query(value = "select * from ding_sales where ding_nick = ?1 ", nativeQuery = true)
    DingSales findByNameOrNickName(String nickName);

}
