package com.reyun.repository;

import com.reyun.model.KeywordsCreative;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * Created by 热云数据 on 2018/5/4.
 */
public class KeywordsCreativeRepositoryImpl {
    @PersistenceContext
    protected EntityManager em;

    @Transactional
    public void batchInsert(List<KeywordsCreative> list) {
        for (int i = 0; i < list.size(); i++) {
            em.persist(list.get(i));
            if (i % 30 == 0) {
                em.flush();
                em.clear();
            }
        }
    }
}
