package com.reyun.repository;

import com.reyun.model.LifeCycleApps;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface LifeCycleAppsRepository extends JpaRepository<LifeCycleApps, Long> {


    @Query(value = "select * from life_cycle_apps where appid = ?1 ",nativeQuery = true)
    LifeCycleApps findByAppKey(String appkey);

    @Query(value = "select * from life_cycle_apps where appid = (select appkey from app where id = ?1)",nativeQuery = true)
    LifeCycleApps findByAppId(String appid);
}
