package com.reyun.repository;

import com.reyun.model.Notice;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * Created by sunhao on 17/3/1.
 */
@Transactional
public interface NoticeRepository  extends JpaRepository<Notice, Long> {

    @Query(value = "select * from notice n where n.isdeploy is true and n.deploy_date>= ?1 and (track_account='-1' or track_account like CONCAT('%<',?2,'>%')) union select * from notice where is_top=1 and isdeploy is true and deploy_date< ?1 and (track_account='-1' or track_account like CONCAT('%<',?2,'>%')) order by deploy_date desc"
            , nativeQuery = true)
    List<Notice> listRecentDeployNotice(String currentDate, Long rootParent);


}
