package com.reyun.repository;

import com.reyun.model.RestrictFlowsLog;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface RestrictFlowsLogRepository extends JpaRepository<RestrictFlowsLog, Long> {
    @Query(value = "select * from restrict_flows_log where account_id = ?  order by creat_time desc limit 1  ", nativeQuery = true)
    RestrictFlowsLog getLatesByAccount(Long accountId);

    @Query(value = "select * from restrict_flows_log where ds_value < ?1 and account_id = ?2 ", nativeQuery = true)
    List<RestrictFlowsLog> findNotUseful(String ds, Long account);
}
