package com.reyun.repository;

import com.reyun.model.SemRename;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface SemRenameRepository extends JpaRepository<SemRename, Long> {

    @Query(value = "select * from sem_rename where status=?1", nativeQuery = true)
    List<SemRename> findNotCompleteTasks(Integer status);

    @Query(value = "select * from sem_rename where appid=?1", nativeQuery = true)
    List<SemRename> findByappid(Long appid);
}