package com.reyun.repository;

import com.reyun.model.UniversalLoginIp;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface UniversalLoginIpRepository extends JpaRepository<UniversalLoginIp, String> {


    @Query(value = "select * from universal_login_ip where ip=?1 limit 1", nativeQuery = true)
    UniversalLoginIp findByIp(String ip);
}
