package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.AdNameSetting;
import com.reyun.util.ResultStatus;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

public interface AdvertisingService {

    ResultStatus importDataWithExcel(String id, Long appid, MultipartFile file);

    ResultStatus importDataWithCSV(String id, Long appid, MultipartFile file);

    List getAdNamesList(String appid, String adType, String searchName, String cid);

    List adChannels();

    void saveAdRenameData(AdNameSetting adName);

    List<String> advertiseridByReport(HttpServletRequest request, Account account);

    ResultStatus importDataOnCSV(String id, Long appid, MultipartFile file);
}

