package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.BlacklistApplication;

import java.util.Map;

/**
 * description:
 *
 * @author nolan
 * @date 25/09/2017
 */
public interface BlacklistService
{
    Map<String, Object> limit(Account account);

    BlacklistApplication create(Account account, BlacklistApplication blacklistApplication);

    void close(Account account);

    String findTell(Account account);

   Map<String, Object> report(Account account);

    BlacklistApplication findOne(Account account);
    //查询已开通
    BlacklistApplication findOneUsed(Account account);

    BlacklistApplication renew(Long id, String phone, Account account);

    BlacklistApplication findOneByParentId(Long parentId);

    Map updateFakeTips(Account loginAccount);

    Map<String,Object> hintArouseServiceInfo(Account loginAccount);

    Object updateArouseTips(Account loginAccount);
}
