package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.Crowd;
import org.springframework.http.ResponseEntity;

import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;

public interface CrowdService {

    Crowd create(Account account, Crowd source);

    Object findDetail(Long id);

    Object findOrders(Long rootParent);

    Map<String,Object> findBlackData(Account account);

    ResponseEntity<byte[]> download(Long id) throws UnsupportedEncodingException;

    HashMap<String, Object> getPriceDetail(Crowd crowd);

    Map<String,Object> findArouseData(Account account);
}
