package com.reyun.service;

import com.reyun.model.CallbackCustomize;
import com.reyun.model.CallbackNextday;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

import java.util.List;

public interface DataCallBackService {

    public JSONObject listParams();

    public JSONArray listEvents(Long channel ,String lanType,Long id);

    public Boolean valid(Long account, Long app, String name);

    public CallbackCustomize save(CallbackCustomize callbackCustomize, Long account, Boolean isCustom);

    public CallbackCustomize delete(Long id, Long account);

    public CallbackCustomize update(CallbackCustomize callbackCustomize, Long account, Boolean isCustom);

    public List<CallbackCustomize> list(Long account, Long app);

    public List<CallbackCustomize> listAll(Long app);

    public CallbackCustomize enable(Long id, Long account);

    public CallbackCustomize forbidden(Long id, Long account);

    List<CallbackCustomize> find(Long app, Long channelId);

    List<CallbackNextday> nextCallList(Long appid);

    int setNextActiveData(Long id, int statu);

    List<CallbackCustomize> nextCallApp(Long appid);
}
