package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.ViewColumn;

import java.util.List;

/**
 * Created by nolan on 28/12/2016.
 * description:
 */
public interface IViewColumnService {

    /**
     * 查找当前用户推广活动详情的字段显示配置
     *
     * @param account
     * @return
     */
    List<ViewColumn> findUserViewColumns(Account account, Long appid, String menu, String lanType);

    /**
     * 保存当前用户字段显示配置
     *
     * @param accountid
     * @param viewcolumn
     */
    void saveUserViewColumn(Long accountid, Long appid, String viewcolumn, String menu);
}
