package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.EditionPricingLevel4Web;
import com.reyun.model.MenuApply;
import com.reyun.util.ResultModel;
import com.reyun.util.ResultStatus;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

public interface LoginService {

	Account login(String email, String pwd ,String ip);

	Account save(Account account);

	int updateAccountInfo(Account account, HttpServletRequest request);

    Account findAccountDetailAndLog(Account account);

    ResultStatus updateAccountPwd(String newPassword, String oldPassword, Account account);

    EditionPricingLevel4Web getChannelPriceEdition(Long appId);

    boolean isH5_Loguser(Account account);

    Map getAccountAuthMenu(Account loginAccount,Long app);

    Map<String, String> getAccountAuthMenuKeys(Account account);

    ResultModel accountAuthMenusApply(Account loginAccount, MenuApply apply);

    void getAuthMenusToRedis(Account loginAccount,boolean redisCheck);

    String getAuthMeunCheckKey(Account account);
}
