package com.reyun.service;

import java.io.UnsupportedEncodingException;
import java.util.List;

import com.reyun.model.Account;
import com.reyun.model.PackageSubCampaign;
import com.reyun.model.SubCampaignSurlModel;
import com.reyun.util.ResultModel;

/**
 * Created by mxq on 17/8/15.
 *
 */
public interface PackageSubCampaignService {

    List<PackageSubCampaign> listSubCampaign(Long campaignId);

    List<PackageSubCampaign> listDisableCampaign(Long campaignId);

    PackageSubCampaign findSubCampaign(Long id);

    PackageSubCampaign save(PackageSubCampaign source, Account account);

    PackageSubCampaign update(PackageSubCampaign source, Long account);

    void enable(String ids, Long account);

    void forbiden(String ids, Long account);

    boolean valid(Long campaign, String name);

    StringBuffer exportSubCampaign(Account account, Long campaignId,String ids) throws UnsupportedEncodingException;

    Long findSubCampaignNumber(Long campaignId);

    public SubCampaignSurlModel transform(PackageSubCampaign subCampaign);
    
    /**
     * 批量创建子分包活动(针对有些特殊渠道：百度原生OCPC)
     * @param list
     * @param account
     * @return
     */
    ResultModel batchSave(List<PackageSubCampaign> list,Account account);

    List<Object[]> findSubCampaignNumberByIds(List<Long> ids);

    Object echoDeepLink(Long appid, Long campaignid);
}