package com.reyun.service;

import com.reyun.model.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * Created by sunhao on 17/5/19.
 *
 */
public interface SubCampaignService {

    Map<String, List> saveSubCampaign(Account account,SubCampaign subCampaignSource);

    List<SubCampaign> listSubCampaign(Long campaignId);

    List<SubCampaign> listDisableCampaign(Long campaignId);

    SubCampaign findSubCampaign(Long subCampaignId);

    Long findSubCampaignNumber(Long campaignId);

    int modifySubCampaignUrl(Long subCampaignId, String url, Account account);

    int deleteSubCampaign(Account account, String ids);

    int enableSubCampaign(Account account, String ids);

    UploadHistory readKeywordFile(MultipartFile file, Account account, Long campaignId);

    List<SubCampaign> saveKeywordInfo(Long uploadHistoryId, Account account, Long campaignId);

    boolean exportSubCampaign(Account account, Long campaignId, List<Long> ids, String lanType);

    boolean exportBatchSubCampaign(Account account,Long appId,List<Long> ids);

    HttpServletResponse downloadSubCampaign(HttpServletRequest request, HttpServletResponse response, Account account, Long exportId) throws IOException;

    List<SubCampaignExport> listSubCampaignExport(Account loginAccount, Long appId);

    int updateSubCampaignExportStatus(Long id, String status);

    void deleteDownloadSubCampaign(Long id);
    /**
     * 查询下载地址下的子活动列表
     */
    List<CampaignUrl4Web> findSubCampaignByUrl(Long appid, String url);

    StringBuffer exportsurls2column(Iterable<Long> ids);

    List<Object []> findSubCampaignNumberByIds(List<Long> ids);
}