package com.reyun.service.impl;

import com.reyun.model.AppExtend;
import com.reyun.repository.AppExtendRepository;
import com.reyun.service.AppExtendService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author liyin
 * @description
 * @date
 */
@Service
public class AppExtendServiceImpl implements AppExtendService {
    @Autowired
    private AppExtendRepository appExtendRepository;


    @Override
    public AppExtend findOneByAppid(Long appid) {
        return appExtendRepository.findOneByAppid(appid);
    }

    @Override
    public AppExtend save(AppExtend appExtend) {
        return appExtendRepository.save(appExtend);
    }

    @Override
    public AppExtend finOne(Long exportid) {
        return appExtendRepository.findOne(exportid);
    }
}
