package com.reyun.service.impl;

import com.reyun.model.ExportGdt;
import com.reyun.repository.ExportGdtRepository;
import com.reyun.service.ExportGdtService;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;

@Service
public class ExportGdtImpl implements ExportGdtService {


	@Autowired
	ExportGdtRepository exportGdtRepository;


	@Override
	public Object find(Long app) {

		return exportGdtRepository.findOne(app);
	}

	@Override
	public Object able(Long app, String email,boolean status) {
		if(status){
			ExportGdt exportGdt = new ExportGdt();
			exportGdt.setApp(app);
			exportGdt.setUpdateAccount(email);
			return exportGdtRepository.save(exportGdt);
		}
		exportGdtRepository.delete(app);
		return app;
	}

	@Override
	public Object check(Long app) {
		HashMap<Object, Object> objectObjectHashMap = new HashMap<>(1);
		objectObjectHashMap.put("status",exportGdtRepository.findOne(app)!=null);
		return objectObjectHashMap;
	}
}
