package com.reyun.service.impl;

import com.reyun.model.*;
import com.reyun.util.ResultModel;
import org.springframework.http.ResponseEntity;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

public interface OnelinkService {

	public Boolean validName(Long appid,String name,Long id);

	public int validAppleId(Long account,Long appid);

	public List<App> listApps(Long account, String platform, String lanType);

	public List<Channel> listChannels(Long appid, String lanType);

	public List<Campaign4Web> listCampaigns(Long appid, Long Channel, String lanType);

	public Onelink create(Long account, Onelink onelink);

	public Onelink update(Long account, Onelink onelink);

	public Onelink findone(Long id);

	public List<Onelink> find(Long account, Long app);

	public Onelink delete(Long account,Long id);

	public void taskSurlToDDb();

	public long findOnelinkNumber(Long campaignid);

    ResponseEntity<byte[]> downloadQrCode(Long id);

    ResultModel codeLogoMake(MultipartFile file, Long appid, Account account, String onelinkSurl);
}
