package com.reyun.taskexecute;

import com.reyun.context.AppUtils;
import com.reyun.model.Account;
import com.reyun.model.Channel;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.BussinessManRepository;
import com.reyun.repository.ChannelRepository;
import com.reyun.util.SendCommonPostMail;
import com.reyun.util.ValidateUtil;

import java.util.*;

/**
 * Created by mxq on 2017/10/24.
 */
public class SendEmailThread extends Thread{
    private AccountRepository accountRepository = AppUtils.getApplicationContext().getBean(AccountRepository.class);
    private ChannelRepository repository = AppUtils.getApplicationContext().getBean(ChannelRepository.class);
    private BussinessManRepository bussinessManRepository = AppUtils.getApplicationContext().getBean(BussinessManRepository.class);

    private Channel channel;
    private Account loginAccount;

    public SendEmailThread(Channel channel, Account loginAccount) {
        this.channel = channel;
        this.loginAccount = loginAccount;
    }

    @Override
    public void run() {
        String subject = "TrackingIo创建渠道";
        if("APPMARKET".equals(channel.getCategory())){
            List<Channel> channelList = repository.findByNameAndCategroy("APPMARKET", channel.getName());
            if(ValidateUtil.isValid(channelList) && channelList.size() == 1){
                Account account = loginAccount;
                if(null != loginAccount.getRootParent()){
                    account = accountRepository.findOne(loginAccount.getRootParent());
                }
                StringBuilder content = new StringBuilder();
                content.append("<!doctype html> <html><head></head><body> ")
                        .append("Larry：</br>")
                        .append("客户 " + account.getCompany() + " 创建了应用市场类型渠道，名称为“"+ channel.getName()+"”，请做对应处理。")
                        .append("</body></html>");
                String contents = content.toString();

                    List<String> list = new ArrayList<>();
                        list.add("support@reyun.com");
                    //list.add("manxiaoqiang@reyun.com");
                    try {
                        //MailUtils.sendHtmlEmail(subject,contents,list);
                        SendCommonPostMail.sendMailReuse(list, subject, contents,null,null);
                    } catch (Exception e) {
                        //logger.error(e.getMessage(),e);
                    }
                }
            }
        }
    }
