package com.reyun.util;

/* 以后上层应用读写消息队列时(例如不同云厂商的kimesis/ckafka产品)请使用本类，勿直接调用特定的产品工具类，例如KinesisUtil */
public class MessageQueueUtil {

    public static void putRecord(String queueName, String data) {
        if (Constant.isQcloudEnv()) { //腾讯云写入ckafka,消息转储到cos
            int pos = data.lastIndexOf("\n");
            data = pos == -1 ? data : data.substring(0, pos);
            KafkaUtil.getInstance().send(queueName, data);
        } else if (Constant.isAwsEnv()) { //亚马逊
            KinesisUtil.getInstance().putRecord(queueName, data);
        }
    }
}