(function(){
    angular.module("app.collect")
        .controller("attributeCtrl",["$scope","$rootScope","HttpService","ToolService","$filter",attributeCtrl]);

    function attributeCtrl($scope,$rootScope,HttpService,ToolService,$filter){

    	$scope.query = function(){
    		var params = {
    			deviceid : $scope.deviceid
    		}

    		var queryPM = HttpService.getInfo('attr/findAttr/'+$scope.appid,params);
    		$scope.infoListLoading = true;
    		queryPM.then(function(data){
    			$scope.attrInfos = data;
    			$scope.infoListLoading = false;
                $rootScope.operSubmitData($filter('translate')("归因查询"));

    		});
    	} 

    	$scope.doQuery = function(){
			ToolService.sendBehaviorUv("deviceView");
    		if(!$scope.deviceid || $scope.deviceid == ''){
    			ToolService.showTips($filter('translate')('请输入设备ID'));
    			return false;
    		}
    		$scope.query();
    	}

    	$scope.$watch("appid",function(n){
    		if(angular.isDefined(n)){
    			$scope.attrInfos = {};
    		}
    	});
    }
})();