(function() {
    angular.module("app.collect")
        .controller("channeloverviewCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$timeout", "$filter","DateService", "$translate", channeloverviewCtrl]);

    function channeloverviewCtrl($scope, $rootScope, HttpService, ToolService, $timeout, $filter, DateService, $translate) {
        /**
         * 语言切换
         */
        var orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        // $scope.$on('curdate', function(e, msg) {
        //     console.log(msg)
        //     $scope.date = msg.date;
            
        // });
        //时间控件
        $scope.beginDate = DateService.getDay(0);
        $scope.timeflag = 'today';
        $scope.$on("beginDate",function(e,msg){
            $scope.beginDate = msg;
            if(msg == DateService.getDay(0)){
                $scope.timeflag = 'today';
            } else if (msg == DateService.getDay(-1)) {
                $scope.timeflag = 'yesday';
            } else {
                $scope.timeflag = '';
            }
            $scope.query();
        });
        $scope.changeDate = function(flag) {
            if(flag == 'today'){
                $scope.beginDate = DateService.getDay(0);
            } else {
                $scope.beginDate = DateService.getDay(-1);
            }
            $scope.timeflag = flag;
            $scope.query();
        }

        //排序
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("{appid:appid,lang:lang}", function(n, o) {
            if (angular.isUndefined($scope.appid)) { return false; }
            $scope.querySelectInfos();
            $scope.query();
            if(n && o && n!==o){
                // $scope.initData();
                console.log(1)
            }
        });

        //分析维度
        $scope.selectFlag = 'channel';
        $scope.changeSelectFlag = function(flag) {
            if($scope.selectFlag != flag) {
                $scope.selectFlag = flag;
                $scope.query();
            }
        }
        // $scope.dimensionList = [
        //     {id:'1',name:$translate.instant("渠道维度")},
        //     {id:'2',name:$translate.instant("活动维度")},
        // ]
        // $scope.dimensionInit = '1';
        // $scope.dimensionId = '1';
        // $scope.$on("dimensionId", function(e, msg) {
        //     console.log(111)
        //     if($scope.dimensionId != msg.info.id){
        //         $scope.dimensionId = msg.info.id
        //         $scope.query();
        //     }
        // });

        //数据筛选
        $scope.querySelectInfos = function() {
            $translate(["不筛选", "自然量"]).then(function(translations) {
                $scope.initSelects(translations["不筛选"], translations["自然量"]);
            }, function(tranIds) {
                $scope.initSelects(tranIds["不筛选"], tranIds["自然量"]);
            });
        }
        $scope.initSelects = function(noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;;
            channelPM.then(function(data) {
                if (!(!$rootScope.isall && $rootScope.curRoleAuth && !$rootScope.curRoleAuth.isNatureOpen)) {
                    data.unshift({ id: "-1", name: nat });
                }
                $scope.channelList = data;
            });

            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;;
            campaignPM.then(function(data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.unshift({ id: "all", name: $scope.campaignNameInit });
                data.filter(function(item) {
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                $scope.campaignList = data;
                $scope.campaignListAll = data;
            });
        }

        $scope.selectlistNum = 0;
        $scope.$on("channelid", function(e, msg) {
            $scope.channelid = msg.info;
            $timeout(function() {
                $scope.query();
            }, 100);
            // $scope.selectlistNum++;
        });

        $scope.campaignInit = "all";
        $scope.$on("campaignid", function(e, msg) {
            $scope.campaignid = msg.info.id;
            $timeout(function() {
                $scope.query();
            }, 100);
            // $scope.selectlistNum++;
        });
        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function(event, data) {
            $scope.campaignList = $scope.campaignListAll
        })

        $scope.searchTextId = "searchTextId";
        $scope.$on($scope.searchTextId, function(event, data) {
            if (!data) {
                return false
            }
            var Pm = HttpService.getInfo($scope.appid + "/campaign/dropdown?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.campaignList = dataList
                }

            });

        });


        // 状态筛选
        $scope.statusList = [
            { id: "", name: $translate.instant("不筛选推广活动状态") },
            { id: "false", name: $translate.instant("已启用推广活动") },
            { id: "true", name: $translate.instant("已停用推广活动") }
        ];
        $scope.statusidInit = "";
        $scope.$on("statusid", function(e, msg) {
            $scope.statusid = msg.info.id;
            $scope.query();
        });

        //右侧输入框搜索
        $scope.filterByTxt = function(txt) {
            $scope.filterTxt = txt;
            $scope.query();
        }

        $scope.campListLoading = true;
        $scope.$on("conentresize", function() {
            if ($scope.campList) $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);
        });

        //数据列表
        $scope.query = function() {
            var qReport = "";
            var eptName = '';
            var params = ToolService.getParams($scope);
            params.startdate = $scope.beginDate
            params.enddate = $scope.beginDate
            params.datatype = 'list'
            params.func = 'channelinfo'
            params.viewcolumn = 'num_install,dau,loss_num,silent_num,backflow_num,rate_backflow_num'
            if($scope.selectFlag == 'channel') {
                qReport = 'channel_bychannel_overview'
                params.viewtype = 'channel'
                eptName = $filter('translate')('渠道');
            } else {
                qReport = 'channel_bycampaign_overview'
                params.viewtype = 'campaign'
                eptName = $filter('translate')('活动');
            }
            if($scope.channelid){
                params.cid = $scope.channelid;
            }
            if($scope.campaignid){
                params.campaignid = $scope.campaignid;
            }
            if($scope.filterTxt){
                params.searchtxt = $scope.filterTxt;
            }
            if($scope.statusid != "") {
                params.del_flag = $scope.statusid;
            }
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("用户生命周期-渠道概览") + "-" + eptName, qReport, params);
            var listPM = HttpService.getReportData(qReport, params);
            listPM.then(function(data){
                // ToolService.hideLoading();
                $scope.campListLoading = false;
                $scope.campList = data;
                $scope.infoListTotal = data.val[0];
                $scope.campAllList = data.val.slice(1);
                $scope.infoList = $scope.campAllList;

                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
            })
        }
        
        //分页
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });
    }

})();