(function () {
		angular.module("app.collect")
        .controller("dashboardCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$filter",dashboardCtrl]);

    function dashboardCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$filter){


		// $scope.iswx = false;
		$scope.initLoading = function () {
			$scope.clickLoading = true;
			$scope.installLoading = true;
			$scope.installrateLoading = true;
			$scope.dauLoading = true;
			$scope.regeditLoading = true;
			$scope.retetionLoading = true;
			$scope.paymentLoading = true;
			$scope.channelClickLoading = true;
			$scope.channelActiveLoading = true;
			$scope.channelPaymentLoading = true;
			$scope.orderLoading = true;
			$scope.deviceLoading = true;
			$scope.amtLoading = true;
			$scope.perticketLoading = true;
			$scope.payrateLoading = true;
			$scope.channelOrderLoading = true;
			$scope.channelAmtLoading = true;
			$scope.channelPerticketLoading = true;
			$scope.channelPayrateLoading = true;
		};
		
		$scope.initLoading();
		$scope.$on('curdate', function (e, msg) {
			$scope.date = msg.date;
			$scope.timeflag = msg.timeflag;
			$scope.subfix = msg.subfix;
		});
		var rmd = new Date().getTime();
		$scope.query = function(){
        	var params = ToolService.getParams($scope);
            params.datatype = 'chart';
            if(!$scope.iswx && !$scope.iswg) {//非小程序时，查询的信息
                //点击量趋势
                $scope.clickConfig = {color: ToolService.getOneColors(), legend: false};
                var clickPM = HttpService.getReportData($scope.nowReports[0].name + $scope.subfix, params);
                $scope.clickLoading = true;
                clickPM.then(function (data) {
                    data.rmd = ++rmd;
                    $scope.clickData = data;
                    $scope.clickLoading = false;

                    $scope.clickDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[0].title, $scope.nowReports[0].name + $scope.subfix, params);
                });

                //激活量趋势
                $scope.installConfig = {color: $scope.isweb ? ToolService.getThreeColors() : ToolService.getTwoColors()};
                var installPM = HttpService.getReportData($scope.nowReports[1].name + $scope.subfix, params);
                $scope.installLoading = true;
                installPM.then(function (data) {
                    data.rmd = ++rmd;
                    $scope.installData = data;
                    $scope.installLoading = false;
                    $scope.installDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[1].title, $scope.nowReports[1].name + $scope.subfix, params);
                });

                //激活率趋势
                var sub = $scope.timeflag == 'yesday' && $scope.isweb ? "ds" : $scope.subfix;
                $scope.installrateConfig = {
                    color: ToolService.getTwoColors(),
                    ispercent: ($scope.isweb ? false : true)
                };
                $scope.nodata = $scope.isweb && $scope.timeflag == 'today';
                if ($scope.nodata) {
                    $scope.installrateLoading = false;
                    $scope.installrateData = {
                        "help": [""], "name": [], "column": [$filter('translate')('日期')], "key": [], "val": [], "israte": null,
                        "dealtype": ["sum"], "reportname": ["h5_dashboard_newusers_byds"],
                        "desc": [$filter('translate')('仪表盘>>新增访客趋势(按小时)')], "keyId": null, "subval": [], "subtotalval": 0
                    };
                } else {
                    var installratePM = HttpService.getReportData($scope.nowReports[2].name + sub, params);
                    $scope.installrateLoading = true;
                    installratePM.then(function (data) {
                        data.rmd = ++rmd;
                        $scope.installrateData = data;
                        $scope.installrateData.subtotalval = $scope.isweb ? data.subtotalval : (data.subtotalval + '%');
                        $scope.installrateLoading = false;
                        $scope.installrateDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[2].title, $scope.nowReports[2].name + sub, params);
                    });
                }

                //DAU趋势
                $scope.dauConfig = {color: ToolService.getOneColors(), legend: false};
                var dauPM = HttpService.getReportData($scope.nowReports[3].name + $scope.subfix, params);
                $scope.dauLoading = true;
                dauPM.then(function (data) {
                    data.rmd = ++rmd;
                    $scope.dauData = data;
                    $scope.dauLoading = false;
                    $scope.dauDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[3].title, $scope.nowReports[3].name + $scope.subfix, params);
                });

                //注册趋势
                $scope.regeditConfig = {color: ToolService.getTwoColors()};
                var regeditPM = HttpService.getReportData($scope.nowReports[4].name + $scope.subfix, params);
                $scope.regeditLoading = true;
                regeditPM.then(function (data) {
                    data.rmd = ++rmd;
                    $scope.regeditData = data;
                    $scope.regeditLoading = false;
                    $scope.regeditDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[4].title, $scope.nowReports[4].name + $scope.subfix, params);
                });



				var noshow = 0;
				if ($scope.industory == 'ec' && !$scope.isweb) {
					if ($scope.showDataModel('order')) {
						//订单趋势
						$scope.orderConfig = { color: ToolService.getTwoColors() };
						var orderPM = HttpService.getReportData($scope.nowReports[10].name + $scope.subfix, params);
						$scope.orderLoading = true;
						orderPM.then(function (data) {
							data.rmd = ++rmd;
							$scope.orderData = data;
							$scope.orderLoading = false;
							$scope.orderDataCondition = ToolService.getChartConditions("仪表盘-" + $scope.nowReports[10].title, $scope.nowReports[10].name + $scope.subfix, params);
						});
						//下单设备趋势
						$scope.deviceConfig = { color: ToolService.getTwoColors() };
						var devicePM = HttpService.getReportData($scope.nowReports[11].name + $scope.subfix, params);
						$scope.deviceLoading = true;
						devicePM.then(function (data) {
							data.rmd = ++rmd;
							$scope.deviceData = data;
							$scope.deviceLoading = false;
							$scope.deviceDataCondition = ToolService.getChartConditions("仪表盘-" + $scope.nowReports[11].title, $scope.nowReports[11].name + $scope.subfix, params);
						});
					}
					if ($scope.showDataModel('pay')) {
						//订单总额
						$scope.amtConfig = { color: ToolService.getTwoColors() };
						var amtPM = HttpService.getReportData($scope.nowReports[12].name + $scope.subfix, params);
						$scope.amtLoading = true;
						amtPM.then(function (data) {
							data.rmd = ++rmd;
							$scope.amtData = data;
							$scope.amtLoading = false;
							$scope.amtDataCondition = ToolService.getChartConditions("仪表盘-" + $scope.nowReports[12].title, $scope.nowReports[12].name + $scope.subfix, params);
						});
						//客单价趋势
						$scope.perticketConfig = { color: ToolService.getTwoColors() };
						var perticketPM = HttpService.getReportData($scope.nowReports[13].name + $scope.subfix, params);
						$scope.perticketLoading = true;
						perticketPM.then(function (data) {
							data.rmd = ++rmd;
							$scope.perticketData = data;
							$scope.perticketLoading = false;
							$scope.perticketDataCondition = ToolService.getChartConditions("仪表盘-" + $scope.nowReports[13].title, $scope.nowReports[13].name + $scope.subfix, params);
						});
						//付费率趋势
						$scope.payrateConfig = { color: ToolService.getTwoColors() };
						var payratePM = HttpService.getReportData($scope.nowReports[14].name + $scope.subfix, params);
						$scope.payrateLoading = true;
						payratePM.then(function (data) {
							data.rmd = ++rmd;
							$scope.payrateData = data;
							$scope.payrateLoading = false;
							$scope.payrateDataCondition = ToolService.getChartConditions("仪表盘-" + $scope.nowReports[14].title, $scope.nowReports[14].name + $scope.subfix, params);
						});
					}
				} else {
					//次日留存趋势
					if ($scope.showDataModel('retention')) {
						var myparams = UtilService.cloneJSON(params);
						// if (myparams.startdate != myparams.enddate) {
							// myparams.startdate = addDate(myparams.startdate, -1);
							// myparams.enddate = addDate(myparams.enddate, -1);
							// console.log(myparams.startdate,myparams.enddate)
						// }
						$scope.retetionConfig = { color: ToolService.getThreeColors(), ispercent: true };
						var retetionPM = HttpService.getReportData($scope.nowReports[9].name, myparams);
						$scope.retetionLoading = true;
						retetionPM.then(function (data) {
							data.rmd = ++rmd;
							$scope.retetionData = data;
							$scope.retetionLoading = false;
							$scope.retetionDataCondition = ToolService.getChartConditions("仪表盘-" + $scope.nowReports[9].title, $scope.nowReports[9].name, myparams);
						});
					}
					else {
						noshow++;
					}
					//收入趋势
					if($scope.showDataModel('pay')){
						$scope.paymentConfig = {color:ToolService.getTwoColors()};
						var paymentPM = HttpService.getReportData($scope.nowReports[5].name+$scope.subfix,params);
						$scope.paymentLoading = true;
						paymentPM.then(function(data){
							data.rmd = ++rmd;
							$scope.paymentData = data;
							$scope.paymentLoading = false;
							$scope.paymentDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[5].title,$scope.nowReports[5].name+$scope.subfix,params);
						});
					}
					else{
						noshow++;
					}
				}

				$scope.modelShow = noshow;
				if ($scope.showDataModel('topauth')) {
					//top10点击渠道
					$scope.channelClickConfig = { color: ToolService.getOneColors(), legend: false, isbartext: true };
					var channelClickPM = HttpService.getReportData("channelclick_top10_bychannel", params);
					$scope.channelClickLoading = true;
					channelClickPM.then(function (data) {
					data.rmd = ++rmd;
					$scope.channelClickData = data;
					$scope.channelClickLoading = false;
					$scope.channelClickDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[6].title,$scope.nowReports[6].name,params);
				});

					//top10激活渠道
					$scope.channelActiveConfig = { color: ToolService.getOneColors(), legend: false, isbartext: true };
					var channelActivePM = HttpService.getReportData($scope.nowReports[7].name, params);
					$scope.channelActiveLoading = true;
					channelActivePM.then(function (data) {
						data.rmd = ++rmd;
						$scope.channelActiveData = data;
						$scope.channelActiveLoading = false;
						$scope.channelActiveDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[7].title,$scope.nowReports[7].name,params);
					});
				}
				if ($scope.showDataModel('topauth')) {
					if ($scope.industory == 'ec' && !$scope.isweb) {
						if ($scope.showDataModel('order')) {
							
						 //top10订单渠道
						 $scope.channelOrderConfig = {color:ToolService.getOneColors(),legend:false,isbartext:true};
						 var channelOrderPM = HttpService.getReportData($scope.nowReports[15].name,params);
						 $scope.channelOrderLoading = true;
						 channelOrderPM.then(function(data){
							 data.rmd = ++rmd;
							 $scope.channelOrderData = data;
							 $scope.channelOrderLoading = false;
							 $scope.channelOrderDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[15].title,$scope.nowReports[15].name,params);
						 });
			   }
	 

						if ($scope.showDataModel('pay')) {
							//top10订单总额渠道
							$scope.channelAmtConfig = {color:ToolService.getOneColors(),legend:false,isbartext:true};
							var channelAmtPM = HttpService.getReportData($scope.nowReports[16].name,params);
							$scope.channelAmtLoading = true;
							channelAmtPM.then(function(data){
								data.rmd = ++rmd;
								$scope.channelAmtData = data;
								$scope.channelAmtLoading = false;
								$scope.channelAmtDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[16].title,$scope.nowReports[16].name,params);
							});

							//top10客单价渠道
							$scope.channelPerticketConfig = {color:ToolService.getOneColors(),legend:false,isbartext:true};
							var channelPerticketPM = HttpService.getReportData($scope.nowReports[17].name,params);
							$scope.channelPerticketLoading = true;
							channelPerticketPM.then(function(data){
								data.rmd = ++rmd;
								$scope.channelPerticketData = data;
								$scope.channelPerticketLoading = false;
								$scope.channelPerticketDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[17].title,$scope.nowReports[17].name,params);
							});
							//top10付费率渠道
							$scope.channelPayrateConfig = {color:ToolService.getOneColors(),legend:false,isbartext:true,ispercent:true};
							var channelPayratePM = HttpService.getReportData($scope.nowReports[18].name,params);
							$scope.channelPayrateLoading = true;
							channelPayratePM.then(function(data){
								data.rmd = ++rmd;
								$scope.channelPayrateData = data;
								$scope.channelPayrateLoading = false;
								$scope.channelPayrateDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[18].title,$scope.nowReports[18].name,params);
							});
		


						}
					} else {
							//top10付费渠道
							if($scope.showDataModel('pay')){
								$scope.channelPaymentConfig = {color:ToolService.getOneColors(),legend:false,isbartext:true};
								var channelPaymentPM = HttpService.getReportData($scope.nowReports[8].name,params);
								$scope.channelPaymentLoading = true;
								channelPaymentPM.then(function(data){
									data.rmd = ++rmd;
									$scope.channelPaymentData = data;
									$scope.channelPaymentLoading = false;
									$scope.channelPaymentDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-"+$scope.nowReports[8].title,$scope.nowReports[8].name,params);
								});
	  
						}

					}
				}
			} else {
				whenWX($scope, params, $scope.nowReports);
			}

		}

		//预约监测横幅提醒
		$scope.getOnlineTips = function(){
			var channelPM = HttpService.getInfo("mng/app/tipRemind/" + $scope.appid);
			channelPM.then(function(data) {
				$rootScope.appOnlineTips = data.appOnlineService.appOnlineTips;
				if($rootScope.appOnlineTips){
					$rootScope.appName = data.appOnlineService.appName;
					$rootScope.appOnlineRemindDays = data.appOnlineService.appOnlineRemindDays;
				}
				
			})
		}
		
		$scope.closeTip = function(){
			var channelPM = HttpService.getInfo("mng/app/todayCloseTip/" + $scope.appid);
			channelPM.then(function(data) {
				$scope.getOnlineTips();
			})
		}
		
		$scope.$on('closeTip', function(event, args) {
			$scope.closeTip();
		});
		//微信小程序时执行请求
		function whenWX(scope,params,reports){
			var wxData = {};
			if($scope.iswg){
				reports = reports.filter(function(item){
					if(item.name == "wx_dashboard_flow_by" ){
						return false;
					}
					return true;
				});
			}		
			reports.forEach(function(item){
				var filed = item.retFiled;
				wxData[filed+'Config'] = {color:getColorList(item.cNum),legend: item.cNum>0 ? true: false,isbartext:true};
				var channelPaymentPM = HttpService.getReportData((item.type == 'overview'|| item.type=='effect') ? (item.name+$scope.subfix): item.name,params);
				wxData[filed+'Loading']= true;
				channelPaymentPM.then(function(data){
					data.rmd = ++rmd;
					wxData[filed+'Data'] = data;
					wxData[filed+'Loading'] = false;
					wxData[filed+'DataCondition'] = ToolService.getChartConditions($filter('translate')('实时')+"-"+item.title,(item.type == 'overview'|| item.type=='effect') ? (item.name+$scope.subfix): item.name,params);
				});
			});
			
			scope.wxData = wxData;

		}


		//根据定义的颜色个数获取颜色列表。 
		function getColorList(num) {
			var colorList = [];
			switch (num) {
				case 1:
					colorList = ToolService.getOneColors();
					break;
				case 2:
					colorList = ToolService.getTwoColors();
					break;
				case 3:
					colorList = ToolService.getThreeColors();
					break;
				case 6:
					colorList = ToolService.getSixColors();
					break;
				case 10:
					colorList = ToolService.getTenColors();
					break;
				default:
					colorList = ToolService.getOneColors();
			}
			return colorList;
		}

        var webReports = [{name:"h5_dashboard_click_by",
                           title:'点击趋势'},
                          {name:"h5_dashboard_flow_by",
                           title:'流量趋势',
                           counts:['PV总数','UV总数','独立IP总数']},
                          {name:"h5_dashboard_newusers_by",
                           title:'新增独立访客趋势',
                           count:'新增独立访客总数'},
                          {name:"h5_dashboard_login_by",
                           title:'登录趋势',
                           count:'登录总数'},
                          {name:"h5_dashboard_register_by",
                           title:'注册趋势'},
                          {name:"h5_dashboard_income_by",
                           title:'收入趋势'},
                          {name:"h5_dashboard_channelclick_top10_bychannel",
                           title:'TOP10点击渠道'},
                          {name:"h5_dashboard_newuser_top10_bychannel",
                           title:'TOP10新增独立访客渠道'},
                          {name:"h5_dashboard_income_top10_bychannel",
                           title:'TOP10收入渠道'}];
        var moveReports = [{name:"click_by",
                           title:'点击趋势'},
                           {name:"install_by",
                           title:'激活趋势',
                           counts:['激活总数']},
                           {name:"rate_install_by",
                           title:'激活率趋势',
                           count:'激活率均值'},
                           {name:"dau_by",
                           title:'DAU趋势',
                           count:'活跃总数'},
                           {name:"reged_by",
                           title:'注册趋势'},
                           {name:"income_by",
                           title:'收入趋势'},
                           {name:"channelclick_top10_bychannel",
                           title:'TOP10点击渠道'},
                           {name:"channelinstall_top10_bychannel",
                           title:'TOP10激活渠道'},
                           {name:"channelincome_top10_bychannel",
                           title:'TOP10收入渠道'},
                           {name:"rate_retentiond1_byds",
                           title:'次日留存趋势'},
                           {name:"order_by",
                           title:'支付订单趋势'},
                           {name:"order_device_by",
                           title:'支付设备趋势'},
                           {name:"order_amt_by",
                           title:'支付总额趋势'},
                           {name:"perticket_by",
                           title:'支付客单价趋势'},
                           {name:"order_pay_rate_by",
                           title:'订单付费率趋势'},
                           {name:"order_top10_bychannel",
                           title:'TOP10支付订单渠道'},
                           {name:"order_amt_top10_bychannel",
                           title:'TOP10支付总额渠道'},
                           {name:"perticket_top10_bychannel",
                           title:'TOP10支付客单价渠道'},
                           {name:"order_pay_rate_top10_bychannel",
                           title:'TOP10订单付费率渠道'}];
		var selfBuiltReports = [{name:"click_by",
			title:'点击趋势'},
			{name:"install_by",
				title:'表单趋势',
				counts:['表单总数']},
			{name:"rate_install_by",
				title:'转换率趋势',
				count:'转换率均值'},
			{name:"dau_by",
				title:'DAU趋势',
				count:'活跃总数'},
			{name:"reged_by",
				title:'注册趋势'},
			{name:"income_by",
				title:'收入趋势'},
			{name:"channelclick_top10_bychannel",
				title:'TOP10点击渠道'},
			{name:"channelinstall_top10_bychannel",
				title:'TOP10表单渠道'},
			{name:"channelincome_top10_bychannel",
				title:'TOP10收入渠道'},
			{name:"rate_retentiond1_byds",
				title:'次日留存趋势'},
			{name:"order_by",
				title:'支付订单趋势'},
			{name:"order_device_by",
				title:'支付设备趋势'},
			{name:"order_amt_by",
				title:'支付总额趋势'},
			{name:"perticket_by",
				title:'支付客单价趋势'},
			{name:"order_pay_rate_by",
				title:'订单付费率趋势'},
			{name:"order_top10_bychannel",
				title:'TOP10支付订单渠道'},
			{name:"order_amt_top10_bychannel",
				title:'TOP10支付总额渠道'},
			{name:"perticket_top10_bychannel",
				title:'TOP10支付客单价渠道'},
			{name:"order_pay_rate_top10_bychannel",
				title:'TOP10订单付费率渠道'}];
        var wxReports = [
			{name:'wx_dashboard_click_by',title:'访问次数趋势',type:'overview',retFiled:'click',cNum:2},
			{name:'wx_dashboard_install_by',title:'新增用户趋势',type:'overview',retFiled:'install',cNum:2},
			{name:'wx_dashboard_flow_by',title:'流量趋势',type:'overview',retFiled:'flow',cNum:2},
			{name:'wx_dashboard_bounce_by',title:'跳出率',type:'overview',retFiled:'bounce',cNum:2},
			{name:'wx_dashboard_register_by',title:'注册趋势',type:'effect',retFiled:'register',cNum:3},
			{name:'wx_rate_retentiond1_by',title:'次日留存趋势',type:'effect',retFiled:'rate',cNum:3},
			{name:'wx_dashboard_income_by',title:'收入趋势',type:'effect',retFiled:'income',cNum:3},
			{name:'wx_dashboard_channelclick_top10_bychannel',title:'TOP10访问渠道',type:'top',retFiled:'channelclick',cNum:1},
			{name:'wx_dashboard_newuser_top10_bychannel',title:'Top10新增用户渠道',type:'top',retFiled:'newuser',cNum:1},
			{name:'wx_dashboard_income_top10_bychannel',title:'TOP10收入渠道',type:'top',retFiled:'income_top10',cNum:1},
			{name:'wx_dashboard_openscene_top10',title:'TOP10访问场景',type:'top',retFiled:'openscene',cNum:1},
			{name:'wx_dashboard_newuserscene_top10',title:'TOP10新增场景',type:'top',retFiled:'newuserscene',cNum:1},
			{name:'wx_dashboard_incomescene_top10',title:'TOP10收入场景',type:'top',retFiled:'incomescene',cNum:1},
		]

        $scope.$watch("timeflag+appid+date.startDate+date.endDate+lang",function(n){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.timeflag)){
				$scope.getOnlineTips();
				var iswxReports=[];
				if($scope.iswg){   //小游戏没有流量趋势
					iswxReports = wxReports.filter(function(item){
						if(item.name == "wx_dashboard_flow_by" ){
							return false;
						}
						return true;
					});
				}else{
					iswxReports = wxReports
				}	
				$scope.nowReports = $scope.isweb ? webReports: ($scope.iswx || $scope.iswg) ? iswxReports: $scope.isSelfBuilt ? selfBuiltReports : moveReports;
        		// $scope.nowReports = $scope.isweb?webReports:moveReports;
            	$scope.industory = $scope.appInstance.industory;
				$scope.query();
        	}
        });
    }
})();
