(function() {
    angular.module("app.collect")
        .controller("fakedecCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "DateService", "$timeout", "$filter", "UtilService", "$location", "$anchorScroll", "$translate", "$state", fakedecCtrl]);

    function fakedecCtrl($rootScope, $scope, HttpService, ToolService, DateService, $timeout, $filter, UtilService, $location, $anchorScroll, $translate, $state) {
        // var app_id = ToolService.getParams($scope);
        var loadingTime = new Date().getTime();
        var durationTime = 1000 * 3;
        $scope.initLoading = function() {
            // 初始化变量
            $scope.clickLoading = true;
            $scope.installOrderLoading = true;
            $scope.hijackLoading = true;
            $scope.subpackageLoading = true;
            $scope.attrTypeLoading = true;
            $scope.mttiLoading = true;
            $scope.zombieDataLoading = true;
            $scope.isChartShow1 = true;
            $scope.isChartShow2 = true;
            $scope.isChartShow3 = true;
            $scope.isChartShow4 = true;
            $scope.isChartShow5 = true;
            $scope.isChartShow6 = true;
            $scope.isChartShow7 = true;
        };

        //设置默认日期是昨日
        var yesDay = ToolService.getYesDay()
        UtilService.setCookie("dataFlag", "yesday", 1);
        UtilService.setCookie("cookieDateFlag", yesDay.startDate, 1);
        UtilService.setCookie("cookieStartDate", yesDay.startDate, 1);
        UtilService.setCookie("cookieEndDate", yesDay.endDate, 1);

        // $scope.appid = app_id.appid;
        $scope.selectFlag = "channel";
        $scope.$on('curdate', function(e, msg) {
            $scope.activeHk = '2';
            $scope.date = msg.date;
        });

        $scope.$on("channelFakeid", function(e, msg) {
            $scope.channelFakeinfo = msg.info;
            var tempList = JSON.parse(JSON.stringify($scope.typeInfoList));
            $scope.typelistFakeInfo = '';
            $scope.typeInfoList = []
            setTimeout(function() {
                $scope.typeInfoList = tempList;
            }, 1000)
        });
        $scope.$on("typelistFakeIds", function(e, msg) {
            $scope.typelistFakeInfo = msg.info;
            var tempList = JSON.parse(JSON.stringify($scope.channelFakeList));
            $scope.channelFakeList = [];
            $scope.channelFakeinfo = '';
            setTimeout(function() {
                $scope.channelFakeList = tempList;
            }, 1000);
        });

        $scope.closeMaturity = function() {
            var url = "login/fake_tips";
            var closePM = HttpService.postInfo(url);
            closePM.then(function(data) {
                $scope.fakeTips = false;
            });
        }

        $scope.queryFakeSelectInfos = function() {
                if (!$scope.firstSelectQuery && $scope.appid) {
                    $translate(["请选择", "自然量"]).then(function(translations) {
                        $scope.getFakeChannel(translations["请选择"], translations["自然量"]);
                    }, function(tranIds) {
                        $scope.getFakeChannel(tranIds["请选择"], tranIds["自然量"]);
                    });
                }
            }
            //获取渠道 
        $scope.getFakeChannel = function(noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;
            channelPM.then(function(data) {
                $scope.firstSelectQuery = false;
                $scope.channelFakeList = data;
            });

            //获取活动
            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            $scope.typeInfoname = noFilter + campaignparams.txt;
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;
            campaignPM.then(function(data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.filter(function(item) {
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                $scope.typeInfoList = data;
                $scope.campaignListAll = data;
                if ($scope.campaignListTotal.total >= 500) {
                    $scope.showSearchFakeBtn = true;
                } else {
                    $scope.showSearchFakeBtn = false;
                }
            });
        }

        $scope.clearTxtFakeId = "clearTxtFakeId";
        $scope.$on($scope.clearTxtFakeId, function(event, data) {
            $scope.typeInfoList = $scope.campaignListAll
        })

        $scope.showSearchFakeBtn = true
        $scope.searchActiveId = "searchActiveId";
        $scope.$on($scope.searchActiveId, function(event, data) {
            if (!data) {
                return false
            }
            var Pm = HttpService.getInfo($scope.appid + "/campaign/dropdown?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.typeInfoList = dataList
                }
            });
        });

        var colors = ["#E25277", "#FFBC12", "#10EEFF", "#4D97FF", "#4fbd3e"];
        var colors2 = ["#10EEFF", "#4D97FF"];
        var fakeReports = [{
                name: "black_top5_click_",
                name2: "black_top5_list_click_",
                title: "关联作弊分析",
                orderList: [{ id: "installTotal", name: "激活总数从高到低" }, { id: "fakeTotal", name: "关联作弊激活总数从高到低" }, { id: "channelBrush", name: "渠道刷量激活数从高到低" }, { id: "appBrush", name: "app刷量激活数从高到低" }, { id: "bigClick", name: "大点击激活数从高到低" }]
            },
            {
                name: "black_top5_device_",
                name2: "black_top5_list_device_",
                title: "虚假安装分析",
                installOrderList: [{ id: "installTotal", name: "激活总数由高到低" }, { id: "fake", name: "虚假安装总数由高到低" }, { id: "Simulator", name: "模拟器激活数由高到低" }, { id: "Brush", name: "真机刷量激活数由高到低" }],
                installRangeList: [{ id: "promotion", name: "推广量" }]
            },
            {
                name: "black_top5_hijack_",
                name2: "black_top5_list_hijack_",
                title: "点击劫持分析",
                attributionList: [{ id: "installTotal", name: "激活总数从高到低" }, { id: "clickJack", name: "点击劫持激活数从高到低" }],
                hijackTimeList: [{ id: "5s", name: "小于5秒" }, { id: "15s", name: "小于15秒" }, { id: "30s", name: "小于30秒" }, { id: "1m", name: "小于1分钟" }, { id: "5m", name: "小于5分钟" }]
            },
            {
                name: "black_top5_hijackpack_",
                name2: "black_top5_list_hijackpack_",
                hijackname: "black_top5_hijacked_pack_",
                hijackname2: "black_top5_list_hijacked_pack_",
                title: "分包劫持分析",
                subPackageList: [{ id: "installTotal", name: "激活总数由高到低" }, { id: "clickJack", name: "劫持激活数由高到低" }],
                subPackageHijackList: [{ id: "installTotal", name: "激活总数由高到低" }, { id: "clickJack", name: "被劫持激活数由高到低" }],
                subHijackList: [{ id: "2", name: "劫持" }, { id: "1", name: "被劫持" }],
                subHijackDate: [{ id: "1", name: "今日数据" }, { id: "2", name: "历史数据" }]
            },
            {
                name: "black_top5_analysis_",
                name2: "black_top5_list_analysis_",
                title: "归因类型分析",
                attrTypeList: [{ id: "installTotal", name: "激活总数从高到低" }, { id: "precision", name: "精准匹配激活数从高到低" }, { id: "blurry", name: "模糊匹配激活数从高到低" }]
            },
            {
                name: "black_top5_mtti_",
                name2: "black_top5_list_mtti_",
                title: "MTTI趋势洞察",
                mttiList: [{ id: "all", name: "全部范围" }, { id: "day", name: "0s-24hr" }]
            },
            {
                name: "black_top5_corpse_",
                name2: "black_top5_list_corpse_",
                title: "僵尸用户分析",
                zombieUserList: [{ id: "installTotal", name: "激活总数从高到低" }, { id: "zombie", name: "僵尸用户数从高到低" }, { id: "active", name: "活跃用户数从高到低" }],
                zombieDataRangeList: [{ id: "promotion", name: "推广量" }],
                dayList: [{ id: "c1", name: "近一天" }, { id: "c3", name: "近三天" }, { id: "c7", name: "近七天" }]
            }
        ];
        $scope.initLoading();
        //1.关联作弊分析
        $scope.orderList = fakeReports[0].orderList;
        $scope.orderListInit = fakeReports[0].orderList[0].id;

        //2.虚假安装分析排序
        $scope.installOrderList = fakeReports[1].installOrderList;
        $scope.installOrderInit = fakeReports[1].installOrderList[0].id;
        //数据范围
        $scope.installRangeList = fakeReports[1].installRangeList;
        $scope.installRangeInit = fakeReports[1].installRangeList[0].id;
        //3.点击劫持分析
        $scope.attributionList = fakeReports[2].attributionList;
        $scope.attributionInit = fakeReports[2].attributionList[0].id;
        $scope.hijackTimeList = fakeReports[2].hijackTimeList;
        $scope.hijackTimeInit = fakeReports[2].hijackTimeList[0].id;
        //分包劫持分析subPackage
        $scope.subPackageList = fakeReports[3].subPackageList;
        $scope.subPackageInit = fakeReports[3].subPackageList[0].id;

        // 归因类型分析 
        $scope.attrTypeList = fakeReports[4].attrTypeList;
        $scope.attrTypeInit = fakeReports[4].attrTypeList[0].id;

        //7.僵尸用户分析
        $scope.zombieUserList = fakeReports[6].zombieUserList;
        $scope.zombieUserInit = fakeReports[6].zombieUserList[0].id;

        $scope.zombieDataRangeList = fakeReports[6].zombieDataRangeList;
        $scope.zombieDataRangeInit = fakeReports[6].zombieDataRangeList[0].id;


        // 关联作弊排序
        $scope.$on('orderId', function(e, msg) {
            $scope.orderById = msg.info.id;
        });
        // 虚假安装排序
        $scope.$on('installOrderId', function(e, msg) {
            $scope.installOrderInfoOn = msg.info.id;
        });
        // 数据范围
        $scope.$on('installRangeId', function(e, msg) {
            $scope.installRangeIOn = msg.info.id;
        });
        // 点击劫持分析排序
        $scope.attributionOn = "installTotal";
        $scope.$on('attributionId', function(e, msg) {
            $scope.attributionOn = msg.info.id;
        });
        // 劫持窗口期
        $scope.$on('hijackTimeId', function(e, msg) {
            $scope.hijackTimeOn = msg.info.id;
        });
        //分包劫持分析排序
        $scope.subPackageOn = "installTotal"
        $scope.$on('subPackageId', function(e, msg) {
            $scope.subPackageOn = msg.info.id;
        });
        // 归因类型分析排序
        $scope.$on('attrTypeId', function(e, msg) {
            $scope.attrTypeOn = msg.info.id;
        });
        // 僵尸用户分析排序
        $scope.zombieUserOn = "installTotal";
        $scope.$on('zombieUserId', function(e, msg) {
            $scope.zombieUserOn = msg.info.id;
        });
        // 僵尸用户分析数据范围
        $scope.$on('zombieDataRangeId', function(e, msg) {
            $scope.zombieDataRangeOn = msg.info.id;
        });
        //全渠道设置
        $scope.allSet = function() {
            var allPM = HttpService.getInfo("mng/channelparam/find/black/"+$scope.appid);
            // ToolService.showLoading();
            allPM.then(function(data) {
                // ToolService.hideLoading();
                $scope.allBlack = data.allChannelBlackMatch;
                if (data.blacklistLevel == -1) {
                    $scope.cheatInit = 999;
                } else {
                    $scope.cheatInit = data.blacklistLevel;
                }
            });
        }

        $scope.beseQuery = function(call) {
                if (!angular.isDefined($scope.appid)) {
                    return false;
                }
                var s_date = ToolService.getParams($scope);
                var subtxt = $scope.selectFlag == 'date' ? "ds" : ($scope.selectFlag == 'channel') ? 'cid' : 'campaignid';
                if (typeof $scope.typelistFakeInfo == 'string' && ($scope.typelistFakeInfo.split(',').length == $scope.typeInfoList.length && $scope.typeInfoList.length != 1)) {
                    $scope.typelistFakeInfo = 'all'
                }
                $scope.fakeReports = fakeReports;
                var params = {
                    startdate: s_date.startdate,
                    enddate: s_date.enddate,
                    appid: s_date.appid,
                    datatype: 'chart',
                    func: 'fake',
                    groupby: subtxt,
                    cid: $scope.channelFakeinfo, 
                    campaignid: $scope.typelistFakeInfo
                }
                call(params)
            }
            //1.关联作弊分析
        $scope.queryClick = function() {
            $scope.beseQuery(function(params) {
                if ($scope.selectFlag != "data") {
                    params.orderby = $scope.orderById;
                }
                $scope.clickConfig = { color: colors };
                var clickPM = HttpService.getReportData($scope.fakeReports[0].name + params.groupby, params);
                $scope.clickLoading = true;
                clickPM.then(function(data) {
                    $scope.clickData = data;
                    $scope.clickLoading = false;
                    $scope.clickDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[0].title, $scope.fakeReports[0].name2 + params.groupby, params);
                });
                var click2PM = HttpService.getReportData($scope.fakeReports[0].name2 + params.groupby, params);
                click2PM.then(function(data) {
                    $scope.tableData = data;
                });

            })

        }

        //2.虚假安装分析
        $scope.queryInstall = function() {
            $scope.beseQuery(function(params) {
                if ($scope.selectFlag != "data") {
                    params.orderby = $scope.installOrderInfoOn; //排序
                }
                params.dataRange = $scope.installRangeIOn; //数据范围
                $scope.installConfig = { color: colors };
                $scope.installOrderLoading = true;
                var installPM = HttpService.getReportData($scope.fakeReports[1].name + params.groupby, params);
                installPM.then(function(data) {
                    $scope.installData = data;
                    $scope.installOrderLoading = false;
                    $scope.installDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[1].title, $scope.fakeReports[1].name2 + params.groupby, params);
                });
                var installPM2 = HttpService.getReportData($scope.fakeReports[1].name2 + params.groupby, params);
                installPM2.then(function(data) {
                    $scope.installTableData = data;
                });
            })

        }

        //3.点击劫持分析
        $scope.queryClickHijack = function() {
                $scope.beseQuery(function(params) {
                    if ($scope.selectFlag != "data") {
                        params.orderby = $scope.attributionOn; //排序
                    }
                    params.timeOrder = $scope.hijackTimeOn; //劫持窗口期
                    $scope.hijackConfig = { color: colors2 };
                    $scope.hijackLoading = true;
                    var hijackPM = HttpService.getReportData($scope.fakeReports[2].name + params.groupby, params);
                    hijackPM.then(function(data) {
                        $scope.hijackData = data;
                        $scope.hijackLoading = false;
                        $scope.hijackDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[2].title, $scope.fakeReports[2].name2 + params.groupby, params);
                    });
                    var hijackPM2 = HttpService.getReportData($scope.fakeReports[2].name2 + params.groupby, params);
                    hijackPM2.then(function(data) {
                        $scope.hijackTableData = data;
                    });
                })
            }
            //4.分包劫持分析
        $scope.querySubpackage = function(type) {
                $scope.beseQuery(function(params) {
                    if ($scope.selectFlag != "data") {
                        params.orderby = $scope.subPackageOn; //排序
                    }
                   
                    if($scope.selectHk == '1'){
                        params.startdate = UtilService.getDay(0)
                        params.enddate = UtilService.getDay(0)
                    }
                    params.hijacked = $scope.activeHk
                    $scope.subpackageConfig = { color: colors2 };
                    $scope.subpackageLoading = true;
                    var subpackagePM,subpackagePM2;
                    if(type == 'hijack'){
                        subpackagePM = HttpService.getReportData($scope.fakeReports[3].hijackname + params.groupby, params);
                        subpackagePM2 = HttpService.getReportData($scope.fakeReports[3].hijackname2 + params.groupby, params);
                        subpackagePM.then(function(data) {
                            $scope.subpackageData = data
                            $scope.subpackageLoading = false;
                            $scope.subpackageDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[3].title, $scope.fakeReports[3].hijackname2 + params.groupby, params);
                        });
                    }else{
                        subpackagePM = HttpService.getReportData($scope.fakeReports[3].name + params.groupby, params);
                        subpackagePM2 = HttpService.getReportData($scope.fakeReports[3].name2 + params.groupby, params);
                        subpackagePM.then(function(data) {
                            $scope.subpackageData = data
                            $scope.subpackageLoading = false;
                            $scope.subpackageDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[3].title, $scope.fakeReports[3].name2 + params.groupby, params);
                        });
                    }
                    subpackagePM2.then(function(data) {
                        $scope.subpackageTableData = data
                    });
                    
                    
                })
            }
            //5.归因类型分析 
        $scope.queryattrType = function() {
                $scope.beseQuery(function(params) {
                    if ($scope.selectFlag != "data") {
                        params.orderby = $scope.attrTypeOn; //排序
                    }
                    $scope.attrTypeConfig = { color: colors2 };
                    $scope.attrTypeLoading = true;
                    var attrTypePM = HttpService.getReportData($scope.fakeReports[4].name + params.groupby, params);
                    attrTypePM.then(function(data) {
                        $scope.attrTypeData = data;
                        $scope.attrTypeLoading = false;
                        $scope.attrTypeDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[4].title, $scope.fakeReports[4].name2 + params.groupby, params);
                    });
                    var attrTypePM2 = HttpService.getReportData($scope.fakeReports[4].name2 + params.groupby, params);
                    attrTypePM2.then(function(data) {
                        $scope.attrTypeTableData = data;
                    });
                })
            }
            //6.MTTI趋势洞察
        $scope.queryMtti = function() {
                $scope.beseQuery(function(params) {
                    params.mtti_all = $scope.activeMt; //选择MTTI范围
                    $scope.mttiConfig = { color: colors, ispercent: true };
                    $scope.mttiLoading = true;
                    var mttiPM = HttpService.getReportData($scope.fakeReports[5].name + params.groupby, params);
                    mttiPM.then(function(data) {
                        $scope.mttiData = data;
                        $scope.mttiLoading = false;
                        $scope.mttiDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[5].title, $scope.fakeReports[5].name2 + params.groupby, params);
                    });
                    var mttiPM2 = HttpService.getReportData($scope.fakeReports[5].name2 + params.groupby, params);
                    mttiPM2.then(function(data) {
                        $scope.mttiTableData = data;
                    });
                })
            }
            //7.僵尸用户分析  
        $scope.queryZombieData = function() {
            $scope.beseQuery(function(params) {
                if ($scope.selectFlag != "data") {
                    params.orderby = $scope.zombieUserOn; //排序
                }
                params.dataRange = $scope.zombieDataRangeOn; //数据范围
                params.level = $scope.activeDay; //观察周期
                $scope.zombieDataConfig = { color: colors2 };
                $scope.zombieDataLoading = true;
                var zombiePM = HttpService.getReportData($scope.fakeReports[6].name + params.groupby, params);
                zombiePM.then(function(data) {
                    $scope.zombieDataData = data;
                    $scope.zombieDataLoading = false;
                    $scope.zombieDataCondition = ToolService.getChartConditions($filter('translate')('防作弊卫士') + "-" + $scope.fakeReports[6].title, $scope.fakeReports[6].name2 + params.groupby, params);
                });
                var zombiePM2 = HttpService.getReportData($scope.fakeReports[6].name2 + params.groupby, params);
                zombiePM2.then(function(data) {
                    $scope.zombieTableData = data;
                });
            })
        }

        $scope.changeSelectFlag = function(flag) {
            ToolService.sendBehaviorUv("flag");
            $scope.selectFlag = flag;
            $scope.activeHk = '2';
            if (flag == "date") {
                $scope.fakeReports[3].subHijackList=[{ id: "2", name: "劫持" }]
                $scope.installRangeList = [{ id: "promotion", name: "推广量" }, { id: "natural ", name: "自然量" }];
                $scope.zombieDataRangeList = [{ id: "promotion", name: "推广量" }, { id: "natural", name: "自然量" }];
            } else {
                $scope.fakeReports[3].subHijackList=[{ id: "2", name: "劫持" }, { id: "1", name: "被劫持" }]
                $scope.installRangeList = fakeReports[1].installRangeList;
                $scope.zombieDataRangeList = fakeReports[6].zombieDataRangeList;
            }
        }
        $scope.$watch("{appid:appid}", function(n, o) {
            if($scope.appid){
                $scope.allSet();
                $scope.queryFakeSelectInfos();
            }
        })
            $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,selectFlag:selectFlag,lang:lang,fakeType:fakeType,typelistFakeInfo:typelistFakeInfo,channelFakeinfo:channelFakeinfo,attributionOn:attributionOn,hijackTimeOn:hijackTimeOn,zombieDataRangeOn:zombieDataRangeOn,zombieUserOn:zombieUserOn,installOrderInfoOn:installOrderInfoOn,installRangeIOn:installRangeIOn,attrTypeOn:attrTypeOn,subPackageOn:subPackageOn,orderById:orderById}", function(n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date) || n == o) {
                return false;
            }
            if (new Date().getTime() - loadingTime < durationTime) { //小于3秒退出
                return false;
            }
            if (($rootScope.fakeType == 1 || $rootScope.fakeType == 2) && $scope.appid) {
                if (n.orderById && n.orderById != o.orderById) { //1.关联作弊分析
                    $scope.queryClick();
                } else if ((n.installOrderInfoOn && n.installOrderInfoOn != o.installOrderInfoOn) || (n.installRangeIOn && n.installRangeIOn != o.installRangeIOn)) { //2.虚假安装分析
                    $scope.queryInstall();
                } else if ((n.attributionOn && n.attributionOn != o.attributionOn) || (n.hijackTimeOn && n.hijackTimeOn != o.hijackTimeOn)) { //3.点击劫持分析
                    $scope.queryClickHijack();
                } else if (n.subPackageOn && n.subPackageOn != o.subPackageOn) { //4.分包劫持分析
                    if($scope.activeHk == '1'){
                        $scope.querySubpackage('hijack');
                    }else{
                        $scope.querySubpackage();
                    }
                   
                } else if (n.attrTypeOn && n.attrTypeOn != o.attrTypeOn) { //5.归因类型分析
                    $scope.queryattrType();
                } else if ((n.zombieDataRangeOn && n.zombieDataRangeOn != o.zombieDataRangeOn) || (n.zombieUserOn && n.zombieUserOn != o.zombieUserOn)) { //7.僵尸用户分析 
                    $scope.queryZombieData();
                } else if ($scope.typelistFakeInfo || $scope.channelFakeinfo || $scope.date) {
                    $scope.query("'hijack'");
                }
                // if (n.appid && n.appid != o.appid) { //渠道、活动下拉框接口
                //     $scope.queryFakeSelectInfos();
                // }
                $scope.firstSelectQuery = true;
                $scope.firstQuery = true;
            }
        }, true)

        $scope.backFlag = function(id) {
            $scope.pageFlag = id;
        }
        $scope.query = function(type) {
            if (!angular.isDefined($scope.date)) {
                setTimeout(function() {
                    $scope.query();
                }, 1000)
                return false
            }
            $scope.queryClick();
            $scope.queryInstall();
            $scope.queryattrType();
            $scope.queryZombieData();
            $scope.queryMtti();
            if($scope.activeHk == '1'){
                $scope.querySubpackage('hijack');
            }else{
                $scope.querySubpackage();
            }
            if (!angular.isDefined($scope.hijackTimeOn)) {
                return false
            }
            $scope.queryClickHijack();
            $scope.firstQuery = false;
        }
        
        setTimeout(function() {
            $scope.query();
        }, 300);
        
        //修改防作弊
        $scope.fixFake = function() {
            ToolService.sendBehaviorUv("fixFake");
            var iden = 'fakedec';
            $state.go("collect.fake", { stateinfo: iden });
            $rootScope.operSubmitData($filter('translate')("修改"));
        }
        $scope.activeDay = "c1"
        $scope.changeDay = function(item) {
            $scope.activeDay = item.id;
            $scope.queryZombieData();
        }
        $scope.activeMt = "all"
        $scope.changeMtti = function(item) {
                $scope.activeMt = item.id;
                $scope.queryMtti();
        }
        $scope.activeHk = '2';
        // type:hijack 被劫持
        $scope.changeHijack=function(item){
            $scope.activeHk = item.id;
            if($scope.activeHk == '1'){//被劫持}
            $scope.subPackageList = fakeReports[3].subPackageHijackList;
            $scope.subPackageInit = fakeReports[3].subPackageHijackList[0].id;
                $scope.querySubpackage('hijack');
            }else{
                $scope.subPackageList = fakeReports[3].subPackageList;
                $scope.subPackageInit = fakeReports[3].subPackageList[0].id;
                $scope.querySubpackage();
            }
        }
        //今日数据、历史数据
        $scope.selectHk = '2';
        $scope.selectDate=function(n){
            $scope.selectHk = n.id;
            if($scope.activeHk == '1'){
                $scope.querySubpackage('hijack');
            }else{
                $scope.querySubpackage();
            }
        }

            //公共IP列表 跳转
        $scope.publicIP = function() {
            ToolService.sendBehaviorUv("publicIP");
            var iden = 'publicIP';
            $state.go("collect.fake", { stateinfo: iden });
        }
    }
})();