(function() {
    angular.module("app.collect")
        .controller("collectCtrl", ["$rootScope", "$scope", "$state", "ToolService", "$timeout", "$filter", collectCtrl]);

    function collectCtrl($rootScope, $scope, $state, ToolService, $timeout, $filter) {
        var meauTree = {
            "analysis": ["campaigninfo", "channeleffect", "attribute", "effectevaluate", "roi", "keyword", "packageinfo"],
            "decisionsupport": ["paymentinsight", "potentialusergroup", "device"],
            "campaignmanager": ["campaign", "campgroup", "datacb", "onelink", "sublink", "subpackage", "customevent"],
            "export": ["logexport", "logdump", "logtool", "report", "subcampaign"],
            "eventmanage": ["event", "profile"]
        };
        $scope.dash = true;
        $scope.showTwoMenu = {};
        $scope.admonitor = true;
        // $scope.lifecycleHasAuth = $rootScope.permissionMenus.lifecycle.has_auth || false
        $scope.getSubMenu = function(menu) {
            $scope[menu] = $scope[menu] ? false : true;
            // if(menu == "lifecycle" && !$scope.lifecycleHasAuth){
            //     $scope.goPage('collect.lifecycle');
            // }
        }
        $scope.getTwoMenu = function(key) {
            $scope.showTwoMenu[key] = !$scope.showTwoMenu[key];
        }
        $scope.getTwoMenuFlag = function(key) {
            return $scope.showTwoMenu[key] || false;
        }

        $scope.closeTip = function() {
            $rootScope.tipCustom = false;
            ToolService.hideAlp();
        }
        $scope.okCust = function() {
            $scope.goPage('collect.custommenu');
            $scope.closeTip();
        }

        $rootScope.$watch("pagePath", function(n) {
            if (angular.isDefined(n)) {
                $scope.subflag = "";
                var idx = n.indexOf("Detail");
                if (idx > -1) {
                    n = n.substring(0, n);
                }
                for (var k in meauTree) {
                    var ms = meauTree[k];
                    if (ms.indexOf(n) > -1) {
                        $scope.subflag = k;
                        break;
                    }
                }

                if (n == 'custommenu') {
                    $scope.subflag = n;
                }
            }

        });

        // $(".leftSidebar").perfectScrollbar();
    }
})();