(function(){
    angular.module("app.collect")
        .controller("paymentinsightCtrl",["$scope","HttpService","ToolService","$filter","UtilService",paymentinsightCtrl]);

    function paymentinsightCtrl($scope,HttpService,ToolService,$filter,UtilService){

    	$scope.$on('curdate',function(e,msg){
            $scope.date = msg.date;
        });

    	var orderBy = $filter('orderBy');
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
        	$scope.sortCol = predicate;
            $scope.paymentData.val = orderBy($scope.paymentData.val, predicate, reverse);
        };

    	$scope.trendConfig = {color:["#5191bd","#6bc1fe","#c7ddea"],hidelast:1};
    	$scope.distributeConfig = {color:["#f07c2f","#ffc053","#ffe6bc"]};
    	$scope.percentConfig = {color:["#f07c2f","#ffaf13","#ffcb65"]};

        $scope.query = function(){
        	var params = ToolService.getParams($scope);
            params.datatype = "chart";
        	
        	var trendPM = HttpService.getReportData("decision_payment_byds", params);
    		$scope.trendLoading = true;
    		trendPM.then(function(data){
    			$scope.trendData = data;
                $scope.trendLoading = false;
    		});

    		var distributePM = HttpService.getReportData("decision_payment_rmb_byds", params);
    		$scope.distributeLoading = true;
    		distributePM.then(function(data){
    			$scope.distributeData = data;
                $scope.distributeLoading = false;
    		});

            var percentPM = HttpService.getReportData("decision_payment_level_byds", params);
            $scope.percentLoading = true;
            percentPM.then(function(data){
                $scope.percentData = data;
                $scope.percentLoading = false;
            });
        };

        $scope.$watch("appid+date.startDate+date.endDate+lang",function(){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.date)){
        		$scope.query();
        	}
        });
    }

})()