(function(){
    angular.module("app.collect")
        .controller("realtimeCtrl",["$rootScope","$scope","HttpService","ToolService","DateService","$filter",realtimeCtrl]);

    function realtimeCtrl($rootScope,$scope,HttpService,ToolService,DateService,$filter){
        $scope.initLoading = function(){
            $scope.clickLoading = true;
            $scope.intallLoading = true;
            $scope.dsclickLoading = true;
            $scope.dauLoading = true;
            $scope.paymentLoading = true;
            $scope.playersLoading = true;
            $scope.orderLoading = true;
            $scope.amtLoading = true;
            $scope.regedLoading = true;
            $scope.logdeviceLoading = true;
            $scope.newamtLoading = true;
            $scope.newpaynumLoading = true;
        };
        $scope.initLoading();
        if($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage){
            $scope.MainSuper = true;
        }else{
            $scope.MainSuper = false;
        }

    	var colors = ["#1fb9e9","#d3c2df"];
        $scope.typelist = ToolService.getChannelCampaignList();
    	$scope.$on("typeId",function(e,msg){
            $scope.typeId = msg.info.id;
            $scope.typeName =msg.info.name;
            if($scope.typeId == "campaign"){  
                // 点击活动的时候调优化后的接口
                $scope.getCampaignData();

            }else{
                $scope.getTypeData();
                $scope.showSearchBtn = false;
            }
            
        });
        $scope.getCampaignData = function(){
            var campaignparams = ToolService.getChannelCampaignParams($scope.typeId,$scope.appid);
            $scope.typeInfoname = !$scope.typeInfoname ? $filter("translate")("所有")+campaignparams.txt : $filter("translate")("请选择")+campaignparams.txt;
            var campaignPM = HttpService.getInfo($scope.appid+"/campaign/dropdown");
            campaignPM.then(function (data) {
                $scope.campaignListTotal = data;
                var data = data.data;      
                data.filter(function(item){
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                var dataList = data.data;
                $scope.typeInfoList = data;
                $scope.campaignListAll = data;
                if($scope.campaignListTotal.total>= 500){
                    $scope.showSearchBtn = true;
                }else{
                    $scope.showSearchBtn = false;
                }
            });
        };
    	$scope.$on("typelistIds",function(e,msg){
            $scope.typeInfoIds = msg.info;
    	});


        var today = DateService.getDay(0);
        $scope.beginDate = DateService.getDay(0);
        $scope.$on("beginDate",function(e,msg){
            $scope.beginDate = msg;
            //根据开始日期设置结束日期
            var daysNum = DateService.getDaysNum($scope.beginDate,today);
            if(daysNum < 6){
                $scope.endDate = DateService.getDay(-(daysNum + 1));
            }else{
                $scope.endDate = today;
            }
        });

        $scope.endDate = DateService.getDay(-1);
        $scope.$on("endDate",function(e,msg){
            $scope.endDate = msg;
        });

        var rmd = new Date().getTime();
    	$scope.getTypeData = function(){
        if($scope.typeInfoIds == -1){
          $scope.typeIDSF5 = ++rmd;
        }
        else{
          $scope.typeInfoIds = -1; 
        }
        $scope.typeInfoIds = -1;
        var urlparms = ToolService.getChannelCampaignParams($scope.typeId,$scope.appid);
        $scope.typeInfoname = !$scope.typeInfoname ? $filter("translate")("所有")+urlparms.txt : $filter("translate")("请选择")+urlparms.txt;
        var urlparmsQudao = urlparms.txt;
    		var listPM = HttpService.getInfo(urlparms.url);
    		listPM.then(function(data){
                if($scope.typeId =='channel'){
                    if(!(!$rootScope.isall && $rootScope.curRoleAuth && !$rootScope.curRoleAuth.isNatureOpen)){
                        data.unshift({id:"-1",name:$filter('translate')('自然量')});
                    }
                }
            $scope.typeInfoList = data;
    		});
    	}
        $scope.$watch("{appid:appid,lang:lang}",function(n,o){
            if(angular.isUndefined($scope.appid)){return false;}
            if(angular.isUndefined($scope.typeId)){
                $scope.typeIdInit = $scope.typelist[0].id;
            }else{
                if($scope.typeIdInit == $scope.typeId){
                    $scope.getTypeData();
                }
                else{
                    $scope.typeIdInit = $scope.typeId;
                }
            }
            if(n.lang && o.lang && n.lang!==o.lang){
                $scope.typelist = ToolService.getChannelCampaignList();
            }
        },true);

        current="";
        $scope.$on("typelistIds",function(e,msg){
    		current = "typelist";
            $scope.channelid = msg.info;
    	});
            

        $scope.query = function(){
            if(!angular.isDefined($scope.appid) || !angular.isDefined($scope.typeInfoIds)){
                return false;
            }
            if($scope.typeId == 'campaign' && typeof $scope.typeInfoIds =='string' && ($scope.typeInfoIds.split(',').length ==$scope.typeInfoList.length && $scope.typeInfoList.length != 1)){
                $scope.typeInfoIds = 'all';
            }
            var params = ToolService.getParams($scope,1);
            params.datatype = 'chart';

            var dateContrast = DateService.getDaysNum($scope.beginDate,today);
            if(dateContrast == 6){
                params.startdate = $scope.beginDate;
                params.enddate = $scope.endDate;
            }else{
                params.startdate = $scope.endDate;
                params.enddate = $scope.beginDate;
            }

            var urlparms = ToolService.getChannelCampaignParams($scope.typeId,$scope.appid);
            if($scope.typeId =='channel'){
                if($scope.channelid!='all'){
                    params.cid = $scope.channelid;
                }
            }
           
         
            //ios、android、H5
            if(!$scope.iswx && !$scope.iswg){
                //实时点击
                $scope.clickConfig = {color:colors};
                var clickPM = HttpService.getReportData($scope.nowReports[0].name,params);
                $scope.clickLoading = true;
                clickPM.then(function(data){
                    $scope.clickData = data;
                    $scope.clickLoading = false;
                    $scope.clickDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[0].title,$scope.nowReports[0].name,params);
                });

                //实时排重点击
                $scope.dsclickConfig = {color:colors};
                var dsclickPM = HttpService.getReportData($scope.nowReports[1].name,params);
                $scope.dsclickLoading = true;
                dsclickPM.then(function(data){
                    $scope.dsclickData = data;
                    $scope.dsclickLoading = false;
                    $scope.dsclickDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[1].title,$scope.nowReports[1].name,params);
                });

                //实时激活
                $scope.intallConfig = {color:colors};
                var intallPM = HttpService.getReportData($scope.nowReports[2].name,params);
                $scope.intallLoading = true;
                intallPM.then(function(data){
                    $scope.intallData = data;
                    $scope.intallLoading = false;
                    $scope.intallDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[2].title,$scope.nowReports[2].name,params);
                });

                //实时DAU
                $scope.dauConfig = {color:colors};
                var dauPM = HttpService.getReportData($scope.nowReports[3].name,params);
                $scope.dauLoading = true;
                dauPM.then(function(data){
                    $scope.dauData = data;
                    $scope.dauLoading = false;
                    $scope.dauDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[3].title,$scope.nowReports[3].name,params);
                });
                if(!$rootScope.isweb){
                    // //实时激活设备付费率（每小时）
                    // radpr(params);
                    //实时注册
                    $scope.regedConfig = {color:colors};
                    var regedPM = HttpService.getReportData($scope.nowReports[9].name,params);
                    $scope.regedLoading = true;
                    regedPM.then(function(data){
                        $scope.regedData = data;
                        $scope.regedLoading = false;
                        $scope.regedDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[9].title,$scope.nowReports[9].name,params);
                    });
                    //实时登陆
                    $scope.logdeviceConfig = {color:colors};
                    var logdevicePM = HttpService.getReportData($scope.nowReports[10].name,params);
                    $scope.logdeviceLoading = true;
                    logdevicePM.then(function(data){
                        $scope.logdeviceData = data;
                        $scope.logdeviceLoading = false;
                        $scope.logdeviceDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[10].title,$scope.nowReports[10].name,params);
                    });
                    if($scope.showDataModel('pay')){
                        //实时新增付费
                        $scope.newamtConfig = {color:colors};
                        var newamtPM = HttpService.getReportData($scope.nowReports[11].name,params);
                        $scope.newamtLoading = true;
                        newamtPM.then(function(data){
                            $scope.newamtData = data;
                            $scope.newamtLoading = false;
                            $scope.newamtDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[11].title,$scope.nowReports[11].name,params);
                        });
                        //实时新增付费设备数
                        $scope.newpaynumConfig = {color:colors};
                        var newpaynumPM = HttpService.getReportData($scope.nowReports[12].name,params);
                        $scope.newpaynumLoading = true;
                        newpaynumPM.then(function(data){
                            $scope.newpaynumData = data;
                            $scope.newpaynumLoading = false;
                            $scope.newpaynumDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[12].title,$scope.nowReports[12].name,params);
                        });
                    }
                }
                if($scope.industory=='ec'  &&!$scope.isweb){
                    if($scope.showDataModel('order')){
                      //实时订单数
                      $scope.orderConfig = {color:colors};
                      var orderPM = HttpService.getReportData($scope.nowReports[6].name,params);
                      $scope.orderLoading = true;
                      orderPM.then(function(data){
                          $scope.orderData = data;
                          $scope.orderLoading = false;
                          $scope.orderDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[6].title,$scope.nowReports[6].name,params);
                      });
                    }
                    if($scope.showDataModel('pay')){
                      //实时订单金额
                      $scope.amtConfig = {color:colors};
                      var amtPM = HttpService.getReportData($scope.nowReports[7].name,params);
                      $scope.amtLoading = true;
                      amtPM.then(function(data){
                          $scope.amtData = data;
                          $scope.amtLoading = false;
                          $scope.amtDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[7].title,$scope.nowReports[7].name,params);
                      });
                    }

                    if(!$rootScope.isweb){
                        //实时激活设备付费率（每小时）
                        radpr(params);
                    }
                }else{
                    if($scope.showDataModel('pay')){
                        //实时收入
                        $scope.paymentConfig = {color:colors};
                        var paymentPM = HttpService.getReportData($scope.nowReports[4].name,params);
                        $scope.paymentLoading = true;
                        paymentPM.then(function(data){
                            $scope.paymentData = data;
                            $scope.paymentLoading = false;
                            $scope.paymentDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[4].title,$scope.nowReports[4].name,params);
                        });
                        //实时付费设备数
                        $scope.playersConfig = {color:colors};
                        var playersPM = HttpService.getReportData($scope.nowReports[5].name,params);
                        $scope.playersLoading = true;
                        playersPM.then(function(data){
                            $scope.playersData = data;
                            $scope.playersLoading = false;
                            $scope.playersDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[5].title,$scope.nowReports[5].name,params);
                        });
                    }
                }

            }else{//微信小程序、小游戏
                whenWX($scope,params,$scope.nowReports);
            }

        }
        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function(event,data) {
            $scope.typeInfoList = $scope.campaignListAll   
        })
  
        $scope.showSearchBtn = true
        $scope.searchActiveId = "searchActiveId";
        $scope.$on($scope.searchActiveId, function(event,data) {
            if(!data){
                return false
            }

            if($scope.typeId == "campaign"){
                var Pm = HttpService.getInfo($scope.appid+"/campaign/dropdown?name="+data);
                Pm.then(function(data){
                    if(data && data.data){
                        var dataList = data.data;
                        dataList.filter(function(item){
                            item.uid = item.id;
                            item.id = item.campaignid;
                            // console.log(item.campaignid)
                        });
                        $scope.typeInfoList = dataList
                    }
                });
            }
           
        });


        //微信小程序时执行请求
        function whenWX(scope,params,reports){
            var wxData = {};
            reports.forEach(function(item){
                if(item.name!='wx_realtime_activation_device_pay_rate' || item.name=='wx_realtime_activation_device_pay_rate'&& $scope.industory=='ec'){
                    var filed = item.retFiled;
                    wxData[filed+'Config'] = {color:colors};
                    var pm = HttpService.getReportData(item.name,params);
                    wxData[filed+'Loading']= true;
                    pm.then(function(data){
                        data.rmd = ++rmd;
                        wxData[filed+'Data'] = data;
                        wxData[filed+'Loading'] = false;
                        wxData[filed+'DataCondition'] = ToolService.getChartConditions($filter('translate')('实时')+"-" + item.title,item.name,params);
                    });
                }
            });
            scope.wxData = wxData;
        }

        var webReports = [
                          {name:"h5_realtime_click_byhour",title:"实时点击"},
                          {name:"h5_realtime_pv_byhour",title:"实时PV"},
                          {name:"h5_realtime_uv_byhour",title:"实时UV"},
                          {name:"h5_realtime_ip_byhour",title:"实时IP"},
                          {name:"h5_realtime_amount_byhour",title:"实时总付费"},
                          {name:"h5_realtime_payer_byhour",title:"实时付费人数"}
                          ];
        var moveReports = [
                           {name:"realtime_click",title:"实时点击"},
                           {name:"realtime_dupclick",title:"实时排重点击"},
                           {name:"realtime_install",title:"实时激活"},
                           // {name:"realtime_dupclick",title:"实时排重点击"},
                           {name:"realtime_dau",title:"实时DAU"},
                           {name:"realtime_income",title:"实时总付费"},
                           {name:"realtime_payer",title:"实时总付费设备数"},
                           {name:"realtime_order", title:"实时支付订单数"},
                           {name:"realtime_order_amt",title:"实时支付总额"},
                           {name:"realtime_activation_device_pay_rate",title:"实时激活设备付费率\（每小时\）"},
                           {name:"realtime_reged",title:"实时注册"},
                           {name:"realtime_logdevice",title:"实时登录"},
                           {name:"realtime_income_new_user_amt",title:"实时新增付费"},
                           {name:"realtime_num_payer_new_user",title:"实时新增付费设备数"},
                           ];
        var selfBuiltReports = [
            {name:"realtime_click",title:"实时点击"},
            {name:"realtime_dupclick",title:"实时排重点击"},
            {name:"realtime_install",title:"实时表单"},
            {name:"realtime_dau",title:"实时DAU"},
            {name:"realtime_income",title:"实时总付费"},
            {name:"realtime_payer",title:"实时总付费设备数"},
            {name:"realtime_order", title:"实时支付订单数"},
            {name:"realtime_order_amt",title:"实时支付总额"},
            {name:"realtime_activation_device_pay_rate",title:"实时表单设备付费率\（每小时\）"},
        ];
        var wxReports = [
            {name:'wx_realtime_click',title:'实时访问次数',type:'overview',retFiled:'click',cNum:2},
            {name:'wx_realtime_newuser',title:'实时新增用户',type:'overview',retFiled:'newuser',cNum:2},
            // {name:'wx_realtime_pv_byhour',title:'实时pv',type:'overview',retFiled:'pv',cNum:2},
            // {name:'wx_realtime_uv_byhour',title:'实时uv',type:'overview',retFiled:'uv',cNum:2},
            {name:'wx_realtime_bounce_byhour',title:'实时跳出率',type:'effect',retFiled:'bounce',cNum:3},
            {name:'wx_realtime_num_new_amout_byhour',title:'实时总付费',type:'effect',retFiled:'new_amout',cNum:3},
            {name:'wx_realtime_num_payers_byhour',title:'实时付费用户数',type:'effect',retFiled:'payers',cNum:3},
            {name:'wx_realtime_activation_device_pay_rate',title:'实时新增用户付费率（每小时）',type:'effect',retFiled:'pay_rate',cNum:3},
        ]

        $scope.$watch("appid+typeInfoIds+beginDate+endDate+lang",function(n){
            if(angular.isDefined($scope.appid) && angular.isDefined($scope.typeInfoIds)){
                // $scope.nowReports = $scope.isweb?webReports:moveReports;
                if($scope.iswx){
                    wxReports.splice(2,0,{name:'wx_realtime_pv_byhour',title:'实时pv',type:'overview',retFiled:'pv',cNum:2},{name:'wx_realtime_uv_byhour',title:'实时uv',type:'overview',retFiled:'uv',cNum:2});
                }
                if($scope.iswg && wxReports[2].name=='wx_realtime_pv_byhour'){
                    wxReports.splice(2,2);
                }
                $scope.nowReports = $scope.isweb?webReports:($scope.iswx || $scope.iswg) ? wxReports : $scope.isSelfBuilt? selfBuiltReports :moveReports;
                $scope.industory = $scope.appInstance.industory;
                $scope.query();
            }
        });
        //实时激活设备付费率（每小时）
        function radpr(params){
            $scope.payRateConfig = {color:colors};
            var playersPM = HttpService.getReportData($scope.nowReports[8].name,params);
            $scope.payRateLoading = true;
            playersPM.then(function(data){
                $scope.payRateData = data;
                $scope.payRateLoading = false;
                $scope.payRateDataCondition = ToolService.getChartConditions($filter('translate')('实时')+"-" + $scope.nowReports[8].title,$scope.nowReports[8].name,params);
            });
        }
    }
})();
