(function() {
    angular.module("app.collect")
        .controller("serveridbackflowCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$timeout", "$filter","DateService", "$translate", serveridbackflowCtrl]);

    function serveridbackflowCtrl($scope, $rootScope, HttpService, ToolService, $timeout, $filter, DateService, $translate) {
       $scope.goLast = function(){
        $scope.goPage("collect.refluxanalysis");
       }
       $scope.addFlowStatus = false;
       $scope.serverType = false;
       $scope.flowStatus =false
       
       /**
        * flag
        * add: //新建
        */
       $scope.setBackflow = function(flag){
        $scope.tip = {}
           if(flag == 'add'){ //新建
                $scope.flowStatus =true;
                $scope.serverId = '';
                $scope.serverName = '';
                $scope.serverType = false;
                $scope.isDisabled = false;
           }else{
                $scope.isDisabled = true
                $scope.flowStatus =false
           }
        ToolService.showAlp();
        $scope.addFlowStatus = true;
        $scope.tip.serverId = {
            status: false
        };
        $scope.tip.serverName = {
            status: false
        };
        
       }
       $scope.saveAdd = function(){
        var verPar = {
            serverId: {
                key: 'isNull',
                val: $scope.serverId
            },
            serverName: {
                key: 'isNull',
                val: $scope.serverName
            }
        };
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        }
        var params = {
            app: $scope.appid,
            serverId:$scope.serverId,
            serverName:$scope.serverName,
            serverType:$scope.serverType?'0':'1' // 1新服  0老服
        }
        if($scope.flowStatus){
            $scope.createServeridbackflow(params)
        }else{
            params.id = $scope.id
            $scope.updateServeridbackflow(params)
        }
       }
       // 新建
       $scope.createServeridbackflow = function(params){
            var addPM = HttpService.postInfo("mng/serveridbackflow/create", params);
            addPM.then((function(data){
                if(data.code == 301){
                    ToolService.showTips(data.message);
                }else if(data.code == 302){
                    ToolService.showTips(data.message);
                }else{
                    ToolService.showTips('添加成功');
                    $scope.closeModal()
                    $scope.query()
                }
            }))
       }
       // 修改
       $scope.updateServeridbackflow = function(params){
        var addPM = HttpService.postInfo("mng/serveridbackflow/update", params);
        addPM.then((function(data){
            if(data.code == 301){
                ToolService.showTips(data.message);
            }else if(data.code == 302){
                ToolService.showTips(data.message);
            }else{
                ToolService.showTips('添加成功');
                $scope.closeModal()
                $scope.query()
            }
        }))
   }
       $scope.query = function(){
        ToolService.showLoading();
        var queryPM = HttpService.getInfo("mng/serveridbackflow/findlist?app="+$scope.appid);
        queryPM.then(function(data){
            ToolService.hideLoading();
            $scope.groupList = data
        })
       }
       $scope.query();

       /**
        * 编辑
        */
       $scope.update = function(data){
        $scope.id = data.id;
        $scope.serverId = data.serverId;
        $scope.serverName = data.serverName;
        $scope.serverType = data.serverType == 0;
        $scope.setBackflow();
       }
       $scope.doRemove = function(info){
        $scope.openStatus = true
        $scope.openAndClose= info.status
        $scope.openId= info.id
        $scope.openServerName= info.serverName
        ToolService.showAlp();
       }
       $scope.openSure = function(){
        // status=0关闭  status=1开启
        var status = 1
        if($scope.openAndClose == 1){
            status = 0
        }
        ToolService.hideAlp();
        var drPM = HttpService.getInfo("mng/serveridbackflow/openAndClose?id="+$scope.openId+'&status='+status);
        drPM.then(function(data){
            $scope.query();
        })
       }
       //delete
       $scope.delete = function(data){
            $scope.delStatus = true
            $scope.delId = data.id;
            $scope.delServerName = data.serverName
            ToolService.showAlp();
       }
       $scope.delSure = function(){
        ToolService.hideAlp();
        var dlPM = HttpService.getInfo("mng/serveridbackflow/delete?id="+$scope.delId);
        dlPM.then(function(data){
            $scope.query();
        })
       }
       $scope.close = function(){
        ToolService.hideAlp();
       }
       $scope.closeModal = function (){
            ToolService.hideAlp();
            $scope.addFlowStatus = false;
       }
       var rmd = new Date().getTime();
       $scope.$on('flipinfo',function(e,msg){
        $scope.flipPage = msg;
        $scope.flipChange = ++ rmd;
    });
    }
    
})();