(function () {
    angular.module("app.login")
        .controller("loginCtrl", ["$rootScope", "$scope", "OptionService", "DateService", "$http", "$filter", "ToolService", "UtilService", "HttpService", "$location", "$translate", "$translateCookieStorage", loginCtrl]);

    function loginCtrl($rootScope, $scope, OptionService, DateService, $http, $filter, ToolService, UtilService, HttpService, $location, $translate, $translateCookieStorage) {
        $scope.now = DateService.getYesDay().startDate;
        $scope.reportDate = DateService.getYesDay().startDate;
        $scope.isrember = false;
        $scope.isonline = true;
        $scope.lang = $translateCookieStorage.get("lang");
        $scope.goStatus = false
        $scope.goNewPage = function () {
            $scope.goStatus = true
            ToolService.showAlp();
        }
        $scope.closeModal = function(){
            $scope.goStatus = false
            ToolService.hideAlp();
        }
         $scope.go = function(){
            $scope.goStatus = false
            ToolService.hideAlp();
            window.open("https://new.trackingio.com/#/home")
         }


        /*var chartInstance = echarts.init(document.getElementById('mapInfo'));
        var options = OptionService.getLoginMapOption({name:[],val:[],key:[]},"map",{});
        chartInstance.setOption(options);*/
        var uname = UtilService.getCookie("ryioUname"),
            upass = UtilService.getCookie("ryioUpass");

        if (!UtilService.isNullStr(uname)) {
            $scope.name = uname;
        }
        if (!UtilService.isNullStr(upass)) {
            $scope.password = upass;
        }

        var code = "";
        $scope.getImgInfo = function (type) {
            if (type == 1) {
                ToolService.sendBehaviorUv("getImgInfo");
            }

            var selectChar = new Array(1, 2, 3, 4, 5, 6, 7, 8, 9, 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 'n', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
            code = "";
            var len = selectChar.length;
            for (var i = 0; i < 4; i++) {
                var charIndex = Math.floor(Math.random() * len);
                code += selectChar[charIndex];
            }
            document.getElementById("imgMa").src = "api/login/getvalidcode?code=" + code;
        }

        $scope.getImgInfo(2);

        var rmdId = UtilService.randRangeId();
        var pinstall = { 'appid': UtilService.getAppkey(), 'context': { '_deviceid': rmdId, '_channelid': '_default_', '_idfa': rmdId, '_idfv': rmdId } };
        $.post(UtilService.getLogRoot() + "/receive/tkio/install", JSON.stringify(pinstall))

        $scope.cip = UtilService.getCookie("cip"); //获取用户的外网ip
        $scope.sendEve = function () {
            ToolService.sendBehaviorUv("search");
        }
        $scope.doLogin = function () {
            var par = {
                email: $scope.name,
                password: $scope.password,
                autologin: $scope.isonline,
                isrember: $scope.isrember,
                cip: $scope.cip || ""
            };

            var verPar = {
                name: {
                    key: 'isNull',
                    val: par.email
                },
                password: {
                    key: 'isNull',
                    val: par.password
                },
                yema: {
                    key: 'isNull',
                    val: $scope.yema
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            ToolService.sendBehaviorUv("doLogin");
            if (angular.uppercase($scope.yema) != angular.uppercase(code)) {
                $scope.tip = {
                    yema: {
                        status: true,
                        txt: "验证码错误"
                    }
                };
                $scope.getImgInfo();
                return false;
            } else {
                var loginPM = HttpService.postInfo("login/loginweb", par);
                loginPM.then(function (data) {
                    if (data.code == 200) {
                        localStorage.setItem("OfflineTip", "show");
                        var account = data.account,
                            token = data.token;
                        if (!$scope.lang) {
                            UtilService.setCookie("NG_TRANSLATE_LANG_KEY", "");
                        }
                        if (account.status == -3) {
                            $scope.noActive = 1;
                            $scope.registerId = account.id;
                            UtilService.setCookie("regId", account.id, 7);
                            UtilService.setCookie("regEmail", $scope.name, 7);
                            UtilService.setCookie("regFlag", 0, 7);
                        } else {
                            var logpm = { 'appid': UtilService.getAppkey(), 'who': account.id, 'context': { '_deviceid': rmdId, '_channelid': '_default_', '_idfa': rmdId, '_idfv': rmdId } };
                            $.post(UtilService.getLogRoot() + "/receive/tkio/loggedin", JSON.stringify(logpm));
                            UtilService.setCookie("ryioUid", account.id, 7);
                            UtilService.setCookie("ryioUname", account.email, 7);
                            UtilService.setCookie("clickUname", account.email, 1);
                            UtilService.setCookie("rootParent", account.rootParent, 7); //用于判断父级是账号
                            UtilService.setCookie("specialUname", data.h5event_log_user || false, 7); //特殊用户wangjun@xinzhoujy.com
                            // UtilService.setCookie("ryioUauth",account.authStr,7);
                            window.localStorage.setItem("ryioUauth", account.authStr);
                            window.localStorage.setItem("ry_user", JSON.stringify(account));
                            UtilService.setCookie("ryioToken", token, 7);
                            UtilService.setCookie("ryioPastDate", account.pastDate, 7);
                            UtilService.setCookie("ryioStatus", account.status, 7);
                            UtilService.setCookie("ryioActiveStatus", account.activeStatus, 7);
                            UtilService.setCookie("ryioIcon", 0, 7);
                            if (account.allowBehavior == null) { account.allowBehavior = true };
                            UtilService.setCookie("ryioAllowBehavior", account.allowBehavior, 7);

                            var isSuper = account.isSuperUser == true && account.isChannelPerson != true;
                            UtilService.setCookie("ryioIsSuper", isSuper, 7);
                            UtilService.setCookie("ryioRole", account.roleCategory, 7);

                            if (data.account.activeStatus != true && data.account.status == 1 && isSuper == true) {
                                UtilService.setCookie("regId", account.id, 7);
                                UtilService.setCookie("regEmail", $scope.name, 7);
                                UtilService.setCookie("regFlag", 1, 7);
                                window.location.href = "olduser.html";
                            } else {
                                if (data.account.status == 1) {
                                    window.location.href = "index.html#/manage/app";
                                } else {
                                    window.location.href = "index.html#/active/product";
                                }
                            }
                        }
                        TrackingIO.loggedin(account.email);
                    } else if (data.code == 724) {
                        //腾讯云迁移相关判断
                        UtilService.setCookie("loginEmail", par.email, 7, '.trackingio.com');
                        UtilService.setCookie("loginPassword", par.password, 7, '.trackingio.com');
                        UtilService.setCookie("loginAutologin", par.autologin, 7, '.trackingio.com');
                        UtilService.setCookie("loginIsrember", par.isrember, 7, '.trackingio.com');
                        window.location.href = data.msg+'/login.html'
                    } else {
                        $scope.tip = {
                            password: {
                                status: true,
                                txt: data.msg
                            }
                        };
                    }

                    //腾讯云迁移相关判断
                    if (loginInfo && loginInfo.email) {
                        UtilService.setCookie("loginEmail", '', -1, '.trackingio.com');
                        UtilService.setCookie("loginPassword", '', -1, '.trackingio.com');
                        UtilService.setCookie("loginAutologin", '', -1, '.trackingio.com');
                        UtilService.setCookie("loginIsrember", '', -1, '.trackingio.com');
                    }
                });
            }
        }

        $scope.noActive = 0;
        $scope.closeWin = function () {
            $scope.noActive = 0;
            $scope.loginSend = 'yes';
        }
        $scope.loginSend = 'yes';
        $scope.sendAgain = function () {
            $scope.loginSend = 'no';
            var sendPM = HttpService.getInfo("reged/sendeactivemail/" + $scope.registerId + "/" + 0);
            sendPM.then(function (data) {
                window.location.href = "activation.html";
            });
        }

        $scope.keyEvt = function (e) {
            if (e.keyCode == 13) {
                $scope.doLogin();
            }
        }

        //腾讯云迁移  新老系统自动登陆判断
        var loginInfo = {
            email: UtilService.getCookie("loginEmail"),
            password: UtilService.getCookie("loginPassword"),
            autologin: UtilService.getCookie("loginAutologin"),
            isrember: UtilService.getCookie("loginIsrember")
        }
        if (loginInfo && loginInfo.email) {
            $scope.name = loginInfo.email;
            $scope.password = loginInfo.password;
            $scope.isonline = loginInfo.autologin;
            $scope.isrember = loginInfo.isrember;
            $scope.yema = code;
            $scope.doLogin();
        }
    }
})();