(function(){
    angular.module("app.login")
       .controller("registerCtrl",["$rootScope","$scope","UtilService","$http","$interval","$location","ToolService","$filter",registerCtrl]);

   function registerCtrl($rootScope,$scope,UtilService,$http,$interval,$location,ToolService,$filter){
       //腾讯云迁移相关逻辑判断
       var urltype = $location.host();
    //    if(urltype!="tweb.trackingio.com") {
    //        window.location.href = 'http://tweb.trackingio.com/register.html'
    //    }
       if(urltype!="www.trackingio.com") {
           window.location.href = 'https://www.trackingio.com/register.html'
       }

       //loading加载
       $scope.showLoading = function(){
           document.getElementById("sysLoad").style.display = "block";
       }
       $scope.hideLoading = function(){
           document.getElementById("sysLoad").style.display = "none";
       }
       $http.get("/data/channel.json").success(function(data){
           $scope.channelNames = data;
       })
       $scope.hasReged = false;
       $scope.sendEve = function(){
        ToolService.sendBehaviorUv("agreements");
    }
       $scope.save = function(){
        ToolService.sendBehaviorUv("save");
           // window.location.href = "activation.html";
           var par = {
               email: $scope.email,
               password: $scope.password,
               company: $scope.company,
               name: $scope.username,
               phone: $scope.phone,
               wechat: $scope.wechat,
               qq: $scope.qq,
               xieyi: $scope.xieyi
           };
           if($rootScope.doMainType == 1){    //新华来源
               par.regSource = 2;
               var verPar = {
                   email: {
                       key: 'email',
                       max:48,
                       val: par.email,
                       txt:$filter('translate')("邮箱最长48位")
                   },
                   password: {
                       key: 'pwd',
                       val: par.password
                   },
                   crmpwd: {
                       key: 'pwd',
                       val: $scope.crmpwd
                   },
                   company: {
                       key: 'companyname',
                       max:96,
                       val: $scope.company
                   },
                   username: {
                       key: 'username',
                       max:32,
                       val: $scope.username
                   },
                   phone: {
                       key: 'cellphone',
                       val: $scope.phone
                   },
                   wechat: {
                       key: 'wechat',
                       val: $scope.wechat
                   },
                   qq: {
                       key: 'qq',
                       val: $scope.qq
                   }
               }
   
           }
           if($rootScope.doMainType == 0){    //trackingio来源
               par.regSource = 0;
               var verPar = {
                   email: {
                       key: 'email',
                       max:48,
                       val: par.email,
                       txt:$filter('translate')("邮箱最长48位")
                   },
                   password: {
                       key: 'pwd',
                       val: par.password
                   },
                   crmpwd: {
                       key: 'pwd',
                       val: $scope.crmpwd
                   },
                   company: {
                       key: 'companyname',
                       max:96,
                       val: $scope.company
                   },
                   username: {
                       key: 'username',
                       max:32,
                       val: $scope.username
                   },
                   phone: {
                       key: 'cellphone',
                       val: $scope.phone
                   },
                   wechat: {
                       key: 'wechat',
                       val: $scope.wechat
                   },
                   qq: {
                       key: 'qq',
                       val: $scope.qq
                   },
                   xieyi:{
                       key: 'xieyi',
                       val: '1'
                   }
               }
   
           }

          
           var reg = /^([a-zA-Z0-9]+[_|\_|\.|\-]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.|\-]?)*[a-zA-Z0-9]+\.[a-zA-Z]{1,63}$/;
           $scope.tip = formJudge(verPar);
           if($scope.email == undefined){
               if ($scope.tip.succ == true) {
                   $scope.tip.succ = false;
               }
               $scope.tip.email = {
                   status:true,
                   txt:$filter('translate')("必填")
               }
           }
           if($scope.email != undefined && !reg.test($scope.email)){
               if ($scope.tip.succ == true) {
                   $scope.tip.succ = false;
               }
               $scope.tip.email = {
                   status:true,
                   txt:$filter('translate')("请输入正确的邮箱格式")
               }
           }
           if($scope.password != $scope.crmpwd){
               if ($scope.tip.succ == true) {
                   $scope.tip.succ = false;
               }
               $scope.tip.crmpwd = {
                   status:true,
                   txt:$filter('translate')("两次密码不一致，请重新输入")
               }
           }
           if($rootScope.doMainType == 0){
               if(!$scope.isrember){
                   if ($scope.tip.succ == true) {
                       $scope.tip.succ = false;
                   }
                   $scope.tip.xieyi = {
                       status: true,
                       txt:$filter('translate')("请勾选同意协议")
                   }
               }
   
           }
           
           if ($scope.tip.succ != true) { 
               return false;
           }
          
           $scope.par = par;
           var emailsub = par.email.substring(par.email.indexOf("@")+1,par.email.lastIndexOf("."));
           if($scope.channelNames && ($scope.channelNames.emails.indexOf(angular.lowercase(emailsub)) > -1 || $scope.channelNames.companys.indexOf(angular.lowercase(par.company)) > -1 || $scope.channelNames.companys.indexOf(angular.lowercase(par.name)) > -1)){
               $scope.channelText = true;
           }else{
               $scope.channelText = false;
               $scope.postSave();
           }
       }
       
       $scope.postSave =function(){
           // window.location.href = "activation.html";
          $scope.channelText = false;
           $scope.errorMessage = "";
           $scope.showLoading();
        
        
           $http.post("api/reged/regedaccount",$scope.par).success(function(data){
            $scope.hideLoading();
               if(data.code == -1){
                   $scope.tip.email = {
                       status:true,
                       txt:$filter('translate')("该邮箱已注册")
                   }
                   //$scope.errorMessage = $filter('translate')("该邮箱已注册");
               }
               else if(data.code == 201){
                   $scope.errorMessage = $filter('translate')("注册失败");
               }
               else if(data.code == 250){
                   $scope.errorMessage = $filter('translate')("邮件发送失败，请重新注册");
               }else{
                   UtilService.setCookie("regId",data.content.id,7);
                   UtilService.setCookie("regEmail",$scope.email,7);
                   UtilService.setCookie("regFlag",0,7);
                   UtilService.setCookie("ryioAcvitation",0,7);
                   
                //    TrackingIO.register($scope.email);
                   var cid = localStorage.getItem("rytf_cid"),
                       campaignid = localStorage.getItem("rytf_campid");
                    let sdkRegParams = {
                        phone: $scope.par.phone,
                        name: $scope.par.name,
                        company: $scope.par.company,
                        email: $scope.par.email,
                        title: ''
                    }

                   if(UtilService.isNullStr(cid)){
                       cid = -1;
                       campaignid = '_default_';
                   }
                   TrackingIO.init("f0f251af10e66a0c94d2e923d8863105");
                   TrackingIO.register($scope.email,sdkRegParams);

                   var params = {
                       appid:UtilService.getTKAppkey(),
                       who:$scope.email,
                       what:"reged",
                       context:{
                           email:$scope.email,
                           "_cid":cid,
                           "_campaignid":campaignid,
                           "_apptype":"wap",
                           company:$scope.company,

                           _deviceid:UtilService.randDeviceId(), //设备ID
                           operatesystem: UtilService.operatorSystem(),//操作系统  _ryos
                           browser: UtilService.getBrowser() //浏览器类型
                       }
                   };
                  
                   $scope.showLoading();
                   $.post(UtilService.getLogRoot()+"/receive/tkio/event",JSON.stringify(params),function(data){
                    $scope.hideLoading();
                        window.location.href = "activation.html";
                   });  
                   
               }
           });
       }
       $scope.keyEvt= function(e){
           if(e.keyCode == 13){
               $scope.save();
           }
       }
       $scope.closeWin = function(){
           $scope.channelText = false;
       } 
   }
})();
