(function(){
    var tempVersion = new Date().getTime();

    angular.module("app.manage")
        .config(['$stateProvider',"$urlRouterProvider",function ($stateProvider,$urlRouterProvider) {
        var menu = "manage",html = ["app","auth","channelAdd","channelSm","channelAdwords","channelToutiao","channelBaidu","channelKuaishou","channelWeixinmp","campgroup","datacb",
        "campaign","subcampaignlist","activityevent","userinfo","nopower","onelink","downloadurl","subpackage","subchannel","exportsetting","customevent",
            "authpower","authrole","deviceManage","advancedServices","crowdAnalysis","crowdAnalysisGuide","crowdAnalysisList","accountauth","channel","customchannel","dataCallback","addDataCallback",
            "ckBatchManage", "ckBatchUpload","fakeGuide"];


        var nodetail = ["systemparam","event","profile","downloadurl"];
        $stateProvider.state(menu,{
            url:"",
            templateUrl: '/template/menu/collect.html?r='+tempVersion,
            controller: "collectCtrl"
        });
        html.forEach(function(h){
            $stateProvider.state('collect.' + h,{
                url:"/" + menu + "/" + h,
                params:{
                    aid:null
                },
                views:{
                    "content@":{
                        templateUrl: "/template/" + menu + "/" + h + '.html?r='+tempVersion,
                        controller: h +"Ctrl"
                    }
                }
            });
            if(nodetail.indexOf(h)==-1){
                var v = h+"Detail";
                $stateProvider.state('collect.' + v,{
                    url:"/" + menu + "/" + v,
                    params:{
                        aid:null
                    },
                    views:{
                        "content@":{
                            templateUrl: "/template/" + menu + "/" + v + '.html?r='+tempVersion,
                            controller: v +"Ctrl"
                        }
                    }
                });
            }
        });
        //其他可以传递参数的路由设置
        var otherHtml = {
            createCrowdTag:[
                {param:'step',isEmpty:true},//isEmpty:参数必填和可以为空区分
                {param:'id',isEmpty:true},
            ],
            crowdAnalysisInfo:[
                {param:'id',isEmpty:true},
            ],
        }
        for(var p in otherHtml){
            var url="/" + menu + "/" + p,params = otherHtml[p];
            params.forEach(function(param){
                    url+='/:'+ param.param +(param.isEmpty ? '?':'');
            })
            $stateProvider.state('collect.' + p,{
                url:url,
                params:{
                    aid:null
                },
                views:{
                    "content@":{
                        templateUrl: "/template/" + menu + "/" + p + '.html?r='+tempVersion,
                        controller: p +"Ctrl"
                    }
                }
            });
        }

       /* var cct = "createCrowdTag";
        $stateProvider.state('collect.' + cct,{
            url:"/" + menu + "/" + cct+"/:step?/:id?",
            params:{
                aid:null
            },
            views:{
                "content@":{
                    templateUrl: "/template/" + menu + "/" + cct + '.html?r='+tempVersion,
                    controller: cct +"Ctrl"
                }
            }
        });

        var cai= "crowdAnalysisInfo";
        $stateProvider.state('collect.' + cai,{
            url:"/" + menu + "/" + cai+"/:id?",
            params:{
                aid:null
            },
            views:{
                "content@":{
                    templateUrl: "/template/" + menu + "/" + cai + '.html?r='+tempVersion,
                    controller: cai +"Ctrl"
                }
            }
        });*/

    }]);
})();
