package com.reyun.service.impl;


import com.reyun.model.Account;
import com.reyun.model.AccountRestrict4Web;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.AccountRestrict4WebRepository;
import com.reyun.service.AccountFlowRestrictService;
import com.reyun.service.AutoTodayFlowService;
import org.joda.time.DateTime;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration({"classpath:applicationContext.xml"})
public class FlowTest {


    @Autowired
    AutoTodayFlowService autoTodayFlowService;

    @Autowired
    AccountRepository accountRepository;

    @Autowired
    AccountFlowRestrictService accountFlowRestrictService;

    @Autowired
    AccountRestrict4WebRepository accountRestrict4WebRepository;


    @Test
    public void testToday() {
        autoTodayFlowService.autoTodayFlowTask(accountRepository.findOne(38L));
    }



    @Test
    public void testPackageMail(){

        Account account = accountRepository.findOne(38L);
        AccountRestrict4Web restrict4Web  = accountRestrict4WebRepository.findOne(533787L);
        autoTodayFlowService.packageFlowNotify(restrict4Web,account);

    }


    @Test
    public void testSQL() {
        DateTime today = new DateTime();
        String appkey = "57ed2dd31596bb4682471e82c0c73c1a";
        BigInteger two = accountFlowRestrictService.getTotalNum(
                today.plusDays(-1).toString("yyyy-MM-dd"),
                today.toString("yyyy-MM-dd"), appkey,
                "account_package_today_click_flow", "click_sum");
    }
}
