#!/bin/sh
APP_HOME=~/trackingio
APP_NAME=trackingio.war
TOMCAT_HOME=~/application/trackingio-web
cd  $APP_HOME
mvn clean compile war:war -Pqcloud-production
echo "构建完成"
pid=`ps -ef|grep $TOMCAT_HOME|grep -v "grep"|awk '{print $2}'`
kill -9 $pid
sleep 1
echo "程序关闭 $pid"
cd $TOMCAT_HOME/webapps
rm -rf *
cp $APP_HOME/target/$APP_NAME .
mv $APP_NAME ROOT.war
sh $TOMCAT_HOME/bin/startup.sh
pid=`ps -ef|grep $TOMCAT_HOME|grep -v "grep"|awk '{print $2}'`
echo "启动完成 $pid"
